<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Edited by XMLSpy --> 
<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
<html>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<style type="text/css">
#header {font-weight: bolder; font-size: 18px;}
#title {font-weight: bolder; font-size: 15px;}
#value {color:blue;}
#result {font-weight: bolder;}
.success {color:#009900;}
.failed {color:#990000;}
body { -moz-transform-origin: 0 0; }
</style>
<body>
<table id="contenttable"><tr><td>
<h1>Audit Log</h1>  
<xsl:apply-templates select="//General"/>
<xsl:apply-templates select="//Operation"/>
<xsl:apply-templates select="//AuditReport/Hash"/>
<xsl:apply-templates select="//VerifyInfo"/>
<xsl:apply-templates select="//CaseInfo"/>
<xsl:apply-templates select="//PushReport"/>
<xsl:apply-templates select="//FileInfo"/>
<xsl:apply-templates select="//AccessErrors"/>
<xsl:apply-templates select="//SegmentInfo"/>
<xsl:apply-templates select="//DriveInfo"/>
<xsl:apply-templates select="//DriveUnlock"/>
<xsl:apply-templates select="//DriveTrimInfo"/>
<xsl:apply-templates select="//ResizeInfo"/>
<xsl:apply-templates select="//WipeInfo"/>
<xsl:apply-templates select="//SecureWipeInfo"/>
<xsl:apply-templates select="//WipeFormatInfo"/>
<xsl:apply-templates select="//ErrorInfo"/>
<xsl:apply-templates select="//PartitionInfo"/>
</td></tr></table>

<script language="javascript">
if (typeof parent.xmlserver === 'undefined') {
	// Only call scaleToOnePage when the parent is NOT the Logicube UI
	scaleToOnePage();
}
function scaleToOnePage() {
	var content_width = document.getElementById('contenttable').offsetWidth;
	var content_height = document.getElementById('contenttable').offsetHeight;
	
	//scale by width or height
	var scale = Math.min(670/content_width, 960/content_height);

	//no upscaling
	if (content_width &gt; 670 || content_height &gt; 960) {
		scale = Math.max(scale, 0.70);
		document.body.style.zoom = (100*scale) + "%";
		document.body.style['MozTransform'] = "scale(" + scale + ")";
	}
}
</script>

<script language="javascript">
/* Decode */
var elem = document.getElementsByClassName('decode');
for (var i = 0; i &lt; elem.length; ++i) {
	var item = elem[i];
	item.innerHTML = item.innerHTML.replace(/%0A/g,"&lt;br&gt;");
	item.innerHTML = item.innerHTML.replace(/%23/g, "#");
	item.innerHTML = item.innerHTML.replace(/%7B/g, "{");
	item.innerHTML = item.innerHTML.replace(/%7D/g, "}");
	item.innerHTML = item.innerHTML.replace(/%5B/g, "[");
	item.innerHTML = item.innerHTML.replace(/%5D/g, "]");
	item.innerHTML = item.innerHTML.replace(/%7C/g, "|");
	item.innerHTML = item.innerHTML.replace(/%3D/g, "=");
	item.innerHTML = item.innerHTML.replace(/%3B/g, ";");
	item.innerHTML = item.innerHTML.replace(/%26/g, "&amp;");
	item.innerHTML = item.innerHTML.replace(/%3C/g, "&lt;");
	item.innerHTML = item.innerHTML.replace(/%3E/g, "&gt;");
	item.innerHTML = item.innerHTML.replace(/%24/g, "$");
	item.innerHTML = item.innerHTML.replace(/%25/g, "%");
	item.innerHTML = item.innerHTML.replace(/%5E/g, "^");
	item.innerHTML = item.innerHTML.replace(/%2A/g, "*");
	item.innerHTML = item.innerHTML.replace(/%5C/g, "\\");
}
</script>

</body>
</html>
</xsl:template>

<xsl:template name="break-string">
  <xsl:param name="string" />
  <xsl:param name="wrap-col" />
  <xsl:choose>
    <xsl:when test="string-length( $string ) >= $wrap-col">
      <xsl:variable name="newstr" select="substring($string, 0, $wrap-col)" />
      <xsl:value-of select="$newstr" />
      <xsl:value-of select="'&#13;&#10;'" disable-output-escaping="yes"/>
      <xsl:call-template name="break-string">
        <xsl:with-param name="string" select="substring($string, $wrap-col, string-length( $string ))" />
        <xsl:with-param name="wrap-col" select="$wrap-col" />
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$string" />
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<!-- Copyright 2010 Aristotle Pagaltzis; under the MIT licence -->
<!-- http://www.opensource.org/licenses/mit-license.php -->
<xsl:template name="wrap-string" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:param name="str" />
  <xsl:param name="wrap-col" />
  <xsl:param name="break-mark" />
  <xsl:param name="pos" select="0" />
  <xsl:choose>

    <xsl:when test="contains( $str, ' ' )">
      <xsl:variable name="first-word" select="substring-before( $str, ' ' )" />
      <xsl:variable name="pos-now" select="$pos + 1 + string-length( $first-word )" />
      <xsl:choose>

        <xsl:when test="$pos > 0 and $pos-now >= $wrap-col">
          <xsl:copy-of select="$break-mark" />
          <xsl:call-template name="wrap-string">
            <xsl:with-param name="str" select="$str" />
            <xsl:with-param name="wrap-col" select="$wrap-col" />
            <xsl:with-param name="break-mark" select="$break-mark" />
            <xsl:with-param name="pos" select="0" />
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise>
          <xsl:value-of select="$first-word" />
          <xsl:text> </xsl:text>
          <xsl:call-template name="wrap-string">
            <xsl:with-param name="str" select="substring-after( $str, ' ' )" />
            <xsl:with-param name="wrap-col" select="$wrap-col" />
            <xsl:with-param name="break-mark" select="$break-mark" />
            <xsl:with-param name="pos" select="$pos-now" />
          </xsl:call-template>
        </xsl:otherwise>

      </xsl:choose>
    </xsl:when>

    <xsl:otherwise>
      <xsl:call-template name="break-string">
        <xsl:with-param name="string" select="$str" />
        <xsl:with-param name="wrap-col" select="$wrap-col" />
      </xsl:call-template>
    </xsl:otherwise>

  </xsl:choose>
</xsl:template>

<xsl:template match="General">
	<table>
        <tr><td id="title">Vendor:</td><td><xsl:value-of select="Vendor"/></td></tr>
        <tr><td id="title">Product:</td><td><xsl:value-of select="Product"/></td></tr>
        <tr><td id="title">Software Version:</td><td><xsl:value-of select="SWVersion"/></td></tr>
	<tr><td id="title">Build Date:</td><td><xsl:value-of select="BuildDate"/></td></tr>
	<tr><td id="title">Unit Serial Number:</td><td><xsl:value-of select="UnitSerial"/></td></tr>
	<tr><td id="title">Time (Local):</td><td><xsl:value-of select="Time"/></td></tr>
	<tr><td id="title">Time (UTC):</td><td><xsl:value-of select="UTC"/></td></tr>
	<tr><td id="title">Date:</td><td><xsl:value-of select="Date"/></td></tr>
	</table>
</xsl:template>

<xsl:template match="CaseInfo">
	<hr size="2"/><table>
	<tr><td id="header">Case Information</td></tr>
	<tr><td id="title">Case/File Name:</td><td class="decode"><xsl:value-of select="CaseName"/></td></tr>
	<tr><td id="title">Case ID:</td><td class="decode"><xsl:value-of select="CaseNumber"/></td></tr>
	<tr><td id="title">Examiner:</td><td class="decode"><xsl:value-of select="ExaminerName"/></td></tr>
	<tr><td id="title">Evidence ID:</td><td class="decode"><xsl:value-of select="EvidenceNumber"/></td></tr>
	<tr>
		<td id="title">Case Notes:</td>
		<td class="decode">
			<xsl:call-template name="wrap-string">
				<xsl:with-param name="str">
					<xsl:value-of select="CaseNotes"/>
				</xsl:with-param>
				<xsl:with-param name="wrap-col" select="60" />
			</xsl:call-template>
		</td>
	</tr>
	</table>
</xsl:template>

<xsl:template match="Operation">
	<hr size="2"/><table>
	<tr><td id="header">Operation Parameters</td></tr>
	<xsl:if test="Mode">
        <tr><td id="title">Mode:</td><td><xsl:value-of select="Mode"/></td></tr>
	</xsl:if>
	<xsl:if test="Method">
        <tr><td id="title">Method:</td><td><xsl:value-of select="Method"/></td></tr>
	</xsl:if>
	<xsl:if test="SrcPartition">
        <tr><td id="title">Captured Partition:</td><td><xsl:value-of select="SrcPartition"/></td></tr>
	</xsl:if>
	<xsl:if test="ResizePercs">
        <tr><td id="title">Resize Percentages:</td><td><xsl:value-of select="ResizePercs"/></td></tr>
	</xsl:if>
	<xsl:if test="PartitionTypes">
        <tr><td id="title">Partition Types:</td><td><xsl:value-of select="PartitionTypes"/></td></tr>
	</xsl:if>
	<xsl:if test="Hash">
	<tr><td id="title">Hash:</td><td><xsl:value-of select="Hash"/></td></tr>
	</xsl:if>
	<xsl:if test="ImagePath">
	<tr><td id="title">Image Path:</td><td><xsl:value-of select="ImagePath"/></td></tr>
	</xsl:if>
	<xsl:if test="LBACount">
	<tr><td id="title">LBA Count:</td><td><xsl:value-of select="LBACount"/></td></tr>
	</xsl:if>
	<xsl:if test="SrcDeviceModel">
	<tr><td id="title">Source Device:</td><td><xsl:value-of select="SrcDeviceModel"/></td></tr>
	</xsl:if>
	<xsl:if test="SrcLogicalSectSize">
	<tr><td id="title">Source Logical Sector Size:</td><td><xsl:value-of select="SrcLogicalSectSize"/></td></tr>
	</xsl:if>
	<xsl:if test="SegmentSize">
	<tr><td id="title">Segment Size:</td><td><xsl:value-of select="SegmentSize"/></td></tr>
	</xsl:if>
	<xsl:if test="CompressionLevel">
	<tr><td id="title">Compression Level:</td><td><xsl:value-of select="CompressionLevel"/></td></tr>
	</xsl:if>
	<xsl:if test="HashEnabled">
	<tr><td id="title">Hash Enabled:</td><td><xsl:value-of select="HashEnabled"/></td></tr>
	</xsl:if>
	<xsl:if test="VerifyHash">
	<tr><td id="title">Verify Hash:</td><td><xsl:value-of select="VerifyHash"/></td></tr>
	</xsl:if>
	<xsl:if test="RAIDEnabled">
	<tr><td id="title">RAID Enabled:</td><td><xsl:value-of select="RAIDEnabled"/></td></tr>
	</xsl:if>
	<xsl:if test="SecureWipe">
	<tr><td id="title">Secure Wipe:</td><td><xsl:value-of select="SecureWipe"/></td></tr>
	</xsl:if>
	<xsl:if test="FormatWipe">
	<tr><td id="title">Format Wipe:</td><td><xsl:value-of select="FormatWipe"/></td></tr>
	</xsl:if>
	<xsl:if test="UnlockHPA">
	<tr><td id="title">Unlock HPA:</td><td><xsl:value-of select="UnlockHPA"/></td></tr>
	</xsl:if>
	<xsl:if test="UnlockDCO">
	<tr><td id="title">Unlock DCO:</td><td><xsl:value-of select="UnlockDCO"/></td></tr>
	</xsl:if>
	<xsl:if test="DriveTrim">
	<tr><td id="title">Drive Trim:</td><td><xsl:value-of select="DriveTrim"/></td></tr>
	</xsl:if>
	<xsl:if test="ErrorGranularity">
	<tr><td id="title">Error Granularity:</td><td><xsl:value-of select="ErrorGranularity"/></td></tr>
	</xsl:if>
	<xsl:if test="CopyLength">
	<tr><td id="title">Copy Length:</td><td><xsl:value-of select="CopyLength"/></td></tr>
	</xsl:if>
	<xsl:if test="DestinationNCQ">
	<tr><td id="title">Destination NCQ:</td><td>ON</td></tr>
	</xsl:if>
	<xsl:if test="SearchRootDir">
	<tr><td id="title">Search Root Path:</td><td class="decode"><xsl:value-of select="SearchRootDir"/></td></tr>
	</xsl:if>
	<xsl:if test="OutputFormat">
	<tr><td id="title">Output Format:</td><td><xsl:value-of select="OutputFormat"/></td></tr>
	</xsl:if>
	<xsl:if test="ExcludePaths">
	<tr><td id="title">Exclude Path Filter:</td><td class="decode"><xsl:value-of select="ExcludePaths"/></td></tr>
	</xsl:if>
	<xsl:if test="IncludePaths">
	<tr><td id="title">Include Path Filter:</td><td class="decode"><xsl:value-of select="IncludePaths"/></td></tr>
	</xsl:if>
	<xsl:if test="FileCategories">
	<tr><td id="title">File Categories:</td><td><xsl:value-of select="FileCategories"/></td></tr>
	</xsl:if>
	<xsl:if test="DictKeywords">
	<tr><td id="title">Search Keywords:</td><td><xsl:value-of select="DictKeywords"/></td></tr>
	</xsl:if>
	<xsl:if test="IgnoreCase">
	<tr><td id="title">Ignore Case:</td><td><xsl:value-of select="IgnoreCase"/></td></tr>
	</xsl:if>
	<xsl:if test="UnicodeChars">
	<tr><td id="title">Search Unicode Chars:</td><td><xsl:value-of select="UnicodeChars"/></td></tr>
	</xsl:if>

	<xsl:variable name="result" select="Result" />
	<xsl:choose>
		<xsl:when test="contains( $result, 'SUCCESS' )"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="Result"/></td></tr></xsl:when>
		<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="Result"/></td></tr></xsl:otherwise>
	</xsl:choose>
	<tr><td id="title">Duration:</td><td><xsl:value-of select="Duration"/></td></tr>
	</table>
</xsl:template>

<xsl:template match="DriveUnlock">
	<hr size="2"/><table>
	<tr><td id="header">Drive Unlock</td></tr>
	<td><table>
	<xsl:for-each select="Drive">
			<tr>
				<td  id="title">Bay:</td>
				<td><xsl:value-of select="@Bay" /></td>

				<td  id="title">Type:</td>
				<td><xsl:value-of select="@Type" /></td>
			</tr>
	</xsl:for-each>
	</table></td>
	</table><br/>
</xsl:template>

<xsl:template match="DriveTrimInfo">
	<hr size="2"/><table>
	<tr><td id="header">Drive Trim</td></tr>
	<td><table>
	<xsl:for-each select="Drive">
			<tr>
				<td  id="title">Bay:</td>
				<td><xsl:value-of select="@Bay" /></td>
				<td></td>
				<td></td>
				<td  id="title">Type:</td>
				<td><xsl:value-of select="@Type" /></td>
				<td></td>
				<td></td>
				<xsl:choose>
					<xsl:when test="@Result='Pass'"><td id="title">Result:</td><td class="success"><xsl:value-of select="@Result"/></td></xsl:when>
					<xsl:otherwise><td id="title">Result:</td><td class="failed"><xsl:value-of select="@Result"/></td></xsl:otherwise>
				</xsl:choose>
			</tr>
	</xsl:for-each>
	</table></td>
	</table><br/>
</xsl:template>


<xsl:template match="WipeInfo">
	<hr size="2"/><table>
	<tr><td id="header">Wipe Patterns</td></tr>
	<td><table>
	<xsl:for-each select="Pass">
			<tr>
				<td  id="title">Pass:</td>
				<td><xsl:value-of select="position()" /></td>

				<td  id="title">Value:</td>
				<td><xsl:value-of select="@Value" /></td>
			</tr>
	</xsl:for-each>
	</table></td>
	</table><br/>
</xsl:template>

<xsl:template match="SecureWipeInfo">
	<hr size="2"/><table>
	<tr><td id="header">Secure Wipe Information</td></tr>
	<tr><td id="title">ATA Password:</td><td><xsl:value-of select="/AuditReport/Operation/ATAPasswd"/></td></tr>
	<xsl:for-each select="Drive">
		<td><table>
			<tr><td  id="title">Bay:</td><td><xsl:value-of select="@Bay" /></td></tr>
			<tr><td  id="title">Secure Erase:</td><td><xsl:value-of select="@SecureErase" /></td></tr>
			<xsl:choose>
				<xsl:when test="@Result='Success'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@Result"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@Result"/></td></tr></xsl:otherwise>
			</xsl:choose>
		</table></td>
	</xsl:for-each>
	</table><br/>
</xsl:template>

<xsl:template match="WipeFormatInfo">
	<hr size="2"/><table>
	<tr><td id="header">Wipe Format Information</td></tr>
	<tr><td id="title">Filesystem: <xsl:value-of select="/AuditReport/Operation/FileSystem"/></td></tr>
	<xsl:for-each select="Drive">
		<td><table>
			<tr><td id="title">Bay:</td><td><xsl:value-of select="@Bay" /></td></tr>
			<xsl:choose>
				<xsl:when test="@Result='Success'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@Result"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@Result"/></td></tr></xsl:otherwise>
			</xsl:choose>
		</table></td>
	</xsl:for-each>
	</table><br/>
</xsl:template>

<xsl:template match="AuditReport/Hash">
	<hr size="2"/><table>
	<tr><td id="header">Hash Information</td></tr>
	<tr><td id="title">LBA Count:</td><td><xsl:value-of select="NumLBA"/></td></tr>
	<tr><td id="title">Sector Size:</td><td><xsl:value-of select="SrcLSectSz"/></td></tr>
	<tr><td id="title">Hash Type:</td><td><xsl:value-of select="HashType"/></td></tr>
	<tr><td id="title">Source Hash:</td><td><xsl:value-of select="SourceHash"/></td></tr>
	<xsl:if test="Result">
	<xsl:choose>
		<xsl:when test="Result='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="Result"/></td></tr></xsl:when>
		<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="Result"/></td></tr></xsl:otherwise>
	</xsl:choose>
	</xsl:if>

	<xsl:if test="VerificationHash">
	<tr><td id="title">Verification Hash:</td><td><xsl:value-of select="VerificationHash"/></td></tr>
	<tr><td id="title">Verification Result:</td><td id="result"><xsl:value-of select="Result"/></td></tr>
	</xsl:if>

	<xsl:if test="HashTypeSec">
	<tr><td id="title">Secondary Hash Type:</td><td><xsl:value-of select="HashTypeSec"/></td></tr>
	<tr><td id="title">Secondary Source Hash:</td><td><xsl:value-of select="SourceHashSec"/></td></tr>
	<xsl:if test="ResultSec">
	<xsl:choose>
		<xsl:when test="ResultSec='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="ResultSec"/></td></tr></xsl:when>
		<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="ResultSec"/></td></tr></xsl:otherwise>
	</xsl:choose>
	</xsl:if>
	</xsl:if>
	<xsl:if test="VerificationHashSec">
	<tr><td id="title">Secondary Verification Hash:</td><td><xsl:value-of select="VerificationHashSec"/></td></tr>
	<tr><td id="title">Verification Result:</td><td id="result"><xsl:value-of select="ResultSec"/></td></tr>
	</xsl:if>

	</table>
</xsl:template>

<xsl:template match="DriveInfo">
	<hr size="2"/><table>
	<tr><td id="header">Drive Information</td></tr>
	<td><table border="1">
	<tr>
		<td id="title" style="text-align:center">Bay</td>
		<td id="title" style="text-align:center">Role</td>
		<td id="title" style="text-align:center">Serial</td>
		<td id="title" style="text-align:center">Model</td>
		<td id="title" style="text-align:center">RAID</td>
		<td id="title" style="text-align:center">HPA Start LBA</td>
		<td id="title" style="text-align:center">DCO Start LBA</td>
		<td id="title" style="text-align:center">Filesystem</td>
		<td id="title" style="text-align:center">Cipher</td>
		<td id="title" style="text-align:center">Cipher Mode</td>
		<td id="title" style="text-align:center">IV Gen</td>
	</tr>
	<xsl:for-each select="Drive">
		<tr><td style="text-align:center"><xsl:value-of select="@Bay" /></td>
		    <xsl:choose>
			<xsl:when test="@Role='Source'">
				<td style="text-align:center">S</td>
			</xsl:when>
			<xsl:when test="@Role='Destination'">
				<td style="text-align:center">D</td>
			</xsl:when>
			<xsl:when test="@Role='Master'">
				<td style="text-align:center">M</td>
			</xsl:when>
			<xsl:when test="@Role='Target'">
				<td style="text-align:center">T</td>
			</xsl:when>
		    </xsl:choose>
		    <td ><xsl:value-of select="@Serial" /></td>
		    <td ><xsl:value-of select="@Model" /></td>
		    <xsl:choose>
			<xsl:when test="@RAID='True'">
				<td style="text-align:center">X</td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center"> </td>
			</xsl:otherwise>
		    </xsl:choose>

		    <xsl:choose>
			<xsl:when test="@HPA">
				<td style="text-align:center"><xsl:value-of select="@HPA" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>

		    <xsl:choose>
			<xsl:when test="@DCO">
				<td style="text-align:center"><xsl:value-of select="@DCO" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>

		    <xsl:choose>
			<xsl:when test="@FileSystem">
				<td style="text-align:center"><xsl:value-of select="@FileSystem" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>
		    <xsl:choose>
			<xsl:when test="@Cipher">
				<td style="text-align:center"><xsl:value-of select="@Cipher" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>
		    <xsl:choose>
			<xsl:when test="@CipherMode">
				<td style="text-align:center"><xsl:value-of select="@CipherMode" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>
		    <xsl:choose>
			<xsl:when test="@IVGen">
				<td style="text-align:center"><xsl:value-of select="@IVGen" /></td>
			</xsl:when>
			<xsl:otherwise>
				<td style="text-align:center">NA</td>
			</xsl:otherwise>
		    </xsl:choose>
		</tr>
	</xsl:for-each>
	</table></td>
	<tr><td id="title">Role Definitions</td></tr>
	<tr><td>S = Source</td></tr>
	<tr><td>D = Destination</td></tr>
	<tr><td>M = Master</td></tr>
	<tr><td>T = Target</td></tr>
	</table><br/>

	<hr size="2"/><table>
	<tr><td id="header">Drive Capacities</td></tr>
	<td><table border="1">
	<tr>
		<td id="title" style="text-align:center">Bay</td>
		<td id="title" style="text-align:center">Model</td>
		<td id="title" style="text-align:center">Serial</td>
		<td id="title" style="text-align:center">Capacity</td>
	</tr>
	<xsl:for-each select="Drive">
		<tr><td style="text-align:center"><xsl:value-of select="@Bay" /></td>
		    <td ><xsl:value-of select="@Model" /></td>
		    <td ><xsl:value-of select="@Serial" /></td>
		    <td ><xsl:value-of select="@Capacity" /></td>
		</tr>
	</xsl:for-each>
	</table></td>
	</table><br/>

</xsl:template>

<xsl:template match="ResizeInfo">
	<hr size="2"/>
	<table>
		<tr><td id="header">Filesystem Resize Info</td></tr>
		<tr>
			<td>
				<table border="1">
					<tr>
						<td id="title" style="text-align:center">Bay</td>
						<td id="title" style="text-align:center">Type</td>
						<td id="title" style="text-align:center">Result</td>
						<td id="title" style="text-align:center">Reason</td>
					</tr>
					<xsl:for-each select="Drive">
						<tr>
						    <td style="text-align:center"><xsl:value-of select="@Bay" /></td>
						    <td ><xsl:value-of select="@Type" /></td>
						    <xsl:choose>
						        <xsl:when test="@Result='Success'"><td class="success"><xsl:value-of select="@Result" /></td></xsl:when>
						        <xsl:when test="@Result='Failed'"><td class="failed"><xsl:value-of select="@Result" /></td></xsl:when>
						        <xsl:otherwise><td><xsl:value-of select="@Result" /></td></xsl:otherwise>
						    </xsl:choose>
						    <td ><xsl:value-of select="@Reason" /></td>
						</tr>
					</xsl:for-each>
				</table>
			</td>
		</tr>
	</table>
	<br/>
</xsl:template>

<xsl:template match="FileInfo">
	<hr size="2"/><table>
	<tr><td id="header">File Information</td></tr>
	</table><br/>
	<xsl:for-each select="Destination">
		<hr size="1"/><table>
		<tr><td id="title">Destination:</td>
		<td><table><tr><td><b>UID: </b><xsl:value-of select="@UID" /></td></tr>
		<tr><td><b>Path: </b><xsl:value-of select="@Path" /></td></tr>
		<tr><td><b>Filesystem: </b><xsl:value-of select="@Filesystem" /></td></tr>
		<tr><td><b>Serial: </b><xsl:value-of select="@Serial" /></td></tr>
		</table></td>
		</tr>
		<xsl:for-each select="File">
			<tr><td  id="title"><i>File <xsl:value-of select="position()" /></i></td></tr>
			<tr><td  id="title">File Name:</td><td><xsl:value-of select="@Name" /></td></tr>
			<tr><td  id="title">Hash:</td><td><xsl:value-of select="@Hash" /></td></tr>
			<xsl:if test="@VHash">
			<tr><td id="title">Verification Hash:</td><td><xsl:value-of select="@VHash"/></td></tr>
			<tr><td id="title">Verification Result:</td><td><xsl:value-of select="@Result"/></td></tr>
			</xsl:if>
			<tr><td></td><td></td></tr>
		</xsl:for-each>
		</table>
		<hr size="2"/>
	</xsl:for-each>
</xsl:template>

<xsl:template match="AccessErrors">
        <xsl:if test="File">
	<hr size="2"/><table>
	<tr><td id="header">File Access Errors</td></tr>
	</table><br/>
	<table><br/>
		<xsl:for-each select="File">
			<tr><td  id="title"><i>File <xsl:value-of select="position()" /></i></td></tr>
			<tr><td  id="title">File Name:</td><td><xsl:value-of select="@Name" /></td></tr>
			<tr><td></td><td></td></tr>
		</xsl:for-each>
		<hr size="2"/>
	</table><br/>
	</xsl:if>
</xsl:template>

<xsl:template match="SegmentInfo">
	<hr size="2"/><table>
	<tr><td id="header">Segment Information</td></tr>
	</table><br/>
	<xsl:for-each select="Destination">
		<hr size="1"/><table>
		<tr><td id="title">Destination:</td>
		<td><table><tr><td><b>UID: </b><xsl:value-of select="@UID" /></td></tr>
		<tr><td><b>Path: </b><xsl:value-of select="@Path" /></td></tr>
		<tr><td><b>Filesystem: </b><xsl:value-of select="@Filesystem" /></td></tr>
		<tr><td><b>Serial: </b><xsl:value-of select="@Serial" /></td></tr>
		</table></td>
		</tr>
		<xsl:for-each select="Segment">
			<tr><td  id="title">File Name:</td><td><xsl:value-of select="@FileName" /></td></tr>
			<tr><td  id="title">Partial Hash:</td><td><xsl:value-of select="@PartialHash" /></td></tr>
			<xsl:if test="@ComputedHash">
			<tr><td id="title">Verification Hash:</td><td><xsl:value-of select="@ComputedHash"/></td></tr>
			<xsl:choose>
				<xsl:when test="@VerificationResult='Pass'"><tr><td id="title">Verification Result:</td><td class="success"><xsl:value-of select="@VerificationResult"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Verification Result:</td><td class="failed"><xsl:value-of select="@VerificationResult"/></td></tr></xsl:otherwise>
			</xsl:choose>
			<tr><td></td><td></td></tr>
			</xsl:if>
		</xsl:for-each>
		</table>
		<hr size="2"/>
	</xsl:for-each>
</xsl:template>

<xsl:template match="VerifyInfo">
	<hr size="2"/><table>
	<tr><td id="header">Verify Information</td></tr>
	<xsl:for-each select="Drive">
		<tr><td  id="title"><i>Drive <xsl:value-of select="position()" /></i></td></tr>
		<td><table>
			<tr><td  id="title">Bay:</td><td><xsl:value-of select="@Bay" /></td></tr>
			<tr><td  id="title">LBA Count:</td><td><xsl:value-of select="@LBA" /></td></tr>
			<tr><td  id="title">Sector Size:</td><td><xsl:value-of select="@LogicalSectSz" /></td></tr>
			<xsl:if test="@HashType">
			<tr><td  id="title">Hash Type:</td><td><xsl:value-of select="@HashType" /></td></tr>
			</xsl:if>
			<tr><td  id="title">Hash:</td><td><xsl:value-of select="@Hash" /></td></tr>
			<xsl:if test="@ExpectedHash">
			<tr><td  id="title">Expected Hash:</td><td><xsl:value-of select="@ExpectedHash" /></td></tr>
			</xsl:if>
			<xsl:choose>
				<xsl:when test="@Result='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@Result"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@Result"/></td></tr></xsl:otherwise>
			</xsl:choose>

			<xsl:if test="@HashSecType">
			<tr><td  id="title">Secondary Hash Type:</td><td><xsl:value-of select="@HashSecType" /></td></tr>
			</xsl:if>
			<xsl:if test="@HashSec">
			<tr><td  id="title">Secondary Hash:</td><td><xsl:value-of select="@HashSec" /></td></tr>
			</xsl:if>
			<xsl:if test="@ExpectedHashSec">
			<tr><td  id="title">Expected Secondary Hash:</td><td><xsl:value-of select="@ExpectedHashSec" /></td></tr>
			</xsl:if>
			<xsl:if test="@ResultSec">
			<xsl:choose>
				<xsl:when test="@ResultSec='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@ResultSec"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@ResultSec"/></td></tr></xsl:otherwise>
			</xsl:choose>
			</xsl:if>
		</table></td>
	</xsl:for-each>
	</table>
</xsl:template>

<xsl:template match="ErrorInfo">
	<hr size="2"/>
	<table>
		<tr>
			<td id="header">Error Information</td>
		</tr>

		<tr>
		<td>
		<table border="1">
			<tr>
				<td id="title" style="text-align:center">Bay</td>
				<td id="title" style="text-align:center">Error Type</td>
				<td id="title" style="text-align:center">Failed Block Count</td>
				<td id="title" style="text-align:center">Completed</td>
				<td id="title" style="text-align:center">Failed Blocks</td>
			</tr>
			<xsl:for-each select="Drive">
				<tr>
					<td style="text-align:center"><xsl:value-of select="@Bay" /></td>
					<td style="text-align:center"><xsl:value-of select="@ErrorType" /></td>
					<td style="text-align:center"><xsl:value-of select="@NumBadSects" /></td>
					<td style="text-align:center"><xsl:value-of select="@Completed" /></td>
					<td style="text-align:center">
						<xsl:if test="BadSects">
							<xsl:for-each select="BadSects">
								<xsl:value-of select="concat(' ', .)" />
							</xsl:for-each>
						</xsl:if>
					</td>
				</tr>
			</xsl:for-each>
		</table>
		</td>
		</tr>
	</table><br/>
</xsl:template>


<xsl:template match="PushReport">
	<hr size="2"/><table>
	<tr><td id="header">Push Report</td></tr>
	</table>
	<xsl:for-each select="Destination">
		<table>
		<tr><td id="title"><i>Destination <xsl:value-of select="position()" /></i></td></tr>
		<tr><td id="title">UID: <xsl:value-of select="@UID" /></td></tr>
		</table>
		<xsl:for-each select="CaseEntry">
			<hr size="1"/><table>
			<tr><td id="title">Case Entry:</td>
			<td><table>
			<tr><td id="title">Name:</td><td><xsl:value-of select="@Name" /></td></tr>
			<tr><td id="title">Source Path:</td><td><xsl:value-of select="@Path" /></td></tr>
			<xsl:if test="@DestnPath">
			<tr><td id="title">Destination Path:</td><td><xsl:value-of select="@DestnPath" /></td></tr>
			</xsl:if>
			<tr><td id="title">Format:</td><td><xsl:value-of select="@Format"/></td></tr>
			<tr><td id="title">Hash Type:</td><td><xsl:value-of select="@HashType"/></td></tr>
			<xsl:choose>
				<xsl:when test="@PushResult='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@PushResult"/></td></tr></xsl:when>
				<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@PushResult"/></td></tr></xsl:otherwise>
			</xsl:choose>
			</table></td>
			</tr>
			<xsl:for-each select="CaseSegment">
				<tr><td id="title"><i>Segment <xsl:value-of select="position()" /></i></td></tr>
				<tr><td id="title">File Name:</td><td><xsl:value-of select="@Name" /></td></tr>
				<tr><td id="title">Partial Hash:</td><td><xsl:value-of select="@Hash" /></td></tr>
				<xsl:if test="@VHash">
				<tr><td id="title">Verification Hash:</td><td><xsl:value-of select="@VHash"/></td></tr>
				<xsl:choose>
					<xsl:when test="@Result='Pass'"><tr><td id="title">Result:</td><td class="success"><xsl:value-of select="@Result"/></td></tr></xsl:when>
					<xsl:otherwise><tr><td id="title">Result:</td><td class="failed"><xsl:value-of select="@Result"/></td></tr></xsl:otherwise>
				</xsl:choose>
				</xsl:if>
				<tr><td></td><td></td></tr>
			</xsl:for-each>
			</table>
		</xsl:for-each>
		<hr size="2"/>
	</xsl:for-each>
</xsl:template>

<xsl:template match="PartitionInfo">
	<hr size="2"/>
	<table>
		<tr><td id="header">Source Partition Information</td></tr>
		<td><table border="1">
			<tr>
				<td id="title" style="text-align:center">Partition</td>
				<td id="title" style="text-align:center">File System</td>
				<td id="title" style="text-align:center">Start</td>
				<td id="title" style="text-align:center">End</td>
				<td id="title" style="text-align:center">Size</td>
				<td id="title" style="text-align:center">Encryption</td>
				<td id="title" style="text-align:center">Decrypted</td>
				<td id="title" style="text-align:center">Captured</td>
			</tr>
		<xsl:for-each select="Partitions">
			<tr><td style="text-align:center"><xsl:value-of select="@PartNumber" /></td>
				<td ><xsl:value-of select="@FileSystem" /></td>
				<td ><xsl:value-of select="@Start" /></td>		    
				<td ><xsl:value-of select="@End" /></td>
				<td ><xsl:value-of select="@Size" /></td>
				<td ><xsl:value-of select="@Encryption" /></td>
				<td ><xsl:value-of select="@Decrypted" /></td>
				<td ><xsl:value-of select="@Captured" /></td>
			</tr>
		</xsl:for-each>
		</table></td>
	</table><br/>
</xsl:template>

</xsl:stylesheet>
