
ATTACH DATABASE 'XXXX' AS saved;
ATTACH DATABASE '/etc/logicube/cdb/default.db' AS deflt;

INSERT INTO bay_cfg (id) SELECT id FROM saved.bay_cfg WHERE saved.bay_cfg.id NOT IN (SELECT id FROM bay_cfg);
UPDATE bay_cfg SET role = (SELECT role FROM saved.bay_cfg b WHERE b.id=bay_cfg.id); 
UPDATE bay_cfg SET readonly = (SELECT readonly FROM saved.bay_cfg b WHERE b.id=bay_cfg.id); 

UPDATE net_cfg SET type = (SELECT type FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET addr = (SELECT addr FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET mask = (SELECT mask FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET gateway = (SELECT gateway FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET nameservers = (SELECT nameservers FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET domain = (SELECT domain FROM saved.net_cfg b WHERE b.name=net_cfg.name);
UPDATE net_cfg SET mtu = (SELECT mtu FROM saved.net_cfg b WHERE b.name=net_cfg.name);
INSERT INTO net_cfg SELECT * FROM saved.net_cfg WHERE saved.net_cfg.name NOT IN (SELECT name FROM net_cfg); 

UPDATE usr_cfg SET name = (SELECT name FROM saved.usr_cfg b WHERE b.name=usr_cfg.name);
UPDATE usr_cfg SET groups = (SELECT groups FROM saved.usr_cfg b WHERE b.name=usr_cfg.name);
UPDATE usr_cfg SET passwd = (SELECT passwd FROM saved.usr_cfg b WHERE b.name=usr_cfg.name);
INSERT INTO usr_cfg SELECT * FROM saved.usr_cfg WHERE saved.usr_cfg.name NOT IN (SELECT name FROM usr_cfg); 
DELETE FROM usr_cfg WHERE name = 'system';
DELETE FROM usr_cfg WHERE name = 'guest';

INSERT INTO saved.repo_cfg SELECT * FROM repo_cfg WHERE repo_cfg.name NOT IN (SELECT name FROM saved.repo_cfg);
UPDATE repo_cfg SET role = (SELECT role FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET path = (SELECT path FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET user = (SELECT user FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET pass = (SELECT pass FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET locn = (SELECT locn FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET type = (SELECT type FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET bay = (SELECT bay FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
UPDATE repo_cfg SET bay_dpart = (SELECT bay_dpart FROM saved.repo_cfg b WHERE b.name=repo_cfg.name);
INSERT INTO repo_cfg SELECT * FROM saved.repo_cfg WHERE saved.repo_cfg.name NOT IN (SELECT name FROM repo_cfg); 
DELETE FROM repo_cfg WHERE name = 'SAS_S1';
DELETE FROM repo_cfg WHERE name = 'SAS_S2';
DELETE FROM repo_cfg WHERE name = 'SCSI_S1';
DELETE FROM repo_cfg WHERE name = 'FW_S1';
DELETE FROM repo_cfg WHERE name = 'USB_S1';

INSERT INTO saved.exp_cfg SELECT * FROM exp_cfg WHERE exp_cfg.name NOT IN (SELECT name FROM saved.exp_cfg);
UPDATE exp_cfg SET path = (SELECT path FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
UPDATE exp_cfg SET etype = (SELECT etype FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
UPDATE exp_cfg SET stype = (SELECT stype FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
UPDATE exp_cfg SET bay = (SELECT bay FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
UPDATE exp_cfg SET pnum = (SELECT pnum FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
UPDATE exp_cfg SET rdonly = (SELECT rdonly FROM saved.exp_cfg b WHERE b.name=exp_cfg.name);
INSERT INTO exp_cfg SELECT * FROM saved.exp_cfg WHERE saved.exp_cfg.name NOT IN (SELECT name FROM exp_cfg); 
INSERT INTO exp_cfg (name, path, etype, stype, bay, pnum, rdonly)
SELECT 'internal_repo', '/repo/default', 0, 1, -1, -1, 0
WHERE NOT EXISTS (SELECT 1 FROM exp_cfg WHERE name='internal_repo');

INSERT INTO task_cfg (id) SELECT id FROM saved.task_cfg WHERE saved.task_cfg.id NOT IN (SELECT id FROM task_cfg);
UPDATE task_cfg SET reserved = (SELECT reserved FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
-- UPDATE task_cfg SET ign_rd_fail = (SELECT ign_rd_fail FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET conv_mbr = (SELECT conv_mbr FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET master = (SELECT master FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET targets = (SELECT targets FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET operation = (SELECT operation FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET mode = (SELECT mode FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET method = (SELECT method FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET src_img = (SELECT src_img FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET dst_img = (SELECT dst_img FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET repo = (SELECT repo FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET hash_type = (SELECT hash_type FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET verify_hash = (SELECT verify_hash FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET hash_value = (SELECT hash_value FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET resz_perc = (SELECT resz_perc FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET nlba = (SELECT nlba FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET mlba_start = (SELECT mlba_start FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET tlba_start = (SELECT tlba_start FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET raid_en = (SELECT raid_en FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET nwipe = (SELECT nwipe FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET wipe_values = (SELECT wipe_values FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET wipe_filesystem = (SELECT wipe_filesystem FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET format_wipe = (SELECT format_wipe FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET sec_wipe = (SELECT sec_wipe FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET uhpa = (SELECT uhpa FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET udco = (SELECT udco FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET val_mode = (SELECT val_mode FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET case_name = (SELECT case_name FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET examiner_name = (SELECT examiner_name FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET case_number = (SELECT case_number FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET evidence_number = (SELECT evidence_number FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET case_notes = (SELECT case_notes FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET comp_level = (SELECT comp_level FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET seg_size = (SELECT seg_size FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET filter = (SELECT filter FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET repo_list = (SELECT repo_list FROM saved.task_cfg b WHERE b.id=task_cfg.id); 
UPDATE task_cfg SET encrypt = (SELECT encrypt FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET drive_trim = (SELECT drive_trim FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET verify_case_hash = (SELECT verify_case_hash FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET ignore_case = (SELECT ignore_case FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET file_output = (SELECT file_output FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET file_filter_mode = (SELECT file_filter_mode FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET file_root = (SELECT file_root FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET custom_filter = (SELECT custom_filter FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET char_encoding_list = (SELECT char_encoding_list FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET category_list = (SELECT category_list FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET preset_filter_list = (SELECT preset_filter_list FROM saved.task_cfg b WHERE b.id=task_cfg.id);
UPDATE task_cfg SET kw_dictionary = (SELECT kw_dictionary FROM saved.task_cfg b WHERE b.id=task_cfg.id);

UPDATE task_cfg SET clone_uuid=0 WHERE id NOT IN (SELECT id FROM deflt.task_cfg);
UPDATE task_cfg SET conv_mbr=0 WHERE id NOT IN (SELECT id FROM deflt.task_cfg);

UPDATE notify_cfg SET beeper = (SELECT beeper FROM saved.notify_cfg b WHERE b.event=notify_cfg.event);
UPDATE notify_cfg SET act_led = (SELECT act_led FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
UPDATE notify_cfg SET sys_led = (SELECT sys_led FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
UPDATE notify_cfg SET lt_red = (SELECT lt_red FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
UPDATE notify_cfg SET lt_amb = (SELECT lt_amb FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
UPDATE notify_cfg SET lt_grn = (SELECT lt_grn FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
UPDATE notify_cfg SET lt_buz = (SELECT lt_buz FROM saved.notify_cfg b WHERE b.event=notify_cfg.event); 
INSERT INTO notify_cfg SELECT * FROM saved.notify_cfg WHERE saved.notify_cfg.event NOT IN (SELECT event FROM notify_cfg); 

INSERT INTO prntr_cfg SELECT * FROM saved.prntr_cfg WHERE saved.prntr_cfg.name NOT IN (SELECT name FROM prntr_cfg); 

UPDATE drive_security_cfg SET id = (SELECT id FROM saved.drive_security_cfg b WHERE b.id=drive_security_cfg.id);
UPDATE drive_security_cfg SET passwd = (SELECT passwd FROM saved.drive_security_cfg b WHERE b.id=drive_security_cfg.id);

INSERT INTO encryption_cfg (id) SELECT id FROM saved.encryption_cfg WHERE saved.encryption_cfg.id NOT IN (SELECT id FROM encryption_cfg);
UPDATE encryption_cfg SET cipher = (SELECT cipher FROM saved.encryption_cfg b WHERE b.id=encryption_cfg.id);
UPDATE encryption_cfg SET ciphermode = (SELECT ciphermode FROM saved.encryption_cfg b WHERE b.id=encryption_cfg.id);
UPDATE encryption_cfg SET ivgen = (SELECT ivgen FROM saved.encryption_cfg b WHERE b.id=encryption_cfg.id);
UPDATE encryption_cfg SET passwd = (SELECT passwd FROM saved.encryption_cfg b WHERE b.id=encryption_cfg.id);

INSERT INTO task_macro_cfg (id) SELECT id FROM saved.task_macro_cfg WHERE saved.task_macro_cfg.id NOT IN (SELECT id FROM task_macro_cfg);
UPDATE task_macro_cfg SET name = (SELECT name FROM saved.task_macro_cfg b WHERE b.id=task_macro_cfg.id);
UPDATE task_macro_cfg SET tasks = (SELECT tasks FROM saved.task_macro_cfg b WHERE b.id=task_macro_cfg.id);

UPDATE case_info_cfg SET field = (SELECT field FROM saved.case_info_cfg b WHERE b.field=case_info_cfg.field);
UPDATE case_info_cfg SET value = (SELECT value FROM saved.case_info_cfg b WHERE b.field=case_info_cfg.field);

INSERT INTO system_cfg (field) SELECT field FROM saved.system_cfg WHERE saved.system_cfg.field NOT IN (SELECT field FROM system_cfg);
UPDATE system_cfg SET textval = (SELECT textval FROM saved.system_cfg b WHERE b.field=system_cfg.field);
UPDATE system_cfg SET numval = (SELECT numval FROM saved.system_cfg b WHERE b.field=system_cfg.field);
UPDATE system_cfg SET boolval = (SELECT boolval FROM saved.system_cfg b WHERE b.field=system_cfg.field);

DETACH DATABASE saved;
DETACH DATABASE deflt;

