#!/usr/bin/python

import sys
import os
import hashlib
import time
from pprint import pprint

dirs={}
files=[]
list=[]
def add_dir(d):
	if d == '':
		d = 'LogicalEntries'
	if d not in dirs:
		if d != 'LogicalEntries':
			pd = os.path.dirname(d)
			add_dir(pd)
		dirs[d] = 1
		list.append(d)
	elif d in dirs:
		dirs[d] = dirs[d] + 1

def process_list(cap_list, metadata, root_dir, verbose=0):
	with open(cap_list, "r") as file:
		for line in file:
			line=line.rstrip('\n')
			if len(line) == 0:
				continue
			d=os.path.dirname(line)
			add_dir(d)
			list.append(line)

	with open(metadata, "w") as file:
		for d in list:
			if d in dirs and d == 'LogicalEntries':
				dummy = '/tmp/dummy.le.%f' % (time.time())
				os.system('touch %s' % (dummy))
				guid = hashlib.md5(dummy).hexdigest()
				if verbose:
					print("L|%d|%s|0|0|0|0|%s|0000|" % (dirs[d], d, guid))
				file.write("L|%d|%s|0|0|0|0|%s|0000|\n" % (dirs[d], d, guid))
				os.remove(dummy)
			elif d in dirs:
				os.system('touch /tmp/dummy.dir')
				guid = hashlib.md5(d).hexdigest()
				dig_md5 = hashlib.md5(open("/tmp/dummy.dir", "r").read()).hexdigest()
				dig_sha = hashlib.sha1(open("/tmp/dummy.dir", "r").read()).hexdigest()
				atime = os.path.getatime("%s/%s" % (root_dir, d))
				ctime = os.path.getctime("%s/%s" % (root_dir, d))
				mtime = os.path.getmtime("%s/%s" % (root_dir, d))
				if verbose:
                                        print("D|%d|%s|%d|%d|%d|%s|%s|%s|" % (dirs[d], d, ctime, atime, mtime, guid, dig_md5, dig_sha))
				file.write("D|%d|%s|0|%d|%d|%d|%s|%s|%s|\n" % (dirs[d], d, ctime, atime, mtime, guid, dig_md5, dig_sha))
			else:
				if verbose:
                                        print("F|0|%s|" % (d))
				file.write("F|0|%s|\n" % (d))
		if os.path.exists('/tmp/dummy.dir'):
			os.remove('/tmp/dummy.dir')

if __name__ == '__main__':
	root_dir = None
	case_dir = None
	cap_list = None
	metadata = None
	filename = None
	verbose  = 0

	for arg in sys.argv:
		opts = arg.split('=')
		if opts[0] == '-d':
			case_dir = opts[1]
		elif opts[0] == '-f':
			filename = opts[1]
		elif opts[0] == '-r':
			root_dir = opts[1]
		elif opts[0] == '-v':
			verbose = 1

	cap_list = "%s/.%s.cap" % (case_dir, filename)
	metadata = "%s/.%s.md" % (case_dir, filename)
	if cap_list is None or metadata is None or root_dir is None:
		print("Usage: gen_lx01_metadata.py -l=capture_list_path -m=metadata_file_path -r=root_dir_path")
		sys.exit(1)

	process_list(cap_list, metadata, root_dir, verbose)
