/* vim: set filetype=javascript: */
function loadCloneJS() {

	//------------------------------------------------------------
	// SET UP TABS, ADD TASK, DELETE TASK
	//------------------------------------------------------------
	//set up tabs
	$("#clone_tab_0").mousedown(function() { selectTab(0); });
	$("#clone_tab_1").mousedown(function() { selectTab(1); });
	$("#clone_tab_2").mousedown(function() { selectTab(2); });
	$("#clone_tab_3").mousedown(function() { selectTab(3); });
	$("#clone_tab_4").mousedown(function() { selectTab(4); });

	//when user clicks clone_new button, create new tab, up to MAX_TABS tabs
	$("#clone_add_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			TaskReserve('Clone');
		}
	});
	//when user clicks clone_cancel button, show confirmation
	$("#clone_delete_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task();
			var info = "<?= t("DELETE_TASK_N_ARE_YOU_SURE", array("1")); ?>";
			if (t == 2) info = "<?= t("DELETE_TASK_N_ARE_YOU_SURE", array("2")); ?>";
			else if (t == 3) info = "<?= t("DELETE_TASK_N_ARE_YOU_SURE", array("3")); ?>";
			else if (t == 4) info = "<?= t("DELETE_TASK_N_ARE_YOU_SURE", array("4")); ?>";
			else if (t == 5) info = "<?= t("DELETE_TASK_N_ARE_YOU_SURE", array("5")); ?>";
			$('#clone_delete_dialog').html(info);
			$('#clone_delete_dialog').dialog('open');
		}
	});
	//set up clone_cancel confirmation dialog
	$("#clone_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				TaskRelease(tab_tasks[OP_CLONE][current_tab[OP_CLONE]]);
			}
		}
	});


	//------------------------------------------------------------
	// CLONE MODE
	//------------------------------------------------------------
	//when user clicks clone_mode button
	$("#clone_mode_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#clone_mode_dialog').dialog('open');
		}
	});

	//set up clone_mode_dialog
	$("#clone_mode_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_mode_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						var id = $(this).attr("id").replace("clone_mode_", "");	//get ID since some platforms exclude modes
						task_config[t]["CloneMode"] = id;
					}
				});

				var setconfig_params = new Array();
				setconfig_params = {"Task": t};

				if (task_config[t]["CloneMode"] == MODE_F2F) {	//CloneMode = F2F, CaptureMethod = File
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_FILE;
					setconfig_params["CloneMode"] = APICAPTUREMETHODS[task_config[t]["CaptureMethod"]]; //update CaptureMethod for File to File
				}
				else if (task_config[t]["CloneMode"] == MODE_D2I) {	//CloneMode = D2I, CaptureMethod = not File (if File, set to E01)
					/* !! DO NOT REMOVE !! This is to fix the momentary appearance of forensic image capture settings on IT platforms*/
					<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
					if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_FILE) task_config[t]["CaptureMethod"] = CAPTUREMETHOD_E01;
					<?php else: ?>
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_LOGICUBE_IMAGE;
					<?php endif; ?>
					setconfig_params["CloneMode"] = APICAPTUREMETHODS[task_config[t]["CaptureMethod"]];
				}
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				else if (task_config[t]["CloneMode"] == MODE_P2F) {
					if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_DD) {
                        setconfig_params["CloneMode"] = "PartitionToDD";
                    }
					else if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_EX01) {
                        setconfig_params["CloneMode"] = "PartitionToEx01";
                    }
					else { /* default && if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_E01) */
                        setconfig_params["CloneMode"] = "PartitionToE01";
					}
                }
                <?php endif; ?>
				else {
					setconfig_params["CloneMode"] = APIMODES[task_config[t]["CloneMode"]];
					<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
					if (task_config[t]["CloneMode"] == MODE_I2D) {
						task_config["CloneMethod"] = METHOD_FXIMAGE;
						setconfig_params["CloneMethod"] = APIMETHODS[task_config["CloneMethod"]];
					}
					/* !! DO NOT REMOVE !! This is to fix the momentary appearance of forensic image capture settings on IT platforms*/
					<?php else: ?>
					if (task_config[t]["CloneMode"] == MODE_I2D) {
						task_config[t]["CaptureMethod"] = CAPTUREMETHOD_LOGICUBE_IMAGE;
						setconfig_params["CloneMethod"] = APIMETHODS[task_config["CloneMethod"]];
					}
					<?php endif; ?>
				}

				updateButtons("mode");
				updateModals("file_image");	//capture method depends on mode
				updateButtons("settings");	//settings button depends on mode
                updateHashSelect();
				$(this).dialog('close');

				//clear out Master/Target and Master/Target Image when not applicable to current mode
				if (task_config[t]["CloneMode"] == MODE_D2D) {
					setconfig_params["SourceImagePath"] = "";
					setconfig_params["DestinationImagePath"] = "";
					//if Forensic mode, set clone method to Mirror
					<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
					task_config["CloneMethod"] = METHOD_MIRROR;
					setconfig_params["CloneMethod"] = APIMETHODS[task_config["CloneMethod"]];
					updateButtons("settings");
					<?php endif; ?>
				}
				else if (task_config[t]["CloneMode"] == MODE_D2I) {
					setconfig_params["SourceImagePath"] = "";
					setconfig_params["Targets"] = new Array();
				}
				else if (task_config[t]["CloneMode"] == MODE_F2F) {
					setconfig_params["Master"] = "";
					setconfig_params["Targets"] = new Array();
				}
				else if (task_config[t]["CloneMode"] == MODE_I2D) {
					setconfig_params["Master"] = "";
					setconfig_params["DestinationImagePath"] = "";
				}
				TaskSetConfiguration(setconfig_params);
			}
		},
		close: function(event, ui) {
			updateModals("mode");
			updateModals("settings");	 //depends on mode
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_mode_select .select-opt").mousedown(function() {
		$("#clone_mode_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});



	//------------------------------------------------------------
	// CLONE MASTER
	//------------------------------------------------------------
	//when user clicks clone_master button, open modal dialog with Master Drive options
	$("#clone_master_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task();
			if (t == -1) return true;

			if (task_config[t]["CloneMode"] == MODE_I2D) { //Image to File
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                $('#push_filesystem_dialog').dialog('open');
                <?php else: ?>
                $('#clone_master_repo_dialog').dialog('open');
                <?php endif; ?>
			}
			else if (task_config[t]["CloneMode"] == MODE_F2F) {	//File to File
				$('#clone_master_source_dialog').dialog('open');
			}
			else {
				$('#clone_master_dialog').dialog('open');
			}
		}
	});

	//set up clone_master_dialog
	$("#clone_master_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;
    
				task_config[t]["Master"] = "";
				$("#clone_master_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        task_config[t]["Master"] = $(this).find(".col1").text();
                    }
				});

				updateButtons("master");

				//send new Master to server
				var setconfig_params = {"Task": t, "Master": task_config[t]["Master"]};

				//update CleverResizePercentages based on Master
				var master = task_config[t]["Master"];
				if (master == "") {
					task_config[t]["CleverResizePercentages"] = new Array();
				}
				else {
					//when selecting a new Master, retain previous Master's CleverResizePercentage values,
					//and fill the rest with 0, if necessary
					var resize = task_config[t]["CleverResizePercentages"];
					var master_drive = driveWithBay(master);
					var new_resize = new Array();
					if (master_drive != -1) {	//make sure drive is still connected
						num_partitions = master_drive.Partitions.length;
						for (var i=0; i<num_partitions; i++) {
							if (i<resize.length) new_resize[i] = resize[i];
							else new_resize[i] = 0;
						}
					}
					task_config[t]["CleverResizePercentages"] = new_resize;
				}
				updateModals("clever");
				setconfig_params["CleverResizePercentages"] = task_config[t]["CleverResizePercentages"];

				//set MirrorRAIDEnable based on Master
				if (master != "") {
					var master_drive = driveWithBay(master);
					if (master_drive != -1)	//make sure drive is still connected
						raidenable = master_drive.RAIDHeaderDetected;

					//update Mirror GUI
					task_config[t]["MirrorRAIDEnable"] = raidenable;
					setconfig_params["MirrorRAIDEnable"] = raidenable;
				}
				TaskSetConfiguration(setconfig_params);
				updateModals("mirror");
				updateModals("settings");		//need to update Clever/Mirror block
				updateButtons("settings");		//need to update Settings button

                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                //open Select Partition dialog
                if (task_config[t]["CloneMode"] == MODE_P2F && master != "") {
                    updatePartitionModal(master);
				    $(this).data('opening_another_dialog', true).dialog('close');
                    $("#clone_master_partition_dialog").dialog('open');
                    return;
                }
                <?php endif; ?>

				$(this).dialog('close');	//do this here instead of sooner so Settings button is updated before dialog closes
			}
		},
		close: function(event, ui) {
			updateModals("master");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	//if the one selected is clicked, unselect
    $("#clone_master_select").unbind("mousedown");
	$("#clone_master_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            //more info buttons
            var bay = $(this).parent().find(".col1").text();
            updateDriveDetails(bay);
            $("#clone_drive_details_dialog").dialog('open');
            $("#clone_drive_details_dialog").parent().css("z-index", "10010");
        }
        else {
            var cur_bay = $(this).parent().find(".col1").html();
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled or if clicking "info" button
            }
            else {
                var sel_bay = "";
                $("#clone_master_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_bay = $(this).find(".col1").html();
                        $(this).toggleClass("ui-selected");
                        var classes = $(this).find(".col3").attr("class");
                        if (classes != "col3") {
                            var togglebackval = classes.substr(classes.lastIndexOf(" ")).replace('/_/g', " ");	//Clone 1 / Assigned / etc.
                            $(this).find(".col3").html(togglebackval);
                        }
                        else $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
                    }
                });

                if (cur_bay != sel_bay) {
                    $(this).parent().toggleClass("ui-selected");
                    $(this).parent().find(".col3").html("<?= t("SELECTED"); ?>");
                }
            }
        }
	});

	$("#clone_drive_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			$("#mcs_container2").mCustomScrollbar("scrollTo", "top");
		}
	});


	//set up clone_master_repo_dialog
	$("#clone_master_repo_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				var new_repo = "";
				if (t == -1) return true;

				$("#clone_master_repo_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) new_repo = repositories[i]["Name"];
				});

				if (current_op == OP_CLONE) {
					$(this).dialog('close');

					//if a Repository has been selected, open Select Image dialog
					if (new_repo != "") {
						var setconfig_params = {"Task": t};
						 if (new_repo != task_config[t]["Repository"]) {		//if a new Repository is selected, clear image paths
							setconfig_params["SourceImagePath"] = "";
							setconfig_params["DestinationImagePath"] = "";
						 }

						RepositoryListContents(new_repo);	//dialog opens after info is returned from API
                        task_config[t]["Repository"] = new_repo;
						setconfig_params["Repository"] = new_repo;	//send new Repository to API
						TaskSetConfiguration(setconfig_params);
					}
					else {
						var setconfig_params = {"Task": t};
						task_config[t]["Repository"] = "";
						task_config[t]["SourceImagePath"] = "";
						setconfig_params["Repository"] = "";
						setconfig_params["SourceImagePath"] = "";
						TaskSetConfiguration(setconfig_params);
					}
				}
				else if (current_op == OP_PUSH) {
					task_config[t]["Repository"] = new_repo;
					updateButtons("master");
					$(this).dialog('close');
					var setconfig_params = {"Task": t};
					setconfig_params["Repository"] = new_repo;
					TaskSetConfiguration(setconfig_params);
                    if (new_repo != "") RepositoryListDirs(new_repo);
				}
			}
		},
		close: function(event, ui) {
			updateModals("master_repo");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_master_repo_select").unbind("mousedown");
	$("#clone_master_repo_select").on("mousedown", ".select-opt", function() {
		var cur_repo = $(this).find(".col1").html();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var sel_repo = "";
			$("#clone_master_repo_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_repo = $(this).find(".col1").html();
					$(this).toggleClass("ui-selected");
				}
			});

			if (cur_repo != sel_repo) {
				$(this).toggleClass("ui-selected");
			}
		}
	});

	//set up clone_master_source_dialog
	$("#clone_master_source_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["Master"] = "";
				task_config[t]["Repository"] = "";
				$("#clone_master_source_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        if ($(this).hasClass("source-type-bay")) {      //bay
							task_config[t]["Master"] = $(this).find(".col1").text();
						}
						else {
							task_config[t]["Repository"] = $(this).find(".col1").text();
						}
						return false;
					}
				});

				updateButtons("master");
				$(this).dialog('close');

				var setconfig_params = {"Task": t};
				setconfig_params["Master"] = task_config[t]["Master"];
				setconfig_params["Repository"] = task_config[t]["Repository"];
				TaskSetConfiguration(setconfig_params);
			}
		},
		close: function(event, ui) {
			updateModals("master_source");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_master_source_select").unbind("mousedown");
    $("#clone_master_source_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            var is_bay = $(this).parent().hasClass("source-type-bay");
            if (is_bay) {
                var bay = $(this).parent().find(".col1").text();
                updateDriveDetails(bay);
                $("#clone_drive_details_dialog").dialog('open');
                $("#clone_drive_details_dialog").parent().css("z-index", "10010");
            }
            else {
                var repo = $(this).parent().find(".col1").text();
                updateRepoDetails(repo);
                $("#clone_repo_details_dialog").dialog('open')
                $("#clone_repo_details_dialog").parent().css("z-index", "10010");
            }
        }
        else {
            var cur_source = $(this).parent().find(".col1").text();
            var cur_is_bay = $(this).parent().hasClass("source-type-bay");
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled or if clicking "info" button
            }
            else {
                var sel_source = "";
                var sel_is_bay = true;
                $("#clone_master_source_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_source = $(this).find(".col1").text();
                        sel_is_bay = $(this).hasClass("source-type-bay");
                        $(this).toggleClass("ui-selected");
                        if (sel_is_bay) {	//bay
                            var classes = $(this).find(".col3").attr("class");
                            if (classes != "col3") {
                                var togglebackval = classes.substr(classes.lastIndexOf(" ")).replace('/_/g', " ");	//Clone 1 / Assigned / etc.
                                $(this).find(".col3").html(togglebackval);
                            }
                            else $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
                        }
                    }
                });

                if ((cur_source != sel_source) || (cur_is_bay != sel_is_bay)) {	//handling switching between same name bay and repo
                    $(this).parent().toggleClass("ui-selected");
                    if (cur_is_bay) {	//bay
                        $(this).parent().find(".col3").html("<?= t("SELECTED"); ?>");
                    }
                }
            }
        }
    });

	//set up clone_repo_details_dialog
	$("#clone_repo_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});

	//set up clone_master_image_dialog
	$("#clone_master_image_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_master_image_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["SourceImagePath"] = images[i]["Path"];
				});

				updateButtons("master");
				$(this).dialog('close');

				//send new Master Image to server
				TaskSetConfiguration({"Task": t, "SourceImagePath": task_config[t]["SourceImagePath"]});
				//get Image settings, update Settings on callback
				ImageGetConfiguration(t, task_config[t]["Repository"], task_config[t]["SourceImagePath"]);
			}
		},
		close: function(event, ui) {
			updateModals("master_image");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_master_image_select").unbind("mousedown");
	$("#clone_master_image_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) { //more info buttons
            var i = $("#clone_master_image_select .select-more").index(this);
            updateImageDetails(i);
            $('#clone_image_details_dialog').dialog('open');
            $("#clone_image_details_dialog").parent().css("z-index", "10010");
        }
        else {
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled or if clicking "info" button
            }
            else {
                $("#clone_master_image_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        $(this).toggleClass("ui-selected");
                    }
                });

                $(this).parent().toggleClass("ui-selected");
            }
        }
	});

	//set up clone_image_details_dialog dialog
	$("#clone_image_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});

    <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
	//set up clone_master_partition_dialog
	$("#clone_master_partition_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_master_partition_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        task_config[t]["Master"] = $(this).find(".col1 .bay").text();
                        task_config[t]["SourcePartitionNumber"] = $(this).find(".col1 .part_num").text();
                    }
				});

				updateButtons("master");
                $(this).data('partition_selected', true);
				$(this).dialog('close');

				//send new Master and Partition to server
				TaskSetConfiguration({"Task": t, "Master": task_config[t]["Master"], "SourcePartitionNumber": task_config[t]["SourcePartitionNumber"]});
			}
		},
		close: function(event, ui) {
            //if closing X was clicked, reset this modal and open Select Master
            //if user selected partition and clicked OK, then just close this modal
			if ($(this).data('partition_selected') !== true) {
                updateModals("master_partition");
                $('#clone_master_dialog').dialog('open');
            }
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_master_partition_select").unbind("mousedown");
	$("#clone_master_partition_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {  //more info buttons
            var bay = $(this).parent().find(".col1 .bay").text();
            var part_num = $(this).parent().find(".col1 .part_num").text();
            updatePartitionDetails(bay, part_num);
            $('#clone_partition_details_dialog').dialog('open');
            $("#clone_partition_details_dialog").parent().css("z-index", "10010");
        }
        else if ($(this).hasClass("part-locked")) {  //locked lock buttons
            var bay = $(this).parent().find(".col1 .bay").text();
            var part_num = $(this).parent().find(".col1 .part_num").text();
            $('#clone_partition_decrypt_bay').val(bay);
            $('#clone_partition_decrypt_part_num').val(part_num);
            $('#partition_decrypt_val').val('');
            $('#clone_partition_decrypt_keyboard_dialog').dialog('open');
            $("#clone_partition_decrypt_keyboard_dialog").parent().css("z-index", "10010");
        }
        else {
            var cur_part = $(this).parent().find(".col1").html();
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled or if clicking "info" button
            }
            else {
                var sel_part = "";
                $("#clone_master_partition_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_part = $(this).find(".col1").html();
                        $(this).toggleClass("ui-selected");
                        $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
                    }
                });

                if (cur_part != sel_part) {
                    $(this).parent().toggleClass("ui-selected");
                    $(this).parent().find(".col3").html("<?= t("SELECTED"); ?>");
                }
            }
        }
	});

	//set up clone_partition_decrypt_keyboard_dialog dialog
	$("#clone_partition_decrypt_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                var pw = $('#partition_decrypt_val').val().trim();
                if (pw != "") {
                    var bay = $('#clone_partition_decrypt_bay').val();
                    var part_num = $('#clone_partition_decrypt_part_num').val();
                    var enc_type = 'Bitlocker';

                    var auth_type = 0;
                    $("#clone_partition_auth_select .select-opt").each(function(i) {
                        if ($(this).hasClass("ui-selected")) auth_type = i;
                    });

                    UnlockPartition({"Bay": bay, "PartitionNumber": part_num, "EncryptionType": enc_type, "Cipher": '', "CipherMode": '', "IVGen": '', "AuthenticationType": APIAUTHTYPES[auth_type], "Password": pw});
                }
                else {
                    $(this).dialog('close');
                }
			}
		},
		close: function(event, ui) {
			resetKeyboard("partition_decrypt");
            $("#clone_partition_decrypt_error").text("");
			$('#clone_master_partition_dialog').dialog('open');
		}
	});

    // clear partition decrypt error if user changes input
    var prev_val = "";
    $("#partition_decrypt_val").on('change keyup paste mouseup', function() {
        if (prev_val != $("#partition_decrypt_val").val()) {
            if ($("#clone_partition_decrypt_error").text() != "") $("#clone_partition_decrypt_error").text("");
        }
        prev_val = $("#partition_decrypt_val").val();
    });
    $("#partition_decrypt_keyboard").on('click', 'div', function() {
        if (prev_val != $("#partition_decrypt_val").val()) {
            if ($("#clone_partition_decrypt_error").text() != "") $("#clone_partition_decrypt_error").text("");
        }
        prev_val = $("#partition_decrypt_val").val();
    });
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_partition_auth_select .select-opt").mousedown(function() {
		$("#clone_partition_auth_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//set up clone_partition_details_dialog dialog
	$("#clone_partition_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});
    <?php endif; ?>


	//------------------------------------------------------------
	// CLONE SETTINGS
	//------------------------------------------------------------
	//when user clicks clone_settings button, open modal dialog with Settings options
	$("#clone_settings_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			updateButtons("settings");
			$('#clone_settings_dialog').dialog('open');
		}
	});

	//set up clone_settings_dialog
	$("#clone_settings_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				updateButtons("settings");
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updateModals("settings");	//only reset modals when Settings X is clicked (not when it closes because HPA, Verify, etc. dialogs are opened)
			}
		}
	});


	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_hpa_select .select-opt").mousedown(function() {
		$("#clone_hpa_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_dco_select .select-opt").mousedown(function() {
		$("#clone_dco_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_drive_trim_select .select-opt").mousedown(function() {
		$("#clone_drive_trim_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_error_handling_select .select-opt").mousedown(function() {
		$("#clone_error_handling_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");

        //if Error Handling = ABORT, disable Error Granularity
        if ($(this).attr("id") == "clone_error_handling_1") {
            disableObj($("#clone_error_granularity_0"));
            disableObj($("#clone_error_granularity_1"));
            disableObj($("#clone_error_granularity_2"));
            disableObj($("#clone_error_granularity_3"));
        }
        else {
            enableObj($("#clone_error_granularity_0"));
            enableObj($("#clone_error_granularity_1"));
            enableObj($("#clone_error_granularity_2"));
            enableObj($("#clone_error_granularity_3"));
        }
	});

    //unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_error_granularity_select .select-opt").mousedown(function() {
        if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            $("#clone_error_granularity_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
            });
            $(this).toggleClass("ui-selected");
        }
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_hash_select .select-opt").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
            $("#clone_hash_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
            });
            $(this).toggleClass("ui-selected");
        }
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_verif_select .select-opt").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$("#clone_verif_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
			});
			$(this).toggleClass("ui-selected");
		}
	});

	//Case Info
	$("#clone_case_info_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_case_info_dialog').dialog('open');
		}
	});
	//set up clone_case_info_dialog
	$("#clone_case_info_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				updateCaseInfoBlock();
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				if (current_op == OP_CLONE) {
					updateCaseInfoBlock();
					$('#clone_settings_dialog').dialog('open');	//only open when Case Info X is clicked (not when it closes because Examiner, Case ID, etc. are opened)
				}
				else if (current_op == OP_WIPE) {
					updateButtons("wipe_case_info");
				}
				else if (current_op == OP_HASH) {
					updateButtons("hash_case_info");
				}
				else if (current_op == OP_PUSH) {
					updateCaseInfoBlock();
					$('#push_settings_dialog').dialog('open');	//only open when Case Info X is clicked (not when it closes because Examiner, Case ID, etc. are opened)
				}
			}
		}
	});

	$("#clone_case_name_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').data('opening_another_dialog', true).dialog('close');
			$("#clone_case_info_keyboard_dialog").dialog({ title: "<?= t("CASE_FILE_NAME"); ?>" });
			$("#clone_case_info_title").html("<?= t("CASE_FILE_NAME"); ?>");
			var t = current_task();
            $("#case_info_val_textarea").hide();
            $("#case_info_val").show();
			if (t >= 0) $("#case_info_val").val(task_config[t]['CaseName']);
			$('#clone_case_info_keyboard_dialog').dialog('open');
			//$('#case_info_val').focus();
		}
	});
	$("#clone_examiner_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').data('opening_another_dialog', true).dialog('close');
			$("#clone_case_info_keyboard_dialog").dialog({ title: "<?= t("EXAMINER"); ?>" });
			$("#clone_case_info_title").html("<?= t("EXAMINER"); ?>");
			var t = current_task();
            $("#case_info_val_textarea").hide();
            $("#case_info_val").show();
			if (t >= 0) $("#case_info_val").val(task_config[t]['ExaminerName']);
			$('#clone_case_info_keyboard_dialog').dialog('open');
			//$('#case_info_val').focus();
		}
	});
	$("#clone_case_id_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').data('opening_another_dialog', true).dialog('close');
			$("#clone_case_info_keyboard_dialog").dialog({ title: "<?= t("CASE_ID"); ?>" });
			$("#clone_case_info_title").html("<?= t("CASE_ID"); ?>");
			var t = current_task();
            $("#case_info_val_textarea").hide();
            $("#case_info_val").show();
			if (t >= 0) $("#case_info_val").val(task_config[t]['CaseNumber']);
			$('#clone_case_info_keyboard_dialog').dialog('open');
			//$('#case_info_val').focus();
		}
	});
	$("#clone_evidence_id_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').data('opening_another_dialog', true).dialog('close');
			$("#clone_case_info_keyboard_dialog").dialog({ title: "<?= t("EVIDENCE_NUMBER"); ?>" });
			$("#clone_case_info_title").html("<?= t("EVIDENCE_NUMBER"); ?>");
			var t = current_task();
            $("#case_info_val_textarea").hide();
            $("#case_info_val").show();
			if (t >= 0) $("#case_info_val").val(task_config[t]['EvidenceNumber']);
			$('#clone_case_info_keyboard_dialog').dialog('open');
			//$('#case_info_val').focus();
		}
	});
	$("#clone_case_notes_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').data('opening_another_dialog', true).dialog('close');
			$("#clone_case_info_keyboard_dialog").dialog({ title: "<?= t("CASE_NOTES"); ?>" });
			$("#clone_case_info_title").html("<?= t("CASE_NOTES"); ?>");
			var t = current_task();
            $("#case_info_val").hide();
            $("#case_info_val_textarea").show();
			if (t >= 0) $("#case_info_val_textarea").val(task_config[t]['CaseNotes']);
			$('#clone_case_info_keyboard_dialog').dialog('open');
			//$('#case_info_val').focus();
		}
	});
	//set up clone_case_info_keyboard_dialog
	$("#clone_case_info_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				var key = "ExaminerName";
				if (t == -1) return true;

				if ($("#clone_case_info_title").html() == "<?= t("CASE_FILE_NAME"); ?>") key = "CaseName";
				else if ($("#clone_case_info_title").html() == "<?= t("CASE_ID"); ?>") key = "CaseNumber";
				else if ($("#clone_case_info_title").html() == "<?= t("EVIDENCE_NUMBER"); ?>") key = "EvidenceNumber";
				else if ($("#clone_case_info_title").html() == "<?= t("CASE_NOTES"); ?>") key = "CaseNotes";
                if (key == "CaseNotes") task_config[t][key] = $("#case_info_val_textarea").val();
                else task_config[t][key] = $("#case_info_val").val();
				updateModals("case_info");
				$(this).dialog('close');
				var setconfig_params = {};
				setconfig_params["Task"] = t;
				setconfig_params[key] = task_config[t][key];
				TaskSetConfiguration(setconfig_params);
			}
		},
		close: function(event, ui) {
			resetKeyboard("case_info");
			$('#clone_case_info_dialog').dialog('open');
		}
	});

	//Clone Method Settings
	$("#clone_method_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            $('#clone_mirror_dialog').dialog('open');
            <?php else: ?>
            $('#clone_method_dialog').dialog('open');
            <?php endif; ?>
		}
	});

	//set up clone_method_dialog
	$("#clone_method_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			updateModals("clone_method");
			if ($(this).data('opening_another_dialog') !== true) {
				$('#clone_settings_dialog').dialog('open');	//only open when X is clicked (not when it closes because other modals are opened)
			}
		}
	});

	//Clone Mode
	$("#clone_method_imgmode_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#clone_method_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_imgmode_dialog').dialog('open');
		}
	});
	//Clone Settings
	$("#clone_method_imgsettings_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task();
			if (t == -1) return true;

			$('#clone_method_dialog').data('opening_another_dialog', true).dialog('close');
			if (task_config[t]["CloneMethod"] == METHOD_CLEVER) $('#clone_clever_dialog').dialog('open');
			else $('#clone_mirror_dialog').dialog('open');
		}
	});

	//set up clone_clever_dialog
	$("#clone_clever_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				//update Clever Resize values
				var t = current_task();
				if (t == -1) return true;
				var master = task_config[t]["Master"];

				task_config[t]["CleverResizePercentages"] = new Array();
				var i = 0;
				while ($("#clone_clever_pct" + (i+1) + "_slider").length > 0) {
					task_config[t]["CleverResizePercentages"][i] = $("#clone_clever_pct" + (i+1) + "_slider").slider("value");
					i++;
				}
				updateCloneMethodBlock();
				$(this).dialog('close');

				updateButtons("settings");		//need to update Settings button
				TaskSetConfiguration({"Task": t, "CleverResizePercentages": task_config[t]["CleverResizePercentages"]});
			}
		},
		close: function(event, ui) {
			updateModals("clever");
			if ($(this).data('opened_by_file_image') === true) $('#clone_file_image_dialog').dialog('open');
			else $('#clone_method_dialog').dialog('open');
			$(this).data('opened_by_file_image', false);
		}
	});

	//Output Format
	$("#clone_output_format_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_output_format_dialog').dialog('open');
		}
	});

	//set up clone_output_format_dialog
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_output_format_select .select-opt").mousedown(function() {
		$("#clone_output_format_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});
	$("#clone_output_format_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_output_format_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["FileOutputFormat"] = i;
				});

				updateOutputFormatBlock();
				$(this).dialog('close');
				$('#clone_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "FileOutputFormat": APIOUTPUTFORMATS[task_config[t]["FileOutputFormat"]]});
			}
		}
	});

	//Root Directory
	$("#clone_root_dir_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			var t = current_task();
			if (t >= 0) $("#root_dir_val").val(task_config[t]['FileSearchRoot']);
			$('#clone_root_dir_keyboard_dialog').dialog('open');
		}
	});
	//set up clone_root_dir_keyboard_dialog
	$("#clone_root_dir_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["FileSearchRoot"] = $("#root_dir_val").val();
				updateRootDirBlock();
				$(this).dialog('close');
				TaskSetConfiguration({"Task": t, "FileSearchRoot": task_config[t]["FileSearchRoot"]});
			}
		},
		close: function(event, ui) {
			resetKeyboard("root_dir");
            $('#clone_settings_dialog').dialog('open');
		}
	});

    $("#clone_root_dir_browse").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
            var src = "";
            var t = current_task();
            if (t == -1) return;

            src = task_config[t]["Master"];
            if (src == "")
                src = task_config[t]["Repository"];
            if (src == "")
                return;
			$('#clone_root_dir_keyboard_dialog').data('opening_another_dialog', true).dialog('close');
            $('#root_dir_browser_dialog .file_browser_dir_content iframe').attr('src', '/bays/' + src + '/');
			$('#root_dir_browser_dialog').dialog('open');
		}
	});
	//set up clone_root_dir_keyboard_dialog
	$("#root_dir_browser_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
                var root_dir = $('#root_dir_browser_dialog .file_browser_dir_content iframe').contents().find('li.path').text();
                $("#root_dir_val").val(root_dir);
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
            $('#clone_root_dir_keyboard_dialog').dialog('open');
		}
	});

    //Path Filter
	$("#clone_path_filter_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_filter_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_path_filter_dialog').dialog('open');
		}
	});

	//set up clone_path_filter_dialog
	$("#clone_path_filter_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				updatePathFilterBlock();
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updatePathFilterBlock();
                $('#clone_filter_settings_dialog').dialog('open');
			}
		}
	});

    //Preset Filters
	$("#clone_preset_filter_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_path_filter_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_preset_filter_dialog').dialog('open');
		}
	});

	//set up clone_preset_filter_dialog
	$("#clone_preset_filter_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

                var presets = new Array();
                for (var i=0; i<APIPRESETFILTERS.length; i++) {
                    if ($("#clone_preset_filter_" + i + "_0").hasClass("ui-selected")) {    //0 button = Yes
                        presets.push(APIPRESETFILTERS[i]);
                        task_config[t]["PresetFilterList"][i] = 1;
                    }
                    else {
                        task_config[t]["PresetFilterList"][i] = 0;
                    }
                }
                updatePresetFilterBlock();
				$(this).dialog('close');
                TaskSetConfiguration({"Task": t, "PresetFilterList": presets});
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updatePresetFilterBlock();
                $('#clone_path_filter_dialog').dialog('open');
			}
		}
	});

    //Custom Filter
	$("#clone_custom_filter_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_path_filter_dialog').data('opening_another_dialog', true).dialog('close');
			var t = current_task();
			if (t >= 0) $("#custom_filter_val").val(task_config[t]['FileCustomFilter']);
			$('#clone_custom_filter_keyboard_dialog').dialog('open');
		}
	});

	//set up clone_custom_filter_keyboard_dialog
	$("#clone_custom_filter_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["FileCustomFilter"] = $("#custom_filter_val").val();
                updateCustomFilterBlock();
				$(this).dialog('close');
                TaskSetConfiguration({"Task": t, "FileCustomFilter": task_config[t]["FileCustomFilter"]});
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updateCustomFilterBlock();
                $('#clone_path_filter_dialog').dialog('open');
			}
		}
	});

    //Signature-Based File Categories
	$("#clone_file_cat_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_filter_settings_dialog').data('opening_another_dialog', true).dialog('close');
			var t = current_task();
			if (t != -1){
				for (var i=0; i<APIFILECATS.length; i++) {
					if (task_config[t]["FileCategoryList"][i]) $("#clone_file_cat_" + i + "_0").addClass("ui-selected");
				}
			}
			$('#clone_file_cat_dialog').dialog('open');
		}
	});

	//set up clone_file_cat_dialog
	$("#clone_file_cat_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

                var filecats = new Array();
                for (var i=0; i<APIFILECATS.length; i++) {
                    if ($("#clone_file_cat_" + i + "_0").hasClass("ui-selected")) {    //0 button = Yes
                        filecats.push(APIFILECATS[i]);
                        task_config[t]["FileCategoryList"][i] = 1;
                    }
                    else {
                        task_config[t]["FileCategoryList"][i] = 0;
                    }
                }
				updateFileCatBlock();
				$(this).dialog('close');
                TaskSetConfiguration({"Task": t, "FileCategoryList": filecats});
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
                $('#clone_filter_settings_dialog').dialog('open');
			}
		}
	});


    //Keywords
	$("#clone_keywords_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_filter_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_keywords_settings_dialog').dialog('open');
		}
	});

	//set up clone_keywords_settings_dialog
	$("#clone_keywords_settings_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_ignore_case_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["IgnoreCase"] = (i == 0 ? true : false);	//0 button = Yes, 1 button = No
				});
				$("#clone_char_encoding_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["FileCharEncodingList"] = (i == 0 ? true : false);	//0 button = Yes, 1 button = No
				});

                updateKeywordsBlock();
				$(this).dialog('close');
				TaskSetConfiguration({"Task": t, "FileCharEncodingList": (task_config[t]["FileCharEncodingList"] ? ["CharEncodingUtf8", "CharEncodingUtf16"] : ["CharEncodingUtf8"]), "IgnoreCase": task_config[t]["IgnoreCase"]});
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
                $('#clone_filter_settings_dialog').dialog('open');
			}
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_ignore_case_select .select-opt").mousedown(function() {
		$("#clone_ignore_case_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_char_encoding_select .select-opt").mousedown(function() {
		$("#clone_char_encoding_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	$("#clone_search_keywords_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_keywords_settings_dialog').data('opening_another_dialog', true).dialog('close');
			var t = current_task();
			if (t >= 0) $("#keywords_val").val(task_config[t]['FileKwDictionary']);
			$('#clone_keywords_keyboard_dialog').dialog('open');
		}
	});

	//set up clone_keywords_keyboard_dialog
	$("#clone_keywords_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["FileKwDictionary"] = $("#keywords_val").val();
				updateSearchKeywordsBlock();
				$(this).dialog('close');
				TaskSetConfiguration({"Task": t, "FileKwDictionary": task_config[t]["FileKwDictionary"]});
			}
		},
		close: function(event, ui) {
			resetKeyboard("keywords");
			$('#clone_keywords_settings_dialog').dialog('open');
		}
	});


    //File Image Settings
	$("#clone_file_image_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_file_image_dialog').dialog('open');
		}
	});

	//set up clone_file_image_dialog
	$("#clone_file_image_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				//update Clever Resize values
				var t = current_task();
				if (t == -1) return true;

				$("#clone_capture_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						task_config[t]["CaptureMethod"] = CAPTUREMETHODS.indexOf($(this).text());
					}
				});
                var mode = APICAPTUREMETHODS[task_config[t]["CaptureMethod"]];
                    
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                if (task_config[t]["CloneMode"] == MODE_P2F) {
                    if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_DD) mode = "PartitionToDD";
                    else if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_E01) mode = "PartitionToE01";
                    else if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_EX01) mode = "PartitionToEx01";
                }
                <?php endif; ?>


				updateFileImageBlock();
				updateTargetRepositoryModal();	//Capture Method determines whether to use Repository or RepositoryList
				updateButtons("mode");	//to display Image File or Target/Destination on main button
				updateButtons("settings");	//settings depends on mode
				updateHashSelect();
				$(this).dialog('close');

				TaskSetConfiguration({"Task": t, "CloneMode": mode});
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updateFileImageBlock();
				updateButtons("settings");	//settings depends on mode
				updateModals("file_image");	//capture method depends on mode
				$('#clone_settings_dialog').dialog('open');	//only open when X is clicked (not when it closes because other modals are opened)
			}
		}
	});

	//File Image Capture Mode select
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_capture_select .select-opt").mousedown(function() {
		$("#clone_capture_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");

		//show/hide blocks depending on capture method
		var capturemethod = CAPTUREMETHODS.indexOf($(this).text());
		if (capturemethod == CAPTUREMETHOD_DD) {
			showObj($("#clone_segment_block"));
			hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
		}
		else if (capturemethod == CAPTUREMETHOD_E01) {
			//Segment Size Whole Disk not allowed for E01 or Ex01
			var t = current_task();
			if (t == -1) return true;

			if (task_config[t]["SegmentSize"] == SEGMENTSIZE_WHOLEDISK) task_config[t]["SegmentSize"] = SEGMENTSIZE_4GB;
			updateCaptureBlocks();
			$("#clone_segment_1").mousedown();
			TaskSetConfiguration({"Task": t, "SegmentSize": APISEGMENTSIZES[task_config[t]["SegmentSize"]]});

			showObj($("#clone_segment_block")); showObj($("#clone_compression_block"));
			hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
		}
		else if (capturemethod == CAPTUREMETHOD_EX01) {
			//Segment Size Whole Disk not allowed for E01 or Ex01
			var t = current_task();
			if (t == -1) return true;

			if (task_config[t]["SegmentSize"] == SEGMENTSIZE_WHOLEDISK) task_config[t]["SegmentSize"] = SEGMENTSIZE_4GB;
			updateCaptureBlocks();
			$("#clone_segment_1").mousedown();
			TaskSetConfiguration({"Task": t, "SegmentSize": APISEGMENTSIZES[task_config[t]["SegmentSize"]]});

			showObj($("#clone_segment_block")); showObj($("#clone_compression_block"));
			hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
		}
		else if (capturemethod == CAPTUREMETHOD_FILE) {
			showObj($("#clone_filefilter_block"));
			hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
		}
		else if (capturemethod == CAPTUREMETHOD_LOGICUBE_IMAGE) {
			showObj($("#clone_imgmode_block"));
			hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block"));

            //hide imgsettings if clone mode is DriveToImage and Clever
            var t = current_task();
			if (t == -1) return true;

            if (task_config[t]["CloneMode"] == MODE_D2I && task_config[t]["CloneMethod"] == METHOD_CLEVER) hideObj($("#clone_imgsettings_block"));
            else showObj($("#clone_imgsettings_block"));
        }
		else {
			hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
		}

	});

	//Segment Size
	$("#clone_segment_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_file_image_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_segment_dialog').dialog('open');
		}
	});
	//set up clone_segment_dialog
	$("#clone_segment_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_segment_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["SegmentSize"] = i
				});

				updateCaptureBlocks();
				$(this).dialog('close');
				$('#clone_file_image_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "SegmentSize": APISEGMENTSIZES[task_config[t]["SegmentSize"]]});
			}
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_segment_select .select-opt").mousedown(function() {
		$("#clone_segment_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//Compression
	$("#clone_compression_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_file_image_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_compression_dialog').dialog('open');
		}
	});
	//set up clone_compression_dialog
	$("#clone_compression_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["CompressionLevel"] = $("#clone_compression_value_slider").slider("value");
				//$("#clone_compression_select .select-opt", this).each(function(i) {
				//	if ($(this).hasClass("ui-selected")) task_config[t]["CompressionLevel"] = i;
				//});

				updateCaptureBlocks();
				$(this).dialog('close');
				$('#clone_file_image_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "CompressionLevel": APICOMPRESSIONS[task_config[t]["CompressionLevel"]]});
			}
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_compression_select .select-opt").mousedown(function() {
		$("#clone_compression_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//File Filter
	$("#clone_filefilter_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_file_image_dialog').data('opening_another_dialog', true).dialog('close');
			var t = current_task();
			if (t >= 0) $("#filefilter_val").val(task_config[t]['FileFilter']);
			$('#clone_filefilter_keyboard_dialog').dialog('open');
		}
	});
	//set up clone_filefilter_keyboard_dialog
	$("#clone_filefilter_keyboard_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["FileFilter"] = $("#filefilter_val").val();
				updateCaptureBlocks();
				$(this).dialog('close');
				TaskSetConfiguration({"Task": t, "FileFilter": task_config[t]["FileFilter"]});
			}
		},
		close: function(event, ui) {
			resetKeyboard("filefilter");
			$('#clone_file_image_dialog').dialog('open');
		}
	});

	//File Image Mode (Clone Method)
	$("#clone_imgmode_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#clone_file_image_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_imgmode_dialog').data('opened_by_file_image', true).dialog('open');
		}
	});
	//set up clone_imgmode_dialog
	$("#clone_imgmode_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_imgmode_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["CloneMethod"] = i;
				});
                updateModals("clone_method");
                updateModals("settings");   //updates Drive Trim
				updateCaptureBlocks();
				$(this).dialog('close');
				TaskSetConfiguration({"Task": t, "CloneMethod": APIMETHODS[task_config[t]["CloneMethod"]]});
			}
		},
		close: function(event, ui) {
			updateModals("imgmode");
			if ($(this).data('opened_by_file_image') === true) $('#clone_file_image_dialog').dialog('open');
			else $('#clone_method_dialog').dialog('open');
			$(this).data('opened_by_file_image', false);
		}
	});
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_imgmode_select .select-opt").mousedown(function() {
		$("#clone_imgmode_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//File Image Settings
	$("#clone_imgsettings_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task();
			if (t == -1) return true;

			$('#clone_file_image_dialog').data('opening_another_dialog', true).dialog('close');
			if (task_config[t]["CloneMethod"] == METHOD_CLEVER) $('#clone_clever_dialog').data('opened_by_file_image', true).dialog('open');
			else $('#clone_mirror_dialog').data('opened_by_file_image', true).dialog('open');
		}
	});

	//Mirror Settings
	//set up clone_mirror_dialog
	$("#clone_mirror_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				//save Mirror Mode
				var t = current_task();
				if (t == -1) return true;

				$("#clone_mirmode_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						if (i == 0) task_config[t]["MirrorRAIDEnable"] = true;
						else task_config[t]["MirrorRAIDEnable"] = false;
					}
				});

				//save Mirror slider values
                if (task_config[t]["Master"] == "") {
                    task_config[t]["LBACount"] = 0;
                }
                else {
                    task_config[t]["LBACount"] = $("#clone_mirror_length_slider").slider("value");
                }
                task_config[t]["MasterStartLBA"] = $("#clone_mirror_mstart_slider").slider("value");
				task_config[t]["TargetStartLBA"] = $("#clone_mirror_tstart_slider").slider("value");

				updateCloneMethodBlock();
				$(this).dialog('close');

				updateButtons("settings");		//need to update Settings button
				var setconfig_params = {"Task": t};
				setconfig_params["MirrorRAIDEnable"] = task_config[t]["MirrorRAIDEnable"];
				setconfig_params["LBACount"] = task_config[t]["LBACount"].toString();
				setconfig_params["MasterStartLBA"] = task_config[t]["MasterStartLBA"].toString();
				setconfig_params["TargetStartLBA"] = task_config[t]["TargetStartLBA"].toString();
				TaskSetConfiguration(setconfig_params);
			}
		},
		close: function(event, ui) {
			updateModals("mirror");
			if ($(this).data('opened_by_file_image') === true) $('#clone_file_image_dialog').dialog('open');
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            else $('#clone_settings_dialog').dialog('open');
            <?php else: ?>
            else $('#clone_method_dialog').dialog('open');
            <?php endif; ?>
			$(this).data('opened_by_file_image', false);
        }
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_mirmode_select .select-opt").mousedown(function() {
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			$("#clone_mirmode_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
			});

			$(this).toggleClass("ui-selected");

			var t = current_task();
			if (t == -1) return true;

			var master = task_config[t]["Master"];
			if (($(this).attr("id") == "clone_mirmode_1") && (master != "")) {	//if Non-RAID, enable rows
				enableMirrorSettings();
			}
			else {	//if RAID, disable rows
				disableMirrorSettings();
			}
		}
	});


	//HPA/DCO Method
	$("#clone_hpa_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_hpa_dialog').dialog('open');
		}
	});

	//set up clone_hpa_dialog
	$("#clone_hpa_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_hpa_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["UnlockHPA"] = (i == 0 ? true : false);	//0 button = Yes, 1 button = No
				});
				$("#clone_dco_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["UnlockDCO"] = (i == 0 ? true : false);
				});
				$("#clone_drive_trim_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["DriveTrim"] = (i == 0 ? true : false);
				});

				updateHPABlock();
				$(this).dialog('close');
				$('#clone_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "UnlockHPA": task_config[t]["UnlockHPA"], "UnlockDCO": task_config[t]["UnlockDCO"], "DriveTrim": task_config[t]["DriveTrim"]});
			}
		}
	});


	//Error Handling
	$("#clone_error_handling_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_error_handling_dialog').dialog('open');
		}
	});

	//set up clone_error_handling_dialog
	$("#clone_error_handling_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_error_handling_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["IgnoreReadFailure"] = (i == 0 ? true : false);	//0 button = Skip/Yes, 1 button = Abort/No
				});
				$("#clone_error_granularity_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["ErrorGranularity"] = i;
				});

				updateErrorHandlingBlock();
				$(this).dialog('close');
				$('#clone_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "IgnoreReadFailure": task_config[t]["IgnoreReadFailure"], "ErrorGranularity": APIERRORGRANULARITIES[task_config[t]["ErrorGranularity"]]});
			}
		}
	});

	//Verification Method
	$("#clone_filter_settings_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_filter_settings_dialog').dialog('open');
		}
	});

	$("#clone_filter_settings_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				updateFilterSettingsBlock();
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				updateFilterSettingsBlock();
				$('#clone_settings_dialog').dialog('open');	//only open when Case Info X is clicked (not when it closes because Examiner, Case ID, etc. are opened)
			}
		}
	});

	//Verification Method
	$("#clone_verif_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_settings_dialog').data('opening_another_dialog', true).dialog('close');
			$('#clone_verif_dialog').dialog('open');
		}
	});

	//set up clone_verif_dialog
	$("#clone_verif_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				$("#clone_hash_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["HashType"] = i;
				});
				$("#clone_verif_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["VerifyHash"] = (i == 0 ? true : false);	//0 button = Yes, 1 button = No
				});

				updateHashVerifBlock();
                updateButtons("settings");
				$(this).dialog('close');
                $('#clone_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]], "VerifyHash": task_config[t]["VerifyHash"]});
			}
		}
	});

	//when user clicks Blocks column, open LBA blocks set dialog
	$(".clone_mirror_settings_row .col3").mousedown(function() {
		if ($(this).parent().attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var slidername = $(this).attr("id").replace("_lbas", "");
			var slidertitle = $(this).parent().find(".col1").text();
			var sliderval = $(this).text();

			$("#blocks_slidername").html(slidername);
			$("#blocks_set_title").html(slidertitle + " Blocks");
			$("#blocks_val").val(sliderval);
			$("#blocks_set_dialog").dialog('open');
		}
	});


	//------------------------------------------------------------
	// CLONE TARGET
	//------------------------------------------------------------
	//when user clicks clone_target button, open modal dialog with Target Drive options
	$("#clone_target_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task();
			if (t == -1) return true;
			if ((task_config[t]["CloneMode"] == MODE_D2I) || task_config[t]["CloneMode"] == MODE_P2F || (task_config[t]["CloneMode"] == MODE_F2F)) {	//Drive to Image
				$('#clone_target_repo_dialog').dialog('open');
			}
			else {
				$('#clone_target_dialog').dialog({ title: "<?= t("SELECT_TARGETS"); ?>"}).dialog('open');
			}
		}
	});

	//set up clone_target_dialog
	//THIS IS SHARED ON WIPE, HASH SCREENS
	$("#clone_target_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				//update targets
				task_config[t]["Targets"] = new Array();
				$("#clone_target_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        task_config[t]["Targets"].push($(this).find(".col1").text());
					}
				 });

				//if updating Wipe Target, also update LBA Count (max = max LBACount of all targets)
				if (current_op == OP_WIPE) {
					var targets = task_config[t]["Targets"];
					var cur_max_lbas = 0;
					for (var i in targets) {
						var target_drive = driveWithBay(targets[i]);
						if (target_drive != -1) {		//make sure drive is still connected
							target_lbas = target_drive.LogicalSectors;
							cur_max_lbas = Math.max(cur_max_lbas, target_lbas);
						}
					}

					if ($("#wipe_lba_range_slider").hasClass("ui-state-disabled")) {	//if slider was disabled (no Target) use 100%
						task_config[t]["LBACount"] = cur_max_lbas;
					}
					else {
						var cur_lbacount = task_config[t]["LBACount"];
						if (cur_lbacount > cur_max_lbas) {
							task_config[t]["LBACount"] = cur_max_lbas;
						}
					}

					updateWipeLBASlider();
				}
				else if (current_op == OP_HASH) {
					var targets = task_config[t]["Targets"];
					var cur_min_lbas = 0;
					for (var i in targets) {
						var target_drive = driveWithBay(targets[i]);
						if (target_drive != -1) {		//make sure drive is still connected
							if (cur_min_lbas == 0) {								//get target with least LBAs
								cur_min_lbas = target_drive.LogicalSectors;
							}
							else {
								target_lbas = target_drive.LogicalSectors;
								cur_min_lbas = Math.min(cur_min_lbas, target_lbas);
							}
						}
					}

					if ($("#hash_lba_length_slider").hasClass("ui-state-disabled")) {	//if slider was disabled (no Target) use 100% for Length, 0% for Target Start
						task_config[t]["LBACount"] = cur_min_lbas;
						task_config[t]["TargetStartLBA"] = 0;
					}
					else {
						var cur_lbacount = task_config[t]["LBACount"];
						var cur_tstart = task_config[t]["TargetStartLBA"];

						if (cur_lbacount > cur_min_lbas) {
							task_config[t]["LBACount"] = cur_min_lbas;
						}
						if (cur_tstart > cur_min_lbas) {
							task_config[t]["TargetStartLBA"] = cur_min_lbas;
						}
					}
					updateHashLBASliders();
				}

				updateButtons("target");
				$(this).dialog('close');
				var setconfig_params = {"Task": t};
				setconfig_params["Targets"] = task_config[t]["Targets"];

				if (current_op == OP_WIPE) {
					setconfig_params["LBACount"] = task_config[t]["LBACount"].toString();
				}
				else if (current_op == OP_HASH) {
					setconfig_params["LBACount"] = task_config[t]["LBACount"].toString();
					setconfig_params["TargetStartLBA"] = task_config[t]["TargetStartLBA"].toString();
				}
				TaskSetConfiguration(setconfig_params);

			}
		},
		close: function(event, ui) {
			updateModals("target");
		}
	});

    $("#clone_target_select").unbind("mousedown");
	$("#clone_target_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            var bay = $(this).parent().find(".col1").text();
            updateDriveDetails(bay);
            $("#clone_drive_details_dialog").dialog('open');
            $("#clone_drive_details_dialog").parent().css("z-index", "10010");
        }
		else {
            if ($(this).parent().hasClass("ui-state-disabled")) {
                //do not select disabled
            }
            else {
                $(this).parent().toggleClass("ui-selected");							//toggle selection to allow multiple Target selections
                if ($(this).parent().hasClass("ui-selected")) {
                    $(this).parent().find(".col3").html("<?= t("SELECTED"); ?>");
                }
                else {
                    var classes = $(this).parent().find(".col3").attr("class");
                    if (classes != "col3") {
                        var togglebackval = classes.substr(classes.lastIndexOf(" ")).replace('/_/g', " ");	//Clone 1 / Assigned / etc.
                        $(this).parent().find(".col3").html(togglebackval);
                    }
                    else $(this).parent().find(".col3").html("<?= t("AVAILABLE"); ?>");
                }
            }
		}
	});

	//set up clone_target_repo_dialog
	//THIS IS SHARED ON PUSH SCREEN
	$("#clone_target_repo_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				if (typeof($(this).data('prompt_task')) != "undefined" && $(this).data('prompt_task') != '') {	//for Prompt Task, get selected repo and send to TaskPromptResponse, don't change task_config
					var new_repo = "";
					$("#clone_target_repo_select .select-opt", this).each(function(i) {
						if ($(this).hasClass("ui-selected")) new_repo = repositories[i]["Name"];
					});
					TaskPromptResponse({'Task': $(this).data('prompt_task'), 'Response': 'CONTINUE', 'Repository': new_repo});
					$(this).data('prompt_task', '');
					$(this).dialog('close');
				}
				else if ((current_op == OP_PUSH) || (task_config[t]["CloneMode"] == MODE_F2F)) {	//for PUSH, set Repository
					var new_repo = "";
					$("#clone_target_repo_select .select-opt", this).each(function(i) {
						if ($(this).hasClass("ui-selected")) new_repo = repositories[i]["Name"];
					});
					var setconfig_params = {"Task": t};
					if (new_repo != "") {
						task_config[t]["RepositoryList"] = new Array(new_repo);
						setconfig_params["RepositoryList"] = new Array(new_repo);	//send new Repository to API
					}
					else {
						task_config[t]["RepositoryList"] = new Array();
						setconfig_params["RepositoryList"] = new Array();
					}
					updateButtons("target");
					$(this).dialog('close');
					TaskSetConfiguration(setconfig_params);
				}
				else if ((task_config[t]["CloneMode"] != MODE_F2F) && (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE)) {	//set Repository and let user select Image
					var new_repo = "";
					$("#clone_target_repo_select .select-opt", this).each(function(i) {
						if ($(this).hasClass("ui-selected")) new_repo = repositories[i]["Name"];
					});

					//if a Repository has been selected, open Select Image dialog
					var setconfig_params = {"Task": t};
					if (new_repo != "") {
						 if (new_repo != task_config[t]["Repository"]) {		//if a new Repository is selected, clear image paths
							setconfig_params["DestinationImagePath"] = "";
							setconfig_params["SourceImagePath"] = "";
						 }

						task_config[t]["Repository"] = new_repo;
						setconfig_params["Repository"] = new_repo;	//send new Repository to API
						RepositoryListContents(new_repo);	//dialog opens after info is returned from API
					}
					else {
						task_config[t]["Repository"] = "";
						task_config[t]["DestinationImagePath"] = "";
						setconfig_params["Repository"] = "";
						setconfig_params["DestinationImagePath"] = "";
					}

					$(this).dialog('close');
					TaskSetConfiguration(setconfig_params);
				}
				else { //set RepositoryList and don't show Image dialog
					task_config[t]["RepositoryList"] = new Array();
					$("#clone_target_repo_select .select-opt", this).each(function(i) {
						if ($(this).hasClass("ui-selected")) task_config[t]["RepositoryList"].push(repositories[i]["Name"]);
					 });

					updateButtons("target");
					$(this).dialog('close');
					TaskSetConfiguration({"Task": t, "RepositoryList": task_config[t]["RepositoryList"]});
				}
			}
		},
		close: function(event, ui) {
			updateModals("target_repo");
			if ((typeof($(this).data('prompt_task')) != "undefined" && $(this).data('prompt_task') != '') && (typeof($("#clone_format_repo_dialog").data('repo')) == "undefined" || $("#clone_format_repo_dialog").data('repo') == '')) {	//if closing Prompt Task dialog
				TaskPromptResponse({'Task': $(this).data('prompt_task'), 'Response': 'CANCEL'});			//(and not closing because Prompt repo is being formatted)
				$(this).data('prompt_task', '');
			}
		}
	});
	//set up prompt_message dialog
	$("#prompt_message_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
				$("#clone_target_repo_dialog").data('prompt_task', $(this).data('prompt_task')).dialog('open');
			}
		}
	});


	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_target_repo_select").unbind("mousedown");
	$("#clone_target_repo_select").on("mousedown", ".select-opt td", function() {
		if (!$(this).parent().hasClass("ui-state-disabled")) {	//check for disabled row (unmounted Network repo)
            if ($(this).parent().hasClass("unmounted-repo")) {   //Format Repository
                var repo = $(this).parent().find(".col1").text();
                $("#clone_format_repo_dialog").data('repo', repo);
                $("#clone_target_repo_dialog").dialog('close');
                $("#clone_format_options_dialog").dialog('open');
            }
            else {
                var t = current_task();
				if (t == -1) return true;

                if (typeof($("#clone_target_repo_dialog").data('prompt_task')) != "undefined" && $("#clone_target_repo_dialog").data('prompt_task') != '') {	//for Prompt Task, only allow one selection and don't allow no selection
                    $("#clone_target_repo_select .select-opt").each(function() {
                        if ($(this).hasClass("ui-selected")) {
                            $(this).toggleClass("ui-selected");
                        }
                    });
                    $(this).parent().toggleClass("ui-selected");
                }
                else if ((current_op == OP_PUSH) || (task_config[t]["CloneMode"] == MODE_F2F) || (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE)) { //only allow one selection
                    var cur_repo = $(this).parent().find(".col1").html();
                    var sel_repo = "";
                    $("#clone_target_repo_select .select-opt").each(function() {
                        if ($(this).hasClass("ui-selected")) {
                            sel_repo = $(this).find(".col1").html();
                            $(this).toggleClass("ui-selected");
                        }
                    });

                    if (cur_repo != sel_repo) {
                        $(this).parent().toggleClass("ui-selected");
                    }
                }
                else {	//allow multiple selections
                    $(this).parent().toggleClass("ui-selected");
                }
            }
		}
	});

	//set up clone_target_image_dialog
	$("#clone_target_image_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: [
			{
				text: "<?= t("NEW_IMAGE_FILE"); ?>",
				className: 'clone_target_image_btn_create',
				click: function() {
					if ($(this).hasClass("ui-state-disabled")) {
					}
					else {
						$("#clone_target_image_name_dialog").dialog("open");
					}
				}
			},
			{
				text: 'OK',
				className: 'clone_target_image_btn_ok',
				click: function() {
					var t = current_task();
					if (t == -1) return true;

					task_config[t]["DestinationImagePath"] = "";
					$("#clone_target_image_select .select-opt", this).each(function(i) {
						if ($(this).hasClass("ui-selected")) task_config[t]["DestinationImagePath"] = images[i]["Path"];
					});

					updateButtons("target");
					$(this).dialog('close');

					//send new Target Image to server
					TaskSetConfiguration({"Task": t, "DestinationImagePath": task_config[t]["DestinationImagePath"]});
				}
			}
		],
		close: function(event, ui) {
			updateModals("target_image");
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
    $("#clone_target_image_select").unbind("mousedown");
	$("#clone_target_image_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            var i = $("#clone_target_image_select .select-more").index(this);
            updateImageDetails(i);
            $("#clone_image_details_dialog").dialog('open');
            $("#clone_image_details_dialog").parent().css("z-index", "10010");
        }
        else {
            var cur_image = $(this).find(".col1").html();
            if ($(this).hasClass("ui-state-disabled")) {
                //do not select disabled
            }
            else {
                var sel_image = "";
                $("#clone_target_image_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_image = $(this).find(".col1").html();
                        $(this).toggleClass("ui-selected");
                    }
                });

                if (cur_image != sel_image) {
                    $(this).toggleClass("ui-selected");
                }
            }
        }
	});

	//Image File Name dialog
	$("#clone_target_image_name_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();		//current task
				if (t == -1) return true;

				var intype = 0;
				$("#clone_target_image_name_type_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) intype = i;
				});
				var filename = "";
				if (intype == 1) var filename = $("#image_name_val").val() + ".img";	//file name entered
				ImageCreateNew(task_config[t]["Repository"], filename);

				$(this).dialog('close');
				$("#image_name_val").val("");	//clear input box
			}
		},
		close: function(event, ui) {
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_target_image_name_type_select .select-opt").mousedown(function() {
		$("#clone_target_image_name_type_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	$("#clone_target_image_name_type_select .select-opt").mouseup(function(e) {	//call this on mouseup, so textbox can be selected
		if ($(this).attr("id") == "clone_target_image_name_type_0") {	//AUTO generate file name
			disableObj($("#clone_target_image_name_value"));
			disableObj($("#clone_target_image_name_keys"));
			disableObj($("#image_name_val"));
			$("#image_name_val").blur();
		}
		else {	//ENTER file name
			enableObj($("#clone_target_image_name_value"));
			enableObj($("#clone_target_image_name_keys"));
			enableObj($("#image_name_val"));
			$("#image_name_val").focus();
		}
	});


	$("#image_name_val").blur(function() {
		$(this).removeClass("focus");
	});
	$("#image_name_val").focus(function() {
		$(this).select();
		$(this).addClass("focus");
	});

	$("#clone_target_image_name_type_0").mousedown();	//initialize selection to AUTO
	$("#clone_target_image_name_type_0").mouseup();

	// handle Image File Name keyboard keys
	$("#clone_target_image_name_keys div").mousedown(function() {
		var val = $("#image_name_val").val();
		var clickedid = $(this).attr("id");
		if (clickedid == "indel") {
			val = val.substring(0, val.length-1);
		}
		else {
			val = val + $(this).text();
		}
		$("#image_name_val").val(val);
	});

	//set up clone_format_options_dialog
	$("#clone_format_options_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar ui-sm-dialog-with-close',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				var filesystem = FILESYSTEM_EXT4;
				$("#clone_format_file_system_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						filesystem = i;
						return false;
					}
				});

				var encrypt = ENCRYPT_OFF;
				$("#clone_format_encrypt_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) {
						encrypt = i;
						return false;
					}
				});

				$("#clone_format_repo_dialog").data('filesystem', filesystem);
				$("#clone_format_repo_dialog").data('encrypt', encrypt);

				var repo = $("#clone_format_repo_dialog").data('repo');
				var info = "<?= t("FORMAT_REPOSITORY_N_ARE_YOU_SURE"); ?>";
				info = info.replace("%1", repo);
				info += "<br/><br/><div style=\"font-size: 0.7em\"><?= t("FORMATTING_WILL_ERASE_ALL_DATA"); ?></div>";
				$("#clone_format_repo_dialog").html(info);
				if (encrypt == ENCRYPT_ON) EncryptionGet();	//get this for next modal
				$(this).data('opening_another_dialog', true).dialog('close');
				$("#clone_format_repo_dialog").dialog('open');
			}
		},
		close: function(event, ui) {
			if ($(this).data('opening_another_dialog') !== true) {
				$("#clone_target_repo_dialog").dialog('open');
			}
            $("#clone_format_file_system_" + DEFAULT_FILESYSTEM).mousedown();  //reset Format File System back to default
		}
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_format_file_system_select .select-opt").mousedown(function() {
		$("#clone_format_file_system_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#clone_format_encrypt_select .select-opt").mousedown(function() {
		$("#clone_format_encrypt_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

	//confirmation dialog
	$("#clone_format_repo_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				if ($(this).html() == "<?= t("FORMAT_COMPLETE"); ?>") {
					$(this).dialog('close');
				}
				else {
					$(this).html("<?= t("FORMATTING"); ?>");
					$(this).prev(".ui-dialog-titlebar").find("button").css('visibility', 'hidden');	//hide NO button
					$(this).next(".ui-dialog-buttonpane").find(".ui-button-text").text("OK");	//change YES to OK
					$(this).next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disable OK button
					$(this).next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled', function() {	//do stuff in callback so Formatting progress shows up in Chrome)
						var repo = $("#clone_format_repo_dialog").data('repo');
						var filesystem = $("#clone_format_repo_dialog").data('filesystem');
						var encrypt = $("#clone_format_repo_dialog").data('encrypt');
						if (encrypt == ENCRYPT_ON) var repo_params = {"Name": repo, "EncryptEnable": APIENCRYPTS[encrypt], "CipherMode": APICIPHERMODES[encryption_config["CipherMode"]], "Cipher": APICIPHERS[encryption_config["Cipher"]], "IVGen": APIIVGENS[encryption_config["IVGen"]], "Password": encryption_config["Password"]};	//Encryption params retrieved in previous modal
						else var repo_params = {"Name": repo};
						repo_params['Filesystem'] = APIFILESYSTEMS[filesystem];
						RepositoryFormat(repo_params);
						updateTargetRepositoryModal();	//this isn't done while modal is open, so call it here explicitly
						$("#clone_format_encrypt_1").mousedown();	//reset Encrypt to Off
					});
				}
			}
		},
		close: function(event, ui) {
			$("#clone_format_repo_dialog").data('repo', '');
			$("#clone_format_repo_dialog").data('encrypt', '');
			$("#clone_target_repo_dialog").dialog('open');
		}
	});


	//------------------------------------------------------------
	// CLONE START BUTTON, PROGRESS BAR, ABORT BUTTON
	//------------------------------------------------------------
	//when user clicks Start button, show confirmation
	$("#clone_start_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			if (current_op == OP_TASK_MACRO) {
				var tab = current_tab[OP_TASK_MACRO];
				var info = "<?= t("START_MACRO_N_ARE_YOU_SURE", array("1")); ?>";
				if (tab == 1) info = "<?= t("START_MACRO_N_ARE_YOU_SURE", array("2")); ?>";
				else if (tab == 2) info = "<?= t("START_MACRO_N_ARE_YOU_SURE", array("3")); ?>";
				else if (tab == 3) info = "<?= t("START_MACRO_N_ARE_YOU_SURE", array("4")); ?>";
				else if (tab == 4) info = "<?= t("START_MACRO_N_ARE_YOU_SURE", array("5")); ?>";
				$('#clone_start_dialog').html(info);
			}
			else {
				var t = current_task();
				if (t == -1) return true;
				var info = "";
				$("#clone_start_dialog").removeClass("warning");
                //check for sufficient destination repo space for Clone D2I, F2F, Push
                if ((t <= 5 && (task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F || task_config[t]["CloneMode"] == MODE_F2F)) || (t >= 16 && t <= 20)) {
                    if (t >= 16 && t <= 20) {   //Push uses "Repository" as source and "RepositoryList" as destination
						var repo = task_config[t]["Repository"];
						var master_repo = repoWithName(repo);
                        master_size = master_repo["Size"] - master_repo["Free"];    //calculate used size
                        var repo_list = task_config[t]["RepositoryList"];
                    }
                    else {  //Clone D2I/P2F use "Repository" or "RepositoryList" as destination
                        var master = task_config[t]["Master"];
						var master_drive = driveWithBay(master);
                        if (task_config[t]["CloneMode"] == MODE_P2F) {  //Clone P2F uses Partition as source
                            var part_num = task_config[t]["SourcePartitionNumber"];
                            master_size = master_drive.Partitions[part_num-1].PartSize;
                        }
                        else {  //Clone D2I uses "Master" as source
							master_size = master_drive.Size;
                        }

                        if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) { //use Repository
                            var repo_list = new Array(task_config[t]["Repository"]);
                        }
                        else {    //use RepositoryList
                            var repo_list = task_config[t]["RepositoryList"];
                        }
                    }

                    var similar_size_repos = "";
				    for (var i in repo_list) {
				        var repo = repoWithName(repo_list[i]);
				        var target_size = repo["Free"];
				        if (target_size - master_size <= 134217728) { //if Destination Repo is less than 128MB larger than Source Repo
				            if (similar_size_repos != "") similar_size_repos += ", ";
				            similar_size_repos += repo_list[i];
				        }
				    }
                    if (similar_size_repos != "") {
				        $("#clone_start_dialog").addClass("warning");
				        if (similar_size_repos.indexOf(", ") > 0) var warning_msg = "<?= t("DESTINATION_REPOS_N_MIGHT_NOT_HAVE_SUFFICIENT_FREE_SPACE"); ?>";
				        else var warning_msg = "<?= t("DESTINATION_REPO_N_MIGHT_NOT_HAVE_SUFFICIENT_FREE_SPACE"); ?>";
				        warning_msg = warning_msg.replace("%1", similar_size_repos);
				        info += "<div style=\"font-size: 0.7em\"><span style=\"text-transform: uppercase\"><?= t("WARNING"); ?>:</span><br/>" + warning_msg + "</div><br/>";
				    }

					if (t == 1) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("1")); ?>";				//map name to operation, e.g. T6 -> W1, shared on Wipe/Hash screens
					else if (t == 2) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("2")); ?>";
					else if (t == 3) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("3")); ?>";
					else if (t == 4) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("4")); ?>";
					else if (t == 5) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("5")); ?>";

                    else if (t == 16) info += "<?= t("START_PUSH_N_ARE_YOU_SURE", array("1")); ?>";
					else if (t == 17) info += "<?= t("START_PUSH_N_ARE_YOU_SURE", array("2")); ?>";
					else if (t == 18) info += "<?= t("START_PUSH_N_ARE_YOU_SURE", array("3")); ?>";
					else if (t == 19) info += "<?= t("START_PUSH_N_ARE_YOU_SURE", array("4")); ?>";
					else if (t == 20) info += "<?= t("START_PUSH_N_ARE_YOU_SURE", array("5")); ?>";
				}
                else if (t <= 5 && (task_config[t]["CloneMode"] == MODE_D2D || task_config[t]["CloneMode"] == MODE_I2D)) {
                    if (t == 1) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("1")); ?>";                               //map name to operation, e.g. T6 -> W1, shared on Wipe/Hash screens
                    else if (t == 2) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("2")); ?>";
                    else if (t == 3) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("3")); ?>";
                    else if (t == 4) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("4")); ?>";
                    else if (t == 5) info += "<?= t("START_TASK_N_ARE_YOU_SURE", array("5")); ?>";
                }
                else if (t == 6) info = "<?= t("START_WIPE_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 7) info = "<?= t("START_WIPE_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 8) info = "<?= t("START_WIPE_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 9) info = "<?= t("START_WIPE_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 10) info = "<?= t("START_WIPE_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 11) info = "<?= t("START_HASH_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 12) info = "<?= t("START_HASH_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 13) info = "<?= t("START_HASH_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 14) info = "<?= t("START_HASH_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 15) info = "<?= t("START_HASH_N_ARE_YOU_SURE", array("5")); ?>";

				$('#clone_start_dialog').html(info);
			}
			$('#clone_start_dialog').dialog('open');
		}
	});
	//set up clone_start confirmation dialog
	$("#clone_start_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				if (current_op == OP_TASK_MACRO) {
					MacroStart(current_tab[OP_TASK_MACRO]+1);
				}
				else {
					var t = current_task();
					if (t == -1) return true;
					TaskStart(t);
				}
			}
		}
	});
	//set up clone_parallel_tasks_dialog for parallel task start
	$("#clone_parallel_task_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var tasks = new Array();
				$("#clone_parallel_task_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) tasks.push(parseInt($(this).find(".task_num").text()));
				});

				$(this).dialog('close');
				TaskStartList(tasks);
			}
		},
		close: function(event, ui) {
		}
	});

    $("#clone_parallel_task_select").unbind("mousedown");
	$("#clone_parallel_task_select").on("mousedown", ".select-opt", function() {
		var cur_task = $(this).find(".col1").html();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			$(this).toggleClass("ui-selected");
		}
	});


	//when user clicks Abort button, show confirmation
	$("#clone_abort_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			if (current_op == OP_TASK_MACRO) {
				var tab = current_tab[OP_TASK_MACRO];
				var info = "<?= t("ABORT_MACRO_N_ARE_YOU_SURE", array("1")); ?>";
				if (tab == 1) info = "<?= t("ABORT_MACRO_N_ARE_YOU_SURE", array("2")); ?>";
				else if (tab == 2) info = "<?= t("ABORT_MACRO_N_ARE_YOU_SURE", array("3")); ?>";
				else if (tab == 3) info = "<?= t("ABORT_MACRO_N_ARE_YOU_SURE", array("4")); ?>";
				else if (tab == 4) info = "<?= t("ABORT_MACRO_N_ARE_YOU_SURE", array("5")); ?>";

				$('#clone_abort_dialog').html(info);
			}
			else {
				var t = current_task();
				if (t == -1) return true;

				var info = "<?= t("ABORT_TASK_N_ARE_YOU_SURE", array("1")); ?>";				//map name to operation, e.g. T6 -> W1, shared on Wipe/Hash screens
				if (t == 2) info = "<?= t("ABORT_TASK_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 3) info = "<?= t("ABORT_TASK_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 4) info = "<?= t("ABORT_TASK_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 5) info = "<?= t("ABORT_TASK_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 6) info = "<?= t("ABORT_WIPE_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 7) info = "<?= t("ABORT_WIPE_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 8) info = "<?= t("ABORT_WIPE_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 9) info = "<?= t("ABORT_WIPE_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 10) info = "<?= t("ABORT_WIPE_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 11) info = "<?= t("ABORT_HASH_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 12) info = "<?= t("ABORT_HASH_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 13) info = "<?= t("ABORT_HASH_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 14) info = "<?= t("ABORT_HASH_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 15) info = "<?= t("ABORT_HASH_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 16) info = "<?= t("ABORT_PUSH_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 17) info = "<?= t("ABORT_PUSH_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 18) info = "<?= t("ABORT_PUSH_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 19) info = "<?= t("ABORT_PUSH_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 20) info = "<?= t("ABORT_PUSH_N_ARE_YOU_SURE", array("5")); ?>";

				$('#clone_abort_dialog').html(info);
			}
			$('#clone_abort_dialog').dialog('open');
		}
	});
	//set up clone_abort confirmation dialog
	$("#clone_abort_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				if (current_op == OP_TASK_MACRO) {
					MacroStop(current_tab[OP_TASK_MACRO]+1);	//acts as MacroAbort
				}
				else {
					var t = current_task();
					if (t == -1) return true;
					TaskAbort(t);
				}

			}
		}
	});


	//when user clicks Reset button, show confirmation
	$("#clone_reset_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			if (current_op == OP_TASK_MACRO) {
				var tab = current_tab[OP_TASK_MACRO];
				var info = "<?= t("RESET_MACRO_N_ARE_YOU_SURE", array("1")); ?>";
				if (tab == 1) info = "<?= t("RESET_MACRO_N_ARE_YOU_SURE", array("2")); ?>";
				else if (tab == 2) info = "<?= t("RESET_MACRO_N_ARE_YOU_SURE", array("3")); ?>";
				else if (tab == 3) info = "<?= t("RESET_MACRO_N_ARE_YOU_SURE", array("4")); ?>";
				else if (tab == 4) info = "<?= t("RESET_MACRO_N_ARE_YOU_SURE", array("5")); ?>";

				$('#clone_reset_dialog').html(info);
			}
			else {
				var t = current_task();
				if (t == -1) return true;

				var info = "<?= t("RESET_TASK_N_ARE_YOU_SURE", array("1")); ?>";				//map name to operation, e.g. T6 -> W1, shared on Wipe/Hash screens
				if (t == 2) info = "<?= t("RESET_TASK_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 3) info = "<?= t("RESET_TASK_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 4) info = "<?= t("RESET_TASK_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 5) info = "<?= t("RESET_TASK_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 6) info = "<?= t("RESET_WIPE_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 7) info = "<?= t("RESET_WIPE_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 8) info = "<?= t("RESET_WIPE_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 9) info = "<?= t("RESET_WIPE_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 10) info = "<?= t("RESET_WIPE_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 11) info = "<?= t("RESET_HASH_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 12) info = "<?= t("RESET_HASH_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 13) info = "<?= t("RESET_HASH_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 14) info = "<?= t("RESET_HASH_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 15) info = "<?= t("RESET_HASH_N_ARE_YOU_SURE", array("5")); ?>";

				else if (t == 16) info = "<?= t("RESET_PUSH_N_ARE_YOU_SURE", array("1")); ?>";
				else if (t == 17) info = "<?= t("RESET_PUSH_N_ARE_YOU_SURE", array("2")); ?>";
				else if (t == 18) info = "<?= t("RESET_PUSH_N_ARE_YOU_SURE", array("3")); ?>";
				else if (t == 19) info = "<?= t("RESET_PUSH_N_ARE_YOU_SURE", array("4")); ?>";
				else if (t == 20) info = "<?= t("RESET_PUSH_N_ARE_YOU_SURE", array("5")); ?>";

				$('#clone_reset_dialog').html(info);
			}

			$('#clone_reset_dialog').dialog('open');
		}
	});
	//set up clone_abort confirmation dialog
	$("#clone_reset_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				if (current_op == OP_TASK_MACRO) {
					MacroStop(current_tab[OP_TASK_MACRO]+1);	//acts as MacroReset
				}
				else {
					var t = current_task();
					if (t == -1) return true;

					TaskReset(t);
				}
			}
		}
	});

	//when user clicks Error message, show Error Details
	$("#clone_error_btn").mousedown(function(i) {
		var error_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
		error_info += "<tr><td>" + $("#clone_error_btn").html() + "</td></tr>\n";
		error_info += "</table>";
		$("#clone_error_details_dialog").html(error_info);
		$("#clone_error_details_dialog").dialog('open');
	});

	$("#clone_error_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});

	//LBA Blocks dialog
	$("#blocks_set_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar ui-sm-dialog-with-close blocks-set-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var slidername = $("#blocks_slidername").html();
				var val = $("#blocks_val").val();
				setSlider(slidername, val);
				$(this).dialog('close');
			}
		}
	});
	$("#blocks_val").blur(function() {
		$(this).removeClass("focus");
	});
	$("#blocks_val").focus(function() {
		$(this).addClass("focus");
	});

	//handle LBA Blocks number keys
	$("#blocks_set_keys div").mousedown(function() {
		var val = $("#blocks_val").val();
		var clickedid = $(this).attr("id");
		if (clickedid == "bkdel") {
			val = val.substring(0, val.length-1);
		}
		else {
			val = val + $(this).text();
		}
		$("#blocks_val").val(val);
	});


	//------------------------------------------------------------
	// INITIAL PAGE
	//------------------------------------------------------------

	//enable all buttons, stylize long dialog buttons
	$(":button", this).each(function() {
		$(this).removeAttr('disabled');
		if ($(this).text() == "<?= t("NEW_IMAGE_FILE"); ?>") {
			$(this).addClass("long-blue-btn");
		}
	});






	//pause/unpause config calls on config dialog open/close
	$("#clone_mode_dialog").bind("dialogopen", function(e) {
		pauseConfigCalls();
	});
	$("#clone_mode_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_master_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_master_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_master_repo_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_master_repo_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_master_source_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_master_source_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_master_image_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_master_image_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_master_partition_dialog").bind("dialogopen", function() {
		$(this).data('partition_selected', false);
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_master_partition_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_partition_decrypt_keyboard_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_partition_decrypt_keyboard_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_settings_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_settings_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_case_info_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_case_info_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_case_info_keyboard_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_case_info_keyboard_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_output_format_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_output_format_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_path_filter_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_path_filter_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_preset_filter_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_preset_filter_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_custom_filter_keyboard_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_custom_filter_keyboard_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_file_cat_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_file_cat_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_filter_settings_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_filter_settings_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});

	$("#clone_keywords_settings_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_keywords_settings_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});

	$("#clone_file_image_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_file_image_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_segment_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_segment_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_compression_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_compression_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_filefilter_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_filefilter_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_method_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_method_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_imgmode_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_imgmode_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_clever_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_clever_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_mirror_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_mirror_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_hpa_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_hpa_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_error_handling_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_error_handling_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_verif_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_verif_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_target_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_target_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_target_repo_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_target_repo_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#prompt_message_dialog").bind("dialogclose", function() {
	});
	$("#clone_format_options_dialog").bind("dialogopen", function() {
		$(this).data('opening_another_dialog', false);
		pauseConfigCalls();
	});
	$("#clone_format_options_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_format_repo_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_format_repo_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find(".ui-button-text").text("YES");	//change OK back to YES
		$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
		$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
		$("#clone_format_repo_dialog").prev(".ui-dialog-titlebar").find("button").css('visibility', 'visible');	//show NO button
	});
	$("#clone_format_progress_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#clone_format_progress_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#clone_target_image_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_target_image_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});
	$("#clone_target_image_name_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
		DRIVE_MODAL_OPEN = true;
	});
	$("#clone_target_image_name_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
		DRIVE_MODAL_OPEN = false;
	});

}




//function to fix the -10000 pixel limit of jquery.animate
$.fx.prototype.cur = function() {
	if ( this.elem[this.prop] != null && (!this.elem.style || this.elem.style[this.prop] == null) ) {
	  return this.elem[ this.prop ];
	}
	var r = parseFloat( jQuery.css( this.elem, this.prop ) );
	return typeof r == 'undefined' ? 0 : r;
}
