/* vim: set filetype=javascript: */
function loadHashJS() {

	//------------------------------------------------------------
	// SET UP TABS, ADD TASK, DELETE TASK
	//------------------------------------------------------------
	//set up tabs
	$("#hash_tab_0").mousedown(function() { selectTab(0); });
	$("#hash_tab_1").mousedown(function() { selectTab(1); });
	$("#hash_tab_2").mousedown(function() { selectTab(2); });
	$("#hash_tab_3").mousedown(function() { selectTab(3); });
	$("#hash_tab_4").mousedown(function() { selectTab(4); });

	//when user clicks hash_add button, create new tab, up to MAX_TABS tabs
	$("#hash_add_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			TaskReserve('Hash');
		}
	});
	//when user clicks clone_cancel button, show confirmation
	$("#hash_delete_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var t = current_task()-10;
			var info = "<?= t("DELETE_HASH_N_ARE_YOU_SURE", array("1")); ?>";
			if (t == 2) info = "<?= t("DELETE_HASH_N_ARE_YOU_SURE", array("2")); ?>";
			else if (t == 3) info = "<?= t("DELETE_HASH_N_ARE_YOU_SURE", array("3")); ?>";
			else if (t == 4) info = "<?= t("DELETE_HASH_N_ARE_YOU_SURE", array("4")); ?>";
			else if (t == 5) info = "<?= t("DELETE_HASH_N_ARE_YOU_SURE", array("5")); ?>";

			$('#hash_delete_dialog').html(info);
			$('#hash_delete_dialog').dialog('open');
		}
	});
	//set up clone_cancel confirmation dialog
	$("#hash_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				TaskRelease(tab_tasks[OP_HASH][current_tab[OP_HASH]]);
			}
		}
	});

	//------------------------------------------------------------
	// HASH MODE
	//------------------------------------------------------------
	//when user clicks hash_target button, open modal dialog with Target Drive options
	$("#hash_mode_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#hash_mode_dialog').dialog('open');
		}
	});
	$("#hash_mode_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

                $("#hash_mode_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        task_config[t]["ValidateMode"] = i;
					}
				});

				var setconfig_params = new Array();
				setconfig_params = {"Task": t, "ValidateMode": APIHASHMODES[task_config[t]["ValidateMode"]]};

                if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY) {
					setconfig_params["VerifyHash"] = true;
                    updateModals("filesystems");
                    updateModals("push_case");
				}
				updateButtons("mode");
                updateButtons("target");
                updateButtons("hash_settings");
                updateModals("hash_settings");
				$(this).dialog('close');
				TaskSetConfiguration(setconfig_params);
			}
		},
		close: function(event, ui) {
			updateModals("mode");
		}
	});

    //unhighlight current selection, highlight new selection, only one selection allowed
	$("#hash_mode_select .select-opt").mousedown(function() {
		$("#hash_mode_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});

    //------------------------------------------------------------
	// HASH TARGET
	//------------------------------------------------------------
	//when user clicks hash_target button, open modal dialog with Target Drive options
	$("#hash_target_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            var t = current_task();
            if (t >= 0) {
                if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY)
                    $('#push_filesystem_dialog').dialog('open');
                else
                    $('#clone_target_dialog').dialog({ title: "<?= t("SELECT_DRIVES"); ?>"}).dialog('open');
            }
            <?php else: ?>
            $('#clone_target_dialog').dialog({ title: "<?= t("SELECT_DRIVES"); ?>"}).dialog('open');
            <?php endif; ?>
        }
	});

	//------------------------------------------------------------
	// HASH SETTINGS
	//------------------------------------------------------------
	//when user clicks hash_settings button, open modal dialog with Settings options
	$("#hash_settings_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#hash_settings_dialog').dialog('open');
		}
	});

	//set up hash_settings_dialog
	$("#hash_settings_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				updateButtons("hash_settings");
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
			updateButtons("hash_settings");
		}
	});

	//when user clicks hash_values button, open modal dialog with Values
	$("#hash_lba_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#hash_settings_dialog').dialog('close');
			$('#hash_lba_dialog').dialog('open');
		}
	});

	//set up hash_lba_dialog
	$("#hash_lba_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;
				//LBA Length and Start
				task_config[t]["LBACount"] = $("#hash_lba_length_slider").slider("value");
				task_config[t]["TargetStartLBA"] = $("#hash_lba_tstart_slider").slider("value");
				
				$(this).dialog('close');
				updateHashLBAButton();
				$('#hash_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "LBACount": task_config[t]["LBACount"].toString(), "TargetStartLBA": task_config[t]["TargetStartLBA"].toString()});
			}
		},
		close: function(event, ui) {
			updateModals("hash_lba");
			$('#hash_settings_dialog').dialog('open');
		}
	});

	//when user clicks Blocks column, open LBA blocks set dialog
	$(".hash_lba_settings_row .col3").mousedown(function() {
		if ($(this).parent().attr('disabled') != 'disabled') {          //'click' isn't automically disabled for DIVs
			var slidername = $(this).attr("id").replace("_lbas", "");
			var slidertitle = $(this).parent().find(".col1").text();
			var sliderval = $(this).text();

			$("#blocks_slidername").html(slidername);
			$("#blocks_set_title").html(slidertitle + " Blocks");
			$("#blocks_val").val(sliderval);
			$("#blocks_set_dialog").dialog('open');
		}
	});

	//when user clicks hash_verify button, open modal
	$("#hash_verify_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#hash_settings_dialog').dialog('close');
			$('#hash_verify_dialog').dialog('open');
		}
	});

	$("#hash_verify_dialog").dialog({
		dialogClass: 'ui-sm-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

                $("#hash_verify_select .select-opt").each(function(i) {
					if ($(this).hasClass("ui-selected")) {
                        task_config[t]["VerifyCaseHash"] = i;
					}
				});

				var setconfig_params = new Array();
				setconfig_params = {"Task": t, "VerifyCaseHash": APIHASHVERIFIES[task_config[t]["VerifyCaseHash"]]};
                updateHashVerifyButton();
				updateButtons("hash_settings");
				$(this).dialog('close');
				$('#hash_settings_dialog').dialog('open');
				TaskSetConfiguration(setconfig_params);
			}
		}
	});
    //unhighlight current selection, highlight new selection, only one selection allowed
	$("#hash_verify_select .select-opt").mousedown(function() {
		$("#hash_verify_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});


	//when user clicks hash_values button, open modal dialog with Values
	$("#hash_values_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#hash_settings_dialog').dialog('close');
			$('#hash_values_dialog').dialog('open');
		}
	});

	//set up hash_values_dialog
	$("#hash_values_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["HashType"] = 1; //SHA-1
				$("#hash_method_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) task_config[t]["HashType"] = i+1;	//add 1 since no None button
				});

				updateHashValuesButton();
				$(this).dialog('close');
				$('#hash_settings_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
			}
		},
		close: function(event, ui) {
			if (!$(this).data('opening_enter_values')) {	//if not closing this dialog because Enter Values dialog is being opened on top
				$('#hash_settings_dialog').dialog('open');
				updateModals("hash_values");
			}
		}
	});
	
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#hash_method_select .select-opt").mousedown(function() {
		$("#hash_method_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
	});
	
	$("#hash_values_table .hash_values_table_row .col1").mousedown(function() {
		$('#hash_values_dialog').data('opening_enter_values', true).dialog('close');
		$('#hash_enter_values_dialog').dialog('open');
	});
	var just_opened = true;
	$("#hash_enter_values_dialog").mouseup(function() {
		if (just_opened) $("#hv0").focus();
		just_opened = false;
	});
	$("#hash_values_table .hash_values_table_row .col2").mousedown(function() {
		$('#hash_values_dialog').data('opening_enter_values', true).dialog('close');
		$('#hash_enter_values_dialog').dialog('open');
	});

	//set up hash_enter_values_dialog
	$("#hash_enter_values_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: false,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				//save hash values
				var t = current_task();
				if (t == -1) return true;

				task_config[t]["HashValue"] = "";
				$("#hash_value_boxes input").each(function() {
					hashval = $(this).val().toUpperCase();
					if (hashval == "") hashval = "00";
					else if (hashval.length == 1) hashval = "0" + hashval;
					task_config[t]["HashValue"] += hashval;
				});

				updateHashValueTable();
				updateHashValuesButton();
				$(this).dialog('close');
				$('#hash_values_dialog').dialog('open');
				TaskSetConfiguration({"Task": t, "HashValue": task_config[t]["HashValue"]});
			}
		},
		close: function(event, ui) {
			$('#hash_values_dialog').dialog('open');
			updateModals("hash_enter_values");
		}
	});

	/* when user types a valid hex value, advance to next input box */
	$("#hash_value_boxes input").keyup(function(e) {
		if (e.keyCode !== 9 && e.keyCode !== 16) {	//if user is Tab/Shift+Tabbing through boxes, don't advance
			var val = $(this).val();
			if (val.length == 2) {
				if (isValidHexNum(val)) {
					$(this).parent().next().find('input').focus();
				}
				else {
					$(this).val("");
				}
			}
		}
	});

	function isValidHexNum(val) {
		var strPattern = /^[0-9a-f]{2}$/i; 
		return strPattern.test(val);
	}

	/* keep focus on input boxes, handle next/prev buttons */
	$focussed_hv = $("#hv0");
	$first_hv = $("#hash_value_boxes div:first-child input");
	$last_hv = $("#hash_value_boxes div:last-child input");
	$("#hash_value_boxes input").blur(function() {
		$(this).parent("div").removeClass("focus");	//remove class from container to handle underline
	});
	$("#hash_value_boxes input").focus(function() {
		$(this).parent().addClass("focus");		//add class to container to handle underline
		$(this).select();
		$focussed_hv = $(this);
	});
	$("#hash_value_right_btn").mouseup(function() {
		if ($focussed_hv.attr("id") != $last_hv.attr("id")) {
			$focussed_hv = $focussed_hv.parent().next().find("input");
		}
		else {
			$focussed_hv = $first_hv;	//wrap
		}
		$focussed_hv.focus();
	});
	$("#hash_value_left_btn").mouseup(function() {
		if ($focussed_hv.attr("id") != $first_hv.attr("id")) {
			$focussed_hv = $focussed_hv.parent().prev().find("input");
		}
		else {
			$focussed_hv = $last_hv;	//wrap
		}
		$focussed_hv.focus();
	});


	/* handle hash keys */
	$("#hash_value_keys div").mouseup(function() {
		var val = $focussed_hv.val();
		if (val.length == 1) $focussed_hv.val(val + $(this).html());
		else $focussed_hv.val($(this).html());
		if ($focussed_hv.val().length == 2) { 
			if ($focussed_hv.attr("id") != $last_hv.attr("id")) $focussed_hv.parent().next().find("input").focus();
			else {
				$focussed_hv = $first_hv;	//wrap
				$focussed_hv.focus();
			}
		}
		else {
			$focussed_hv.focus();
		}
	});


	//Hash info - show expected/computer value for Clone w/ Verify and Hash tasks
	$("#clone_progress_details").mousedown(function() {
		var t = current_task();
		if (t == -1) return true;

		if ((current_op == OP_CLONE && task_status[t]["TaskState"] == "TASK_COMPLETED" && task_status[t]["ExpectedHashValue"] != "") ||
            (current_op == OP_HASH && (task_status[t]["TaskState"] == "TASK_COMPLETED" || task_status[t]["TaskState"] == "Hash Failed!"))) {
            var expval = formatHashValue(task_status[t]["ExpectedHashValue"], 32);
			var task_info = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"6\" width=\"100%\">";
			task_info += "<tr><td valign=\"top\" colspan=\"4\"><strong>Expected Value:</strong></td></tr>";
			task_info += "<tr><td valign=\"top\" width=\"100\">&nbsp;</td><td valign=\"top\">&nbsp;</td><td width=\"30\"&nbsp;</td><td valign=\"top\">" + expval + "</td></tr>";
			
			var compvals = task_status[t]['ComputedHashValues'];
			for (var i in compvals) {
				for (var k in compvals[i]) {
					var compval = formatHashValue(compvals[i][k], 32);
						if (i == 0) task_info += "<tr><td valign=\"top\" colspan=\"4\"><strong>Computed Values:</strong></td></tr>";
						task_info += "<tr class=\"" + (compval == expval || parseInt(expval) == 0 ? "match" : "nomatch") + "\"><td valign=\"top\" width=\"100\" class=\"" + (compval == expval || parseInt(expval) == 0 ? "check" : "ex") + "\">&nbsp;</td><td valign=\"top\">" + k + "</td><td width=\"30\"&nbsp;</td><td valign=\"top\">" + compval + "</td></tr>";
				}
			}
			task_info += "</table>";
			$("#hash_task_details_content").html(task_info);
			$("#hash_task_details_dialog").dialog('open');
		}
	});



	//set up hash_enter_values_dialog
	$("#hash_task_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		}
	});

	//------------------------------------------------------------
	// CASE INFO
	//------------------------------------------------------------
	//Case Info
	$("#hash_case_info_btn").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			$('#clone_case_info_dialog').dialog('open');
		}
	});


	//pause/unpause config calls on config dialog open/close
	$("#hash_mode_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#hash_mode_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#hash_settings_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#hash_settings_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#hash_values_dialog").bind("dialogopen", function() {
		$(this).data('opening_enter_values', false);	//initialize data
		pauseConfigCalls();
	});
	$("#hash_values_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#hash_lba_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#hash_lba_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#hash_enter_values_dialog").bind("dialogopen", function() {
		just_opened = true;
		pauseConfigCalls();
	});
	$("#hash_enter_values_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});
	$("#hash_verify_dialog").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#hash_verify_dialog").bind("dialogclose", function() {
		unpauseConfigCalls();
	});


}
