/* vim: set filetype=javascript: */
function loadTaskMacroJS() {
    //------------------------------------------------------------
	// SET UP TABS
	//------------------------------------------------------------
	//set up tabs
	$("#task_macro_tab_0").mousedown(function() { selectMacroTab(0); });
	$("#task_macro_tab_1").mousedown(function() { selectMacroTab(1); });
	$("#task_macro_tab_2").mousedown(function() { selectMacroTab(2); });
	$("#task_macro_tab_3").mousedown(function() { selectMacroTab(3); });
	$("#task_macro_tab_4").mousedown(function() { selectMacroTab(4); });


	$("#task_macro_tasks_block").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			$('#task_macro_operations_dialog').dialog('open');
		}
	});
	//set up task_macro_operations_dialog
	$("#task_macro_operations_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				$(this).dialog('close');
			}
		},
		close: function(event, ui) {
		}
	});

	//user clicks an Operation
	$("#task_macro_operations .task_macro_op .op").mousedown(function() {
		if ($(this).parent().attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			updateMacroTaskSelect($(this).text());
			$('#task_macro_operations_dialog').dialog('close');
			var op = $("#task_macro_operations .task_macro_op").index($(this).parent());
			var info = "<?= t("SELECT_TASK_FOR_OPERATION_N"); ?>";
			info = info.replace("%1", parseInt(op)+1);
			$('#task_macro_task_select_dialog').dialog('option', 'title', info);
			$('#task_macro_task_select_dialog').data('operation', op).dialog('open');
		}
	});
	//set up task_macro_task_select_dialog
	$("#task_macro_task_select_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var tab = current_tab[OP_TASK_MACRO];
				var t = 0;
				$("#task_macro_task_select .select-opt", this).each(function(i) {
					if ($(this).hasClass("ui-selected")) t = parseInt($(this).find(".task_num").text());
				});
				
				//update Operations dialog
				var op = $(this).data("operation");
				macro_list[tab]['Tasks'][op] = t;
				updateMacroPage();

				$(this).dialog('close');
				$('#task_macro_operations_dialog').dialog('open');
				
				//update macro
				MacroSetTask({'Id': tab+1, 'Task': t, 'Index': op});
				MacroList();
			}
		},
		close: function(event, ui) {
			$('#task_macro_operations_dialog').dialog('open');
		}
	});

    $("#task_macro_task_select").unbind("mousedown");                           //need to unbind "on" functions to prevent the function from being 
    $("#task_macro_task_select").on("mousedown", ".select-opt", function() {    //loaded and called twice after new language is loaded
		var cur_oper = $(this).find(".col1").html();
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var sel_oper = "";
			$("#task_macro_task_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					sel_oper = $(this).find(".col1").html();
					$(this).toggleClass("ui-selected");
				}
			});
	
			if (cur_oper != sel_oper) {
				$(this).toggleClass("ui-selected");
			}
		}		
	});

	//user clicks Operation X button to delete
	$("#task_macro_operations .task_macro_op .x").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {		//'click' isn't automically disabled for DIVs
			var op = $("#task_macro_operations .task_macro_op").index($(this).parent());
			var info = "<?= t("DELETE_OPERATION_N_ARE_YOU_SURE"); ?>";
			info = info.replace("%1", parseInt(op)+1);
			$('#task_macro_operation_delete_dialog').html(info);
			$('#task_macro_operations_dialog').dialog('close');
			$('#task_macro_operation_delete_dialog').data("op", parseInt(op)+1).dialog('open');
		}
	});
	//set up task_macro_operation_delete_dialog confirmation dialog
	$("#task_macro_operation_delete_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				var tab = current_tab[OP_TASK_MACRO];
				var op = parseInt($(this).data("op"))-1;
				MacroDelTask({'Id': tab+1, 'Task': 0, 'Index': op});	//need Task: 0 for API
			}
		},
		close: function(event, ui) {
			$('#task_macro_operations_dialog').dialog('open');
		}
	});
	


	//pause/unpause config calls on config dialog open/close
	$("#task_macro_task_select").bind("dialogopen", function() {
		pauseConfigCalls();
	});
	$("#task_macro_task_select").bind("dialogclose", function() {
		unpauseConfigCalls();
	});

}
