/* vim: set filetype=javascript: */
function loadUSBDeviceJS() {

	//------------------------------------------------------------
	// SET UP TABS, ADD TASK, DELETE TASK
	//------------------------------------------------------------
	//set up tabs
	$("#usb_device_tab_0").mousedown(function() { selectNonTaskTab(0); });
	$("#usb_device_tab_1").mousedown(function() { update_usb_settings_only = true; GetConfiguration(); selectNonTaskTab(1); });
	$("#usb_device_tab_2").mousedown(function() { selectNonTaskTab(2); });
	$("#usb_device_tab_3").mousedown(function() { selectNonTaskTab(3); });


	//Engage/Disengage button
	$("#usb_device_engage_btn").mousedown(function() {	//only one bay allowed to be selected at a time for now
		if ($(this).hasClass("ui-state-disabled")) {
			//do not select disabled
		}
		else {
			var bay = "";
			var usbstatus = "";
			$("#usb_device_drive_select .select-opt").each(function() {
				if ($(this).hasClass("ui-selected")) {
					bay = $(this).find(".col1").text();
					usbstatus = $(this).find(".col3").text();
					if (usbstatus == "<?= t("ENGAGED"); ?>") {
						USBDeviceModeStop({'Bays': new Array(bay)});
						//engaged column status and button updated in BayStatus callback
					}
					else {
						USBDeviceModeStart({'Bays': new Array(bay)});
						//engaged column status and button updated in BayStatus callback
					}
					return false; 	//only one allowed for now so exit loop
				}
			});
		}
	});


    //unhighlight current selection, highlight new selection, only one selection allowed
	//if a bay is engaged, show Disengage button for that row, disable Engage button for other rows
    $("#usb_device_drive_select").unbind("mousedown");
	$("#usb_device_drive_select").on("mousedown", ".select-opt td", function() {
        if ($(this).hasClass("select-more")) {
            var bay = $(this).parent().find(".col1").text();
            updateDriveDetails(bay);
            $("#clone_drive_details_dialog").dialog('open');
            $("#clone_drive_details_dialog").parent().css("z-index", "10010");
        }
		else {
            if ($(this).hasClass("ui-state-disabled")) {
                //do not select disabled
            }
            else {
                var cur_bay = $(this).parent().find(".col1").html();
                var sel_bay = "";
                var bay_engaged = false;
                $("#usb_device_drive_select .select-opt").each(function() {
                    if ($(this).hasClass("ui-selected")) {
                        sel_bay = $(this).find(".col1").html();
                        $(this).toggleClass("ui-selected");
                    }
                    if ($(this).find(".col3").html() == "<?= t("ENGAGED"); ?>") bay_engaged = true;
                });

                if (cur_bay != sel_bay) {
                    $(this).parent().toggleClass("ui-selected");
                    if ($(this).parent().find(".col3").html() == "<?= t("ENGAGED"); ?>") $("#usb_device_engage_btn").html("<?= t("DISENGAGE_BTN"); ?>");
                    else $("#usb_device_engage_btn").html("<?= t("ENGAGE_BTN"); ?>");
                }
                else {
                    $("#usb_device_engage_btn").html("<?= t("ENGAGE_BTN"); ?>");
                }

                if ($(this).parent().hasClass("ui-selected") && bay_engaged && $("#usb_device_engage_btn").html() == "<?= t("ENGAGE_BTN"); ?>") disableObj($("#usb_device_engage_btn"));
                else enableObj($("#usb_device_engage_btn"));
            }
        }
	});


    //unhighlight current selection, highlight new selection, only one selection allowed
	//if a bay is engaged, show Disengage button for that row, disable Engage button for other rows
    disableObj($("#clear_hpa_dco_btn"));
    disableObj($("#set_hpa_dco_btn"));
    $("#hpa_dco_drive_select").unbind("mousedown");
	$("#hpa_dco_drive_select").on("mousedown", ".select-opt td", function() {
        var cur_drive = $(this).parent().find(".col1").html();
        var sel_drive = "";
        $("#hpa_dco_drive_select .select-opt").each(function() {
            if ($(this).hasClass("ui-selected")) {
                sel_drive = $(this).find(".col1").html();
                $(this).toggleClass("ui-selected");
            }
        });

        if (cur_drive != sel_drive) {
            $(this).parent().toggleClass("ui-selected");
        }

        if ($(this).parent().hasClass("ui-selected")) {
            enableObj($("#set_hpa_dco_btn"));
            var hpa_dco_drive = driveWithBay(cur_drive);
            if (hpa_dco_drive['HPAEnabled'] == "Yes" || hpa_dco_drive['DCOEnabled'] == "Yes") {         
                enableObj($("#clear_hpa_dco_btn"));
            }
            else {
                disableObj($("#clear_hpa_dco_btn"));
            }
        }
		else {
            disableObj($("#clear_hpa_dco_btn"));
            disableObj($("#set_hpa_dco_btn"));
        }
	});
                                           


    /* Export Mode */
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#usb_export_mode_select .select-opt").mousedown(function() {
		$("#usb_export_mode_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
		if (!update_usb_settings_only) {
			if ($(this).attr("id") == "usb_export_mode_0") var m = APIUSBEXPORTMODES[USBEXPORTMODE_WRITESUPPRESS];
			else var m = APIUSBEXPORTMODES[USBEXPORTMODE_READONLY];
			SetConfiguration({"ReadOnlyExport": m});
		}
    });

	/* Export Type */
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#usb_export_type_select .select-opt").mousedown(function() {
		$("#usb_export_type_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
		if (!update_usb_settings_only) {
			if ($(this).attr("id") == "usb_export_type_0") var d = USBEXPORTTYPE_FIXEDDRIVE;
			else if ($(this).attr("id") == "usb_export_type_1") var d = USBEXPORTTYPE_REMOVABLE;
			else var d = USBEXPORTTYPE_AUTO;
			SetConfiguration({"ExportType": d});
		}
    });

	/* DCO Passthrough */
	//unhighlight current selection, highlight new selection, only one selection allowed
	$("#usb_dco_passthrough_select .select-opt").mousedown(function() {
		$("#usb_dco_passthrough_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
		});
		$(this).toggleClass("ui-selected");
		if (!update_usb_settings_only) {
			if ($(this).attr("id") == "usb_dco_passthrough_0") var d = APIUSBDCOPASSTHROUGHS[USBDCOPASSTHROUGH_ENABLED];
			else var d = APIUSBDCOPASSTHROUGHS[USBDCOPASSTHROUGH_DISABLED];
			SetConfiguration({"DCOPassThrough": d});
		}
    });

    /* HPA/DCO */
    //set up Clear HPA/DCO button
	$("#clear_hpa_dco_btn").mousedown(function() {
        if (!$(this).hasClass("ui-state-disabled")) {
            $("#hpa_dco_drive_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    var hpa_dco_sel_drive = $(this).find(".col1").text();
                    var hpa_dco_drive = driveWithBay(hpa_dco_sel_drive);
                    var hpa = (hpa_dco_drive['HPAEnabled'] == "Yes");
                    var dco = (hpa_dco_drive['DCOEnabled'] == "Yes");
                    if (hpa && dco) {
                        var info = "<?= t("WRITEPROTECT_REMOVING_HPA_DCO_ON_N_WARNING"); ?>";
                    }
                    else {
                        var info = "<?= t("WRITEPROTECT_REMOVING_HPA_ON_N_WARNING"); ?>";
                    }
                    info = info.replace("%1", '<span id="hpa_dco_sel_drive">' + hpa_dco_sel_drive + '</span>');
                    $("#clear_hpa_dco_dialog").html(info);
                    $("#clear_hpa_dco_dialog").dialog('open');
                    return;
                }
            });
        }
    });
	//set up clear_hpa_dialog
	$("#clear_hpa_dco_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				ClearHpaDco($("#hpa_dco_sel_drive").text());
			}
		}
	});

	//set up Set HPA/DCO button
	$("#set_hpa_dco_btn").mousedown(function() {
        if (!$(this).hasClass("ui-state-disabled")) {
            $("#hpa_dco_drive_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) {
                    var set_hpa_dco_sel_drive = $(this).find(".col1").text();
                    $("#set_hpa_dco_dialog").data('set_hpa_dco_sel_drive', set_hpa_dco_sel_drive).dialog('open');
                    return;
                }
            });
        }
    });
	//Set HPA/DCO dialog
	$("#set_hpa_dco_dialog").dialog({
		dialogClass: 'ui-sm-dialog ui-sm-dialog-notitlebar ui-sm-dialog-with-close set-hpa-dco-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		resizable: false,
		draggable: false,
		buttons: {
			'OK': function() {
				var hpa_val = $("#hpa_val").val();
				var dco_val = $("#dco_val").val();
				$(this).dialog('close');
                SetHpaDco({'Bay': $(this).data('set_hpa_dco_sel_drive'), 'HPASizeSectors': hpa_val, 'DCOSizeSectors': dco_val});
                $("#hpa_val").val('');
                $("#dco_val").val('');
			}
		}
	});

    var hpa_dco_focus = "hpa";
	$("#hpa_val").focus(function() {
        hpa_dco_focus = "hpa";
	});
	$("#dco_val").focus(function() {
        hpa_dco_focus = "dco";
	});

	//handle HPA Size / DCO Size number keys
	$("#set_hpa_dco_keys div").mousedown(function() {
        if (hpa_dco_focus == "hpa") {
            var val = $("#hpa_val").val();
        }
        else {
            var val = $("#dco_val").val();
        }
		var clickedid = $(this).attr("id");
		if (clickedid == "bkdel") {
			val = val.substring(0, val.length-1);
		}
		else {
			val = val + $(this).text();
		}
        if (hpa_dco_focus == "hpa") {
            $("#hpa_val").val(val);
        }
        else {
            $("#dco_val").val(val);
        }
	});
	$("#set_hpa_dco_keys div").mouseup(function() {
        if (hpa_dco_focus == "dco") {
            $("#dco_val").focus();
        }
        else {
            $("#hpa_val").focus();
        }
    });

    /* Exports */
	$("#usb_reengage").mousedown(function() {
		$("#usb_reengage_dialog").dialog('open');
	});
	//set up usb_reengage confirmation dialog
	$("#usb_reengage_dialog").dialog({
		dialogClass: 'ui-conf-dialog',
		bgiframe: true,
		autoOpen: false,
		modal: true,
		buttons: {
			'YES': function() {
				$(this).dialog('close');
				USBExportManagerRestart();
			}
		}
	});
}
