<?php include("config.php"); //sets $LOGICUBE_THEME and $LOGICUBE_DEFAULT_LANGUAGE ?>
<?php
//TRANSLATIONS
//On initial page load, GUI will use 'lang' cookie or $LOGICUBE_DEFAULT_LANGUAGE (set in config.php) (no AJAX load) for fast loading.
//If no cookie is found, the GUI will call GetConfiguration and then load this via AJAX if a new language is detected.

//After $lang is set, check for files in the following order until one exists:
//languages/$LOGICUBE_THEME/LANGUAGE/lang.csv
//languages/default/LANGUAGE/lang.csv
//languages/$LOGICUBE_THEME/$LOGICUBE_DEFAULT_LANGUAGE/lang.csv
//languages/default/$LOGICUBE_DEFAULT_LANGUAGE/lang.csv

if (isset($_POST['lang'])) $lang = $_POST['lang'];	//if language is being updated via AJAX
else $lang = $_COOKIE['lang'];	//if initial page load

//store translation strings from language file in an array
ini_set("auto_detect_line_endings", true);
$strings = array();
$file = 'languages/' . $LOGICUBE_THEME . '/' . $lang . '/lang.csv';
if (!file_exists($file)) $file = 'languages/default/' . $lang . '/lang.csv';	//get default theme language file
if (!file_exists($file)) {
	$file = 'languages/' . $LOGICUBE_THEME . '/' . $LOGICUBE_DEFAULT_LANGUAGE . '/lang.csv';
	$lang = $LOGICUBE_DEFAULT_LANGUAGE;
}
if (!file_exists($file)) {
	$file = 'languages/default/' . $LOGICUBE_DEFAULT_LANGUAGE . '/lang.csv';
	$lang = $LOGICUBE_DEFAULT_LANGUAGE;
}

if (($handle = fopen($file, 'r')) !== FALSE) {
	while (($line_parts = fgetcsv($handle, 1000, ",")) !== FALSE) {			
		//remove comments (lines that start with "#")
		if (strpos($line_parts[0], "#") === 0) {
			$line_parts = array();
		}
		else {
			$string_id = $line_parts[0];
			$translated_string = $line_parts[1];
			$font_size = $line_parts[2];
			if ($font_size != "") $translated_string = "<span style='font-size: " . $font_size . "'>" . $translated_string . "</span>";
			$strings[$lang][$string_id] = $translated_string;
		}

	}
	fclose($handle);
}
//print_r($strings);

//translate function (called throughout code)
//translate string using current language, if string not found default to English, otherwise return string_id
//$repl_strs is an array of replacement strings to replace %1, %2, ... in the translated string
//e.g. if language file contains DELETE_TASK_N;"Delete Task %1", then t("DELETE_TASK_N", array("3")) -> "Delete Task 3" 
function t($string_id, $repl_strs=array()) {
	global $strings, $lang;

	//get translated string
	if (isset($strings[$lang][$string_id]))
		$translated_string = $strings[$lang][$string_id];
	else if (isset($strings["en"][$string_id]))
		$translated_string = $strings["en"][$string_id];
	else
		$translated_string = $string_id;

	//replace placeholders with replacement strings 
	foreach ($repl_strs as $i=>$repl) {
		$translated_string = str_replace("%" . ($i+1), $repl, $translated_string);
	}
	$translated_string = str_replace("\"", "&quot;", $translated_string);	//change quotes to HTML

	return $translated_string;
}
?>

<?php if (isset($_POST['lang'])) { ?>
<?php include("main.php"); ?>
<?php } ?>
