/* vim: set filetype=javascript: */
//----------------------------------------------------------------------------------------
// GLOBAL VARIABLES
//
// These are used throughout the UI. The XML-RPC functions
// are called from the UI, and the callback function stores
// the values in these global variables.
//----------------------------------------------------------------------------------------

var DEFAULT_LANGUAGE = "<?= $lang; ?>";		//default language, set by cookie or GetConfiguration
var VERIFY_OPTION = false;					//set by GetConfiguration
var ENCRYPTION_OPTION = false;				//set by GetConfiguration
var WIPE_ONLY = "<?= $WIPE_ONLY_OPTION; ?>";//WIPE_ONLY_OPTION set in platform-specific config.php, WIPE_ONLY set by GetConfiguration

var IMAGE_RESTORE_OPTION = true;			//set by GetConfiguration
var FILETOFILE_OPTION = true;				//set by GetConfiguration
var FILE_BROWSER_OPTION = true;				//set by GetConfiguration
var MULTI_TASKING_OPTION = true;			//set by GetConfiguration
var PARALLEL_IMAGING_OPTION = true;			//set by GetConfiguration
var NETWORKING_OPTION = true;				//set by GetConfiguration

var DEFAULT_FILESYSTEM = 0;                 //set by GetConfiguration
var AUTO_DISK_INACTIVITY_TIMER = false;     //set by GetConfiguration
var DISK_INACTIVITY_TIMEOUT = 0;            //set by GetConfiguration
var DESTINATION_NCQ = 0;                    //set by GetConfiguration
var READ_ONLY_EXPORT = 0;               //set by GetConfiguration
var REMOVABLE_EXPORT = 0;               //set by GetConfiguration
var DCO_PASSTHROUGH = 0;                //set by GetConfiguration
var AUTO_REMOVE_HPA = 0;                //set by GetConfiguration
var AUTO_REMOVE_DCO = 0;                //set by GetConfiguration

var LOG_CALLBACKS = 1;
var scroll_to_settings = false;
var update_usb_settings_only = false;

var server_status =  "";			//global server status

var all_drives = new Array();		//global array with drives info from server
var drives = new Array();			//global array with drives info from server (connected drives only)
var networks = new Array();			//global array with networks info from server (used in Manage Repos - Add Repository)
var bays = new Array();				//global array with bay names and roles (used in Settings - Bay Roles, from DbBayConfig)

var repositories = new Array();		//array with repositories info from server
var filesystems = new Array();		//array with mounted filesystems info from server
var images = new Array();			//array with images info from server
var interfaces = new Array();		//array with interfaces info from server

var task_status = new Array();		//array with status info for each task (similar to API object)
									//e.g. task_status[1] = { 'TaskState': "TASK_AVAILABLE", "Mode": 0, "Master": 0, "Targets": [1,2], "Method": 1, ... }

var task_config = new Array(); 		//array with config info for each task (similar to API object)
var macro_list = new Array();		//array with info for each macro (similar to API object)

var tab_tasks = new Array();        //array with the task #s for each tab on Clone, Wipe, Hash screen,
                                    //always ascending order, not necessarily consecutive, e.g. ([1, 4, 5], [6], [11, 13], [16])
									//note: Clone tasks 1-5, Wipe tasks 6-10, Hash tasks 11-15, Push tasks 16-20

var MAX_TABS = 5;					//max # of tabs displayed on task screens on the GUI

var passkey_config = {Name: 'ConfigLock', Key: 'Not Set', Enabled: false, Timeout: 1, KeyValue: '', Challenge: '', Callback: ''};
									//array with Config Lock pass key config info, initialize here
									//{Key: 'Set/Not Set', Enabled: true/false, Timeout: 60, KeyValue: '123456', Challenge: 'xxxxx', Callback: 'unlockGUI'}

var logkey_config = {Name: 'AuditLog', Key: 'Not Set', Enabled: false, Timeout: 1, KeyValue: '', Challenge: '', Callback: ''};
									//array with Audit Log pass key config info, initialize here

var add_repo_config = {Name: '', Location: '', Bay: '', PartitionNumber: '', Path: '', Domain: '', Username: '', Password: '', Role: '', InterfaceName: ''};	//array with parameters used to call Add Repository (Manage Repos screen)

var iscsi_config = {Connected: false, Portal: '', IQN: '', Username: '', Password: '', Role: ''};	//array with parameters for iSCSI calls

var encryption_config = {CipherMode: '', Cipher: '', IVGen: '', Password: ''};	//array with parameters for Encryption calls

var timezones = new Array();	//array of Time Zone options retrieved from server
var timezone = "";				//current Time Zone retrieved from server

var notifications_config = {'success': 0, 'error': 0};    //array of Notification settings retrieved from server

var network_settings_config = {Server: '', Username: '', Password: ''};	//array with parameters for IP Settings calls

var network_interface_config = {'Name': '', 'Type': '', 'MTU': '', 'IPAddress': '', 'NetMask': '', 'Gateway': '', 'NameServers': ''};


var OPS = new Array("Clone", "Wipe", "Hash", "Push", "Task Macro", "USB Device", "Logs", "Stats", "Manage Repos", "Settings", "Network Settings", "Software", "Restart", "Drives", "File Browser");	//the task operations/screens
<?php if (($LOGICUBE_PLATFORM == "forensic") || ($LOGICUBE_PLATFORM == "zxiforensic") || ($LOGICUBE_PLATFORM == "talonu")): ?>
var num_task_ops = 4;
var num_tasks = 20;
<?php elseif ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
var num_task_ops = 1;   //leave num_task_ops and num_tasks even though not used, so task arrays don't cause errors
var num_tasks = 0;
<?php elseif ($LOGICUBE_PLATFORM == "zxtower"): ?>
var num_task_ops = 2;   //leave num_task_ops and num_tasks even though not used, so task arrays don't cause errors
var num_tasks = 10;
<?php elseif ($LOGICUBE_PLATFORM == "echoplusng"): ?>
var num_task_ops = 2;   //leave num_task_ops and num_tasks even though not used, so task arrays don't cause errors
var num_tasks = 10;
<?php else: ?>
var num_task_ops = 3;
var num_tasks = 15;
<?php endif; ?>
var TASK_OPS = OPS.slice(0, num_task_ops);		//Clone, Wipe, Hash, Push
var OP_CLONE = 0;
var OP_WIPE = 1;
var OP_HASH = 2;
var OP_PUSH = 3;
var OP_TASK_MACRO = 4;
var OP_USB_DEVICE = 5;
var OP_LOGS = 6;
var OP_STATS = 7;
var OP_MANAGE_REPOS = 8;
var OP_SETTINGS = 9;
var OP_NETWORK_SETTINGS = 10;
var OP_SOFTWARE = 11;
var OP_RESTART = 12;
var OP_DRIVES = 13;
var OP_FILE_BROWSER = 14;

var current_op = OP_CLONE;					//current op/screen
var current_tab = new Array(-1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
				                            //tab currently visible on each screen (0 to 4 on Clone, Wipe, Hash screens, varies on other screens)
								            //current_tab for Clone, Wipe, Hash handled in addTab, deleteTab, etc. functions
var current_adv_stats_bay = "";				//current bay displayed on the Adv. Drive Stats tab

function current_task() {
	var t = ((current_op < TASK_OPS.length) ? tab_tasks[current_op][current_tab[current_op]] : -1);
	return ((t == undefined)?-1:t);
}	//returns currently viewed task

function flat_tab_tasks() { return tab_tasks.reduce(function(a, b) { return a.concat(b); }); }	//returns one-dimensional tab_tasks array

var MODES = new Array("<?= t("DRIVE_TO_DRIVE"); ?>", "<?= t("IMAGE_TO_DRIVE"); ?>", "<?= t("DRIVE_TO_IMAGE"); ?>", "<?= t("FILE_TO_FILE"); ?>");
var MODE_D2D = 0;
var MODE_I2D = 1;
var MODE_D2I = 2;
var MODE_F2F = 3;
var MODE_P2F = 4;
var APIMODES = new Array("DriveToDrive", "ImageToDrive", "DriveToImage", "FileCopy");
<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
MODES[1] = "<?= t("FILE_TO_DRIVE"); ?>";
MODES[2] = "<?= t("DRIVE_TO_FILE"); ?>";
MODES[4] = "<?= t("PARTITION_TO_FILE"); ?>";
APIMODES[4] = "PartitionToFile";
var AUTHTYPES = new Array("<?= t("PASSPHRASE"); ?>", "<?= t("RECOVERY_KEY"); ?>");
var AUTHTYPE_PASSPHRASE = 0;
var AUTHTYPE_RECOVERYKEY = 1;
var APIAUTHTYPES = new Array("Passphrase", "RecoveryKey");
<?php endif; ?>

/* !!! DO NOT CHANGE !!! this fixes the issue of FxImage showing up for non-forensic platforms */
var METHODS = new Array("<?= t("CLEVER"); ?>", "<?= t("MIRROR"); ?>");
<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
METHODS[3] = "<?= t("FXIMAGE"); ?>";
<?php endif; ?>
var METHOD_CLEVER = 0;
var METHOD_MIRROR = 1;
var METHOD_FXIMAGE = 2;
var APIMETHODS = new Array("Clever", "Mirror", "FxImage");

var HASHES = new Array("<?= t("NONE"); ?>", "<?= t("SHA_1"); ?>", "<?= t("SHA_256"); ?>", "<?= t("MD5"); ?>", "<?= t("SHA1_MD5"); ?>");
var HASH_NONE = 0;
var HASH_SHA1 = 1;
var HASH_SHA2 = 2;
var HASH_MD5 = 3;
var HASH_SHA1_MD5 = 4;
var APIHASHES = new Array("NONE", "SHA-1", "SHA-256", "MD5", "SHA1-MD5");

var OUTPUTFORMATS = new Array("<?= t("DIRECTORY_TREE"); ?>", "<?= t("MFT_REPORT"); ?>", "<?= t("LX01_ARCHIVE"); ?>", "<?= t("ZIP_ARCHIVE"); ?>");
var OUTPUTFORMAT_DIRECTORY_TREE = 0;
var OUTPUTFORMAT_MFT_REPORT = 1;
var OUTPUTFORMAT_LX01_ARCHIVE = 2;
var OUTPUTFORMAT_ZIP_ARCHIVE = 3;
var APIOUTPUTFORMATS = new Array("FileOutputRaw", "FileMftReport", "FileOutputLx01", "FileOutputZip");

// PresetFilterList and FileCategoryList are stored in the API as an array of strings, e.g. ["FilePresetFilterUsers", "FilePresetFilterNoSwap"] and stored here as [1, 0, 0, 0, 1] to match button state
var PRESETFILTERS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
var APIPRESETFILTERS = new Array("FilePresetFilterUsers", "FilePresetFilterTmp", "FilePresetFilterNoWin", "FilePresetFilterNoProg", "FilePresetFilterNoSwap");
var PRESETFILTERS_LONG = new Array("<?= t("INCLUDE_ALL_USERS_DIRS"); ?>", "<?= t("INCLUDE_ALL_TEMP_WIN_DIRS"); ?>", "<?= t("EXCLUDE_WIN_DIRS"); ?>", "<?= t("EXCLUDE_PROGRAM_DIRS"); ?>", "<?= t("EXCLUDE_SWAP_HIB_DIRS"); ?>");
var PRESETFILTERS_SHORT = new Array("<?= t("INCLUDE_USERS"); ?>", "<?= t("INCLUDE_TMP"); ?>", "<?= t("EXCLUDE_WIN"); ?>", "<?= t("EXCLUDE_PROGRAM"); ?>", "<?= t("EXCLUDE_SWAP_HIB"); ?>");

var FILECATS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
var APIFILECATS = new Array("FileCategoryDoc", "FileCategoryAudio", "FileCategoryImg", "FileCategoryVideo", "FileCategoryArch");
var FILECATS_LONG = new Array("<?= t("DOCUMENTS"); ?>", "<?= t("AUDIO"); ?>", "<?= t("IMAGES"); ?>", "<?= t("VIDEO"); ?>", "<?= t("ARCHIVES"); ?>");
var FILECATS_SHORT = new Array("<?= t("DOCS"); ?>", "<?= t("AUDIO"); ?>", "<?= t("IMAGES"); ?>", "<?= t("VIDEO"); ?>", "<?= t("ARCHIVES"); ?>");

var IGNORECASES = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
var CHARENCODINGS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
    
var ERRORHANDLINGS = new Array("<?= t("SKIP"); ?>", "<?= t("ABORT"); ?>");

var ERRORGRANULARITIES = new Array("<?= t("1_SECTOR"); ?>", "<?= t("4096_BYTES"); ?>", "<?= t("64_KIB"); ?>");
var ERRORGRANULARITY_1 = 0;
var ERRORGRANULARITY_8 = 1;
var ERRORGRANULARITY_128 = 2;
var APIERRORGRANULARITIES = new Array(1, 8, 128);

var VERIFS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");

var MIRMODES = new Array("<?= t("RAID_BTN"); ?>", "<?= t("NON_RAID_BTN"); ?>");

var CAPTUREMETHODS = new Array("<?= t("dd"); ?>", "<?= t("E01"); ?>", "<?= t("EX01"); ?>", "<?= t("LOGICUBE_IMAGE"); ?>", "<?= t("FILE"); ?>");
var CAPTUREMETHOD_DD = 0;
var CAPTUREMETHOD_E01 = 1;
var CAPTUREMETHOD_EX01 = 2;
var CAPTUREMETHOD_LOGICUBE_IMAGE = 3;
var CAPTUREMETHOD_FILE = 4;
var APICAPTUREMETHODS = new Array("DriveToDD", "DriveToE01", "DriveToEx01", "DriveToImage", "FileCopy");	//these are in CloneMode on the server side

var SEGMENTSIZES = new Array("<?= t("2GB"); ?>", "<?= t("4GB"); ?>", "<?= t("8GB"); ?>", "<?= t("16GB"); ?>", "<?= t("WHOLE_DISK"); ?>");
var SEGMENTSIZE_2GB = 0;
var SEGMENTSIZE_4GB = 1;
var SEGMENTSIZE_8GB = 2;
var SEGMENTSIZE_16GB = 3;
var SEGMENTSIZE_WHOLEDISK = 4;
var APISEGMENTSIZES = new Array("2Gb", "4Gb", "8Gb", "16Gb", "WholeDisk");

var COMPRESSIONS = new Array("<?= t("NONE"); ?>", "<?= t("DEFAULT"); ?>", "<?= t("ZLIBFAST"); ?>", "<?= t("ZLIBGOOD"); ?>", "<?= t("ZLIBBEST"); ?>");
var COMPRESSION_NONE = 0;
var COMPRESSION_DEFAULT = 1;
var COMPRESSION_ZLIBFAST = 2;
var COMPRESSION_ZLIBGOOD = 3;
var COMPRESSION_ZLIBBEST = 4;
var APICOMPRESSIONS = new Array("None", "Default", "ZlibFast", "ZlibGood", "ZlibBest");

var TARGETIMGNAMES = new Array("<?= t("AUTO"); ?>", "<?= t("ENTER"); ?>");

var WIPEMETHODS = new Array("<?= t("NONE"); ?>", "<?= t("DOD"); ?>", "<?= t("CUSTOM"); ?>");
var WIPEMETHOD_NONE = 0;
var WIPEMETHOD_DOD = 1;
var WIPEMETHOD_CUSTOM = 2;
var APIWIPEMETHODS = new Array("None", "DoD", "Custom");

var WIPEERASES = new Array("<?= t("ON"); ?>", "<?= t("OFF"); ?>");
var HPAS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
var DCOS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");
var DRIVETRIMS = new Array("<?= t("YES"); ?>", "<?= t("NO"); ?>");

var WIPEPASSES = new Array("<?= t("SKIP"); ?>", "<?= t("RANDOM"); ?>", "<?= t("RANDOM_BUFFER"); ?>", "<?= t("VALUE"); ?>");
var WIPEPASS_SKIP = 0;
var WIPEPASS_RANDOM = 1;
var WIPEPASS_RANDOM_BUFFER = 2;
var WIPEPASS_VALUE = 3;

var REPOROLES = new Array("<?= t("SOURCE"); ?>", "<?= t("DESTINATION"); ?>", "<?= t("BOTH"); ?>");
var REPOROLE_SOURCE = 0;
var REPOROLE_DESTINATION = 1;
var REPOROLE_BOTH = 2;
var APIREPOROLES = new Array("Source", "Destination", "Both");

var FORMATS = new Array("<?= t("ON"); ?>", "<?= t("OFF"); ?>");
var FORMAT_ON = 0;
var FORMAT_OFF = 1;

var HASHMODES = new Array("<?= t("DRIVE_HASH"); ?>", "<?= t("CASE_VERIFY"); ?>");
var HASHMODE_DRIVE_HASH = 0;
var HASHMODE_CASE_VERIFY = 1;
var APIHASHMODES = new Array("DriveHash", "CaseVerify");

<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
var HASHVERIFIES = new Array("<?= t("PRIMARY"); ?>", "<?= t("BOTH"); ?>");
var HASHVERIFY_PRIMARY = 0;
var HASHVERIFY_BOTH = 1;
var APIHASHVERIFIES = new Array("Primary", "Both");
<?php else: ?>
var HASHVERIFIES = new Array("<?= t("PRIMARY"); ?>", "<?= t("SECONDARY"); ?>", "<?= t("BOTH"); ?>");
var HASHVERIFY_PRIMARY = 0;
var HASHVERIFY_SECONDARY = 1;
var HASHVERIFY_BOTH = 2;
var APIHASHVERIFIES = new Array("Primary", "Secondary", "Both");
<?php endif; ?>
    
var FILESYSTEMS = new Array("<?= t("EXT4"); ?>", "<?= t("NTFS"); ?>");
var FILESYSTEM_EXT4 = 0;
var FILESYSTEM_NTFS = 1;
var APIFILESYSTEMS = new Array("ext4", "ntfs");

var ENCRYPTS = new Array("<?= t("ON"); ?>", "<?= t("OFF"); ?>");
var ENCRYPT_ON = 0;
var ENCRYPT_OFF = 1;
var APIENCRYPTS = new Array("encrypt", "");

var CIPHERMODES = new Array("<?= t("TC-XTS"); ?>", "<?= t("CBC"); ?>", "<?= t("ECB"); ?>", "<?= t("VCRYPT"); ?>");
var CIPHERMODE_TC_XTS = 0;
var CIPHERMODE_CBC = 1;
var CIPHERMODE_ECB = 2;
var CIPHERMODE_VCRYPT = 3;
var APICIPHERMODES = new Array("TC-XTS", "CBC", "ECB", "VCRYPT");

var CIPHERS = new Array("<?= t("AES"); ?>");
var CIPHER_AES = 0;
var APICIPHERS = new Array("aes");

var IVGENS = new Array("<?= t("PLAIN64"); ?>", "<?= t("ESSIV_SHA256"); ?>");
var IVGEN_PLAIN64 = 0;
var IVGEN_ESSIV = 1;
var APIIVGENS = new Array("plain64", "ESSIV:SHA256");

var STEALTHMODES = new Array("<?= t("ON"); ?>", "<?= t("OFF"); ?>");
var STEALTHMODE_ON = 0;
var STEALTHMODE_OFF = 1;
var APISTEALTHMODES = new Array("ON", "OFF");

var DESTINATIONNCQS = new Array("<?= t("ON"); ?>", "<?= t("OFF"); ?>");
var DESTINATIONNCQ_ON = 0;
var DESTINATIONNCQ_OFF = 1;
var APIDESTINATIONNCQS = new Array(true, false);

var BAYROLES = new Array("<?= t("MASTER"); ?>", "<?= t("TARGET"); ?>", "<?= t("BOTH"); ?>");
var BAYROLE_MASTER = 0;
var BAYROLE_TARGET = 1;
var BAYROLE_BOTH = 2;
var APIBAYROLES = new Array("Master", "Target", "Master/Target");

var NOTIFICATIONS = new Array("<?= t("NONE"); ?>", "<?= t("SOUND"); ?>");
var NOTIFICATION_NONE = 0;
var NOTIFICATION_SOUND = 1;
var APINOTIFICATIONS = new Array(0, 1);
    
var USBEXPORTSTATUSES = new Array("<?= t("ENGAGED"); ?>", "<?= t("AVAILABLE"); ?>");
var USBEXPORTSTATUS_ENGAGED = 0;
var USBEXPORTSTATUS_AVAILABLE = 1;
var APIUSBEXPORTSTATUSES = new Array("Engaged", "Available");

var USBEXPORTMODES = new Array("<?= t("WRITE_SUPPRESS"); ?>", "<?= t("READ_ONLY"); ?>");
var USBEXPORTMODE_WRITESUPPRESS = 0;
var USBEXPORTMODE_READONLY = 1;
var APIUSBEXPORTMODES = new Array(false, true);

var USBEXPORTTYPES = new Array("<?= t("FIXED_DRIVE"); ?>", "<?= t("REMOVABLE"); ?>", "<?= t("AUTO"); ?>");
var USBEXPORTTYPE_FIXEDDRIVE = 0;
var USBEXPORTTYPE_REMOVABLE = 1;
var USBEXPORTTYPE_AUTO = 2;

var USBDCOPASSTHROUGHS = new Array("<?= t("ENABLED"); ?>", "<?= t("DISABLED"); ?>");
var USBDCOPASSTHROUGH_ENABLED = 0;
var USBDCOPASSTHROUGH_DISABLED = 1;
var APIUSBDCOPASSTHROUGHS = new Array(true, false);

var AUTOREMOVEHPAS = new Array("<?= t("ENABLED"); ?>", "<?= t("DISABLED"); ?>");
var AUTOREMOVEHPA_ENABLED = 0;
var AUTOREMOVEHPA_DISABLED = 1;
var APIAUTOREMOVEHPAS = new Array(true, false);

var AUTOREMOVEDCOS = new Array("<?= t("ENABLED"); ?>", "<?= t("DISABLED"); ?>");
var AUTOREMOVEDCO_ENABLED = 0;
var AUTOREMOVEDCO_DISABLED = 1;
var APIAUTOREMOVEDCOS = new Array(true, false);

var INTERFACETYPES = new Array("<?= t("STATIC"); ?>", "<?= t("DHCP"); ?>");
var INTERFACETYPE_STATIC = 0;
var INTERFACETYPE_DHCP = 1;
var APIINTERFACETYPES = new Array("static", "dhcp");

var UPDATE_INTERVAL = 2000;			//when running a task, check TaskStatus every 2 seconds
var SLOWER_UPDATE_INTERVAL = 10000;	//for RepositoryList, check every 10 seconds
var PAUSE_CONFIG_CALLS = false;		//while user has a modal dialog open and is editing config settings,
									//pause calls the get task's config settings from server
var DRIVE_MODAL_OPEN = false;		//when Master or Target window is open, don't update "Selected" drive status

var CLOCK_UPDATE_INTERVAL = 60000;	//call GetDateTime to get time every minute

var NW_INTERFACE_STATS_UPDATE_INTERVAL = 2000;  //for ZXi Forensic when on the Stats page, 
                                                //update Network Interface Stats every 2 seconds

var START_SERVER_CALLS = true;		//FOR DEBUGGING, allow user to start/stop server calls
var SHOW_CALLBACK_ALERTS = false;	//FOR DEBUGGING, allow user to show/hide callback alerts

var UPDATE_FILE_BROWSER_PAGE = false;

//------------------------------------------------------------
// XML-RPC FUNCTIONS
//------------------------------------------------------------
var ip = location.host;
//if (ip == "localhost") ip = "127.0.0.1";
var xmlserver = "http://" + ip + "/RPC2";	//fix JavaScript error: Uncaught NetworkError: A network error occurred. on line 116 for http://localhost/js/xmlrpc.js.
//var xmlserver = "http://209.239.228.40:80/RPC2";

//specify XML-RPC API version
function SetVersion(v) {
	var params = new Array();
	params[0] = v;
	xmlrpc(xmlserver, "SetVersion", params, callback, err, final);
}

//get default config
function GetConfiguration() {
	var params = new Array();
	xmlrpc(xmlserver, "GetConfiguration", params, callback, err, final);
}
//set default config
function SetConfiguration(config_params) {
	var params = new Array();
	params[0] = config_params;
	xmlrpc(xmlserver, "SetConfiguration", params, callback, err, final);
}

//initialize global values
function initGlobals() {
	//allocate task tabs
	for (var i=0; i<num_task_ops; i++) {
		tab_tasks[i] = new Array();
    }

    //allocate task status and configuration
	for (var t=1; t<=num_tasks; t++) {
		if (typeof(task_status[t]) == "undefined") task_status[t] = new Array();      //allocate status array for the task

        if (typeof(task_config[t]) == "undefined") {    //allocate and initialize configuration array for the task
			task_config[t] = new Array();
			task_config[t]["Master"] = "";
			task_config[t]["Targets"] = new Array();
			task_config[t]["RepositoryList"] = new Array();
			task_config[t]["HashType"] = HASH_NONE;
			task_config[t]["CleverResizePercentages"] = new Array();
			task_config[t]["LBACount"] = 0;
			task_config[t]["Repository"] = "";
			task_config[t]["SourceImagePath"] = "";
			task_config[t]["DestinationImagePath"] = "";
			task_config[t]["HashValue"] = "";
			task_config[t]["ValidateMode"] = HASHMODE_DRIVE_HASH;
			task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_DIRECTORY_TREE;
			if (t > 15) task_config[t]["Operation"] = OP_PUSH;
			else if (t > 10) task_config[t]["Operation"] = OP_HASH;
			else if (t > 5) task_config[t]["Operation"] = OP_WIPE;
			else task_config[t]["Operation"] = OP_CLONE;
		}
	}
}
    
//show time
var intervalIdClock;
function startClockServerCalls() {
	clearInterval(intervalIdClock);
    GetDateTime();
}
//'Date' => "Jun 04, 2015", 'LocalTime' => "15:58:37 (PDT -0700)"
function updateClock(d, t) {
    var dt = d + " " + t.replace(/:[0-9][0-9] /, " ");
    /* var d = new Date();
    var h = d.getHours();
    var m = d.getMinutes();
    m = (m < 10) ? "0" + m : m;
    var dt = $.datepicker.formatDate('MM d, yy', d) + " " + (h > 12 ? (h-12 + ":" + m + " PM") : (h + ":" + m + " AM")); */

    $("#datetime").html(dt);

    intervalIdClock = setInterval("startClockServerCalls()", CLOCK_UPDATE_INTERVAL);
}


//show disabled GUI and server status while back end loads
var intervalId4;
function startServerStatusCalls() {
	clearInterval(intervalId4);
	GetServerStatus();
}
//callback from GetServerStatus
function updateServerStatus(s, ec, ins) {
	if (s == "Ready") {
		$("#disabled_gui_status").css("display", "none");
		$("#disabled_gui_status div").html("");
        GetConfiguration();
	}
	else if (s == "Error") {
		$("#disabled_gui_status").css("display", "table");
		$("#disabled_gui_status div").html("<?= t("POST_ERROR"); ?>" + (ec != "" ? " " + ec : "") + ": " + ins);
	}
	else if (s == "FW_Upgrade_Done") {
		$("#disabled_gui_status").css("display", "table");
		$("#disabled_gui_status div").html(ins);
	}
	else {
		var status = "<img src=\"themes/<?php print $LOGICUBE_THEME; ?>/images/ajax-loader.gif\" /><br/>" + s + "...";
		if ($("#disabled_gui_status").css("display") == "none") {
			$("#disabled_gui_status").css("display", "table");
		}
		if ($("#disabled_gui_status div").html() != status) {	//check for this so loader image doesn't restart
			$("#disabled_gui_status div").html(status);
		}
		intervalId4 = setInterval("startServerStatusCalls()", UPDATE_INTERVAL);
	}
	server_status = s;	//update global server status
}


//periodically poll server for BayStatus and TaskStatus
var intervalId;
function startServerCalls() {
    if (START_SERVER_CALLS && !changing_language) {
        clearInterval(intervalId);

        if (!PAUSE_CONFIG_CALLS) PassKeyGet("ConfigLock");
        BayStatus();
		//if file browser update is required
		if (UPDATE_FILE_BROWSER_PAGE) {
			GetSourceBrowserList();
			UPDATE_FILE_BROWSER_PAGE = false;
		}
        TaskList();
        //TaskStatus calls made in TaskList callback

        if (current_op == OP_SETTINGS) GetStealthMode();	//see if user has turned Stealth Mode off on the device
    }
}

//call TaskStatus on tasks returned by TaskList
function taskStatusCalls(t) {
	for (var i in t) {
		TaskStatus(t[i]["Task"]);
	}
	if (current_op == OP_TASK_MACRO) {	//show progress on Task Macro page
		MacroStatus(current_tab[OP_TASK_MACRO]+1);
	}

	intervalId = setInterval("startServerCalls()", UPDATE_INTERVAL);
}

//periodically poll server for RepositoryList (slower interval than other server calls)
var intervalId3;
function startSlowerServerCalls() {
    if (START_SERVER_CALLS && !changing_language) {
        //console.log('startSlowerServerCalls');
        clearInterval(intervalId3);
        RepositoryList();
        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
        GetMountedFsList();
        <?php endif; ?>
    }
}
//called on RepositoryList callback
function slowerServerCalls() {
	intervalId3 = setInterval("startSlowerServerCalls()", SLOWER_UPDATE_INTERVAL);
}

//periodically poll server for ApplicationCheckForUpdatesStatus
var intervalId1;
function startAppUpdateCalls() {
	clearInterval(intervalId1);
	ApplicationCheckForUpdatesStatus();
}
function stopAppUpdateCalls() {
	clearInterval(intervalId1);
}
//on callback from ApplicationCheckForUpdatesStatus, update status
function updateAppStatus(stats, taskstate) {
	if ("CurrentJob" in stats) {
		var cj = stats['CurrentJob'];
		if (("Status" in cj) && ("LatestVersion" in cj)) {
			var os = cj['OperationStep'];
			var lv = cj['LatestVersion'];
			var p = cj['Path'];
			var s = cj['Status'];

			if (os == "ApplicationCheckForUpdatesWww") {
				$("#software_network_box").html(lv);
				$("#software_network_path").html(p);
				if (lv != "Not Available") enableObj($("#software_network_update"));
				else disableObj($("#software_network_update"));
			}
			else if (os == "ApplicationCheckForUpdatesUsb") {
				$("#software_usb_box").html(lv);
				$("#software_usb_path").html(p);
				if (lv != "Not Available") enableObj($("#software_usb_update"));
				else disableObj($("#software_usb_update"));
			}

			$("#software_update_dialog").html(s);
			hideObj($('.ui-set-up-abort-button'));
			showObj($('.ui-set-up-ok-button'));

			stopAppUpdateCalls();
			return;
		}
		else {
			var os = cj['OperationStep'];
			var step = cj['Step'];

			if (os == "ApplicationCheckForUpdatesWww") {
				$("#software_update_dialog").html(s);
			}
			else if (os == "ApplicationCheckForUpdatesUsb") {
				$("#software_update_dialog").html(step);
			}
		}
	}
	else if (taskstate == "TASK_RESERVED") {
		//don't show any update info if task hasn't started
	}
	else if (taskstate != "TASK_WORKING") {
		$("#software_update_dialog").html(taskstate);
		hideObj($('.ui-set-up-abort-button'));
		showObj($('.ui-set-up-ok-button'));
		stopAppUpdateCalls();
		return;
	}

	hideObj($('.ui-set-up-ok-button'));
	showObj($('.ui-set-up-abort-button'));
	if (START_SERVER_CALLS) intervalId1 = setInterval("startAppUpdateCalls()", UPDATE_INTERVAL);
}


//periodically poll server for ApplicationUpgradeStatus
var intervalId2;
function startAppUpgradeCalls() {
	clearInterval(intervalId2);
	ApplicationUpgradeStatus();
}
function stopAppUpgradeCalls() {
	clearInterval(intervalId2);
}
//on callback from ApplicationUpgradeStatus, update status
function updateAppUpgradeStatus(stats) {
	if ("CurrentJob" in stats) {
		var cj = stats['CurrentJob'];
		if ("Step" in cj) {
			var step = cj['Step'];
			var elapsed = cj['SecondsElapsed'];
			var jobpct = Math.floor(stats['JobsPercentage']);
			var jobcmp = Math.floor(stats['JobsCompleted']);	//total bytes completed
			var jobtotal = stats['JobsTotal'];
			var os = cj['OperationStep'];

			if (step == "Install Complete") {
				var s = "<?= t("UPDATE_COMPLETE"); ?><br/><br/><div style=\"font-size: 0.8em\"><?= t("PLEASE_POWER_OFF_ON"); ?></div>";
				$("#software_upgrade_dialog").html(s);

				$("#software_network_box").html("");
				$("#software_usb_box").html("");
				disableObj($("#software_network_update"));
				disableObj($("#software_usb_update"));

				hideObj($('.ui-set-upgrade-abort-button'));
				showObj($('.ui-set-upgrade-ok-button'));

				stopAppUpdateCalls();
				return;
			}
			else if ((step == "Download Failed") || (step == "Setup Failed") ||
				     (step == "Installing Dependencies Failed") || (step == "Install Failed") ||
				     (step == "Verify Failed") || (step == "Aborted")) {
				var s = "<?= t("LOADING_SOFTWARE"); ?><br/>" + step + "<br/>";
				$("#software_upgrade_dialog").html(s);

				$("#software_network_box").html("");
				$("#software_usb_box").html("");
				disableObj($("#software_network_update"));
				disableObj($("#software_usb_update"));

				hideObj($('.ui-set-upgrade-abort-button'));
				showObj($('.ui-set-upgrade-ok-button'));

				stopAppUpdateCalls();
				return;
			}
			else {
				var s = "<?= t("LOADING_SOFTWARE"); ?><br/>" + step + "<br/>" +
					"<div style=\"margin-left: 45px\">" + jobpct + "% " +
					"<img style=\"position: relative; top: 3px\" src=\"themes/<?php print $LOGICUBE_THEME; ?>/images/ajax-loader-modal-conf.gif\" /></div>";
				$("#software_upgrade_dialog").html(s);

				hideObj($('.ui-set-upgrade-ok-button'));

				if ((step == "Setting up Installer") || (step == "Installing Dependencies") ||
				    (step == "Installing") || (step == "Verifying") || (step == "Aborting"))
					hideObj($('.ui-set-upgrade-abort-button'));
				else
					showObj($('.ui-set-upgrade-abort-button'));
 			}
 		}
		else {
			hideObj($('.ui-set-upgrade-ok-button'));
			showObj($('.ui-set-upgrade-abort-button'));
		}
    }

    if (START_SERVER_CALLS) intervalId2 = setInterval("startAppUpgradeCalls()", UPDATE_INTERVAL);
}

function updateFeatureList(features) {
	//var features = new Array({"Name": "Verify Option", "Value": true}, {"Name": "SAS Option", "Value": false});	//TESTING
	if ($("#stats_features_select .header_row").length == 0) {		//first time showing Features
		$("#stats_features_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("OPTION"); ?></td><td class=\"col2\"><?= t("INSTALLED"); ?></td><td class=\"col3\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var f in features) {
			$("#stats_features_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + features[f]["Name"] + "</td>"
                + "<td class=\"col2" + (features[f]["Value"] == "1" ? " feature-installed" : " feature-not-installed") + "\"></td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#stats_features_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {	//Features already initialized, just update rows with new drive info
		var row = -1;
		$("#stats_features_select .select_row").each(function(i) {
			if (features.length > i) {
				$(this).find(".col1").html(features[i]["Name"]);
                if (features[i]["Value"] == "1") {
					$(this).find(".col2").addClass("feature-installed");
					$(this).find(".col2").removeClass("feature-not-installed");
				}
				else {
					$(this).find(".col2").addClass("feature-not-installed");
					$(this).find(".col2").removeClass("feature-installed");
				}
			}
			else {	//fewer Features than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<features.length; j++) {	//more Features than before, so add before footer row
			$("#stats_features_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + features[j]["Name"] + "</td>"
				+ "<td class=\"col2" + (features[j]["Value"] == "1" ? " feature-installed" : " feature-not-installed") + "\"></td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}



//FOR DEBUGGING
function toggleServerCalls() {
	if (START_SERVER_CALLS) {
		clearInterval(intervalId);
		clearInterval(intervalId3);
		$("#toggle_server_calls").html("Start Server Calls");
	}
	else {
		startServerCalls();
		startSlowerServerCalls();
		$("#toggle_server_calls").html("Stop Server Calls");
	}

	START_SERVER_CALLS = !START_SERVER_CALLS;
}

//FOR DEBUGGING
function toggleCallbackAlerts() {
	if (SHOW_CALLBACK_ALERTS) {
		$("#toggle_callback_alerts").html("Show Callback Alerts");
	}
	else {
		$("#toggle_callback_alerts").html("Hide Callback Alerts");
	}

	SHOW_CALLBACK_ALERTS = !SHOW_CALLBACK_ALERTS;
}


//FOR DEBUGGING
function alert_callback(msg) {
	if (SHOW_CALLBACK_ALERTS) {
        alert(msg);
        console.log(msg);
    }
}

function pauseConfigCalls() {
	PAUSE_CONFIG_CALLS = true;
}
function unpauseConfigCalls() {
	PAUSE_CONFIG_CALLS = false;
}


//API CALLS
function GetServerStatus() {
	var params = new Array();
	xmlrpc(xmlserver, "GetServerStatus", params, callback, err, final);
}

function PassKeyGet(name) {
	var params = new Array({'Name': name});
	xmlrpc(xmlserver, "PassKeyGet", params, callback, err, final);
}
function PassKeySet(name, keyvalue) {
	if (name == "AuditLog") var key_config = logkey_config;
	else var key_config = passkey_config;
	if (key_config['Key'] == 'Not Set') {
		key_config['KeyValue'] = keyvalue;
		var keyset_params = {"Name": name, "Key": key_config['KeyValue'], "Enabled": key_config['Enabled'], "Timeout": key_config['Timeout']*60};
	}
	else {
		var response = Sha1.hash(key_config['KeyValue'] + key_config['Challenge']);
		if (keyvalue != "") key_config['KeyValue'] = keyvalue;		//in case disabling or updating auto lock
		var keyset_params = {"Name": name, "Key": key_config['KeyValue'], "Enabled": key_config['Enabled'], "Timeout": key_config['Timeout']*60, "Response": response};
		key_config['Challenge'] = '';
	}

	var params = new Array();
	params[0] = keyset_params;
	xmlrpc(xmlserver, "PassKeySet", params, callback, err, final);
}
function PassKeyValidate(name) {
	if (name == "AuditLog") var key_config = logkey_config;
	else var key_config = passkey_config;
	var keyval_params = {'Name': name, 'Key': key_config['KeyValue']};
	var params = new Array();
	params[0] = keyval_params;
	xmlrpc(xmlserver, "PassKeyValidate", params, callback, err, final);
}


function BayStatus() {
	var params = new Array();
	xmlrpc(xmlserver, "BayStatus", params, callback, err, final);
}

function TaskList() {
	var params = new Array();
	xmlrpc(xmlserver, "TaskList", params, callback, err, final);
}
function TaskStatus(t) {
	var params = new Array();
	params[0] = t;
	xmlrpc(xmlserver, "TaskStatus", params, callback, err, final);
}
function TaskPromptResponse(prompt_params) {
	var params = new Array();
	params[0] = prompt_params;
	xmlrpc(xmlserver, "TaskPromptResponse", params, callback, err, final);
}
function TaskGetConfiguration(t) {
	var params = new Array();
	params[0] = t;
	xmlrpc(xmlserver, "TaskGetConfiguration", params, callback, err, final);
}
function TaskSetConfiguration(setconfig_params) {
	var params = new Array();
	params[0] = setconfig_params;
	xmlrpc(xmlserver, "TaskSetConfiguration", params, callback, err, final);
}
function TaskReserve(op) {
	var taskreserve_params = {'Task': 0, 'Operation': op};
	var params = new Array();
	params[0] = taskreserve_params;
	xmlrpc(xmlserver, "TaskReserve", params, callback, err, final);
}
function TaskRelease(t) {
	var params = new Array();
	params[0] = t;
	xmlrpc(xmlserver, "TaskRelease", params, callback, err, final);
}
function TaskStart(t) {
	disableObj($("#clone_start_btn"));	//**SEE IF THIS IS THE RIGHT PLACE FOR THIS**
	var params = new Array();
	params[0] = t;
    console.log(params);
	xmlrpc(xmlserver, "TaskStart", params, callback, err, final);
}
function TaskStartList(tasks) {
	disableObj($("#clone_start_btn"));	//**SEE IF THIS IS THE RIGHT PLACE FOR THIS**
	var params = new Array();
	params[0] = tasks;
    console.log(params);
	xmlrpc(xmlserver, "TaskStartList", params, callback, err, final);
}
function TaskAbort(t) {
	disableObj($("#clone_abort_btn"));	//**SEE IF THIS IS THE RIGHT PLACE FOR THIS**
	var params = new Array();
	params[0] = t;
	xmlrpc(xmlserver, "TaskAbort", params, callback, err, final);
}
function TaskReset(t) {
	var params = new Array();
	params[0] = t;
	xmlrpc(xmlserver, "TaskReset", params, callback, err, final);
}

function RepositoryList() {
	var params = new Array();
	xmlrpc(xmlserver, "RepositoryList", params, callback, err, final);
}
function RepositoryListContents(n) {
	var repolist_params = {'Name': n};
	var params = new Array();
	params[0] = repolist_params;
	xmlrpc(xmlserver, "RepositoryListContents", params, callback, err, final);
}
function RepositoryListDirs(n) {
	var repolist_params = {'Name': n};
	var params = new Array();
	params[0] = repolist_params;
	xmlrpc(xmlserver, "RepositoryListDirs", params, callback, err, final);
}

function GetMountedFsList() {
	var params = new Array();
	xmlrpc(xmlserver, "GetMountedFsList", params, callback, err, final);
}
function GetMountedFsContents(n, mp) {
	var fs_params = {'Name': n, 'MountPath': mp};
	var params = new Array();
	params[0] = fs_params;
	xmlrpc(xmlserver, "GetMountedFsContents", params, callback, err, final);
}

function ImageCreateNew(r, p) {
	if (p != "") {
		var imgcreate_params = {'Repository': r, 'Path': p};
	}
	else {
		var imgcreate_params = {'Repository': r};
	}
	var params = new Array();
	params[0] = imgcreate_params;
	xmlrpc(xmlserver, "ImageCreateNew", params, callback, err, final);
}

function ImageGetConfiguration(t, r, p) {
	var imgconfig_params = {'Task': t, 'Repository': r, 'Path': p};
	var params = new Array();
	params[0] = imgconfig_params;
	xmlrpc(xmlserver, "ImageGetConfiguration", params, callback, err, final);
}

function UnlockPartition(unlock_params) {
	var params = new Array();
	params[0] = unlock_params;
	xmlrpc(xmlserver, "UnlockPartition", params, callback, err, final);
}

/* TASK MACRO API CALLS */
function MacroList() {
	var params = new Array();
	xmlrpc(xmlserver, "MacroList", params, callback, err, final);
}
function MacroSetTask(macro_params) {
	var params = new Array();
	params[0] = macro_params;
	xmlrpc(xmlserver, "MacroSetTask", params, callback, err, final);
}
function MacroDelTask(macro_params) {
	var params = new Array();
	params[0] = macro_params;
	xmlrpc(xmlserver, "MacroDelTask", params, callback, err, final);
}
function MacroStart(m) {
	disableObj($("#clone_start_btn"));	//**SEE IF THIS IS THE RIGHT PLACE FOR THIS**
	var params = new Array();
	params[0] = m;
	xmlrpc(xmlserver, "MacroStart", params, callback, err, final);
}
function MacroStop(m) {
	disableObj($("#clone_abort_btn"));	//**SEE IF THIS IS THE RIGHT PLACE FOR THIS**
	var params = new Array();
	params[0] = m;
	xmlrpc(xmlserver, "MacroStop", params, callback, err, final);
}
function MacroStatus(m) {
	var params = new Array();
	params[0] = m;
	xmlrpc(xmlserver, "MacroStatus", params, callback, err, final);
}


/* USB DEVICE API CALLS */
function USBDeviceModeStart(usb_params) {
	var params = new Array();
	params[0] = usb_params;
	xmlrpc(xmlserver, "USBDeviceModeStart", params, callback, err, final);
}
function USBDeviceModeStop(usb_params) {
	var params = new Array();
	params[0] = usb_params;
	xmlrpc(xmlserver, "USBDeviceModeStop", params, callback, err, final);
}
function USBExportManagerRestart() {
	var params = new Array();
	xmlrpc(xmlserver, "USBExportManagerRestart", params, callback, err, final);
}
function ClearHpaDco(drive) {
	var params = new Array();
	params[0] = drive;
	xmlrpc(xmlserver, "ClearHpaDco", params, callback, err, final);
}
function SetHpaDco(hpa_dco_params) {
	var params = new Array();
	params[0] = hpa_dco_params;
	xmlrpc(xmlserver, "SetHpaDco", params, callback, err, final);
}

/* LOGS API CALLS */
function ListAuditLogs() {
	var params = new Array();
	xmlrpc(xmlserver, "ListAuditLogs", params, callback, err, final);
}
function ExportAuditLog(log_params) {
    //show loader
    disableGUI();
    var status = "<?= t("EXPORTING"); ?><br/><img style=\"position: relative; top: 3px\" src=\"themes/<?php print $LOGICUBE_THEME; ?>/images/ajax-loader.gif\" />";
    $("#disabled_gui_status").css("display", "table");
    $("#disabled_gui_status div").html(status);

    setTimeout(function() { //delay call so loader image shows up
        var params = new Array();
        params[0] = log_params;
        xmlrpc(xmlserver, "ExportAuditLog", params, callback, err, final);
    }, 500);
}
function DeleteAuditLog(log_params) {
	var params = new Array();
	params[0] = log_params;
	xmlrpc(xmlserver, "DeleteAuditLog", params, callback, err, final);
}
function DeleteAllAuditLogs(log_params) {
	var params = new Array();
	params[0] = log_params;
	xmlrpc(xmlserver, "DeleteAllAuditLogs", params, callback, err, final);
}

/* SETTINGS / STATS API CALLS */
function ApplicationVersion() {
	var params = new Array();
	xmlrpc(xmlserver, "ApplicationVersion", params, callback, err, final);
}
function GetDateTime() {
    var params = new Array();
    xmlrpc(xmlserver, "GetDateTime", params, callback, err, final);
}
function CheckFirmwareUpdate() {
	var params = new Array();
	xmlrpc(xmlserver, "CheckFirmwareUpdate", params, callback, err, final);
}
function UpgradeFirmware() {
	var params = new Array();
	xmlrpc(xmlserver, "UpgradeFirmware", params, callback, err, final);
}

function BayReadSmartData(bay) {
	var params = new Array();
	params[0] = bay;
	xmlrpc(xmlserver, "BayReadSmartData", params, callback, err, final);
}

function ApplicationCheckForUpdates(loc) {
	var appcheck_params = {'Location': loc};
	var params = new Array();
	params[0] = appcheck_params;
	xmlrpc(xmlserver, "ApplicationCheckForUpdates", params, callback, err, final);
}

function ApplicationCheckForUpdatesStatus() {
	var params = new Array();
	xmlrpc(xmlserver, "ApplicationCheckForUpdatesStatus", params, callback, err, final);
}

function ApplicationCheckForUpdatesAbort() {
	var params = new Array();
	xmlrpc(xmlserver, "ApplicationCheckForUpdatesAbort", params, callback, err, final);
}

function ApplicationUpgrade(p) {
	var appupgrade_params = {'Path': p};
	var params = new Array();
	params[0] = appupgrade_params;
	xmlrpc(xmlserver, "ApplicationUpgrade", params, callback, err, final);
}

function ApplicationUpgradeStatus() {
	var params = new Array();
	xmlrpc(xmlserver, "ApplicationUpgradeStatus", params, callback, err, final);
}

function ApplicationUpgradeAbort() {
	var params = new Array();
	xmlrpc(xmlserver, "ApplicationUpgradeAbort", params, callback, err, final);
}

function GetFeatureList() {
	var params = new Array();
	xmlrpc(xmlserver, "GetFeatureList", params, callback, err, final);
}

function GetNWInterfaceStats() {
	var params = new Array();
	xmlrpc(xmlserver, "GetNWInterfaceStats", params, callback, err, final);
}

function DbManagement(db_params) {
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbManagement", params, callback, err, final);
}

function DbNetworkConfig(db_params) {
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbNetworkConfig", params, callback, err, final);
}

function EncryptionGet() {
	var params = new Array();
	xmlrpc(xmlserver, "EncryptionGet", params, callback, err, final);
}

function EncryptionSet(enc_params) {
	var params = new Array();
	params[0] = enc_params;
	xmlrpc(xmlserver, "EncryptionSet", params, callback, err, final);
}

function CheckLanguageSupport(cl_params) {
	var params = new Array();
	params[0] = cl_params;
	xmlrpc(xmlserver, "CheckLanguageSupport", params, callback, err, final);
}

function SetLanguageSupportKey(sl_params) {
	var params = new Array();
	params[0] = sl_params;
	xmlrpc(xmlserver, "SetLanguageSupportKey", params, callback, err, final);
}

function TimeZoneList() {
	var params = new Array();
	xmlrpc(xmlserver, "TimeZoneList", params, callback, err, final);
}

function TimeZoneGet() {
	var params = new Array();
	xmlrpc(xmlserver, "TimeZoneGet", params, callback, err, final);
}

function TimeZoneSet(tz_params) {
	var params = new Array();
	params[0] = tz_params;
	xmlrpc(xmlserver, "TimeZoneSet", params, callback, err, final);
}

function GetLCDBrightness() {
	var params = new Array();
	xmlrpc(xmlserver, "GetLCDBrightness", params, callback, err, final);
}

function SetLCDBrightness(b) {
	var params = new Array();
	params[0] = b;
	xmlrpc(xmlserver, "SetLCDBrightness", params, callback, err, final);
}

function GetStealthMode() {
	var params = new Array();
	xmlrpc(xmlserver, "GetStealthMode", params, callback, err, final);
}

function SetStealthMode(s) {
	var params = new Array();
	params[0] = s;
	xmlrpc(xmlserver, "SetStealthMode", params, callback, err, final);
}

function AssignBayRole(r) {
	var params = new Array();
	params[0] = r;
	xmlrpc(xmlserver, "AssignBayRole", params, callback, err, final);
}

function NotificationsGetAll() {
	var params = new Array();
	xmlrpc(xmlserver, "NotificationsGetAll", params, callback, err, final);
}

function SetBeeper(sb_params) {
	var params = new Array();
	params[0] = sb_params;
	xmlrpc(xmlserver, "SetBeeper", params, callback, err, final);
}

/* NETWORK SETTINGS API CALLS */
function DbServicesConfig(db_params) {
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbServicesConfig", params, callback, err, final);
}

function DbBayConfig(db_params) {
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbBayConfig", params, callback, err, final);
}

function DbHttpProxyConfig(oper) {
	if (oper == 6) var db_params = {'DbOpr': oper, 'server': network_settings_config['Server'], 'username': network_settings_config['Username'], 'password': network_settings_config['Password']};
	else var db_params = {'DbOpr': oper};
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbHttpProxyConfig", params, callback, err, final);
}

function GetNWInterfaceList() {
	var params = new Array();
	xmlrpc(xmlserver, "GetNWInterfaceList", params, callback, err, final);
}

function SetNWInterface(nwint_params) {
    if (nwint_params['Type'] == INTERFACETYPE_DHCP) {
	   nwint_params['Gateway'] = null;
	   nwint_params['NameServers'] = null;
    }
	nwint_params['Type'] = APIINTERFACETYPES[nwint_params['Type']];
	var params = new Array();
	params[0] = nwint_params;
	xmlrpc(xmlserver, "SetNWInterface", params, callback, err, final);
}

/* MANAGE REPOS API CALLS */
function RepositoryAdd(repo_params) {
	if (repo_params['Location'] == "Network") {
		delete repo_params['Bay'];
		delete repo_params['PartitionNumber'];
	}
	else if (repo_params['Location'] == "Bay") {
		delete repo_params['Path'];
		delete repo_params['Domain'];
		delete repo_params['Username'];
		delete repo_params['Password'];
	}
	repo_params['Role'] = APIREPOROLES[repo_params['Role']];
	var params = new Array();
	params[0] = repo_params;
	xmlrpc(xmlserver, "RepositoryAdd", params, callback, err, final);
}

function RepositoryRemove(r) {
	var repo_params = {'Name': r};
	var params = new Array();
	params[0] = repo_params;
	xmlrpc(xmlserver, "RepositoryRemove", params, callback, err, final);
}

function ImageDelete(repo_file_params) {
	var params = new Array();
	params[0] = repo_file_params;
	xmlrpc(xmlserver, "ImageDelete", params, callback, err, final);
}

function ImageDeleteAll(repo_name) {
	var repo_params = {'Repository': repo_name};
	var params = new Array();
	params[0] = repo_params;
	xmlrpc(xmlserver, "ImageDeleteAll", params, callback, err, final);
}

function RepositoryFormat(repo_params) {
	var params = new Array();
	params[0] = repo_params;
	xmlrpc(xmlserver, "RepositoryFormat", params, callback, err, final);
}

function DbIscsiConfig(db_params) {
	var params = new Array();
	params[0] = db_params;
	xmlrpc(xmlserver, "DbIscsiConfig", params, callback, err, final);
}
function IscsiConnect(iscsi_params) {
	var params = new Array();
	params[0] = iscsi_params;
	xmlrpc(xmlserver, "IscsiConnect", params, callback, err, final);
}
function IscsiDisconnect(iscsi_params) {
	var params = new Array();
	params[0] = iscsi_params;
	xmlrpc(xmlserver, "IscsiDisconnect", params, callback, err, final);
}

function IscsiList() {
	var params = new Array();
	xmlrpc(xmlserver, "IscsiList", params, callback, err, final);
}

/* POWER OFF API CALLS */
function RunCommand(c) {
	var runcommand_params = {'Command': c};
	var params = new Array();
	params[0] = runcommand_params;
	xmlrpc(xmlserver, "RunCommand", params, callback, err, final);
}

/* FILE BROWSER API CALLS */
function GetSourceBrowserList() {
	var params = new Array();
	xmlrpc(xmlserver, "GetSourceBrowserList", params, callback, err, final);
}
                                            
function callback(ret) {
	var method = ret['Method'];
    //console.log('method=' + method + ' changing_language=' + changing_language);
    if (changing_language) {    //if in the process of changing language, don't update anything to avoid JS errors
        console.log('method=' + method + ' changing_language=' + changing_language);
        return;
    }
	if (method != "GetDateTime" && method != "PassKeyGet" && method != "GetStealthMode" && method != "BayStatus" && method != "RepositoryList" && method != "GetMountedFsList" && method != "TaskStatus" && method != "TaskList" /*&& method != "TaskGetConfiguration"*/) alert_callback(dump(ret, 4));

	if ((ret['Result'] == "COMMAND_ACCEPTED") || (ret['Result'] == "COMMAND_COMPLETED")) {
		switch(method) {
			case "SetVersion":
                startServerStatusCalls();
                startClockServerCalls();
				break;
			case "GetServerStatus":
				var s = ret['Status'];
				var ec = "";
				var ins = "";
				if ('ErrorCode' in ret) ec = ret['ErrorCode'];
				if ('Instruction' in ret) ins = ret['Instruction'];
				updateServerStatus(s, ec, ins);
				break;
			case "GetConfiguration":
				var c = ret['Configuration'];            
				DEFAULT_LANGUAGE = c['DefaultLanguage'];
				VERIFY_OPTION = c['VerifyOption'];
				ENCRYPTION_OPTION = c['EncryptionOption'];
				if (!ENCRYPTION_OPTION) {
					$("#settings_tab_2").remove();
					hideObj($("#clone_format_encrypt_container"));
					hideObj($("#wipe_format_encryption_title"));
					hideObj($("#wipe_format_encryption_select"));
				}
				WIPE_ONLY = c['WipeOnlyOption'];

				IMAGE_RESTORE_OPTION = c['ImageRestoreOption'];
				FILETOFILE_OPTION = c['FileToFileOption'];
				FILE_BROWSER_OPTION = c['FileBrowserOption'];
				if (!FILE_BROWSER_OPTION) $("#navbtn_file_browser").remove();
				NETWORKING_OPTION = c['NetworkingOption'];
				if (!NETWORKING_OPTION) {
					$("#navbtn_push").remove();
					$("#navbtn_push_content").remove();
					$("#navbtn_manage_repos").remove();
					$("#manage_repos_content").remove();
				}
				MULTI_TASKING_OPTION = c['MultiTaskingOption'];
				PARALLEL_IMAGING_OPTION = c['ParallelImagingOption'];

		                DEFAULT_FILESYSTEM = (c['DefaultFilesystem'] == "ext4" ? FILESYSTEM_EXT4 : FILESYSTEM_NTFS);
                AUTO_DISK_INACTIVITY_TIMER = c['AutoDiskInactivityTimer'];
                DISK_INACTIVITY_TIMEOUT = c['DiskInactivityTimeout'];
                DESTINATION_NCQ = (c['DestinationNcq'] == true ? DESTINATIONNCQ_ON : DESTINATIONNCQ_OFF);
                READ_ONLY_EXPORT = (c['ReadOnlyExport'] == true ? USBEXPORTMODE_READONLY : USBEXPORTMODE_WRITESUPPRESS);
		REMOVABLE_EXPORT = c['ExportType'];
                DCO_PASSTHROUGH = (c['DCOPassThrough'] == true ? USBDCOPASSTHROUGH_ENABLED : USBDCOPASSTHROUGH_DISABLED);
                AUTO_REMOVE_HPA = (c['AutoRemoveHPA'] == true ? AUTOREMOVEHPA_ENABLED : AUTOREMOVEHPA_DISABLED);
                AUTO_REMOVE_DCO = (c['AutoRemoveDCO'] == true ? AUTOREMOVEDCO_ENABLED : AUTOREMOVEDCO_DISABLED);
                if (update_usb_settings_only) {
                    updateUSBSettings();
                }
                else {
                    initPage();
                    updateDefaultFileSystem();
                    updateDrivePower();
                    updateDestinationNCQ();
                }
				break;
			case "SetConfiguration":
                break;
			case "PassKeyGet":
				var name = ret['Name'];	//"ConfigLock" or "AuditLog"
				var key = ret['Key'];	//"Set" or "Not Set"
				if ('Enabled' in ret) var enabled = ret['Enabled'];
				else var enabled = false;
				if ('Timeout' in ret) var timeout = Math.round(ret['Timeout']/60);
				else var timeout = 0;
				updateKeyConfig(name, key, enabled, timeout);
				break;
			case "PassKeyValidate":
				var key = ret['Name'];
				var valid = ret['Valid'];
				if ('Challenge' in ret) var challenge = ret['Challenge'];
				else challenge = '';
				handlePassKeyValidate(key, valid, challenge);
				break;
			//set up DRIVES so drive info is at first object level: e.g. d.Bay, d.Size
			//and partition info is in the 'Partition' object: e.g. d.Partitions[0].FileSystem, d.Partitions[0].PartSize
			case "BayStatus":
				var d = ret['Drives'];
				updateDrives(d);
				checkFileBrowserUpdateRequired(d);
				break;
			case "DbNetworkConfig":
				var n = ret['DbNetCfgList'];
				updateNetworks(n);
				break;
			case "TaskList":
				var t = ret['Tasks'];
				taskStatusCalls(t);
                <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
                enableGUI();
                <?php endif; ?>
				break;
			case "TaskStatus":
				var t = parseInt(ret['Task']);
				if (t > num_tasks) return;
				if ('PromptUser' in ret) {
					if ($("#clone_target_repo_select .select-opt").length > 0) {
						var prompt_msg = ret['PromptUser']['Message'];
						var prompt_type = ret['PromptUser']['Type'];
						if (prompt_type == "SelectDestinationRepo") {
							if (!$("#clone_target_repo_dialog").dialog('isOpen') && !$("#prompt_message_dialog").dialog('isOpen') && !$("#clone_format_options_dialog").dialog('isOpen') && !$("#clone_format_repo_dialog").dialog('isOpen')) {
								//switch to prompted task
								var m = t;
								if (t > 15) { m -= 15; switchToOperation(OP_PUSH); }
								else if (t > 10) { m -= 10; switchToOperation(OP_HASH); }
								else if (t > 5) { m -= 5; switchToOperation(OP_WIPE); }
								else if (t > 0) { switchToOperation(OP_CLONE); }
								selectTab(m-1);

								//show prompt message, which upon closing will open repo select modal
								$("#prompt_message_dialog").html(prompt_msg).data('prompt_task', t).dialog('open');
							}
						}
					}
				}
                                                                                                                    
                if ('TaskState' in ret && 'Stats' in ret) {
                    var state = ret['TaskState'];
                    var stats = ret['Stats'];
                    if ('ExpectedHashValue' in ret) stats['ExpectedHashValue'] = ret['ExpectedHashValue'];
                    else stats['ExpectedHashValue'] = "";
                    if ('ComputedHashValues' in ret) stats['ComputedHashValues'] = ret['ComputedHashValues'];
                    else stats['ComputedHashValues'] = "";
                    updateTaskStatus(t, state, stats);
                }
				break;
			case "TaskSetConfiguration":
				//do nothing
				break;
			case "TaskGetConfiguration":
				var t = parseInt(ret['Task']);
				var config = ret['Configuration'];
				updateTaskConfig(t, config);
				break;
			case "TaskReserve":
				var t = parseInt(ret['Task']);
				TaskStatus(t);
				break;
			case "TaskRelease":
				var t = parseInt(ret['Task']);
				deleteTab(t);
				task_status[t]["TaskState"] = "TASK_AVAILABLE";
				break;
			case "TaskStart":
				var t = parseInt(ret['Task']);
				if ('ParallelTasks' in ret) {
					var pt = ret['ParallelTasks'];
					updateParallelTaskSelect(t, pt);
					$("#clone_parallel_task_dialog").dialog('open');
				}
				else {
					TaskStatus(t);
				}
				break;
			case "TaskStartList":
				//TaskStatus on each task
				break;
			case "TaskAbort":
				var t = parseInt(ret['Task']);
				TaskStatus(t);
				break;
			case "TaskReset":
				var t = parseInt(ret['Task']);
				TaskStatus(t);
				break;
			case "MacroList":
				macro_list = ret['Macros'];
				updateMacroPage();
				break;
			case "MacroDelTask":
				MacroList();
				break;
			case "MacroStart":
				var m = ret['Id'];
				MacroStatus(m);
				break;
			case "MacroStop":
				var m = ret['Id'];
				MacroStatus(m);
				break;
			case "MacroStatus":
				if ('Id' in ret['Status']) {
					var m = ret['Status']['Id'];
					macro_list[m-1] = ret['Status'];
				}
				updateMacroPage();
				break;
			case "RepositoryList":
				var r = ret['Repositories'];
				updateRepositories(r);
				slowerServerCalls();
				break;
			case "RepositoryListContents":
				var imgs = ret['Images'];
				updateImages(imgs);
				break;
            case "RepositoryListDirs":
                var cases = ret['Directories'];
                updateCaseList(cases);
                break;
            case "GetMountedFsList":
                var fslist = ret['MountedFsList'];
                updateFilesystems(fslist);
                break;
            case "GetMountedFsContents":
                var cases = ret['Contents'];
                updateCaseList(cases);
                break;
            case "ImageCreateNew":
				var t = current_task();
				var p = ret['Path'];		//set target image to newly created image
				task_config[t]["DestinationImagePath"] = p;
				TaskSetConfiguration({"Task": t, "DestinationImagePath": p});
				if (typeof(task_config[t]["Repository"]) != "undefined") {
					RepositoryListContents(task_config[t]["Repository"]);
				}
				var top = Math.min(0, $("#mcs_container9").height() - $("#clone_target_image_select").height());
				$("#mcs_container9 .container").css("top", top + "px");
				break;
			case "ImageGetConfiguration":
				var t = ret['Task'];
				var config = ret['ImageConfiguration'];
				updateImageConfigSettings(t, config);
				break;
			case "UnlockPartition":
                var status = ret['Status'];
                if (status == 'COMMAND_UNLOCK_SUCCESS') {
                    if ($("#clone_partition_decrypt_error").text() != "") $("#clone_partition_decrypt_error").text("");
                    $("#clone_partition_auth_0").mousedown();
                    $("#clone_master_partition_select").find("tr.ui-selected td.col4").removeClass("part-locked").addClass("part-unlocked");
                    $("#clone_partition_decrypt_keyboard_dialog").dialog('close');
                }
                else {
                    $("#clone_partition_decrypt_error").text("<?= t("COMMAND_ERROR_UNLOCK_FAILED"); ?>");
                }
				break;
			case "USBDeviceModeStart":
				BayStatus();
				break;
			case "USBDeviceModeStop":
				BayStatus();
				break;
            case "USBExportManagerRestart":
                break;
            case "ClearHpaDco":
                break;
            case "SetHpaDco":
                break;
			case "ListAuditLogs":
				var lfs = ret['Logs'];
				updateLogFiles(lfs);
				break;
			case "ExportAuditLog":
                //hide loader
                $("#disabled_gui_status").css("display", "none");
		        $("#disabled_gui_status div").html("");
                enableGUI();

                $("#logs_export_dialog").html("<?= t("LOG_FILE_EXPORTED_SUCCESSFULLY"); ?>");
				$("#logs_export_dialog").dialog('open');
				break;
			case "DeleteAuditLog":
				ListAuditLogs();
				break;
			case "DeleteAllAuditLogs":
				ListAuditLogs();
				break;
			case "ApplicationVersion":
				updateAppVersion(ret);
				break;
            case "GetDateTime":
                updateClock(ret['Date'], ret['LocalTime']);
                break;
			case "CheckFirmwareUpdate":
				updateFirmwareStatus(ret);
				break;
			case "BayReadSmartData":
				var attr = ret['Smart']['Attributes'];
				updateAdvDriveStats(attr);
				break;
			case "ApplicationCheckForUpdates":
                startAppUpdateCalls();
				break;
			case "ApplicationCheckForUpdatesStatus":
				var stats = ret['Stats'];
				var taskstate = ret['TaskState'];
				updateAppStatus(stats, taskstate);
				break;
			case "ApplicationCheckForUpdatesAbort":
				stopAppUpdateCalls();
				break;
			case "ApplicationUpgrade":
				$('#software_upgrade_dialog').html("<?= t("LOADING_SOFTWARE"); ?>");
				$('#software_upgrade_dialog').dialog('open');
				startAppUpgradeCalls();
				break;
			case "ApplicationUpgradeStatus":
				var stats = ret['Stats'];
				updateAppUpgradeStatus(stats);
				break;
			case "ApplicationUpgradeAbort":
				stopAppUpgradeCalls();
				break;
			case "GetFeatureList":
				var features = ret['FeatureList'];
				updateFeatureList(features);
				break;
			case "GetNWInterfaceStats":
				var stats = ret['NWInterfaceList'];
				updateNWInterfaceStats(stats);
				break;
			case "DbManagement":
				if (ret['DbOpr'] == 0) {
					$('#settings_config_apply_dialog').html('Configuration applied successfully');
					$("#settings_config_apply_dialog").dialog('open');
				}
				else if (typeof(ret['DbList']) != "undefined") {
					updateSettingsProfiles(ret['DbList']);
				}
				break;
			case "EncryptionGet":
				var r = ret['DbEncryptionCfg'];
				if (r['CipherMode'] == APICIPHERMODES[CIPHERMODE_TC_XTS]) encryption_config['CipherMode'] = CIPHERMODE_TC_XTS;
				else if (r['CipherMode'] == APICIPHERMODES[CIPHERMODE_ECB]) encryption_config['CipherMode'] = CIPHERMODE_ECB;
				else if (r['CipherMode'] == APICIPHERMODES[CIPHERMODE_VCRYPT]) encryption_config['CipherMode'] = CIPHERMODE_VCRYPT;
				else encryption_config['CipherMode'] = CIPHERMODE_CBC;
				if (r['Cipher'] == APICIPHERS[CIPHER_AES]) encryption_config['Cipher'] = CIPHER_AES;
				else encryption_config['Cipher'] = CIPHER_AES;
				if (r['IVGen'] == APIIVGENS[IVGEN_ESSIV]) encryption_config['IVGen'] = IVGEN_ESSIV;
				else encryption_config['IVGen'] = IVGEN_PLAIN64;
				encryption_config['Password'] = r['Password'];
				updateEncryptionModals();
				updateEncryptionButtons();
				break;
			case "EncryptionSet":
				break;
            case "CheckLanguageSupport":
                if (verifying_init_lang_support) {  //support check on initial load
                    if (ret['Status'] == "Valid") {
                        finishInitPage(false, ret['Name']);
                    }
                    else {
                        //attempting to load unit with unverified language, so load default language
                        setCookie('lang', '0', 0);	//delete cookie
                        finishInitPage(true, DEFAULT_LANGUAGE);
                    }
                    verifying_init_lang_support = false;
                }
                else {  //support check when changing languages
                    if (ret['Status'] == "Valid") loadLanguage(ret['Name']);
                    else {
                        //attempting to switch to unverified language, so show validation code modal
                        $("#settings_lang_validation_error").html('');
                        $("#settings_lang_validation_name").text(ret['Name']);
                        $("#lv").val('');
                        $("#settings_lang_validation_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disable OK button
                        $("#settings_lang_validation_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
                        $("#settings_lang_validation_dialog").dialog('open');
                    }
                }
                break;
            case "SetLanguageSupportKey":
                if (ret['Status'] == "Valid") {
                    $("#settings_lang_validation_dialog").dialog('close');
                    $("#settings_lang_validation_error").html('');
                    $("#settings_lang_validation_name").text('');
                    loadLanguage(ret['Name']);
                }
                else {
                    $("#settings_lang_validation_error").html('<?= t("ERROR_INVALID_CODE_PLEASE_TRY_AGAIN"); ?>');
                    $("#settings_lang_validation_dialog").dialog('open');
                }
                break;
			case "TimeZoneList":
				timezones = ret['TimeZones'];
				updateTimeZoneRegionSelect();
				break;
			case "TimeZoneGet":
				timezone = ret['TimeZone'];
				updateTimeZonePage();
				break;
			case "TimeZoneSet":
				break;
			case "GetLCDBrightness":
				var b = ret['Status'];
				updateBrightnessPage(b);
				break;
			case "GetStealthMode":
				var s = ret['Status'];
				updateStealthModePage(s);
				break;
			case "NotificationsGetAll":
				var n = ret['DbNotificationsCfgList'];
				updateNotificationsPage(n);
				break;
			case "DbBayConfig":
				var r = ret['DbBayCfgList'];
				updateBayRoles(r);
				break;
			case "DbServicesConfig":
				if ('DbServicesCfgList' in ret) updateNetworkServices(ret['DbServicesCfgList']);	//if getting Services, not setting
                else if ('name' in ret && 'allowed' in ret) updateNetworkServiceRow(ret['name'], ret['allowed']);
				break;
			case "DbHttpProxyConfig":
				if ('DbHttpProxyCfgList' in ret) updateNetworkSettings(ret['DbHttpProxyCfgList']);	//if getting Settings, not setting
				break;
			case "GetNWInterfaceList":
                //alert(dump(ret, 2));
				interfaces = ret['NWInterfaceList'];
                for (var i in interfaces) {
					if (interfaces[i]['Type'] == "static") interfaces[i]['Type'] = INTERFACETYPE_STATIC;
					else interfaces[i]['Type'] = INTERFACETYPE_DHCP;
                }
                if (current_op == OP_MANAGE_REPOS) updateNetworkSourceModal();
                else updateInterfaceList();
				break;
            case "SetNWInterface":
                GetNWInterfaceList();   //call this so the Interface list page gets udpated
                break;
			case "RepositoryAdd":
				RepositoryList();
				clearAddRepoConfig();
				break;
			case "RepositoryRemove":
				RepositoryList();
				break;
			case "RepositoryFormat":
				$("#clone_format_repo_dialog").html("<?= t("FORMAT_COMPLETE"); ?>");
				$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
				$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');

				RepositoryList();
				break;
			case "DbIscsiConfig":
				if ('DbIscsiCfg' in ret) {
					var dbcfg = ret['DbIscsiCfg'];
					iscsi_config['Portal'] = dbcfg['portal'];
					iscsi_config['IQN'] = dbcfg['iqn'];
					iscsi_config['Username'] = dbcfg['username'];
					iscsi_config['Password'] = dbcfg['password'];

					if (dbcfg['role'] == "Destination") iscsi_config['Role'] = REPOROLE_DESTINATION;
					else if (dbcfg['role'] == "Both") iscsi_config['Role'] = REPOROLE_BOTH;
					else iscsi_config['Role'] = REPOROLE_SOURCE;

					updateIscsiPage();
				}
				break;
            case "IscsiConnect":
                iscsi_config['Connected'] = true;
                $("#iscsi_connect_dialog").html("<?= t("CONNECTED"); ?>");
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
                updateIscsiPage();
                break;
            case "IscsiDisconnect":
                iscsi_config['Connected'] = false;
                $("#iscsi_connect_dialog").html("<?= t("DISCONNECTED"); ?>");
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
                updateIscsiPage();
                break;
			case "IscsiList":
				break;
			case "GetSourceBrowserList":
                var dirs = ret['SourceBrowserList'];
                updateFileBrowserTabs(dirs);
				break;
			default:
				break;
		}
	}
	else { 		//COMMAND_BUSY, COMMAND_ERROR_SYNTAX, COMMAND_ERROR_RESOURCE_UNAVAILABLE
		if (ret['Method'] == "GetServerStatus") { 	//retry
			GetServerStatus();
		}
		else if (ret['Method'] == "ApplicationUpgrade") {
			$('#software_upgrade_dialog').dialog('close');
			var error_msg = "Application Upgrade Error: " + ret['Result'];
			showTransientError(error_msg);
		}
		else {
			if (ret['Method'] == "RepositoryFormat") {
				$("#clone_format_repo_dialog").dialog('close');
				$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
				$("#clone_format_repo_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
			}
            else if (ret['Method'] == "IscsiConnect" || ret['Method'] == "IscsiDisconnect") {
                $("#iscsi_connect_dialog").dialog('close');
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//enable OK button
                $("#iscsi_connect_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
                enableObj($("#iscsi_network_block"));
                enableObj($("#iscsi_role_block"));
                disableObj($("#iscsi_disconnect"));
                enableObj($("#iscsi_connect"));
            }
            else if (ret['Method'] == "ExportAuditLog") {
                //hide loader
                $("#disabled_gui_status").css("display", "none");
		        $("#disabled_gui_status div").html("");
                enableGUI();
            }
			var xmlrpc_error_msg = "XML-RPC " + method + " operation failed: " + ret['Result'];
			showTransientError(xmlrpc_error_msg);
		}
	}

}

//do this the first time the Clone page is loaded
//check the TaskStatus of tasks #1-5 and update GUI
var verifying_init_lang_support = false;    //flag to verifying language support on initial load (done for Korean)
function initPage() {
    //set language
    var update_lang = false;
    var lang = getCookie('lang');
    if (lang != 'english' && lang != 'chinese' && lang != 'korean' && lang != 'japanese' && lang != 'custom') {	//if no valid cookie found, use DEFAULT_LANGUAGE from GetConfiguration
        lang = DEFAULT_LANGUAGE;
        if ((DEFAULT_LANGUAGE != "") && (DEFAULT_LANGUAGE != "<?= $lang; ?>")) {		//if we need to update GUI with new language
            update_lang = true;
        }
    }
    else if (lang == 'korean') {
        verifying_init_lang_support = true;
        CheckLanguageSupport({'Name': 'korean'});
        return;
    }
    finishInitPage(update_lang, lang);
}
function finishInitPage(update_lang, lang) {
    if (update_lang) {
        $("#main").load("languages.php", {lang: lang}, function() {	//AJAX load new language
            $("#clone_progressbar").progressbar({
                value: 0,
                create: function() {
                    $("#clone_subtask_progressbar").progressbar({
                        value: 0,
                        create: function() {
                            disableObj($("#clone_start_btn"));
                            initOtherModals();
                            startServerCalls();
                            startSlowerServerCalls();
                        }
                    });
                }
            });
        });
    }
    else {
        $("#clone_progressbar").progressbar({
            value: 0,
            create: function() {
                $("#clone_subtask_progressbar").progressbar({
                    value: 0,
                    create: function() {
                        disableObj($("#clone_start_btn"));
                        initOtherModals();
                        startServerCalls();
                        startSlowerServerCalls();
                    }
                });
            }
        });
    }

    setCookie('lang', lang, 365*1440);	//expire in 1 yr
    //remove certain features if WipeOnly
    if (WIPE_ONLY) {
        $("#navbtn_clone").remove();            //remove Clone, Hash, Manage Repos
        $("#navbtn_hash").remove();
        $("#navbtn_manage_repos").remove();
        $("#clone_content").hide();             //still need some Clone dialogs
        $("#hash_content").remove();
        $("#manage_repos_content").remove();

        $("#wipe_format").remove();     //Wipe Settings
        if ($("#stats_tab_2").length > 0) $("#stats_tab_2").remove();     //I/O Ports tab
        $("#stats_tab_3").remove();     //Options tab
        $("#settings_tab_6").remove();  //Bay Roles tab
    }

    $("#nav_buttons .navbtn:nth-child(-n+4)").css("display", "table");  //show first 4 nav btns
    if (scroll_to_settings) {   //if we just changed language, stay on Settings page Language tab
        var num_scrolldowns = Math.ceil($("#navbtn_settings").index() / 4) - 1;
        for (var i=0; i<num_scrolldowns; i++) {
            $("#nav_down").mousedown();
                                         }
        switchToOperation(OP_SETTINGS); //don't do mousedown to bypass possible config lock
        selectNonTaskTab(3);
    }

        //remove Bay Roles from all except ZXi
        //(done here instead of in platform JS files because it needs to be removed from default also
    <?php if ($LOGICUBE_PLATFORM != "zclonexi"): ?>
	$("#settings_tab_6, #settings_page_6").remove();
    <?php endif; ?>
    <?php if ($LOGICUBE_PLATFORM != "writeprotect" && $LOGICUBE_PLATFORM != "writeprotectportable" && $LOGICUBE_PLATFORM != "pciebridge"): ?>
	$("#settings_tab_8, #settings_page_8, #settings_tab_9, #settings_page_9").remove();
    <?php endif; ?>

    //load JS for pages, needs to be done after selectables, etc. are created in initOtherModals
    <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower"): ?> loadDrivesJS(); <?php endif; ?>
    loadCloneJS();
    loadWipeJS();
    loadHashJS();
    loadPushJS();
    loadTaskMacroJS();
    loadUSBDeviceJS();
    loadLogsJS();
    loadStatsJS();
    loadManageReposJS();
    loadSettingsJS();
    loadNetworkSettingsJS();
    loadSoftwareJS();
    loadRestartJS();
    loadFileBrowserJS();
    loadLastJS();
    if (lang == "korean") loadHangulIMEJS();
}

//load new page, turn off old button, turn on new button
function switchToOperation(op) {
	if (op != current_op) {
		var current_op_pre = OPS[current_op].toLowerCase().replace(" ", "_");
		var op_pre = OPS[op].toLowerCase().replace(" ", "_");
		$("#navbtn_" + op_pre).addClass("selected");
		$("#navbtn_" + current_op_pre).removeClass("selected");

		current_op = op;

		if (current_op < TASK_OPS.length) {	//do this for task ops only
			showObj($("#clone_prog"));
			updateProgressBars();	//updateGUI does these three plus updateTabs,
			updateButtons("all");	//we don't need to updateTabs, just show/hide operation content
			updateModals("all");

			$("#clone_abort_btn").html("<?= t("ABORT_TASK_BTN"); ?>");
			$("#clone_abort_dialog").attr("title", "<?= t("ABORT_TASK"); ?>");
			$("#clone_reset_btn").html("<?= t("RESET_TASK_BTN"); ?>");
			$("#clone_reset_dialog").attr("title", "<?= t("RESET_TASK"); ?>");
		}
		else if (current_op == OP_TASK_MACRO) {
			showObj($("#clone_prog"));
			MacroList();

			$("#clone_abort_btn").html("<?= t("ABORT_MACRO_BTN"); ?>");
			$("#clone_abort_dialog").attr("title", "<?= t("ABORT_MACRO"); ?>");
			$("#clone_reset_btn").html("<?= t("RESET_MACRO_BTN"); ?>");
			$("#clone_reset_dialog").attr("title", "<?= t("RESET_MACRO"); ?>");
		}
		else {
			hideObj($("#clone_prog"));	//only need clone_prog stuff on task ops
		}

		showObj($("#" + op_pre + "_content"));
		hideObj($("#" + current_op_pre + "_content"));

		//(GUI is disabled/enabled if necessary)
		//do XML-RPC calls here (after switching screens) because of delay due to synchronous API calls
		//disable GUI if necessary and reenable on callback
		if (op == OP_USB_DEVICE) {
			updateUSBDevicePage();
            <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
			updateHPADCODrives();
            <?php endif; ?>
		}
		else if (op == OP_LOGS) {
			PassKeyGet("AuditLog");
			ListAuditLogs();
		}
		else if (op == OP_STATS) {
			ApplicationVersion();
			if ((current_adv_stats_bay == "") || (driveWithBay(current_adv_stats_bay) == -1)) {	//set current bay
				if (drives.length > 0) {
					current_adv_stats_bay = drives[0]["Bay"];
					updateAdvDriveStatsBay(current_adv_stats_bay);
					BayReadSmartData(current_adv_stats_bay);
				}
				else current_adv_stats_bay = "";
			}
			<?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "talonu" || $LOGICUBE_PLATFORM == "echoplusng"): ?>
			GetFeatureList();
			<?php endif; ?>
		}
		else if (op == OP_MANAGE_REPOS) {
			RepositoryList();
			DbIscsiConfig({'DbOpr':5,'id': 1});
		}
		else if (op == OP_SETTINGS) {
			DbManagement({'DbOpr': 4});
			PassKeyGet("AuditLog");
			EncryptionGet();
			TimeZoneGet();
			TimeZoneList();
			GetLCDBrightness();
			GetStealthMode();
                        <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng" ): ?>
			DbBayConfig({'DbOpr': 4});
			<?php endif; ?>
			NotificationsGetAll();
		}
		else if (op == OP_NETWORK_SETTINGS) {
            DbServicesConfig({'DbOpr': 4});
            GetNWInterfaceList();
			DbHttpProxyConfig(4);
        }
		else if (op == OP_SOFTWARE) {
			ApplicationVersion();
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng" || $LOGICUBE_PLATFORM == "talonu" || $LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge" || $LOGICUBE_PLATFORM == "zxiforensic"): ?>
			CheckFirmwareUpdate();
			<?php endif; ?>
		}
		else if (op == OP_RESTART) {
			//nothing needed
		}
		else if (op == OP_DRIVES) {
			updateDrivesSelect();
		}
		else if (op == OP_FILE_BROWSER) {
            GetSourceBrowserList();
		}

        //start NW Interface Stats calls when on Stats page, stop when off page
        if (op == OP_STATS) {
            startNWInterfaceStatsCalls();
        }
        else {
            stopNWInterfaceStatsCalls();
        }

	}
}



//show error dialog for transient errors
function showTransientError(msg) {
	enableGUI();

    var trace = printStackTrace();
	console.log(trace.join('\n'));

    var error_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
	error_info += "<tr><td>" + msg + "</td></tr>\n";
	error_info += "</table>";

	$('#clone_error_details_scroller').html(error_info);
	$('#clone_error_details_dialog').dialog('open');
}


//XML-RPC error function
function err(e) {
	var xmlrpc_error_msg = "XML-RPC " + e;
	showTransientError(xmlrpc_error_msg);
}

//XML-RPC final function
function final() {
	//alert('final');
}



/* Language */
function loadLanguage(lang) {
    disableGUI();
    var status = "<img src=\"themes/<?php print $LOGICUBE_THEME; ?>/images/ajax-loader.gif\" />";
    $("#disabled_gui_status").css("display", "table");
    $("#disabled_gui_status div").html(status);

    $(".ui-dialog").empty();	//clear out dialogs here because they are created outside of #main
    changing_language = true;

    $("#main").load("languages.php", {lang: lang}, function() {
        changing_language = false;
        DEFAULT_LANGUAGE = lang;
        setCookie('lang', lang, 365*1440);	//expire in 1 yr

        //show current language as selected
        $("#settings_lang_btns .select-opt").each(function(i) {
            if ($(this).attr("id") == "settings_lang_" + DEFAULT_LANGUAGE) $(this).addClass("ui-selected");
            else $(this).removeClass("ui-selected");
        });

        //stay on Settings page Languages tab (handled after WipeOnly value removes buttons)
        scroll_to_settings = true;

        //NOTE: works without page reload when using asynchronous XML-RPC calls, however we reverted to synchronous, so do this here
        document.location.reload(true);
    });
}


/* Config Lock */
function initPassKeyModals() {
	//set up Edit Key Settings & Unlock input boxes
	for (var i=0; i<6; i++) {
		$("#settings_key_boxes").append("<div id=\"kv" + i + "_container\"><input type=\"password\" value=\"\" maxlength=\"1\" id=\"kv" + i + "\" /></div>");
	}
	for (var i=6; i<12; i++) {
		$("#settings_rekey_boxes").append("<div id=\"kv" + i + "_container\"><input type=\"password\" value=\"\" maxlength=\"1\" id=\"kv" + i + "\" /></div>");
	}
	for (var i=0; i<6; i++) {
		$("#settings_unlock_boxes").append("<div id=\"uv" + i + "_container\"><input type=\"password\" value=\"\" maxlength=\"1\" id=\"uv" + i + "\" /></div>");
	}

	//set up Edit Key Settings & Unlock keys
	var vals = [];
	for (var i=0; i<16; i++) {
		vals.push(i);
	}
	$(vals, this).each(function(i) {
		$("#settings_key_keys").append("<div id=\"kk" + i + "\">" + dispHexDigit(i) + "</div>");
	});
	$("#settings_key_keys").append("<div id=\"kkdel\">&larr;</div>");
	$(vals, this).each(function(i) {
		$("#settings_unlock_keys").append("<div id=\"uk" + i + "\">" + dispHexDigit(i) + "</div>");
	});
	$("#settings_unlock_keys").append("<div id=\"ukdel\">&larr;</div>");

	//set up Auto Lock slider
	createSlider("settings_autolock_value", passkey_config['Timeout']);
	$("#settings_autolock_value_slider").slider("option", "min", 1);
	$("#settings_autolock_value_slider").slider("option", "max", 60);
}

function updatePassKeyModals(key) {
	if (key == "AuditLog") var key_config = logkey_config;
	else var key_config = passkey_config;

	//update Enable/Disable
	if (key_config['Enabled']) $("#settings_lock_enable").mouseup();
	else $("#settings_lock_disable").mouseup();

	//clear Edit Key Settings & Unlock input boxes
	$("#settings_key_enter input").each(function() {
		$(this).val("");
	});
	$("#settings_key_boxes input:first-child").focus();
	$("#settings_unlock_boxes input").each(function(i) {
		$(this).val("");
	});
	$("#settings_unlock_boxes input:first-child").focus();

	if (key == "ConfigLock") {
		//update Autolock Slider
		setSlider("settings_autolock_value", passkey_config['Timeout']);
	}
}

function updatePassKeyButtons(name) {
	if (name == "AuditLog") {
		//update Log Password button text
		$("#settings_log_password_btn_bottom").html("Key: " + logkey_config['Key']);
	}
	else {
		//update Key button text
		$("#settings_key_btn_bottom").html("Key: " + passkey_config['Key']);

		//update Auto Lock button text
		$("#settings_autolock_btn_bottom").html(passkey_config['Timeout'] + " " + (passkey_config['Timeout'] > 1 ? "<?= t("MINUTES"); ?>" : "<?= t("MINUTE"); ?>"));

		//disable/enable Auto Lock button and Lock icon
		if ((passkey_config['Key'] == 'Not Set') || (passkey_config['Enabled'] == false)) {
			disableObj($("#settings_autolock_btn"));
			disableObj($("#lock_icon"));
		}
		else {
			enableObj($("#settings_autolock_btn"));
			enableObj($("#lock_icon"));
		}
	}
}

function lockGUI() {
	$("#lock_icon").addClass("locked");
	enableObj($("#lock_icon"));
}

function unlockGUI() {
	$("#lock_icon").removeClass("locked");
	if ((passkey_config['Key'] == 'Not Set') || (passkey_config['Enabled'] == false)) disableObj($("#lock_icon"));
	else enableObj($("#lock_icon"));
}

//if Key is Enabled and there's no "unlocked" cookie, system is locked
function systemLocked() {
	if (server_status != "Ready") return true;
	else if (passkey_config['Enabled'] && (getCookie('unlocked') != '1')) return true;
	return false;
}

//callback from PassKeyGet
function updateKeyConfig(name, key, enabled, timeout) {
	if (name == "AuditLog") {
		logkey_config['Enabled'] = enabled;
		logkey_config['Key'] = key;
		logkey_config['Timeout'] = 1;
		updatePassKeyButtons(name);
		updatePassKeyModals(name);
	}
	else {
		passkey_config['Enabled'] = enabled;
		passkey_config['Key'] = key;
		passkey_config['Timeout'] = timeout;
		updatePassKeyButtons(name);
		updatePassKeyModals(name);

		if ((key == 'Not Set') || ((key == 'Set') && !enabled)) {
			unlockGUI();
			setCookie('unlocked', '0', 0);	//delete cookie to reset any previous unlocks
		}
		else {
			if (getCookie('unlocked') == '1') unlockGUI();
			else lockGUI();
		}
	}
}

function handlePassKeyValidate(name, valid, challenge) {
	if (name == "AuditLog") var key_config = logkey_config;
	else var key_config = passkey_config;

	if (valid == "Yes") {
		if ((name == "ConfigLock") && (key_config['Callback'] == "unlockGUI")) {
			//unlock GUI
			unlockGUI();
			setCookie('unlocked', '1', key_config['Timeout']);	//set cookie
		}
        else if ((name == "ConfigLock") && (key_config['Callback'] == "settings_key_dialog" || key_config['Callback'] == "settings_autolock_dialog")) {
			$("#" + key_config['Callback']).dialog('open');
        }
		//do callback (mousedown)
		else if (key_config['Callback'] != "") {
			unlockGUI();
			setCookie('unlocked', '1', key_config['Timeout']);	//set cookie
			$("#" + key_config['Callback']).addClass('key_validated');
			$("#" + key_config['Callback']).mousedown();
		}

		if (name == "AuditLog") logkey_config['Challenge'] = challenge;		//save challenge
		else passkey_config['Challenge'] = challenge;

		$("#settings_unlock_error").html("");
	}
	else {
		if (name == "AuditLog") logkey_config['KeyValue'] = '';	//clear invalid Key
		else passkey_config['KeyValue'] = '';

		$("#settings_unlock_error").html("<?= t("ERROR_INVALID_KEY_PLEASE_TRY_AGAIN"); ?>");
		if (name == "AuditLog") $("#settings_unlock_dialog").dialog('option', 'title', "<?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): ?><?= t("ENTER_FILE_DELETION_PASSWORD_TO_UNLOCK"); ?><?php else: ?><?= t("ENTER_LOG_FILE_DELETION_PASSWORD_TO_UNLOCK"); ?><?php endif; ?>");
		else $("#settings_unlock_dialog").dialog('option', 'title', "<?= t("ENTER_KEY_TO_UNLOCK"); ?>");
		$("#settings_unlock_dialog").data('name', name);
		$("#settings_unlock_dialog").dialog('open');
		checkKeysEntered();
		$first_uv.focus();
	}
}


//disable OK button until all Keys entered
function checkKeysEntered() {
	var error = false;
	for (var i=0; i<6; i++) {	//if anything blank, no error
		if ($("#uv" + i).val() == "") {
			$("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disableObj function only handles ids
			$("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
			return true;
		}
	}
	$("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//disableObj function only handles ids
	$("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
	return true;
}

//check if FileBrowserPage needs to be refreshed (only if a
//mounted drive got disconnected)
function checkFileBrowserUpdateRequired(d) {
	var j = 0;
	var drives = new Array();
	var tabs = new Array();
	var k = 0;

	// find connected and mounted drives
	for (var i in d) {
		if (d[i][0]["Connected"] && d[i][0]["Mounted"])
			drives[k++] = "<p>" + d[i][0]['Bay'] + "</p>";
	}

	// go thru the list of tabs
	k = 0;
	$("#file_browser_tabbar .btn-tab").each(function(j) {
		var t = $(this).html();
		// if browser update is not already required (because we
		// found a disconnected drive in the previous iterations)
		if (!UPDATE_FILE_BROWSER_PAGE) {
			var found = false;
			// check if the bay the tab represents is still in
			// connected state
			for (var i in drives) {
				if (t == drives[i]) {
					found = true;
					break;
				}
			}
			UPDATE_FILE_BROWSER_PAGE = (!found);
		}
		// save the tab in the list
		tabs[k++] = t;
	});

	// if browser update is not already required
	// check if a new drive has been connected
	if (!UPDATE_FILE_BROWSER_PAGE) {
		for (var i in drives) {
			var found = false;
			for (var j in tabs) {
				if (drives[i] == tabs[j]) {
					found = true;
					break;
				}
			}
			if (!found) {
				UPDATE_FILE_BROWSER_PAGE = true;
				break;
			}
		}
	}
}

//update global 'drives' with server callback info
function updateDrives(d) {
	all_drives = new Array();
	drives = new Array();
	var num_drives = 0;
	for (var i in d) {
		all_drives[i] = d[i][0];
		if (typeof(d[i][1]) == "undefined") all_drives[i].Partitions = new Array();
		else all_drives[i].Partitions = d[i][1];
		if (d[i][0]["Connected"]) {
			drives[num_drives] = all_drives[i];
			num_drives++;
		}
	}

	if (current_op < TASK_OPS.length) {
		updateDriveModals();		//update Master/Target models on task screens
		updateMasterSourceModal();
	}
	else if (current_op == OP_USB_DEVICE) {
		updateUSBDevicePage();		//update Drives list on USB Device screen
        <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
        updateHPADCODrives();
        <?php endif; ?>
	}
	else if (current_op == OP_MANAGE_REPOS) {
		//updateFormatDrivesPage();		//update Format Drives page on Manage Repos screen
		//DbNetworkConfig(4);			//update Add Repository Drives select screen
		updateAddRepoDrivesModal();		//update Select Drives modal for Add Repository
	}
	else if (current_op == OP_DRIVES) {
		updateDrivesSelect();
	}
}
//update global 'networks' with server callback info
function updateNetworks(n) {
	networks = n;
	//updateAddRepoDrivesModal();	//update Select Drives modal for Add Repository
}

//update global 'repositories' with server callback info
function updateRepositories(r) {
	repositories = new Array();
 	for (var i in r) {
 		repositories[i] = r[i];
		// If 'Images' key is not in result then put "N/A"
		if ('Images' in r[i]) {
			repositories[i]["NumFiles"] = r[i]["Images"];
		}
        else {
			repositories[i]["NumFiles"] = "<?= t("N_A"); ?>";
		}

		// If 'Free' key is not defined in result then put "N/A"
		if ('Free' in r[i]) {
			repositories[i]["FreeSpace"] = getDispSize(r[i]["Free"], 2, 0);
		}
        else {
			repositories[i]["FreeSpace"] = "<?= t("N_A"); ?>";
		}
 	}

	if (current_op == OP_CLONE) {
		updateMasterRepositoryModal();
		updateMasterSourceModal();
		updateTargetRepositoryModal();
		// !! DO NOT ENABLE: This causes the Target Repository modal not to refresh when open !!
		//if (!PAUSE_CONFIG_CALLS) updateTargetRepositoryModal();
	}
	else if (current_op == OP_PUSH) {
		updateMasterRepositoryModal();
		updateTargetRepositoryModal();
	}
	else if (current_op == OP_MANAGE_REPOS) {
		updateManageReposPage();
	}
}

//update global 'filesystems' with server callback info
function updateFilesystems(fslist) {
/* !! DO NOT ENABLE: This causes the FileSystem selection modal not to refresh when open !!
	if (filesystems.length == 0 || current_op == OP_PUSH) {    //if first time called or on Push page, update modal
        filesystems = fslist;
		updateFilesystemModal();
	}
    else {
        filesystems = fslist;
    }
*/
	filesystems = fslist;
	updateFilesystemModal();
}

function updateImages(imgs) {
	images = imgs;

	if (current_op == OP_MANAGE_REPOS) {
		updateRepoFilesSelect();
	}
	else {
		updateMasterImageModal();	//make sure Image modals are in sync with images array so updateModals doesn't break
		updateTargetImageModal();

		var t = current_task();
		if (t == -1) return;
		if (task_config[t]["CloneMode"] == MODE_I2D) {
			//open Select (Master) Image dialog
			$('#clone_master_image_dialog').dialog('open');
		}
		else if ((task_config[t]["CloneMode"] == MODE_D2I) || (task_config[t]["CloneMode"] == MODE_F2F)) {
			//open Select (Target) Image dialog
			$('#clone_target_image_dialog').dialog('open');
		}
	}
}

function updateCaseList(cases) {
    var t = current_task();
	if (t == -1) return;

    var sel_cases = task_config[t]["CaseList"];
	if ($("#push_case_select .header_row").length == 0) {		//first time showing Case Select
		//initialize Case Select
        $("#push_case_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("CASE"); ?></td></tr>");
        for (var c in cases) {
            $("#push_case_select").append("<tr class=\"select_row select-opt" + (inArray(cases[c], sel_cases) ? " ui-selected" : "") + "\"><td class=\"col1\">" + cases[c] + "</td>"
                + "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
        }
        $("#push_case_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
    }
	else {		//Case Select already initialized, just update rows with new info
		var row = -1;
		$("#push_case_select .select_row").each(function(i) {
			if (cases.length > i) {
				$(this).find(".col1").html(cases[i]);
				if (inArray(cases[i], sel_cases)) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			}
			else {	//fewer cases than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<cases.length; j++) {	//more cases than before, so add before footer row
			$("#push_case_select .footer_row").before("<tr class=\"select_row select-opt" + (inArray(cases[j], sel_cases) ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + cases[j] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
	}

    //open dialog
    if (current_op == OP_CLONE) $("#push_case_dialog").dialog({ title: "<?= t("SELECT_CASE"); ?>" }).dialog('open');
    else if (current_op == OP_HASH) $("#push_case_dialog").dialog({ title: "<?= t("SELECT_CASE"); ?>" }).dialog('open');
    else $("#push_case_dialog").dialog({ title: "<?= t("SELECT_CASES"); ?>" }).dialog('open');
}

function updateImageConfigSettings(t, config) {
	var setconfig_params = {"Task": t};
	for (var c in config) {
		if (c == "Partitions") {	//save image Clever Partition info as formatting string
			var parts = config[c];	//"<Number1>,<Size1>,<FileSystem1>;<Number2>,<Size2>,<FileSystem2>;..."
			var partinfo = "";
			var resize = new Array();
			for (var p in parts) {
				if (partinfo != "") partinfo += ";";
				partinfo += parts[p]["Number"] + "," + parts[p]["Size"] + "," + parts[p]["FileSystem"];
				resize[p] = 0;
			}
			setconfig_params["SourcePartitionNumber"] = partinfo;
			setconfig_params["CleverResizePercentages"] = resize;
		}
		else if (c == "LBACount") setconfig_params["LBACount"] = config[c].toString();
		else if (c == "SourceSize") setconfig_params["SourceSize"] = config[c].toString();
		else setconfig_params[c] = config[c];
	}
	TaskSetConfiguration(setconfig_params);
}

/* Logs */
//update Log Files screen
function updateLogFiles(lfs) {
	//disable buttons
	disableObj($("#logs_view_btn, #logs_export_btn, #logs_delete_btn"));

	//enable Delete All button if one or more logs
	if (lfs.length == 0) disableObj($("#logs_delete_all_btn"));
	else enableObj($("#logs_delete_all_btn"));

	//clear rows
	$("#logs_view_select").empty();

	//populate rows
	$("#logs_view_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("LOG_FILE_NAME"); ?></td><td class=\"col2\"><?= t("DATE_CREATED_LOG_COL"); ?></td></tr>");
	for (var f in lfs) {
		var logname = lfs[f]['Name'].substring(0, lfs[f]['Name'].lastIndexOf(".xml"));
		$("#logs_view_select").append("<tr class=\"select_row select-opt\"><td class=\"col1\"><div>" + logname + "</div></td>"
			+ "<td class=\"col2\"><div>" + lfs[f]['DateModified'] + "</div></td></tr>"
			+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td></tr>");
	}
	$("#logs_view_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td></tr>");

	//set up row selector
	$("#logs_view_select .select-opt").mousedown(function() {
		var cur_log = $(this).find(".col1").text();
		var sel_log = "";
		$("#logs_view_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) {
				sel_log = $(this).find(".col1").text();
				$(this).toggleClass("ui-selected");
			}
		});

		if (cur_log != sel_log) {
			$(this).toggleClass("ui-selected");
		}
		if ($(this).hasClass("ui-selected")) enableObj($("#logs_view_btn, #logs_export_btn, #logs_delete_btn"));
		else disableObj($("#logs_view_btn, #logs_export_btn, #logs_delete_btn"));
	});

	//set up View button
	$("#logs_view_btn").mousedown(function() {
		$("#logs_view_select .select-opt").each(function() {
			if ($(this).hasClass("ui-selected")) {
				var sel_log = $(this).find(".col1 div").text();

                //check if URL exists
                var href = location.href + "log/pdf/" + sel_log.replace(/ /g, "%20") + ".pdf";
                var http = new XMLHttpRequest();
                http.open('HEAD', href, false);
                http.send();
                if (http.status == 404) {
                    var msg = "Log file " + "<b>" + sel_log + "</b>" +  " not available for viewing.";
                    $("#logs_view_content").html(msg);
                    $("#logs_view_dialog").dialog({ title: sel_log });
                    $('#logs_view_dialog').dialog('open');
                }
                else {
                    //load PDF
                    $("#pdfjs_viewer").attr('src', '/js/pdfjs/web/viewer.html?file=' + href + '#page=1').show();
                }

                return;
			}
		});
	});
}

function formatLogKey(key) {
	if (key == "swversion") return "<?= t("VERSION"); ?>";
	else if (key == "builddate") return "<?= t("BUILD_DATE"); ?>";
	else if (key == "unitserial") return "<?= t("SERIAL_NUMBER"); ?>";
	else if (key == "unlockdco") return "<?= t("UNLOCK_DCO"); ?>";
	else if (key == "unlockhpa") return "<?= t("UNLOCK_HPA"); ?>";
	else if (key == "raidenabled") return "<?= t("RAID_ENABLED"); ?>";
	else if (key == "hashenabled") return "<?= t("HASH_ENABLED"); ?>";
	else if (key == "segmentsize") return "<?= t("SEGMENT_SIZE"); ?>";
	else if (key == "compressionlevel") return "<?= t("COMPRESSION_LEVEL"); ?>";
	else if (key == "verifyhash") return "<?= t("VERIFY_HASH"); ?>";
	else if (key == "lbacount") return "<?= t("LBA_COUNT"); ?>";
	else if (key == "imagepath") return "<?= t("IMAGE_PATH"); ?>";
	else if (key == "casename") return "<?= t("CASE_FILE_NAME"); ?>";
	else if (key == "examinername") return "<?= t("EXAMINER"); ?>";
	else if (key == "evidencenumber") return "<?= t("EVIDENCE_NUMBER"); ?>";
	else if (key == "casenumber") return "<?= t("CASE_ID"); ?>";
	else if (key == "casenotes") return "<?= t("CASE_NOTES"); ?>";
	else if (key == "partitiontypes") return "<?= t("PARTITION TYPES"); ?>";
	else if (key == "resizepercs") return "<?= t("RESIZE_PERCS"); ?>";
	else if (key == "raid") return "<?= t("RAID"); ?>";
	else if (key == "dco") return "<?= t("DCO"); ?>";
	else if (key == "hpa") return "<?= t("HPA"); ?>";
	else if (key == "badsects") return "<?= t("BAD_SECTORS"); ?>";
	else if (key == "atapasswd") return "<?= t("ATA_PASSWORD"); ?>";
	else if (key == "securewipe") return "<?= t("SECURE_WIPE"); ?>";
	else if (key == "time") return "<?= t("TIME"); ?>";
	else if (key == "utc") return "<?= t("UTC"); ?>";
	else if (key == "hashtype") return "<?= t("HASH_TYPE"); ?>";
	else if (key == "numlba") return "<?= t("LBA_COUNT"); ?>";
	else if (key == "sourcehash") return "<?= t("SOURCE_HASH"); ?>";
	else if (key == "uid") return "<?= t("UID"); ?>";
	else if (key == "filename") return "<?= t("FILE_NAME"); ?>";
	else if (key == "partialhash") return "<?= t("PARTIAL_HASH"); ?>";
	else if (key == "hash") return "<?= t("HASH"); ?>";
	else if (key == "vhash") return "<?= t("VERIFICATION_HASH"); ?>";
	else if (key == "pushresult") return "<?= t("PUSH_RESULT"); ?>";
    else if (key == "drivetrim") return "<?= t("DRIVE_TRIM"); ?>";
    else if (key == "numbadsects") return "<?= t("NUM_BAD_SECTORS"); ?>";
    else if (key == "errtype") return "<?= t("ERROR_TYPE"); ?>";
    else if (key == "type") return "<?= t("TYPE"); ?>";
    else if (key == "srclogicalsectsize") return "<?= t("SRC_LOGICAL_SECT_SZ"); ?>";
    else if (key == "errorgranularity") return "<?= t("ERROR_GRANULARITY"); ?>";
    return key.charAt(0).toUpperCase() + key.substring(1);
}


/* Software Updates / Stats / Settings */
function updateAppVersion(ret) {
	//update Software Updates page
	var v = ret['Version'];
        $("#software_version").html("<?php if ($LOGICUBE_PLATFORM == "writeprotect"): ?><?= t("YOUR_WRITEPROTECT_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "writeprotectportable"): ?><?= t("YOUR_WRITEPROTECTPORTABLE_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "pciebridge"): ?><?= t("YOUR_PB_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "zclonexi"): ?><?= t("YOUR_ZXI_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "zxtower"): ?><?= t("YOUR_ZXT_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "talonu"): ?><?= t("YOUR_TALONU_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "zxiforensic"): ?><?= t("YOUR_ZXIFORENSIC_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "supersonixng"): ?><?= t("YOUR_SUPERSONIXNG_SOFTWARE_VERSION"); ?><?php elseif ($LOGICUBE_PLATFORM == "echoplusxng"): ?><?= t("YOUR_ECHOPLUSNG_SOFTWARE_VERSION"); ?><?php else: ?><?= t("YOUR_FALCON_SOFTWARE_VERSION"); ?><?php endif; ?>: " + v);

	//update Stats page
	var app_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
	for (var key in ret) {
		if ((key != "Method") && (key != "Result")) {
			app_info += "<tr><td style=\"width: 30%;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td>";
			if (typeof(ret[key]) == "object") {
				//NetworkInterfaceList = ['0' => ['Name' => "eth0", 'IPAddress' => "192.168.1.19", 'MACAddress' => "00:1f:f2:08:a7:af"], ...]
				app_info += "<td valign=\"top\">";
				for (var i in ret[key]) {
					for (var subkey in ret[key][i]) {
						app_info += subkey + ": " + ret[key][i][subkey] + "<br/>";
					}
				}
				app_info += "</td></tr>\n";
			}
			else {
				app_info += "<td valign=\"top\">" + ret[key] + "</td></tr>\n";
			}
		}
	}
	app_info += "</table>";
	$("#stats_about_content").html(app_info);
}

function updateFirmwareStatus(ret) {
	var upgrade_avail = ret['Status'];
	if (upgrade_avail) {
		$("#firmware_update_box").html("<?= t("FIRMWARE_UPGRADE_AVAILABLE"); ?>");
		enableObj($("#firmware_update_btn"));
	}
	else {
		$("#firmware_update_box").html("<?= t("FIRMWARE_UPGRADE_NOT_AVAILABLE"); ?>");
		disableObj($("#firmware_update_btn"));
	}
}

//update Adv. Drive Stats screen
function updateAdvDriveStatsBay(bay) {
	$("#stats_bay_box").html(bay);
}
function updateAdvDriveStats(attr) {
	//populate rows
	//show header row with Model
	var num_cols = 1;
	if (attr.length > 0) num_cols = Object.keys(attr[0]).length - 3;
	var cur_adv_drive = driveWithBay(current_adv_stats_bay);
	var cur_model = cur_adv_drive["Model"];
	var attr_row_html = "<tr class=\"stats_attr_select_hdr_row\"><td class=\"col1\" colspan=\"" + num_cols + "\">MODEL: " + cur_model + "</td></tr>";

	//show row with attributes
	if (attr.length > 0) {
		attr_row_html += "<tr class=\"stats_attr_select_row\"><td class=\"attrcol1\">Attribute Name</td><td class=\"attrcol\">Value<hr/>Worst<hr/>Threshold</td>";
		for (var k in attr[0]) {
			if ((k != "Name") && (k != "Value") && (k != "Worst") && (k != "Threshold") && (k != "Good") && (k != "GoodPast")) {
				attr_row_html += "<td class=\"attrcol\"><div>" + k + "</div></td>";
			}
		}
		attr_row_html += "<td class=\"attrcol\"><div>Good<hr/>GoodPast</div></td>";
		attr_row_html += "</tr>";
	}
	else {
		attr_row_html += "<tr class=\"stats_attr_select_row\"><td class=\"attrcol1\">SMART counters are not supported</td></tr>";
	}
	attr_row_html += "<tr class=\"stats_attr_spacer_row\"><td class=\"col1\"></td>"
	if (attr.length > 0) {
		attr_row_html += "<td class=\"col\"></td>";
		for (var k in attr[0]) {
			if ((k != "Name") && (k != "Value") && (k != "Worst") && (k != "Threshold") && (k != "Good") && (k != "GoodPast")) {
				attr_row_html += "<td class=\"col\"></td>";
			}
		}
		attr_row_html += "<td class=\"col\"></td>";
	}
	attr_row_html += "</tr>";

	//show rows with data
	for (var a in attr) {
		attr_row_html += "<tr class=\"stats_attr_select_row\"><td class=\"col1\">" + attr[a]["Name"] + "</td>" +
			"<td class=\"col\"><div>" + attr[a]["Value"] + "<hr/>" + attr[a]["Worst"] + "<hr/>" + attr[a]["Threshold"] + "</div></td>";
		for (var k in attr[a]) {
			if ((k != "Name") && (k != "Value") && (k != "Worst") && (k != "Threshold") && (k != "Good") && (k != "GoodPast")) {
				attr_row_html += "<td class=\"col\"><div>" + attr[a][k] + "</div></td>";
			}
		}
		attr_row_html += "<td class=\"col\"><div>" + attr[a]["Good"] + "<hr/>" + attr[a]["GoodPast"] + "</div></td>";
		attr_row_html += "</tr>";
		attr_row_html += "<tr class=\"stats_attr_spacer_row\"><td class=\"col1\"></td><td class=\"col\"></td>"
		for (var k in attr[a]) {
			if ((k != "Name") && (k != "Value") && (k != "Worst") && (k != "Threshold") && (k != "Good") && (k != "GoodPast")) {
				attr_row_html += "<td class=\"col\"></td>";
			}
		}
		attr_row_html += "<td class=\"col\"></td>";
		attr_row_html += "</tr>";
	}
	attr_row_html += "<tr class=\"stats_attr_select_ftr_row\"><td class=\"col1\" colspan=\"" + num_cols + "\"></td></tr>";
	$("#stats_attr_select").html(attr_row_html);
}

//periodically poll server for Network Interface Stats
var intervalId5;
function startNWInterfaceStatsCalls() {
	clearInterval(intervalId5);
	GetNWInterfaceStats();
}
function stopNWInterfaceStatsCalls() {
	clearInterval(intervalId5);
}
function updateNWInterfaceStats(interfaces) {
	//populate rows
	var row_html = "<tr class=\"stats_interface_select_row\"><td class=\"attrcol\">Interface</td><td class=\"attrcol\">Rx<br/>Bytes</td><td class=\"attrcol\">Rx<br/>Packets</td><td class=\"attrcol\">Rx<br/>Dropped</td><td class=\"attrcol\">Rx<br/>Errors</td><td class=\"attrcol\">Tx<br/>Bytes</td><td class=\"attrcol\">Tx<br/>Packets</td><td class=\"attrcol\">Tx<br/>Dropped</td><td class=\"attrcol\">Tx<br/>Errors</td><td class=\"attrcol\">Status</td></tr>";
	row_html += "<tr class=\"stats_interface_spacer_row\"><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td></tr>"

	for (var i in interfaces) {
        row_html += "<tr class=\"stats_interface_select_row\"><td class=\"col\">" + interfaces[i]['Name'] + "</td><td class=\"col\">" + interfaces[i]['RxBytes'] + "</td><td class=\"col\">" + interfaces[i]['RxPackets'] + "</td><td class=\"col\">" + interfaces[i]['RxDropped'] + "</td><td class=\"col\">" + interfaces[i]['RxErrors'] + "</td><td class=\"col\">" + interfaces[i]['TxBytes'] + "</td><td class=\"col\">" + interfaces[i]['TxPackets'] + "</td><td class=\"col\">" + interfaces[i]['TxDropped'] + "</td><td class=\"col\">" + interfaces[i]['TxErrors'] + "</td><td class=\"col\">" + interfaces[i]['Status'] + "</td></tr>";
        row_html += "<tr class=\"stats_interface_spacer_row\"><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td><td class=\"col\"></td></tr>";
    }
	
    row_html += "<tr class=\"stats_interface_select_ftr_row\"><td class=\"col\" colspan=\"10\"></td></tr>";

	$("#stats_interface_select").html(row_html);

    intervalId5 = setInterval("startNWInterfaceStatsCalls()", NW_INTERFACE_STATS_UPDATE_INTERVAL);
}


//update task 't' with status info 's'
function updateTaskStatus(t, state, stats) {
	//update task_status array
	if (typeof(task_status[t]) == "undefined") task_status[t] = new Array();
	task_status[t]['TaskState'] = state;

	if (("PushStats" in task_status[t]) && !("PushStats" in stats))
		delete task_status[t]["PushStats"];

	if (("FileCopyStats" in task_status[t]) && !("FileCopyStats" in stats))
		delete task_status[t]["FileCopyStats"];

	for (var s in stats) {
		task_status[t][s] = stats[s];
	}
	//alert(dump(task_status, 4));

	//update GUI
	var ftt = flat_tab_tasks();
	if (state == "TASK_AVAILABLE") {
		if (inArray(t, ftt)) deleteTab(t);
	}
	else {
		if (inArray(t, ftt)) {
			if (t == current_task()) {
				updateProgressBars();
				if (!PAUSE_CONFIG_CALLS) TaskGetConfiguration(t);	//if user has a modal dialog open and is editing config settings, don't get task config
			}
			else {
				TaskGetConfiguration(t);	//get configuration for existing tasks, e.g. in case Local user changed a TASK_RESERVED task's config
			}
		}
		else {
			TaskGetConfiguration(t);	//get configuration before adding tab, so correct button info is set before showing
			addTab(t);
			var all_screens_ready = true;	//make sure each task operation screen has at least one tab before enabling GUI
			for (var op in TASK_OPS) {
				if (tab_tasks[op].length == 0) all_screens_ready = false;
			}
			if (all_screens_ready) {
				enableGUI();
			}
		}
	}

}

function updateTaskConfig(t, config) {
	if (typeof(task_config[t]) == "undefined") task_config[t] = new Array();

	//initialize values in case they don't exist, or the task has been released (some values do not come in API task config until they're set)
	task_config[t]["Master"] = "";
	task_config[t]["Targets"] = new Array();
	task_config[t]["RepositoryList"] = new Array();
	task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_DIRECTORY_TREE;
	task_config[t]["HashType"] = HASH_NONE;
	task_config[t]["CleverResizePercentages"] = new Array();
	task_config[t]["LBACount"] = 0;
	task_config[t]["Repository"] = "";
	task_config[t]["SourceImagePath"] = "";
	task_config[t]["DestinationImagePath"] = "";
	task_config[t]["HashValue"] = "";
    task_config[t]["PresetFilterList"] = [0, 0, 0, 0, 0];
    task_config[t]["FileCategoryList"] = [0, 0, 0, 0, 0];
    task_config[t]["FileCharEncodingList"] = false;
    task_config[t]["ErrorGranularity"] = ERRORGRANULARITY_1;
    task_config[t]["ValidateMode"] = HASHMODE_DRIVE_HASH;
	task_config[t]["CaseList"] = new Array();
	task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_DIRECTORY_TREE;
	task_config[t]["FileSearchRoot"] = "";
	task_config[t]["FileCustomFilter"] = "";

            
	for (var c in config) {
		if ((c == "CloneMode") && (task_config[t]["Operation"] == OP_CLONE)) {
			if (!('CaptureMethod' in task_config[t])) task_config[t]["CaptureMethod"] = CAPTUREMETHOD_E01;
			if (config[c] == "DriveToDrive") {
				task_config[t]["CloneMode"] = MODE_D2D;
				<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): //for Falcon, set clone method to Mirror ?>
				if (('CloneMethod' in task_config[t]) && (task_config[t]["CloneMethod"] != METHOD_MIRROR)) {
					task_config[t]["CloneMethod"] = METHOD_MIRROR;
					TaskSetConfiguration({"Task": t, "CloneMethod": APIMETHODS[task_config[t]["CloneMethod"]]});
				}
				<?php endif; ?>
			}
			else if (config[c] == "ImageToDrive") {
				task_config[t]["CloneMode"] = MODE_I2D;
			}
			else if (config[c] == "FileCopy") {
				task_config[t]["CloneMode"] = MODE_F2F;
				task_config[t]["CaptureMethod"] = CAPTUREMETHOD_FILE;
				if (config["HashType"] == HASH_NONE) {		//NONE not allowed for File To File
					task_config[t]["HashType"] = HASH_SHA1;
					TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
				}
                                <?php if ($LOGICUBE_PLATFORM == "default" || $LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): //if Default, set clone mode to D2D ?>
				task_config[t]["CloneMode"] = MODE_D2D;
				TaskSetConfiguration({"Task": t, "CloneMode": APIMODES[task_config[t]["CloneMode"]]});
				<?php endif; ?>
			}
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            // Partition To File
            else if (config[c] == "PartitionToDD") {
                task_config[t]["CloneMode"] = MODE_P2F;
                task_config[t]["CaptureMethod"] = CAPTUREMETHOD_DD;            
            }
            else if (config[c] == "PartitionToE01") {
                task_config[t]["CloneMode"] = MODE_P2F;
                task_config[t]["CaptureMethod"] = CAPTUREMETHOD_E01;
                if (config["HashType"] == HASH_NONE) {		//NONE not allowed for E01 or EX01
                    task_config[t]["HashType"] = HASH_SHA1;
                    TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
                }
            }
            else if (config[c] == "PartitionToEx01") {
                task_config[t]["CloneMode"] = MODE_P2F;
                task_config[t]["CaptureMethod"] = CAPTUREMETHOD_EX01;
                if (config["HashType"] == HASH_NONE) {		//NONE not allowed for E01 or EX01
                    task_config[t]["HashType"] = HASH_SHA1;
                    TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
                }
            }
            <?php endif; ?>
			else {	//Drive To Image
				task_config[t]["CloneMode"] = MODE_D2I;	//DriveToDD, DriveToE01, DriveToEx01, etc.
                                <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): //for ZXi, Logicube Image is only option ?>
                if (('CaptureMethod' in task_config[t]) && (task_config[t]["CaptureMethod"] != CAPTUREMETHOD_LOGICUBE_IMAGE)) {
				    task_config[t]["CaptureMethod"] = CAPTUREMETHOD_LOGICUBE_IMAGE;
				    TaskSetConfiguration({"Task": t, "CloneMode": APICAPTUREMETHODS[task_config[t]["CaptureMethod"]]});
                }
				<?php else: ?>
				if (config[c] == "DriveToDD") {
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_DD;
				}
				else if (config[c] == "DriveToE01") {
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_E01;
					if (config["HashType"] == HASH_NONE) {		//NONE not allowed for E01 or EX01
						task_config[t]["HashType"] = HASH_SHA1;
						TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
					}
				}
				else if (config[c] == "DriveToEx01") {
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_EX01;
					if (config["HashType"] == HASH_NONE) {		//NONE not allowed for E01 or EX01
						task_config[t]["HashType"] = HASH_SHA1;
						TaskSetConfiguration({"Task": t, "HashType": APIHASHES[task_config[t]["HashType"]]});
					}
				}
				else {
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_LOGICUBE_IMAGE;
					<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): //for Falcon, set clone mode to D2I ?>
					task_config[t]["CaptureMethod"] = CAPTUREMETHOD_E01;	//no Logicube Image for Falcon
					TaskSetConfiguration({"Task": t, "CloneMode": APICAPTUREMETHODS[task_config[t]["CaptureMethod"]]});
					<?php endif; ?>
				}
				<?php endif; ?>
			}
		}
		else if (c == "SegmentSize") {
			task_config[t]["SegmentSize"] = SEGMENTSIZE_2GB;
			if (config[c] == "4Gb") task_config[t]["SegmentSize"] = SEGMENTSIZE_4GB;
			else if (config[c] == "8Gb") task_config[t]["SegmentSize"] = SEGMENTSIZE_8GB;
			else if (config[c] == "16Gb") task_config[t]["SegmentSize"] = SEGMENTSIZE_16GB;
			else if (config[c] == "WholeDisk") task_config[t]["SegmentSize"] = SEGMENTSIZE_WHOLEDISK;
		}
		else if (c == "CompressionLevel") {
			task_config[t]["CompressionLevel"] = COMPRESSION_NONE;
			if (config[c] == "Default") task_config[t]["CompressionLevel"] = COMPRESSION_DEFAULT;
			else if (config[c] == "ZlibFast") task_config[t]["CompressionLevel"] = COMPRESSION_ZLIBFAST;
			else if (config[c] == "ZlibGood") task_config[t]["CompressionLevel"] = COMPRESSION_ZLIBGOOD;
			else if (config[c] == "ZlibBest") task_config[t]["CompressionLevel"] = COMPRESSION_ZLIBBEST;
		}
		else if (c == "CloneMethod") {
			if (config[c] == "Mirror") task_config[t]["CloneMethod"] = METHOD_MIRROR;
			else task_config[t]["CloneMethod"] = METHOD_CLEVER;
		}
		else if (c == "FileOutputFormat") {
			if (config[c] == "FileOutputRaw") task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_DIRECTORY_TREE;
			else if (config[c] == "FileMftReport") task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_MFT_REPORT;
			else if (config[c] == "FileOutputLx01") task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_LX01_ARCHIVE;
			else if (config[c] == "FileOutputZip") task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_ZIP_ARCHIVE;
			else task_config[t]["FileOutputFormat"] = OUTPUTFORMAT_DIRECTORY_TREE;
		}
        // FileCategoryList and PresetFilterList are stored in the API as an array of strings, e.g. ["FilePresetFilterUsers", "FilePresetFilterNoSwap"] and stored here as [1, 0, 0, 0, 1] to match button state
		else if (c == "PresetFilterList") {
            for (var i=0; i<APIPRESETFILTERS.length; i++) {
                if (inArray(APIPRESETFILTERS[i], config[c])) {
                    task_config[t]["PresetFilterList"][i] = 1;
                }
            }
		}
		else if (c == "FileCategoryList") {
            for (var i=0; i<APIFILECATS.length; i++) {
                if (inArray(APIFILECATS[i], config[c])) {
                    task_config[t]["FileCategoryList"][i] = 1;
                }
            }
		}
		else if (c == "FileCharEncodingList") {
            if (inArray("CharEncodingUtf16", config[c])) task_config[t]["FileCharEncodingList"] = true;
            else task_config[t]["FileCharEncodingList"] = false;
        }
		else if (c == "ErrorGranularity") {
			if (config[c] == "8") task_config[t]["ErrorGranularity"] = ERRORGRANULARITY_8;
			else if (config[c] == "128") task_config[t]["ErrorGranularity"] = ERRORGRANULARITY_128;
			else if (config[c] == "256") task_config[t]["ErrorGranularity"] = ERRORGRANULARITY_256;
			else task_config[t]["ErrorGranularity"] = ERRORGRANULARITY_1;
		}
		else if (c == "HashType") {
			if (config[c] == "MD5") task_config[t]["HashType"] = HASH_MD5;
			else if (config[c] == "SHA-1") task_config[t]["HashType"] = HASH_SHA1;
			else if (config[c] == "SHA-256") task_config[t]["HashType"] = HASH_SHA2;
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
			else if (config[c] == "SHA1-MD5") task_config[t]["HashType"] = HASH_SHA1_MD5;
            <?php endif; ?>
			else task_config[t]["HashType"] = HASH_NONE;
		}
		else if (c == "Operation") {
			if (t > 15) task_config[t]["Operation"] = OP_PUSH;
			else if (t > 10) task_config[t]["Operation"] = OP_HASH;
			else if (t > 5) task_config[t]["Operation"] = OP_WIPE;
			else task_config[t]["Operation"] = OP_CLONE;
		}
		else if (c == "WipeMethod") {
			if (config[c] == "None") task_config[t]["WipeMethod"] = WIPEMETHOD_NONE;
			else if (config[c] == "Custom") task_config[t]["WipeMethod"] = WIPEMETHOD_CUSTOM;
			else if (config[c] == "DoD") task_config[t]["WipeMethod"] = WIPEMETHOD_DOD;

			//if user has just edited Wipe Mode, GUI is disabled, so we need to re-eneable after updating Mode and Passes buttons
			if (t == current_task()) {
				updateWipeModeButton();	//this is also done below, do here also for simplicity
				updateWipePassesButton();
				var all_screens_ready = true;	//make sure each task operation screen has at least one tab before enabling GUI
				for (var op in TASK_OPS) {
					if (tab_tasks[op].length == 0) all_screens_ready = false;
				}
				if (all_screens_ready) {
					enableGUI();
				}
			}
		}
		else if (c == "WipeFilesystem") {
			if (config[c] == "ext4") task_config[t]["WipeFilesystem"] = FILESYSTEM_EXT4;
			else task_config[t]["WipeFilesystem"] = FILESYSTEM_NTFS;
		}
        else if (c == "ValidateMode") {
			if (config[c] == "CaseVerify") task_config[t]["ValidateMode"] = HASHMODE_CASE_VERIFY;
            else task_config[t]["ValidateMode"] = HASHMODE_DRIVE_HASH;
        }
        else if (c == "VerifyCaseHash") {
			if (config[c] == "Secondary") task_config[t]["VerifyCaseHash"] = HASHVERIFY_SECONDARY;
			else if (config[c] == "Both") task_config[t]["VerifyCaseHash"] = HASHVERIFY_BOTH;
			else task_config[t]["VerifyCaseHash"] = HASHVERIFY_PRIMARY;
        }
		else if (c == "HashValue") {
			task_config[t]["HashValue"] = config[c].toUpperCase();
		}
		else {
			task_config[t][c] = config[c];
		}
	}

	//if viewing the task whose configuration was just updated, update the buttons
	if (t == current_task()) {
		updateButtons("all");
		updateModals("all");
	}
}

//add t to tab_tasks, update Clone, Wipe, or Hash tabs
function addTab(t) {
	var op = task_config[t]["Operation"];
	if (!inArray(t, tab_tasks[op])) {
		tab_tasks[op][tab_tasks[op].length] = t;

		if (tab_tasks[op].length == 1) {	//if t is only tab, set current_tab[op] = tab with task t
			current_tab[op] = 0;
			updateGUI();
		}
		else if (tab_tasks[op].length > 1) {	//if new tab is one of many, sort task #s and maintain viewing the same task
			tab_tasks[op].sort(function(a,b){return a - b});	//sort numerically

			if (op == current_op) {		//only need to update if a task has been added to the current screen
				current_tab[current_op] = tabWithTask(op, current_task());
			}
			updateTabs();
		}
	}
}

//remove t from tab_tasks
//if t = task of current_tab[0], set current_tab[0] = next tab up (or -1 if no
//tabs left) and updateGUI()
function deleteTab(t) {
	var ftt = flat_tab_tasks();
	var viewed_task = current_task();
	var op = task_config[t]["Operation"];
	if (inArray(t, ftt)) {
		tab_tasks = removeFromArrayOfArrays(tab_tasks, t);
		if (tab_tasks[op].length == 0) {	//if no more tasks on the screen that just had a tab deleted, disable GUI
			current_tab[op] = -1;
			disableGUI();
			TaskList();						//immediately poll tasks so user doesn't see a screen with no tasks
		}
		else if (current_tab[op] == tab_tasks[op].length) {	//if we deleted and were viewing the highest tab, view the next one down
			current_tab[op] -= 1;
			updateGUI();
		}
		else if (t == viewed_task) {	//if we deleted the task we were viewing, update GUI (will be replaced with next tab up's task)
			updateGUI();
		}
		else {		//some non-viewed tab is being deleted, so just update tabs
			updateTabs();
		}
	}
}

//(user clicked tab) set current_tab[current_op] = tab and updateGUI()
function selectTab(tab) {
	if ((tab != current_tab[current_op]) && (tab >= 0) && (tab <= tab_tasks[current_op].length-1)) {
		current_tab[current_op] = tab;
		updateGUI();
	}
}

//switch between tabs on the Task Macro screen
function selectMacroTab(tab) {
	if (tab != current_tab[OP_TASK_MACRO]) {
		$("#task_macro_tab_" + current_tab[OP_TASK_MACRO]).removeClass("selected");
		$("#task_macro_tab_" + tab).addClass("selected");
		current_tab[OP_TASK_MACRO] = tab;
		updateMacroPage();
		updateMacroProgressBars();
		MacroStatus(current_tab[OP_TASK_MACRO]+1);
	}
}


//switch between tabs on non-task screens (Logs, Stats, Settings, etc.), show/hide tab/content and update current_tab
function selectNonTaskTab(tab) {
	var op_pre = OPS[current_op].toLowerCase().replace(" ", "_");
    if (tab != current_tab[current_op]) {
        $("#" + op_pre + "_tab_" + current_tab[current_op]).removeClass("selected");
        $("#" + op_pre + "_tab_" + tab).addClass("selected");
        hideObj($("#" + op_pre + "_page_" + current_tab[current_op]));
        showObj($("#" + op_pre + "_page_" + tab));
        current_tab[current_op] = tab;
    }
}

//get the tab that has t as its task
function tabWithTask(op, t) {
	for (var i=0; i<tab_tasks[op].length; i++) {
		if (tab_tasks[op][i] == t) return i;
	}
	return -1;
}

//set up selectable list of drives in Select Master and Select Target modals
//(called whenever 'drives' changes)
function updateDriveModals() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var master = "";
		var targets = new Array();
	}
	else {
		var master = task_config[t]["Master"];
		var targets = task_config[t]["Targets"];
	}
    
    //only show drives with proper role
    var master_drives = new Array();
    var target_drives = new Array();
    for (var d in drives) {
        if (drives[d]["Role"] == "Master") master_drives.push(drives[d]);
        else if (drives[d]["Role"] == "Target") target_drives.push(drives[d]);
        else if (drives[d]["Role"] == "Master/Target") {
            master_drives.push(drives[d]);
            target_drives.push(drives[d]);
        }
    }
    if (current_op == OP_HASH) target_drives = drives;

	//have the drive modals been initialized
	if ($("#clone_master_select .header_row").length == 0) {		//first time showing drives in Master/Target Select
		//initialize Master Select
		$("#clone_master_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?></td><td class=\"col2\"><?= t("DRIVE_INFORMATION"); ?></td><td class=\"col3\"><?= t("DRIVE_STATUS"); ?></td><td class=\"col4\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var d in master_drives) {
			$("#clone_master_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + master_drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + master_drives[d]["Model"] + "<br/>" + getDispSize(master_drives[d]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((master_drives[d]["IsSAS"] && !master_drives[d]["IsPortSASEnabled"]) || !master_drives[d]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#clone_master_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");

		//initialize Target Select
		$("#clone_target_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?></td><td class=\"col2\"><?= t("DRIVE_INFORMATION"); ?></td><td class=\"col3\"><?= t("DRIVE_STATUS"); ?></td><td class=\"col4\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var d in target_drives) {
			$("#clone_target_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + target_drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + target_drives[d]["Model"] + "<br/>" + getDispSize(target_drives[d]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((target_drives[d]["IsSAS"] && !target_drives[d]["IsPortSASEnabled"]) || !target_drives[d]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
                + "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#clone_target_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");

	}
	else {	//Master/Target are already initialized, just update rows with new drive info
		var master_row = -1;
		$("#clone_master_select .select_row").each(function(i) {
			if (master_drives.length > i) {
				if ($(this).find(".col1").html() != master_drives[i]["Bay"]) {	//if row has a new drive, update status
					if (master_drives[i]["Bay"] == master && $(this).hasClass("ui-selected")) $(this).find(".col3").html("<?= t("SELECTED"); ?>");
					else $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
					$(this).find(".col3").attr("class", "col3");
				}
				$(this).find(".col1").html(master_drives[i]["Bay"]);
				$(this).find(".col2").html(master_drives[i]["Model"] + "<br/>" + getDispSize(master_drives[i]["Size"]));
				if ((master_drives[i]["IsSAS"] && !master_drives[i]["IsPortSASEnabled"]) || !master_drives[i]["IsPortEnabled"]) $(this).find(".col4").addClass("sas-alert");
				else $(this).find(".col4").removeClass("sas-alert");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			master_row = i;
		});
		for (var j=master_row+1; j<master_drives.length; j++) {	//more drives than before, so add before footer row
			$("#clone_master_select .footer_row").before("<tr class=\"select_row select-opt" + (master_drives[j]["Bay"] == master ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + master_drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + master_drives[j]["Model"] + "<br/>" + getDispSize(master_drives[j]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((master_drives[j]["IsSAS"] && !master_drives[j]["IsPortSASEnabled"]) || !master_drives[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}

		var target_row = -1;
		$("#clone_target_select .select_row").each(function(i) {
			if (target_drives.length > i) {
				if ($(this).find(".col1").html() != target_drives[i]["Bay"]) {	//if row has a new drive, update status
					if (inArray(target_drives[i]["Bay"], targets) && $(this).hasClass("ui-selected")) $(this).find(".col3").html("<?= t("SELECTED"); ?>");
					else $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
					$(this).find(".col3").attr("class", "col3");
				}
				$(this).find(".col1").html(target_drives[i]["Bay"]);
				$(this).find(".col2").html(target_drives[i]["Model"] + "<br/>" + getDispSize(target_drives[i]["Size"]));
				if ((target_drives[i]["IsSAS"] && !target_drives[i]["IsPortSASEnabled"]) || !target_drives[i]["IsPortEnabled"]) $(this).find(".col4").addClass("sas-alert");
				else $(this).find(".col4").removeClass("sas-alert");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			target_row = i;
		});
		for (var j=target_row+1; j<target_drives.length; j++) {	//more drives than before, so add before footer row
			$("#clone_target_select .footer_row").before("<tr class=\"select_row select-opt" + (inArray(target_drives[j]["Bay"], targets) ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + target_drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + target_drives[j]["Model"] + "<br/>" + getDispSize(target_drives[j]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((target_drives[j]["IsSAS"] && !target_drives[j]["IsPortSASEnabled"]) || !target_drives[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}

	}

	disableHideDrives();
	updateDriveStatus("master");
	updateDriveStatus("target");
}

function updateMasterRepositoryModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var repo = "";
	}
	else {
		var repo = task_config[t]["Repository"];
	}

	//initialize Master Repository Select
	if ($("#clone_master_repo_select .header_row").length == 0) {		//first time showing drives in Master/Target Select
		//initialize Master Select
		$("#clone_master_repo_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("REPOSITORY"); ?></td><td class=\"col2\"><?= t("LOCATION"); ?></td><td class=\"col3\"><?= t("NUM_OF_FILES"); ?></td></tr>");
		for (var r in repositories) {
			$("#clone_master_repo_select").append("<tr class=\"select_row select-opt" + (repositories[r]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled unmounted-repo" : (repositories[r]["Name"] == repo ? " ui-selected" : "")) + "\">"
				+ "<td class=\"col1\">" + repositories[r]["Name"] + "</td>"
				+ "<td class=\"col2\">" + repositories[r]["LocationDisplay"] + (repositories[r]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
				+ "<td class=\"col3\">" + repositories[r]["NumFiles"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#clone_master_repo_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {		//Master Repos are already initialized, just update rows with new repo info
		var master_repo_row = -1;
		$("#clone_master_repo_select .select_row").each(function(i) {
			if (repositories.length > i) {
				$(this).find(".col1").html(repositories[i]["Name"]);
				$(this).find(".col2").html(repositories[i]["LocationDisplay"]);
				$(this).find(".col3").html(repositories[i]["NumFiles"]);
				if (repositories[i]["Status"] == "NOT_MOUNTED") $(this).addClass("ui-state-disabled").addClass("unmounted-repo");
				else $(this).removeClass("ui-state-disabled").removeClass("unmounted-repo");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			master_repo_row = i;
		});
		for (var j=master_repo_row+1; j<repositories.length; j++) {	//more drives than before, so add before footer row
			$("#clone_master_repo_select .footer_row").before("<tr class=\"select_row select-opt" + (repositories[j]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled unmounted-repo" : (repositories[j]["Name"] == repo ? " ui-selected" : "")) + "\">"
				+ "<td class=\"col1\">" + repositories[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + repositories[j]["LocationDisplay"] + (repositories[j]["Status"] != "MOUNTED" ? "<br/>(" + repositories[j]["Status"] + ")" : "") + "</td>"
				+ "<td class=\"col3\">" + repositories[j]["NumFiles"] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}

function updateFilesystemModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var fs = "";
	}
	else {
		var fs = task_config[t]["MountPath"];
	}

	if ($("#push_filesystem_select .header_row").length == 0) {		//first time showing Filesystems
		//initialize Filesystem select
		$("#push_filesystem_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("NAME"); ?></td><td class=\"col2\"><?= t("LOCATION"); ?></td><td class=\"col3\"><?= t("NUM_OF_FILES"); ?></td></tr>");
		for (var f in filesystems) {
			$("#push_filesystem_select").append("<tr class=\"select_row select-opt" + (filesystems[f]["MountPath"] == fs ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + filesystems[f]["Name"] + "</td>"
				+ "<td class=\"col2\">" + filesystems[f]["Location"] + "</td>"
				+ "<td class=\"col3\">" + filesystems[f]["Contents"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#push_filesystem_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {		//Filesystems are already initialized, just update rows with new info
		var dir_row = -1;
		$("#push_filesystem_select .select_row").each(function(i) {
			if (filesystems.length > i) {
				$(this).find(".col1").html(filesystems[i]["Name"]);
				$(this).find(".col2").html(filesystems[i]["Location"]);
				$(this).find(".col3").html(filesystems[i]["Contents"]);
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			dir_row = i;
		});
		for (var j=dir_row+1; j<filesystems.length; j++) {	//more filesystems than before, so add before footer row
			$("#push_filesystem_select .footer_row").before("<tr class=\"select_row select-opt" + (filesystems[j]["MountPath"] == fs ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + filesystems[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + filesystems[j]["Location"] + "</td>"
				+ "<td class=\"col3\">" + filesystems[j]["Contents"] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}

function updateMasterSourceModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var source = "";
	}
	else {
		var source = task_config[t]["Master"];
		if (source == "") source = task_config[t]["Repository"];
	}

	var sources = new Array();
	for (var d in drives) {
		sources.push(drives[d]);
	}
	for (var r in repositories) {
		sources.push(repositories[r]);
	}

	//initialize Master Source Select
	if ($("#clone_master_source_select .header_row").length == 0) {		//first time showing sources in Master/Target Select
		//initialize Master Source Select
		$("#clone_master_source_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?> /<br/><?= t("REPOSITORY"); ?></td><td class=\"col2\"><?= t("DRIVE_INFORMATION"); ?> /<br/><?= t("LOCATION"); ?></td><td class=\"col3\"><?= t("DRIVE_STATUS"); ?> /<br/><?= t("NUM_OF_FILES"); ?></td><td class=\"col4\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var s in sources) {
			if ("SerialNumber" in sources[s]) {	//bay
				$("#clone_master_source_select").append("<tr class=\"select_row select-opt source-type-bay\">"
					+ "<td class=\"col1\">" + sources[s]["Bay"] + "</td>"
					+ "<td class=\"col2\">" + sources[s]["Model"] + "<br/>" + getDispSize(sources[s]["Size"]) + "</td>"
					+ "<td class=\"col3\"></td>"
                    + "<td class=\"col4 select-more" + (((sources[s]["IsSAS"] && !sources[s]["IsPortSASEnabled"]) || !sources[s]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
					+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
			}
			else {	//repo
				$("#clone_master_source_select").append("<tr class=\"select_row select-opt source-type-repo" + (sources[s]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled unmounted-repo" : (sources[s]["Name"] == source ? " ui-selected" : "")) + "\">"
					+ "<td class=\"col1\">" + sources[s]["Name"] + "</td>"
					+ "<td class=\"col2\">" + sources[s]["LocationDisplay"] + (sources[s]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
					+ "<td class=\"col3\">" + sources[s]["NumFiles"] + "</td>"
					+ "<td class=\"col4 select-more\"></td>"
					+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
			}
		}
		$("#clone_master_source_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
	}
	else {		//Master Sources are already initialized, just update rows with new repo info
		var master_source_row = -1;
		$("#clone_master_source_select .select_row").each(function(i) {
			if (sources.length > i) {
				if ("SerialNumber" in sources[i]) { //bay
					$(this).removeClass("source-type-repo").addClass("source-type-bay");
					$(this).find(".col1").html(sources[i]["Bay"]);
					$(this).find(".col2").html(sources[i]["Model"] + "<br/>" + getDispSize(sources[i]["Size"]));
                    if ((sources[i]["IsSAS"] && !sources[i]["IsPortSASEnabled"]) || !sources[i]["IsPortEnabled"]) $(this).find(".col4").addClass("sas-alert");
					else $(this).find(".col4").removeClass("sas-alert");
					// !! DO NOT REMOVE: Will cause the source drives to be disabled; if the only
					// other repo in list is an un-mounted network repo - when they are plugged in.
					$(this).removeClass("ui-state-disabled").removeClass("unmounted-repo");
				}
				else {	//repo
					$(this).removeClass("source-type-bay").addClass("source-type-repo");
					$(this).find(".col1").html(sources[i]["Name"]);
					$(this).find(".col2").html(sources[i]["LocationDisplay"]);
					$(this).find(".col3").html(sources[i]["NumFiles"]);
					if (sources[i]["Status"] == "NOT_MOUNTED") $(this).addClass("ui-state-disabled").addClass("unmounted-repo");
					else $(this).removeClass("ui-state-disabled").removeClass("unmounted-repo");
					$(this).find(".col4").removeClass("sas-alert");
				}
			}
			else {	//fewer sources than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			master_source_row = i;
		});
		for (var j=master_source_row+1; j<sources.length; j++) {	//more sources than before, so add before footer row
			if ("SerialNumber" in sources[j]) { //bay {
				$("#clone_master_source_select .footer_row").before("<tr class=\"select_row select-opt source-type-bay" + (sources[j]["Bay"] == source ? " ui-selected" : "") + "\">"
					+ "<td class=\"col1\">" + sources[j]["Bay"] + "</td>"
					+ "<td class=\"col2\">" + sources[j]["Model"] + "<br/>" + getDispSize(sources[j]["Size"]) + "</td>"
					+ "<td class=\"col3\"></td>"
                    + "<td class=\"col4 select-more" + (((sources[j]["IsSAS"] && !sources[j]["IsPortSASEnabled"]) || !sources[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
					+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
			}
			else {
				$("#clone_master_source_select .footer_row").before("<tr class=\"select_row select-opt source-type-repo" + (sources[j]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled unmounted-repo" : (sources[j]["Name"] == source ? " ui-selected" : "")) + "\">"
					+ "<td class=\"col1\">" + sources[j]["Name"] + "</td>"
					+ "<td class=\"col2\">" + sources[j]["LocationDisplay"] + (sources[j]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
					+ "<td class=\"col3\">" + sources[j]["NumFiles"] + "</td>"
					+ "<td class=\"col4 select-more\"></td>"
					+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
			}
		}
	}
	updateDriveStatus("master_source");
}

function updateMasterImageModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var master_image = "";
	}
	else {
		var master_image = task_config[t]["SourceImagePath"];
	}

	//initialize Master Image Select
	if ($("#clone_master_image_select .header_row").length == 0) {		//first time showing drives in Master/Target Select
		//initialize Master Select
		$("#clone_master_image_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("FILE_NAME"); ?></td><td class=\"col2\"><?= t("DATE_CREATED"); ?></td><td class=\"col3\"><?= t("MORE_INFO"); ?></td></tr>");
		for (var i in images) {
			$("#clone_master_image_select").append("<tr class=\"select_row select-opt" + (images[i]["Path"] == master_image ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + images[i]["Name"] + "</td>"
				+ "<td class=\"col2\">" + images[i]["DateCreated"] + "</td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#clone_master_image_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {		//Master Images are already initialized, just update rows with new repo info
		var master_image_row = -1;
		$("#clone_master_image_select .select_row").each(function(i) {
			if (images.length > i) {
				$(this).find(".col1").html(images[i]["Name"]);
				$(this).find(".col2").html(images[i]["DateCreated"]);
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			master_image_row = i;
		});
		for (var j=master_image_row+1; j<images.length; j++) {	//more drives than before, so add before footer row
			$("#clone_master_image_select .footer_row").before("<tr class=\"select_row select-opt" + (images[j]["Path"] == master_image ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + images[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + images[j]["DateCreated"] + "</td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}

function updateTargetRepositoryModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var repos = new Array();
	}
	else {
		if ((task_config[t]["CloneMode"] != MODE_F2F) && (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE)) { //use Repository
			var repos = new Array(task_config[t]["Repository"]);
		}
		else {    //use RepositoryList
			var repos = task_config[t]["RepositoryList"];
		}
	}

	if ($("#clone_target_repo_select .header_row").length == 0) {		//first time showing repos in Target Select
		//initialize Target Repo Select
		$("#clone_target_repo_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("REPOSITORY"); ?></td><td class=\"col2\"><?= t("LOCATION"); ?></td><td class=\"col3\"><?= t("NUM_OF_FILES"); ?></td><td class=\"col4\"><?= t("FREE_SPACE"); ?></td><td class=\"col5\"><?= t("FORMAT"); ?></td></tr>");
		for (var r in repositories) {
			$("#clone_target_repo_select").append("<tr class=\"select_row select-opt" + (repositories[r]["Status"] == "NOT_MOUNTED" ? (repositories[r]["Location"] == "Network" ? " ui-state-disabled" : "") + " unmounted-repo" : "") + (inArray(repositories[r]["Name"], repos) ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + repositories[r]["Name"] + "</td>"
				+ "<td class=\"col2\">" + repositories[r]["LocationDisplay"] + (repositories[r]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
				+ "<td class=\"col3\">" + repositories[r]["NumFiles"] + "</td>"
				+ "<td class=\"col4\">" + repositories[r]["FreeSpace"] + "</td>"
				+ "<td class=\"col5" + ((repositories[r]["Location"] == "Bay" && repositories[r]["Status"] == "NOT_MOUNTED") ? " format-repo" : (repositories[r]["Encrypted"] ? " encrypted-repo" : "")) + "\">" + (repositories[r]["Status"] == "NOT_MOUNTED" ? "" : repositories[r]["Type"]) + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
		$("#clone_target_repo_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
	}
	else {		//Target Repos are already initialized, just update rows with new image info
		var target_repo_row = -1;
		$("#clone_target_repo_select .select_row").each(function(i) {
			if (repositories.length > i) {
				if (repositories[i]["Status"] == "NOT_MOUNTED") {
					// disable row if its a un-mounted network repo
					if (repositories[i]["Location"] == "Network")
						$(this).addClass("ui-state-disabled");
					// !! DO NOT REMOVE: Removing this will cause the disk based
					// un-mounted repos to show up disabled; if the only other repo
					// in the list is an un-mounted network repo.
					// disk based repos should be available for formatting
					else
						$(this).removeClass("ui-state-disabled");
					$(this).addClass("unmounted-repo")
				}
				else {
					if (repositories[i]["Location"] == "Network") $(this).removeClass("ui-state-disabled");
					$(this).removeClass("unmounted-repo");
				}

				// !! DO NOT ENABLE: This causes the Repository selections to revert !!
				//if (inArray(repositories[i]["Name"], repos)) $(this).addClass("ui-selected");
				//else $(this).removeClass("ui-selected");
			
				$(this).find(".col1").html(repositories[i]["Name"]);
				$(this).find(".col2").html(repositories[i]["LocationDisplay"] + (repositories[i]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : ""));
				$(this).find(".col3").html(repositories[i]["NumFiles"]);
				$(this).find(".col4").html(repositories[i]["FreeSpace"]);

				// !! DO NOT CHANGE: Reverting this change will cause the 
				// un-mounted disk repos to show up with the encrypted icon and
				// no way to format
				// un-mounted bay? add format-repo class and remove encrypted-repo
				if (repositories[i]["Location"] == "Bay" && repositories[i]["Status"] == "NOT_MOUNTED"){
					$(this).find(".col5").addClass("format-repo");
					$(this).find(".col5").removeClass("encrypted-repo");
				}
				// mounted repo? remove format-repo class and add encrypted-repo (if encrypted)
				else {
					$(this).find(".col5").removeClass("format-repo");
					// encrypted-repo? add encrypted-repo class; otherwise remove it
					if (repositories[i]["Encrypted"])
						$(this).find(".col5").addClass("encrypted-repo");
					else
						$(this).find(".col5").removeClass("encrypted-repo");
				}

				$(this).find(".col5").html(repositories[i]["Status"] == "NOT_MOUNTED" ? "" : repositories[i]["Type"]);
			}
			else {	//fewer repos than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			target_repo_row = i;
		});
		for (var j=target_repo_row+1; j<repositories.length; j++) {	//more repos than before, so add before footer row
			// !! DO NOT CHANGE: Adding (current_op == OP_PUSH) condition causes the this causes unmounted network repos to become available when a destination drive is detected !!
			$("#clone_target_repo_select .footer_row").before("<tr class=\"select_row select-opt" + (repositories[j]["Status"] == "NOT_MOUNTED" ? (repositories[j]["Location"] == "Network" ? " ui-state-disabled" : "") + " unmounted-repo" : "") + (inArray(repositories[j]["Name"], repos) ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + repositories[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + repositories[j]["LocationDisplay"] + (repositories[j]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
				+ "<td class=\"col3\">" + repositories[j]["NumFiles"] + "</td>"
				+ "<td class=\"col4\">" + repositories[j]["FreeSpace"] + "</td>"
				+ "<td class=\"col5" + ((repositories[j]["Location"] == "Bay" && repositories[j]["Status"] == "NOT_MOUNTED") ? " format-repo" : (repositories[j]["Encrypted"] ? " encrypted-repo" : "")) + "\">" + (repositories[j]["Status"] == "NOT_MOUNTED" ? "" : repositories[j]["Type"]) + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
	}
}

function updateTargetImageModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var target_image = "";
	}
	else {
		var target_image = task_config[t]["DestinationImagePath"];
	}

	var has_new_file = false;
	if ($("#clone_target_image_select .header_row").length == 0) {		//first time showing drives in Marget/Target Select
		//initialize Target Image Select
		$("#clone_target_image_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("FILE_NAME"); ?></td><td class=\"col2\"><?= t("DATE_CREATED"); ?></td><td class=\"col3\">More Info</td></tr>");
		for (var i in images) {
			$("#clone_target_image_select").append("<tr class=\"select_row select-opt" + (images[i]["Path"] == target_image ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + images[i]["Name"] + "</td>"
				+ "<td class=\"col2\">" + images[i]["DateCreated"] + "</td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
			if (images[i]["Size"] == 0) has_new_file = true;
		}
		$("#clone_target_image_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {		//Target Images are already initialized, just update rows with new image info
		var target_image_row = -1;
		$("#clone_target_image_select .select_row").each(function(i) {
			if (images.length > i) {
				if (images[i]["Path"] == target_image) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
				$(this).find(".col1").html(images[i]["Name"]);
				$(this).find(".col2").html(images[i]["DateCreated"]);
				if (images[i]["Size"] == 0) has_new_file = true;
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			target_image_row = i;
		});
		for (var j=target_image_row+1; j<images.length; j++) {	//more images than before, so add before footer row
			$("#clone_target_image_select .footer_row").before("<tr class=\"select_row select-opt" + (images[j]["Path"] == target_image ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + images[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + images[j]["DateCreated"] + "</td>"
				+ "<td class=\"col3 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
			if (images[j]["Size"] == 0) has_new_file = true;
		}
	}

	//if a 0 size file exists, don't allow user to create new file
	if (has_new_file) disableObj($(".clone_target_image_btn_create"));
	else enableObj($(".clone_target_image_btn_create"));
}

    
//set up list of drives on Settings > Bay Roles screen
function updateBayRoles(r) {
	bays = r;
	updateBayRoleSelect();
}

function updateBayRoleSelect() {
	//has the table been initialized
	if ($("#settings_bayroles_select .header_row").length == 0) {		//first time showing drives in Bay Roles Select
		//initialize Bay Roles Select
		$("#settings_bayroles_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?></td><td class=\"col2\"><?= t("ASSIGNED_ROLE"); ?></td><td class=\"col3\"><?= t("EDIT_ROLE"); ?></td></tr>");
		for (var b in bays) {
			$("#settings_bayroles_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + bays[b]["name"] + "</td>"
				+ "<td class=\"col2\">" + bays[b]["role"] + "</td>"
				+ "<td class=\"col3 edit-role\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#settings_bayroles_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {	//Bay Roles already initialized, just update rows with new drive info
		var bay_row = -1;
		$("#settings_bayroles_select .select_row").each(function(i) {
			if (bays.length > i) {
				$(this).find(".col1").html(bays[i]["name"]);
				$(this).find(".col2").html(bays[i]["role"]);
			}
			else {	//fewer bays than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			bay_row = i;
		});
		for (var j=bay_row+1; j<bays.length; j++) {	//more drives than before, so add before footer row
			$("#settings_bayroles_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + bays[j]["name"] + "</td>"
				+ "<td class=\"col2\">" + bays[j]["role"] + "</td>"
				+ "<td class=\"col3 edit-role\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}

//show all_drives on Drives page (ZXi only)
function updateDrivesSelect() {
	//has the table been initialized
	if ($("#drives_select .header_row").length == 0) {		//first time showing drives in Drives Select
		//initialize Bay Roles Select
		$("#drives_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?></td><td class=\"col2\"><?= t("DRIVE_INFORMATION"); ?></td><td class=\"col3\"><?= t("DRIVE_CONNECTED"); ?></td><td class=\"col4\"><?= t("MORE_INFO"); ?></td></tr>");
		for (var d in all_drives) {
			$("#drives_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + all_drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + ('Model' in all_drives[d] ? all_drives[d]["Model"] : "-") + "<br/>" + ('Size' in all_drives[d] ? getDispSize(all_drives[d]["Size"]) : "") + "</td>"
				+ "<td class=\"col3" + (all_drives[d]["Connected"] ? " drive-connected" : " drive-not-connected") + "\"></td>"
                + "<td class=\"col4 select-more" + ((all_drives[d]["Connected"] && ((all_drives[d]["IsSAS"] && !all_drives[d]["IsPortSASEnabled"]) || !all_drives[d]["IsPortEnabled"])) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#drives_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
	}
	else {	//Drives Select already initialized, just update rows with new drive info
		var bay_row = -1;
		$("#drives_select .select_row").each(function(i) {
			if (all_drives.length > i) {
				$(this).find(".col1").html(all_drives[i]["Bay"]);
				$(this).find(".col2").html(('Model' in all_drives[i] ? all_drives[i]["Model"] : "-") + "<br/>" + ('Size' in all_drives[i] ? getDispSize(all_drives[i]["Size"]) : ""));
				if (all_drives[i]["Connected"]) $(this).find(".col3").removeClass("drive-not-connected").addClass("drive-connected");
				else $(this).find(".col3").removeClass("drive-connected").addClass("drive-not-connected");
				if (all_drives[i]["Connected"] && ((all_drives[i]["IsSAS"] && !all_drives[i]["IsPortSASEnabled"]) || !all_drives[i]["IsPortEnabled"]))
					 $(this).find(".col4").addClass("sas-alert");
				else $(this).find(".col4").removeClass("sas-alert");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			bay_row = i;
		});
		for (var j=bay_row+1; j<all_drives.length; j++) {	//more drives than before, so add before footer row
			$("#drives_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + all_drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + ('Model' in all_drives[j] ? all_drives[j]["Model"] : "-") + "<br/>" + ('Size' in all_drives[j] ? getDispSize(all_drives[j]["Size"]) : "") + "</td>"
				+ "<td class=\"col3" + (all_drives[j]["Connected"] ? " drive-connected" : " drive-not-connected") + "\"></td>"
				+ "<td class=\"col4 select-more" + (((all_drives[j]["IsSAS"] && !all_drives[j]["IsPortSASEnabled"]) || !all_drives[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
	}
}

//show repo files on Manage Repos page (ZXi only)
function updateRepoFilesSelect() {
	//has the table been initialized
	if ($("#manage_repos_files_select .header_row").length == 0) {		//first time showing files in Repo Files Select
		//initialize Repo Files Select
		$("#manage_repos_files_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DATE_CREATED"); ?></td><td class=\"col2\"><?= t("FILE_NAME"); ?></td><td class=\"col3\"><?= t("SIZE"); ?></td></tr>");
		for (var n in images) {
			$("#manage_repos_files_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + images[n]["DateCreated"] + "</td>"
				+ "<td class=\"col2\">" + images[n]["Name"] + "</td>"
				+ "<td class=\"col3\">" + getDispSize(images[n]["Size"]) + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#manage_repos_files_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
	}
	else {	//Drives Select already initialized, just update rows with new drive info
		var file_row = -1;
		$("#manage_repos_files_select .select_row").each(function(i) {
			if (images.length > i) {
				$(this).removeClass("ui-selected");	//de-select all rows when Files list is refreshed
				$(this).find(".col1").html(images[i]["DateCreated"]);
				$(this).find(".col2").html(images[i]["Name"]);
				$(this).find(".col3").html(getDispSize(images[i]["Size"]));
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			file_row = i;
		});
		for (var j=file_row+1; j<images.length; j++) {	//more drives than before, so add before footer row
			$("#manage_repos_files_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + images[j]["DateCreated"] + "</td>"
				+ "<td class=\"col2\">" + images[j]["Name"] + "</td>"
				+ "<td class=\"col3\">" + getDispSize(images[j]["Size"]) + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}

	disableObj($("#manage_repos_files_delete_btn"));	//all rows are de-selected each time
	//enable Delete All button if one or more files, disable Delete button if no files
	if (images.length == 0) disableObj($("#manage_repos_files_delete_all_btn"));
	else enableObj($("#manage_repos_files_delete_all_btn"));
}


function updateWipePassesModal() {
	var t = current_task();
	if (t == -1) return;
	if (typeof(task_config[t]) == "undefined") {
		var wipe_values = "";
	}
	else {
		var wipe_values = task_config[t]["WipeValues"];
		var wipe_mode = task_config[t]["WipeMethod"];
	}

	//initialize Wipe Passes Select
	if ($(".wipe_passes_select_hdr_row").length == 0) {		//first time showing drives in Master/Target Select
		$("#wipe_passes_select").append("<tr class=\"wipe_passes_select_hdr_row\"><td class=\"col1\"><?= t("PASSES"); ?></td><td class=\"col2\"><?= t("VALUE"); ?></td><td class=\"col3\"><?= t("EDIT"); ?></td></tr>");
		for (var v=0; v<7; v++) {	//7 Pass rows
			var wipe_val = (wipe_values.length > v ? wipe_values[v] : "");
			$("#wipe_passes_select").append("<tr class=\"wipe_passes_select_row select-opt\">"
				+ "<td class=\"col1" + (v == 6 ? " last-row" : "") + "\">" + (v+1) + "</td>"
				+ "<td class=\"col2" + (v == 6 ? " last-row" : "") + "\">" + dispWipeValue(wipe_val) + "</td>"
				+ "<td class=\"col3" + (v == 6 ? " last-row" : "") + "\"><div class=\"btn-edit edit-pass lock-button\" " + (v > wipe_values.length ? "style=\"visibility: hidden\"" : "") + "></div></td></tr>"
				+ (v < 6 ? "<tr class=\"wipe_passes_spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>" : ""));
		}
	}
	else {		//Master Repos are already initialized, just update rows with new wipe values
		$(".wipe_passes_select_row").each(function(i) {
			var wipe_val = (wipe_values.length > i ? wipe_values[i] : "");
			$(this).find(".col2").html(dispWipeValue(wipe_val));
			$(this).find(".col3").html("<div class=\"btn-edit edit-pass\" " + (i > wipe_values.length ? "style=\"visibility: hidden\"" : "") + "></div>");
		});
	}
}

//update Network Settings screen
function updateNetworkServices(services) {
    //have the drive modals been initialized
	if ($("#network_services_select .header_row").length == 0) {		//first time showing drives in Network Services Select
		//initialize Network Services Select
		$("#network_services_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("NAME"); ?></td><td class=\"col2\"><?= t("DESCRIPTION"); ?></td><td class=\"col3\"><?= t("STATE"); ?></td></tr>");
		for (var s in services) {
			$("#network_services_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + services[s]["name"] + "</td>"
				+ "<td class=\"col2\">" + services[s]["desc"] + "</td>"
				+ "<td class=\"col3\">" + (services[s]["allowed"] ? "<?= t("ENABLED") ?>" : "<?= t("DISABLED"); ?>") + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
		$("#network_services_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td>");

        //disable button
        disableObj($("#network_services_enable_btn"));
    }
	else {	//Network Services Select already initialized, just update rows with new drive info
		var row = -1;
		$("#network_services_select .select_row").each(function(i) {
			if (services.length > i) {
				$(this).find(".col1").text(services[i]["name"]);
				$(this).find(".col2").text(services[i]["desc"]);
				$(this).find(".col3").html(services[i]["allowed"] ? "<?= t("ENABLED") ?>" : "<?= t("DISABLED"); ?>");
            }
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<services.length; j++) {	//more drives than before, so add before footer row
			$("#network_services_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + services[j]["name"] + "</td>"
				+ "<td class=\"col2\">" + services[j]["desc"] + "</td>"
				+ "<td class=\"col3\">" + (services[j]["allowed"] ? "<?= t("ENABLED") ?>" : "<?= t("DISABLED"); ?>") + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>");
		}
	}
}
            
function updateNetworkServiceRow(name, allowed) {
    $("#network_services_select .select_row").each(function() {
        if ($(this).find(".col1").text() == name) {
            $(this).find(".col3").html(allowed ? "<?= t("ENABLED"); ?>" : "<?= t("DISABLED"); ?>");
            if ($(this).hasClass("ui-selected")) $("#network_services_enable_btn").html(allowed ? "<?= t("DISABLE_BTN"); ?>" : "<?= t("ENABLE_BTN"); ?>");
        }
    });
}
                    
function updateNetworkSettings(dblist) {
	network_settings_config['Server'] = dblist['server'];
	network_settings_config['Username'] = dblist['username'];
	network_settings_config['Password'] = dblist['password'];

	var password = Array(network_settings_config['Password'].length+1).join("*");	//change to *s
	var serverinfo = network_settings_config['Server'];
	var userinfo = "<?= t("USERNAME"); ?>: " + network_settings_config['Username'] + "<br/>"
		+ "<?= t("PASSWORD"); ?>: " + password;
	$("#network_settings_server_block_content").html(serverinfo);
	$("#network_settings_user_block_content").html(userinfo);

	var port = serverinfo.match(/:[0-9]+$/);		//see if there's a port
	if (port != null) {
		var server = serverinfo.substr(0, serverinfo.lastIndexOf(":"));
		var port = serverinfo.substr(serverinfo.lastIndexOf(":")+1);
	}
	else {
		var server = serverinfo;
		var port = "";
	}

	$("#network_settings_server_val").val(server);
	$("#network_settings_port_val").val(port);
	$("#network_settings_username_val").val(network_settings_config['Username']);
	$("#network_settings_password_val").val(password);
	$("#network_settings_repassword_val").val(password);
}

//update Interface List screen
function updateInterfaceList() {
    //have the drive modals been initialized
	if ($("#network_interfaces_select .header_row").length == 0) {		//first time showing drives in Network Services Select
		//initialize Interfaces select
		$("#network_interfaces_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("NAME"); ?></td><td class=\"col2\"><?= t("MAC_ADDRESS"); ?></td><td class=\"col3\"><?= t("CONFIG_TYPE"); ?></td><td class=\"col4\"><?= t("MTU"); ?></td><td class=\"col5\"><?= t("STATUS"); ?></td></tr>");
		for (var s in interfaces) {
			$("#network_interfaces_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + interfaces[s]["Name"] + "</td>"
				+ "<td class=\"col2\">" + interfaces[s]["MACAddress"] + "</td>"
				+ "<td class=\"col3\">" + INTERFACETYPES[interfaces[s]["Type"]] + "</td>"
				+ "<td class=\"col4\">" + interfaces[s]["MTU"] + "</td>"
				+ "<td class=\"col5\">" + interfaces[s]["Status"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
		$("#network_interfaces_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td>");

        //disable button
        disableObj($("#network_interfaces_edit_config_btn"));
    }
	else {	//Interfaces select already initialized, just update rows with new drive info
		var row = -1;
		$("#network_interfaces_select .select_row").each(function(i) {
			if (interfaces.length > i) {
				$(this).find(".col1").text(interfaces[i]["Name"]);
				$(this).find(".col2").text(interfaces[i]["MACAddress"]);
				$(this).find(".col3").html(INTERFACETYPES[interfaces[i]["Type"]]);
				$(this).find(".col4").text(interfaces[i]["MTU"]);
				$(this).find(".col5").text(interfaces[i]["Status"]);
            }
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<interfaces.length; j++) {	//more drives than before, so add before footer row
			$("#network_interfaces_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + interfaces[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + interfaces[j]["MACAddress"] + "</td>"
				+ "<td class=\"col3\">" + INTERFACETYPES[interfaces[j]["Type"]] + "</td>"
				+ "<td class=\"col4\">" + interfaces[j]["MTU"] + "</td>"
				+ "<td class=\"col5\">" + interfaces[j]["Status"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
	}
}

                                                        
//update iSCSI screen
function updateIscsiPage() {
	$("#iscsi_network_block_content").html("<?= t("PORTAL"); ?>: " + truncate(iscsi_config['Portal'], 10) + "<br/>" +
		"<?= t("USERNAME"); ?>: " + truncate(iscsi_config['Username'], 10) + "<br/>" + "<?= t("PASSWORD"); ?>: " + (iscsi_config['Password'] == "" ? "" : "<?= t("PASSWORD_SET"); ?>"));
	$("#iscsi_role_block_content").html(REPOROLES[iscsi_config['Role']]);

	$("#iscsi_portal_val").val(iscsi_config['Portal']);
	$("#iscsi_username_val").val(iscsi_config['Username']);
	$("#iscsi_password_val").val(iscsi_config['Password']);
	$("#iscsi_role_select .select-opt").each(function(i) {
		if (i == iscsi_config['Role']) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});

    if (iscsi_config['Connected']) {
        disableObj($("#iscsi_network_block"));
        disableObj($("#iscsi_role_block"));
        disableObj($("#iscsi_connect"));
        enableObj($("#iscsi_disconnect"));
    }
    else {
        enableObj($("#iscsi_network_block"));
        enableObj($("#iscsi_role_block"));
        if (iscsi_config['Portal'] == "") disableObj($("#iscsi_connect"));
        else enableObj($("#iscsi_connect"));
        disableObj($("#iscsi_disconnect"));
    }
}

function updateDefaultFileSystem() {
	$("#config_file_system_block_content").html(FILESYSTEMS[DEFAULT_FILESYSTEM]);  //update Config page
	$("#config_file_system_" + DEFAULT_FILESYSTEM).mousedown();    //update Config modal
	$("#clone_format_file_system_" + DEFAULT_FILESYSTEM).mousedown();  //update Format File System modal
}

function updateDrivePower() {
    //var timer_enabled = AUTO_DISK_INACTIVITY_TIMER;
    setSlider("drive_inactivity_timeout_value", DISK_INACTIVITY_TIMEOUT);   //update Timeout slider
    if (DISK_INACTIVITY_TIMEOUT == 0) { //update block
        $("#drive_inactivity_block_content").html("<?= t("TIMER"); ?>" + ": " + "<?= t("DISABLED"); ?>");
    }
    else {
        $("#drive_inactivity_block_content").html("<?= t("TIMER"); ?>" + ": " + "<?= t("ENABLED"); ?><br/><?= t("TIMEOUT"); ?>: " + DISK_INACTIVITY_TIMEOUT);
    }
}

function updateDestinationNCQ() {
    $("#settings_destncq_" + DESTINATION_NCQ).mousedown();
}

function updateUSBSettings() {
    $("#usb_export_mode_" + READ_ONLY_EXPORT).mousedown();
    $("#usb_export_type_" + REMOVABLE_EXPORT).mousedown();
    $("#usb_dco_passthrough_" + DCO_PASSTHROUGH).mousedown();
    $("#settings_auto_remove_hpa_" + AUTO_REMOVE_HPA).mousedown();
    $("#settings_auto_remove_dco_" + AUTO_REMOVE_DCO).mousedown();
    update_usb_settings_only = false;
}

//update Settings User Profiles/Configurations screen
function updateSettingsProfiles(dblist) {
    if ($("#settings_profiles_select .header_row").length == 0) {		//first time showing User Profiles/Configuration select
        //disable buttons
        disableObj($("#settings_config_save, #settings_config_load"));

        $("#settings_profiles_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("USER_PROFILES_CONFIGS"); ?></td><td class=\"col2\"><?= t("DELETE"); ?></td></tr>");
		for (var d in dblist) {
			$("#settings_profiles_select").append("<tr class=\"select_row select-opt\"><td class=\"col1\"><div>" + dblist[d] + "</div></td><td class=\"col2 delete-profile\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td></tr>");
		}
		$("#settings_profiles_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td></tr>");
	}
	else {
		var db_row = -1;
		$("#settings_profiles_select .select_row").each(function(i) {
			if (dblist.length > i) {
				var new_db = dblist[i];
				var cur_db = $(this).find(".col1").text();
				if ((new_db != cur_db) && $(this).hasClass("ui-selected")) $(this).removeClass("ui-selected");
				$(this).find(".col1 div").text(new_db);
			}
			else {	//fewer profiles than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			db_row = i;
		});
		for (var j=db_row+1; j<dblist.length; j++) {	//more images than before, so add before footer row
			$("#settings_profiles_select .footer_row").before("<tr class=\"select_row select-opt\"><td class=\"col1\"><div>" + dblist[j] + "</div></td><td class=\"col2 delete-profile\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td></tr>");
		}
	}
}

//update CipherMode buttons and Encryption Password in modals
function updateEncryptionModals() {
	var cm = encryption_config['CipherMode'];
	$("#settings_cipher_mode_select .select-opt").each(function(i) {
		if (i == cm) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});

	var c = encryption_config['Cipher'];
	$("#settings_cipher_select .select-opt").each(function(i) {
		if (i == c) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});

	var ivg = encryption_config['IVGen'];
	$("#settings_ivgen_select .select-opt").each(function(i) {
		if (i == ivg) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});

	$("#settings_encpass_val").val(encryption_config['Password']);
}

//update CipherMode and Encryption Password in buttons
function updateEncryptionButtons() {
	$("#settings_cipher_mode_btn_bottom").html(CIPHERMODES[encryption_config['CipherMode']]);
	if (encryption_config['CipherMode'] == CIPHERMODE_TC_XTS || encryption_config['CipherMode'] == CIPHERMODE_VCRYPT) { 
        disableObj($("#settings_ivgen_btn")); $("#settings_ivgen_btn_bottom").html(""); 
    }
	else {
        enableObj($("#settings_ivgen_btn"));
        $("#settings_ivgen_btn_bottom").html(IVGENS[encryption_config['IVGen']]);
    }
	$("#settings_cipher_btn_bottom").html(CIPHERS[encryption_config['Cipher']]);
	$("#settings_encpass_btn_bottom").html(encryption_config['Password']);
}

//update Time Zone Region select in modal
function updateTimeZoneRegionSelect() {
	$("#settings_timezone_region_select").empty();
	$("#settings_timezone_region_select").append("<tr class=\"header_row\"><td class=\"col1\"></td></tr>");
	for (var region in timezones) {	//TimeZones = ['US' => ['0' => "US/Samoa", '1' => "US/Pacific-New", ...], ...]
		$("#settings_timezone_region_select").append("<tr class=\"select_row select-opt" + (timezone.substring(0, timezone.indexOf("/")) == region ? " ui-selected" : "") + "\"><td class=\"col1\">" + region + "</td></tr>"
			+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
	}
	$("#settings_timezone_region_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
}
//update Time Zone select in modal
function updateTimeZoneSelect(region) {
	$("#settings_timezone_select").empty();
	$("#settings_timezone_select").append("<tr class=\"header_row\"><td class=\"col1\"></td></tr>");
	for (var i in timezones[region]) {	//['0' => "US/Samoa", '1' => "US/Pacific-New", ...]
		$("#settings_timezone_select").append("<tr class=\"select_row select-opt" + (timezones[region][i] == timezone ? " ui-selected" : "") + "\"><td class=\"col1\">" + timezones[region][i] + "</td></tr>"
			+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
	}
	$("#settings_timezone_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
}
//updates Time Zone variable, button, and selection (assumes settings_timezone_select is initialized)
function updateTimeZonePage() {
	$("#settings_timezone_btn_bottom").html(timezone);
	$("#settings_timezone_region_select .select-opt").each(function() {
		if ($(this).find(".col1").text() == timezone.substring(0, timezone.indexOf("/"))) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});
	$("#settings_timezone_select .select-opt").each(function() {
		if ($(this).find(".col1").text() == timezone) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});
}

//update Brightness
function updateBrightnessPage(b) {
	//convert 0-255 value to 0-100% in 10% increments
	var pct = Math.round(b*10/255)*10;
	setSlider("settings_brightness_value", pct, true);
}

//update Stealth Mode
function updateStealthModePage(s) {
	if (s == APISTEALTHMODES[STEALTHMODE_ON]) {
		$("#settings_stealth_0").addClass("ui-selected");
		$("#settings_stealth_1").removeClass("ui-selected");
	}
	else {
		$("#settings_stealth_1").addClass("ui-selected");
		$("#settings_stealth_0").removeClass("ui-selected");
	}
}

//update Notifications
function updateNotificationsPage(notifications) {
    for (var n in notifications) {
        if (notifications[n]['NotificationsEvent'] == "success") {
            notifications_config['success'] = notifications[n]['NotificationsBeeper'];
        }
        else if (notifications[n]['NotificationsEvent'] == "error") {
            notifications_config['error'] = notifications[n]['NotificationsBeeper'];
        }
    }

    updateNotificationsButton();
    updateNotificationsModal();
}
function updateNotificationsButton() {
    $("#settings_end_of_task_btn_bottom").html("<?= t("SUCCESS"); ?>: " + (notifications_config['success'] == 1 ? "<?= t("SOUND"); ?>" : "<?= t("NONE"); ?>") + "<br/><?= t("ERROR"); ?>: " + (notifications_config['error'] == 1 ? "<?= t("SOUND"); ?>" : "<?= t("NONE"); ?>"));
}
function updateNotificationsModal() {
    $("#settings_end_of_task_success_select .select-opt").each(function(i) {
        if (notifications_config['success'] == i) $(this).addClass("ui-selected");
        else $(this).removeClass("ui-selected");
    });
    $("#settings_end_of_task_error_select .select-opt").each(function(i) {
        if (notifications_config['error'] == i) $(this).addClass("ui-selected");
        else $(this).removeClass("ui-selected");
    });
}


function updateManageReposPage() {
	//only show non-Local repositories
	var non_local_repositories = new Array();
	for (var r in repositories) {
		/*if (repositories[r]["Local"] == false) */non_local_repositories.push(repositories[r]);
	}

 	//initialize Manage Repos Select
	if ($("#manage_repos_select .header_row").length == 0) {		//first time showing repos in Manage Repos Select
		//initialize Master Select
		$("#manage_repos_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("NAME"); ?></td><td class=\"col2\"><?= t("LOCATION"); ?></td><td class=\"col3\"><?= t("FILE_SYSTEM"); ?></td><td class=\"col4\"><?= t("FREE_SPACE"); ?></td><td class=\"col5\"><?= t("EDIT_FILES"); ?></td><td class=\"col6\"><?= t("EDIT"); ?></td><td class=\"col7\"><?= t("DELETE"); ?></td></tr>");
		for (var r in non_local_repositories) {
			$("#manage_repos_select").append("<tr class=\"select_row select-opt" + (non_local_repositories[r]["Location"] == "Network" ? " network-repo" : "") + "\">"
				+ "<td class=\"col1\">" + non_local_repositories[r]["Name"] + "</td>"
				+ "<td class=\"col2\">" + non_local_repositories[r]["LocationDisplay"] + (non_local_repositories[r]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
				+ "<td class=\"col3\">" + non_local_repositories[r]["Type"] + "</td>"
				+ "<td class=\"col4\">" + non_local_repositories[r]["FreeSpace"] + "</td>"
				+ "<td class=\"col5 edit-files" + (non_local_repositories[r]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled" : "") + "\"></td>"
				+ "<td class=\"col6" + (non_local_repositories[r]["Location"] == "Network" ? " edit-repo lock-button" : "") + "\"></td>"
				+ "<td class=\"col7 delete-repo lock-button\" id=\"delete-repo-" + r + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td><td class=\"col6\"></td><td class=\"col7\"></td></tr>");
		}
		$("#manage_repos_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td><td class=\"col6\"></td><td class=\"col7\"></td></tr>");
	}
	else {		//Manage Repos are already initialized, just update rows with new repo info
		var manage_repo_row = -1;
		$("#manage_repos_select .select_row").each(function(i) {
			if (non_local_repositories.length > i) {
                if (non_local_repositories[i]["Location"] == "Network") $(this).addClass("network-repo");
                else $(this).removeClass("network-repo");
                $(this).find(".col1").html(non_local_repositories[i]["Name"]);
				$(this).find(".col2").html(non_local_repositories[i]["LocationDisplay"] + (non_local_repositories[i]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : ""));
				$(this).find(".col3").html(non_local_repositories[i]["Type"]);
				$(this).find(".col4").html(non_local_repositories[i]["FreeSpace"]);
                if (non_local_repositories[i]["Status"] == "NOT_MOUNTED") $(this).find(".col5").addClass("ui-state-disabled");
                else $(this).find(".col5").removeClass("ui-state-disabled");
                if (non_local_repositories[i]["Location"] == "Network") $(this).find(".col6").addClass("edit-repo lock-button");
                else $(this).find(".col6").removeClass("edit-repo lock-button");
            }
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			manage_repo_row = i;
		});
		for (var j=manage_repo_row+1; j<non_local_repositories.length; j++) {	//more drives than before, so add before footer row
			$("#manage_repos_select .footer_row").before("<tr class=\"select_row select-opt" + (non_local_repositories[j]["Location"] == "Network" ? " network-repo" : "") + "\">"
				+ "<td class=\"col1\">" + non_local_repositories[j]["Name"] + "</td>"
				+ "<td class=\"col2\">" + non_local_repositories[j]["LocationDisplay"] + (non_local_repositories[j]["Status"] == "NOT_MOUNTED" ? "<br/>(<?= t("NOT_MOUNTED"); ?>)" : "") + "</td>"
				+ "<td class=\"col3\">" + non_local_repositories[j]["Type"] + "</td>"
				+ "<td class=\"col4\">" + non_local_repositories[j]["FreeSpace"] + "</td>"
				+ "<td class=\"col5 edit-files" + (non_local_repositories[j]["Status"] == "NOT_MOUNTED" ? " ui-state-disabled" : "") + "\"></td>"
				+ "<td class=\"col6" + (non_local_repositories[r]["Location"] == "Network" ? " edit-repo lock-button" : "") + "\"></td>"
				+ "<td class=\"col7 delete-repo lock-button\" id=\"delete-repo-" + r + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td><td class=\"col6\"></td><td class=\"col7\"></td></tr>");
		}
	}
}

//update Manage Repos - Format tab
function updateFormatDrivesPage() {
	//have the drive modals been initialized
	if ($("#format_drives_select .header_row").length == 0) {		//first time showing drives in Format Drives Select
		//initialize Master Select
		$("#format_drives_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE_BAY"); ?></td><td class=\"col2\"><?= t("DRIVE_INFORMATION"); ?></td><td class=\"col3\"><?= t("DRIVE_STATUS"); ?></td><td class=\"col4\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var d in drives) {
			$("#format_drives_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[d]["Model"] + "<br/>" + getDispSize(drives[d]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((drives[d]["IsSAS"] && !drives[d]["IsPortSASEnabled"]) || !drives[d]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#format_drives_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
	}
	else {	//Format Drives table is already initialized, just update rows with new drive info
		var row = -1;
		$("#format_drives_select .select_row").each(function(i) {
			if (drives.length > i) {
				$(this).find(".col1").html(drives[i]["Bay"]);
				$(this).find(".col2").html(drives[i]["Model"] + "<br/>" + getDispSize(drives[i]["Size"]));
				//$(this).removeClass("ui-selected");	//deselect rows each time user visits page, because status is updated to "Available" w/ Master/Target rows
				if ((drives[i]["IsSAS"] && !drives[i]["IsPortSASEnabled"]) || !drives[i]["IsPortEnabled"]) $(this).find(".col4").addClass("sas-alert");
				else $(this).find(".col4").removeClass("sas-alert");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<drives.length; j++) {	//more drives than before, so add before footer row
			$("#format_drives_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[j]["Model"] + "<br/>" + getDispSize(drives[j]["Size"]) + "</td>"
				+ "<td class=\"col3\"></td>"
				+ "<td class=\"col4 select-more" + (((drives[j]["IsSAS"] && !drives[j]["IsPortSASEnabled"]) || !drives[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
	}

	disableHideDrives();
	updateDriveStatus("manage_drives");
}


//update Add Repository Select Drive modal
//show drives and networks
function updateAddRepoDrivesModal() {
	var drives_list = new Array();
                                           
	for (var d in drives) {
		var bay = drives[d]["Bay"];
		for (var i=0; i<drives[d].Partitions.length; i++) {
			//only show non-Local drives
			if (drives[d].Local == false) {
				var part = drives[d].Partitions[i];
				var num = part["Number"];
				var filesys = part.FileSystem.toUpperCase();
				drives_list.push("<span class=\"bay\">" + bay + "</span> Partition <span class=\"partition\">" + num + "</span> <span class=\"filesystem\">(" + filesys + ")</span>");
			}
		}
	}
	drives_list.push("<span class=\"bay\">Network Share</span>");

	//have the drive modals been initialized
	if ($("#repo_drives_select .header_row").length == 0) {		//first time showing drives in Format Drives Select
		//initialize Master Select
		$("#repo_drives_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("DRIVE"); ?></td></tr>");
		for (var d in drives_list) {
			$("#repo_drives_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives_list[d] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
		$("#repo_drives_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
	}
	else {	//Add Repo Drives table is already initialized, just update rows with new drive info
		var row = -1;
		$("#repo_drives_select .select_row").each(function(i) {
			if (drives_list.length > i) {
				$(this).find(".col1").html(drives_list[i]);
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<drives_list.length; j++) {	//more drives than before, so add before footer row
			$("#repo_drives_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives_list[j] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
	}
}

//update Network Source modal
//show drives and networks
function updateNetworkSourceModal() {
    var sel_interface = add_repo_config['InterfaceName'];
	//have the drive modals been initialized
	if ($("#repo_network_source_select .header_row").length == 0) {		//first time showing drives in Format Drives Select
		//initialize Source Select
		$("#repo_network_source_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("INTERFACE"); ?></td></tr>");
        $("#repo_network_source_select").append("<tr class=\"select_row select-opt" + (sel_interface == "" ? " ui-selected" : "") + "\">"
            + "<td class=\"col1\"><?= t("ANY"); ?></td>"
            + "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
        for (var n in interfaces) {
			$("#repo_network_source_select").append("<tr class=\"select_row select-opt" + (sel_interface == interfaces[n]['Name'] ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + interfaces[n]['Name'] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
		$("#repo_network_source_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
	}
	else {	//Source table is already initialized, just update rows with new drive info
		var row = -1;
		$("#repo_network_source_select .select_row").each(function(i) {
            if (i == 0) {
                if (sel_interface == "") $(this).addClass("ui-selected");
                return true;   //skip "Any" row
            }
			if (interfaces.length > i-1) {
				$(this).find(".col1").html(interfaces[i-1]['Name']);
                if (sel_interface == interfaces[i-1]['Name']) $(this).addClass("ui-selected");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<interfaces.length+1; j++) {	//more sources than before, so add before footer row
            if (j == 0) {
                if (sel_interface == "") $(this).addClass("ui-selected");
                return true;   //skip "Any" row
            }
			$("#repo_network_source_select .footer_row").before("<tr class=\"select_row select-opt" + (sel_interface == interfaces[j-1]['Name'] ? " ui-selected" : "") + "\">"
				+ "<td class=\"col1\">" + interfaces[j-1]['Name'] + "</td>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
	}

    $('#manage_repos_add_dialog').data('opening_another_dialog', true).dialog('close');
    $('#repo_network_source_dialog').dialog('open');                                         
}
                        
function updateNWInterfaceModals(sel_interface) {
    //populate Edit Config modal and sub-modals with selected interface info
    network_interface_config = {'Name': sel_interface['Name'], 'Type': sel_interface['Type'], 'MTU': sel_interface['MTU'], 'IPAddress': sel_interface['IPAddress'], 'NetMask': sel_interface['NetMask'], 'Gateway': sel_interface['Gateway'], 'NameServers': sel_interface['NameServers']};

    $("#interface_type_block_content").html(INTERFACETYPES[sel_interface['Type']]);
    $("#interface_type_select .select-opt").each(function(i) {
        if (i == sel_interface['Type']) $(this).addClass("ui-selected");
        else $(this).removeClass("ui-selected");
    });

    var ipsettings = "<?= t("IP_NETMASK"); ?>: " + sel_interface['IPAddress'] + "/" + sel_interface['NetMask'] + ", " + "<?= t("GATEWAY"); ?>: " + sel_interface['Gateway'] + ", " + "<?= t("DNS_SERVER"); ?>: " + sel_interface['NameServers'];
    $("#interface_ip_block_content").html(ipsettings);
    if (sel_interface['Type'] == INTERFACETYPE_DHCP) disableObj($("#interface_ip_block"));
    else enableObj($("#interface_ip_block"));
    
    var ipvals = sel_interface['IPAddress'].split(".");
    $("#iv_ip0").val(ipvals[0]);
    $("#iv_ip1").val(ipvals[1]);
    $("#iv_ip2").val(ipvals[2]);
    $("#iv_ip3").val(ipvals[3]);
    $("#iv_netmask").val(sel_interface['NetMask']);

    var gatewayvals = (sel_interface['Gateway'] == "assigned by dhcp" ? ["", "", "", ""] : sel_interface['Gateway'].split("."));
    $("#iv_gateway0").val(gatewayvals[0]);
    $("#iv_gateway1").val(gatewayvals[1]);
    $("#iv_gateway2").val(gatewayvals[2]);
    $("#iv_gateway3").val(gatewayvals[3]);

    var dnsvals = (sel_interface['NameServers'] == "assigned by dhcp" ? ["", "", "", ""] : sel_interface['NameServers'].split("."));
    $("#iv_dns0").val(dnsvals[0]);
    $("#iv_dns1").val(dnsvals[1]);
    $("#iv_dns2").val(dnsvals[2]);
    $("#iv_dns3").val(dnsvals[3]);

    $("#interface_mtu_block_content").html(sel_interface['MTU']);
    $("#mtu_val").val(sel_interface['MTU']);
            
    enableDisableNWInterfaceOKButton();
}

function enableDisableNWInterfaceOKButton() {
    if ((network_interface_config['Type'] == INTERFACETYPE_DHCP) || 
        (network_interface_config['Type'] == INTERFACETYPE_STATIC && 
         network_interface_config['IPAddress'] != "" && network_interface_config['NetMask'] != "" && 
         network_interface_config['Gateway'] != "" && network_interface_config['NameServers'] != "")) {
        $("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").removeAttr('disabled');	//disableObj function only handles ids
        $("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").removeClass('ui-state-disabled');
    }
    else {
        $("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").attr('disabled', 'disabled');	//disableObj function only handles ids
        $("#settings_unlock_dialog").next(".ui-dialog-buttonpane").find("button").addClass('ui-state-disabled');
    }
}

//after successful RepositoryAdd, clear add_repo_config and modals
function clearAddRepoConfig() {
	for (var k in add_repo_config) add_repo_config[k] = '';
	$("#repo_name_block_content").html("");
	$("#repo_drive_block_content").html("");
	$("#repo_network_block_content").html("");
	$("#repo_name_val").val("");
	$("#repo_drives_select .select-opt").each(function() {
		$(this).removeClass("ui-selected");
	});
	$("#repo_role_select .select-opt").each(function(i) {
		if (i == REPOROLE_BOTH) $(this).addClass("ui-selected");
		else $(this).removeClass("ui-selected");
	});
	add_repo_config['Role'] = REPOROLE_BOTH;
	$("#repo_role_block_content").html(REPOROLES[add_repo_config['Role']]);

    <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
	$("#repo_network_source_block_content").html("<?= t("ANY"); ?>");
	$("#repo_network_destination_block_content").html("");
	$("#repo_network_source_select .select-opt").each(function(i) {
        if (i == 0) $(this).addClass("ui-selected");    //select "Any" row
		else $(this).removeClass("ui-selected");
	});
    disableObj($("#repo_network_source_block"));
    disableObj($("#repo_network_destination_block"));
    <?php else: ?>
    disableObj($("#repo_network_block"));
    <?php endif; ?>
}

//update File Browser tabs and current iframe src
function updateFileBrowserTabs(dirs) {
    if (dirs.length == 0) {
        $("#file_browser_tabbar").empty();
        hideObj($("#file_browser_page_0"));
    }
    else {
        if ($("#file_browser_tabbar .btn-tab").length == 0) {    //first time showing tabs
            for (var d in dirs) {
                if (d >= 6) break;  //ONLY SHOW 6 TABS MAX
                $("#file_browser_tabbar").append("<div id=\"file_browser_tab_" + d + "\" class=\"btn-tab" + (d == 0 ? " selected" : "") + "\" data-path=\"" + dirs[d]['Path'] + "/\"><p>" + dirs[d]['Bay'] + "</p></div>");
            }
            selectNonTaskTab(0);
            loadFileBrowserIframe(0);
            showObj($("#file_browser_page_0"));
        }
        else {
            var tab = -1;
            var selected = 0;
            $("#file_browser_tabbar .btn-tab").each(function(i) {
                if (dirs.length > i) {
                    $(this).attr("data-path", dirs[i]['Path'] + "/");
                    $(this).html("<p>" + dirs[i]['Bay'] + "</p>");
                }
                else {	//fewer dirs than before, so delete additional tabs
                    if ($(this).hasClass('selected')) {
                        $("#file_browser_tab_" + (i-1)).mousedown();
                        selectNonTaskTab(i-1);
                        selected = i;
                    }
                    else
                        selected = -1;
                    $(this).remove();
                }
                tab = i;
            });
            if (selected == -1) {
                $("#file_browser_tab_0").mousedown();
                selectNonTaskTab(0);
            }
            for (var j=tab+1; j<dirs.length; j++) {	//more dirs than before, so add at end
                if (j >= 6) break;  //ONLY SHOW 6 TABS MAX
                $("#file_browser_tabbar").append("<div id=\"file_browser_tab_" + j + "\" class=\"btn-tab\" data-path=\"" + dirs[j]['Path'] + "/\"><p>" + dirs[j]['Bay'] + "</p></div>");
            }
        }
    }
}

//set up selectable lists and sliders in other non-drive (not Select Master or Select Target) modals
function initOtherModals() {
	//initialize Mode selectable options
	<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
	$([0, 1, 2, 3, 4]).each(function(i) {
	<?php else: ?>
	$([0, 1, 2]).each(function(i) {
	<?php endif; ?>
       if (!IMAGE_RESTORE_OPTION && i == 1) return true;   //don't show File to Drive
       if (!FILETOFILE_OPTION && i == 3) return true;      //don't show File to File

        var mode = MODES[i];
        $("#clone_mode_select").append("<div id=\"clone_mode_" + i + "\" class=\"select-opt btn-sq\">" + mode + "</div>");
        
        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
        $("#clone_mode_1").insertAfter("#clone_mode_3");
		<?php endif; ?>
    });

	//initialize Clone Method selectable options
	$(METHODS, this).each(function(i) {
		$("#clone_imgmode_select").append("<div id=\"clone_imgmode_" + i + "\" class=\"select-opt btn-sq\">" + METHODS[i] + "</div>");	//when this appears in the File Image modal
	});

    <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
	$(AUTHTYPES, this).each(function(i) {
		$("#clone_partition_auth_select").append("<div id=\"clone_partition_auth_" + i + "\" class=\"select-opt btn-med" + (i == 0 ? " ui-selected" : "") + "\">" + AUTHTYPES[i] + "</div>");
	});

    $(OUTPUTFORMATS, this).each(function(i) {
		$("#clone_output_format_select").append("<div id=\"clone_output_format_" + i + "\" class=\"select-opt btn-med\">" + OUTPUTFORMATS[i] + "</div>");
	});

	$(PRESETFILTERS_LONG, this).each(function(i) {
        var html = "";
        html = "<label>" + PRESETFILTERS_LONG[i] + "</label><div id=\"clone_preset_filter_" + i + "_select\">";
        $(PRESETFILTERS, this).each(function(j) {
            html += "<div id=\"clone_preset_filter_" + i + "_" + j + "\" class=\"select-opt btn-med\">" + PRESETFILTERS[j] + "</div>";
        });
        html += "</div>";
        $("#clone_preset_filter_select").append(html);

        //set up select toggle
        $("#clone_preset_filter_" + i + "_select .select-opt").mousedown(function() {
            $("#clone_preset_filter_" + i + "_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
            });
            $(this).toggleClass("ui-selected");
        });
    });

	$(FILECATS_LONG, this).each(function(i) {
        var html = "";
        html = "<label>" + FILECATS_LONG[i] + "</label><div id=\"clone_file_cat_" + i + "_select\">";
        $(FILECATS, this).each(function(j) {
            html += "<div id=\"clone_file_cat_" + i + "_" + j + "\" class=\"select-opt btn-med\">" + FILECATS[j] + "</div>";
        });
        html += "</div>";
        $("#clone_file_cat_select").append(html);

        //set up select toggle
        $("#clone_file_cat_" + i + "_select .select-opt").mousedown(function() {
            $("#clone_file_cat_" + i + "_select .select-opt").each(function() {
                if ($(this).hasClass("ui-selected")) $(this).toggleClass("ui-selected");
            });
            $(this).toggleClass("ui-selected");
        });
    });

	//initialize Search Keywords selectable options
	$(IGNORECASES, this).each(function(i) {
		$("#clone_ignore_case_select").append("<div id=\"clone_ignore_case_" + i + "\" class=\"select-opt btn-med\">" + IGNORECASES[i] + "</div>");
	});
	$(CHARENCODINGS, this).each(function(i) {
		$("#clone_char_encoding_select").append("<div id=\"clone_char_encoding_" + i + "\" class=\"select-opt btn-med\">" + CHARENCODINGS[i] + "</div>");
	});
                
    <?php endif; ?>
                
	//initialize Clone HPA/DCO selectable options
	$([0, 1], this).each(function(i) {
		$("#clone_hpa_select").append("<div id=\"clone_hpa_" + i + "\" class=\"select-opt btn-med\">" + HPAS[i] + "</div>");
	});
	$([0, 1], this).each(function(i) {
		$("#clone_dco_select").append("<div id=\"clone_dco_" + i + "\" class=\"select-opt btn-med\">" + DCOS[i] + "</div>");
	});
	$([0, 1], this).each(function(i) {
		$("#clone_drive_trim_select").append("<div id=\"clone_drive_trim_" + i + "\" class=\"select-opt btn-med\">" + DRIVETRIMS[i] + "</div>");
	});
	$(ERRORHANDLINGS).each(function(i) {
		$("#clone_error_handling_select").append("<div id=\"clone_error_handling_" + i + "\" class=\"select-opt btn-med\">" + ERRORHANDLINGS[i] + "</div>");
	});
	$(ERRORGRANULARITIES).each(function(i) {
		$("#clone_error_granularity_select").append("<div id=\"clone_error_granularity_" + i + "\" class=\"select-opt btn-med\">" + ERRORGRANULARITIES[i] + "</div>");
	});

	//initialize Hash Method selectable options
	$(HASHES, this).each(function(i) {
		$("#clone_hash_select").append("<div id=\"clone_hash_" + i + "\" class=\"select-opt btn-med\">" + HASHES[i] + "</div>");
	});

	//initialize Verify Method selectable options
	$(VERIFS, this).each(function(i) {
		$("#clone_verif_select").append("<div id=\"clone_verif_" + i + "\" class=\"select-opt btn-med\">" + VERIFS[i] + "</div>");
		if (!VERIFY_OPTION) disableObj($("#clone_verif_" + i));		//no Verify option
        //set VerifyHash to false if true???
	});

	//initialize Mirror Mode selectable options
	$(MIRMODES).each(function(i) {
		$("#clone_mirmode_select").append("<div id=\"clone_mirmode_" + i + "\" class=\"select-opt btn-sq\">" + MIRMODES[i] + "</div>");
	});

	<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
	$(CAPTUREMETHODS).each(function(i) {
		$("#clone_capture_select").append("<div id=\"clone_capture_" + i + "\" style=\"display: inline-block\" class=\"select-opt btn-med\">" + CAPTUREMETHODS[i] + "</div>");
	});
	<?php else: ?>
	$("#clone_capture_select").append("<div id=\"clone_capture_3 style=\"display: inline-block\" class=\"select-opt btn-med\">" + CAPTUREMETHODS[3] + "</div>");
	<?php endif; ?>

	$(SEGMENTSIZES).each(function(i) {
		$("#clone_segment_select").append("<div id=\"clone_segment_" + i + "\" class=\"select-opt btn-med\">" + SEGMENTSIZES[i] + "</div>");
	});

    //set up Compression slider
	createSlider("clone_compression_value", 0);
	$("#clone_compression_value_slider").slider("option", "max", 4);
	$("#clone_compression_value_slider").slider("option", "step", 1);

	//set up Mirror sliders
    createSlider("clone_mirror_length", 1);
	$("#clone_mirror_length_slider").slider("option", "min", 1);
	createSlider("clone_mirror_mstart", 0);
	createSlider("clone_mirror_tstart", 0);
	//(Mirror sliders max value is reset every time Master is selected)

	//(Clever sliders are recreated every time Master is selected)

	//initialize Target Image File Name selectable options
	$(TARGETIMGNAMES).each(function(i) {
		$("#clone_target_image_name_type_select").append("<div id=\"clone_target_image_name_type_" + i + "\" class=\"select-opt btn-med\">" + TARGETIMGNAMES[i] + "</div>");
	});

	//initialize Format File System selectable options
	$(FILESYSTEMS).each(function(i) {
		$("#clone_format_file_system_select").append("<div id=\"clone_format_file_system_" + i + "\" class=\"select-opt btn-med\">" + FILESYSTEMS[i] + "</div>");
	});

	//initialize Format Encrypt selectable options
	$(ENCRYPTS).each(function(i) {
		$("#clone_format_encrypt_select").append("<div id=\"clone_format_encrypt_" + i + "\" class=\"select-opt btn-med" + (i == ENCRYPT_OFF ? " ui-selected" : "") + "\">" + ENCRYPTS[i] + "</div>");
	});

	/* WIPE */
	//initialize Wipe Erase selectable options
	$(WIPEERASES).each(function(i) {
		$("#wipe_erase_select").append("<div id=\"wipe_erase_" + i + "\" class=\"select-opt btn-med\">" + WIPEERASES[i] + "</div>");
	});
	//initialize Wipe Mode selectable options
	$(WIPEMETHODS).each(function(i) {
		$("#wipe_mode_select").append("<div id=\"wipe_mode_" + i + "\" class=\"select-opt btn-med\">" + WIPEMETHODS[i] + "</div>");
	});
	//initialize Clone HPA/DCO selectable options
	$(HPAS).each(function(i) {
		$("#wipe_hpa_select").append("<div id=\"wipe_hpa_" + i + "\" class=\"select-opt btn-med\">" + HPAS[i] + "</div>");
	});
	$(DCOS).each(function(i) {
		$("#wipe_dco_select").append("<div id=\"wipe_dco_" + i + "\" class=\"select-opt btn-med\">" + DCOS[i] + "</div>");
	});

	//set up Wipe settings slider
	createSlider("wipe_lba_range", 1);
	$("#wipe_lba_range_slider").slider("option", "min", 1);

	//set up Wipe Pass selectable options
	$(WIPEPASSES).each(function(i) {
		$("#wipe_pass_value_select").append("<div id=\"wipe_pass_value_" + i + "\" class=\"select-opt btn-med\">" + WIPEPASSES[i] + "</div>");
	});

	//set up Wipe Pass Value slider
	createSlider("wipe_pass_value", 0);
	$("#wipe_pass_value_slider").slider("option", "max", 255);

	//initialize Wipe Format selectable options
	$(FORMATS).each(function(i) {
		$("#wipe_format_select").append("<div id=\"wipe_format_" + i + "\" class=\"select-opt btn-med\">" + FORMATS[i] + "</div>");
	});

	//initialize Hash Mode selectable options
	$(HASHMODES).each(function(i) {
		$("#hash_mode_select").append("<div id=\"hash_mode_" + i + "\" class=\"select-opt btn-sq\">" + HASHMODES[i] + "</div>");
	});

	//initialize Hash Mode selectable options
	$(HASHVERIFIES).each(function(i) {
		$("#hash_verify_select").append("<div id=\"hash_verify_" + i + "\" class=\"select-opt btn-med\">" + HASHVERIFIES[i] + "</div>");
	});

	//initialize Wipe File System selectable options
	$(FILESYSTEMS).each(function(i) {
		$("#wipe_format_file_system_select").append("<div id=\"wipe_format_file_system_" + i + "\" class=\"select-opt btn-med\">" + FILESYSTEMS[i] + "</div>");
	});

	//initialize Wipe Encryption selectable options
	$(ENCRYPTS).each(function(i) {
		$("#wipe_format_encryption_select").append("<div id=\"wipe_format_encryption_" + i + "\" class=\"select-opt btn-med\">" + ENCRYPTS[i] + "</div>");
	});

	/* HASH */
	//set up Hash Method selectable options
	$([0, 1, 2, 3]).each(function(i) {
		if (i > 0) $("#hash_method_select").append("<div id=\"hash_method_" + i + "\" class=\"select-opt btn-med\">" + HASHES[i] + "</div>");
	});
	//set up Hash values input boxes
	var vals = [];
	for (var i=0; i<32; i++) {
		vals.push(i);
	}
	$(vals, this).each(function(i) {
		$("#hash_value_boxes").append("<div id=\"hv" + i + "_container\"" + (i==0 ? " class=\"focus\"" : "") + "><input type=\"text\" value=\"\" maxlength=\"2\" id=\"hv" + i + "\"/></div>");
	});

	//set up Hash key buttons
	var vals = [];
	for (var i=0; i<16; i++) {
		vals.push(i);
	}
	$(vals, this).each(function(i) {
		$("#hash_value_keys").append("<div id=\"hk" + i + "\">" + dispHexDigit(i) + "</div>");
	});

    /* PUSH */
	//initialize Verify Method selectable options
	$([0, 1], this).each(function(i) {
		$("#push_verif_select").append("<div id=\"push_verif_" + i + "\" class=\"select-opt btn-med\">" + VERIFS[i] + "</div>");
		if (!VERIFY_OPTION) disableObj($("#clone_verif_" + i));		//no Verify option
        //set VerifyHash to false if true???
	});

	//set up Hash LBA sliders
	createSlider("hash_lba_length", 1);
	$("#hash_lba_length_slider").slider("option", "min", 1);
	createSlider("hash_lba_tstart", 0);
	//(Hash LBA slider max value is reset every time Target is selected)

	/* MANAGE REPOS */
	//initialize Add Repo Role selectable options
	$(REPOROLES, this).each(function(i) {
		$("#repo_role_select").append("<div id=\"repo_role_" + i + "\" class=\"select-opt btn-med" + (i == REPOROLE_BOTH ? " ui-selected" : "") + "\">" + REPOROLES[i] + "</div>");
	});
	add_repo_config['Role'] = REPOROLE_BOTH;
	$("#repo_role_block_content").html(REPOROLES[add_repo_config['Role']]);	//"Both" is the default
    <?php if ($LOGICUBE_PLATFORM == "zxiforensic"): ?>
	$("#repo_network_source_block_content").html("<?= t("ANY"); ?>");	//"Any" is the default
    <?php endif; ?>

	//initialize iSCSI Role selectable options
	$(REPOROLES, this).each(function(i) {
		$("#iscsi_role_select").append("<div id=\"iscsi_role_" + i + "\" class=\"select-opt btn-med" + (i == REPOROLE_BOTH ? " ui-selected" : "") +"\">" + REPOROLES[i] + "</div>");
	});
	$("#iscsi_role_block_content").html(REPOROLES[REPOROLE_BOTH]);	//"Both" is the default

	//initialize File System selectable options
	$(FILESYSTEMS).each(function(i) {
		$("#config_file_system_select").append("<div id=\"config_file_system_" + i + "\" class=\"select-opt btn-med\">" + FILESYSTEMS[i] + "</div>");
	});

    /* USB DEVICE */
	//initialize Export Mode selectable options
	$(USBEXPORTMODES).each(function(i) {
		$("#usb_export_mode_select").append("<div id=\"usb_export_mode_" + i + "\" class=\"select-opt btn-med\">" + USBEXPORTMODES[i] + "</div>");
	});

	//initialize Export Type selectable options
	$(USBEXPORTTYPES).each(function(i) {
		$("#usb_export_type_select").append("<div id=\"usb_export_type_" + i + "\" class=\"select-opt btn-med\">" + USBEXPORTTYPES[i] + "</div>");
	});

	//initialize DCO Passthrough selectable options
	$(USBDCOPASSTHROUGHS).each(function(i) {
		$("#usb_dco_passthrough_select").append("<div id=\"usb_dco_passthrough_" + i + "\" class=\"select-opt btn-med\">" + USBDCOPASSTHROUGHS[i] + "</div>");
	});

	/* SETTINGS */
	initPassKeyModals();

	//initialize Encryption Cipher Mode selectable options
	$(CIPHERMODES, this).each(function(i) {
		$("#settings_cipher_mode_select").append("<div id=\"settings_cipher_mode_" + i + "\" class=\"select-opt btn-med\">" + CIPHERMODES[i] + "</div>");
	});

	//initialize Encryption Cipher selectable options
	$(CIPHERS, this).each(function(i) {
		$("#settings_cipher_select").append("<div id=\"settings_cipher_" + i + "\" class=\"select-opt btn-med\">" + CIPHERS[i] + "</div>");
	});

	//initialize Encryption IV Generation selectable options
	$(IVGENS, this).each(function(i) {
		$("#settings_ivgen_select").append("<div id=\"settings_ivgens_" + i + "\" class=\"select-opt btn-med\">" + IVGENS[i] + "</div>");
	});

	//set up Brightness slider
	createSlider("settings_brightness_value", 0);
	$("#settings_brightness_value_slider").slider("option", "max", 100);
	$("#settings_brightness_value_slider").slider("option", "step", 10);

	//initialize Stealth Mode selectable options
	$(STEALTHMODES).each(function(i) {
		$("#settings_stealth_select").append("<div id=\"settings_stealth_" + i + "\" class=\"select-opt btn-med\">" + STEALTHMODES[i] + "</div>");
	});

	//initialize Destination NCQ selectable options
	$(DESTINATIONNCQS).each(function(i) {
		$("#settings_destncq_select").append("<div id=\"settings_destncq_" + i + "\" class=\"select-opt btn-med\">" + DESTINATIONNCQS[i] + "</div>");
	});

	//set up Language Validation Code key buttons
	var vals = [];
	for (var i=0; i<16; i++) {
		vals.push(i);
	}
	$(vals, this).each(function(i) {
		$("#settings_lang_validation_keys").append("<div id=\"lv" + i + "\">" + dispHexDigit(i) + "</div>");
	});
       $("#settings_lang_validation_keys").append("<div id=\"lvdel\"><?= t("KEYBOARD_DELETE"); ?></div>");
	$("#settings_lang_validation_keys").append("<div id=\"lvleft\">&#9664</div>");
	$("#settings_lang_validation_keys").append("<div id=\"lvright\">&#9654</div>");

        <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): ?>
	//initialize Bay Role selectable options
	$(BAYROLES).each(function(i) {
		$("#settings_bayroles_role_select").append("<div id=\"settings_bayroles_role_" + i + "\" class=\"select-opt btn-med\">" + BAYROLES[i] + "</div>");
	});
	<?php endif; ?>

	//initialize Notifications selectable options
	$(NOTIFICATIONS, this).each(function(i) {
		$("#settings_end_of_task_success_select").append("<div id=\"settings_end_of_task_success_" + i + "\" class=\"select-opt btn-med\">" + NOTIFICATIONS[i] + "</div>");
	});
	$(NOTIFICATIONS, this).each(function(i) {
		$("#settings_end_of_task_error_select").append("<div id=\"settings_end_of_task_error_" + i + "\" class=\"select-opt btn-med\">" + NOTIFICATIONS[i] + "</div>");
	});

    <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
	//initialize Auto Remove HPA/DCO selectable options
	$(AUTOREMOVEHPAS).each(function(i) {
		$("#settings_auto_remove_hpa_select").append("<div id=\"settings_auto_remove_hpa_" + i + "\" class=\"select-opt btn-med\">" + AUTOREMOVEHPAS[i] + "</div>");
	});
	/*$(AUTOREMOVEDCOS).each(function(i) {
		$("#settings_auto_remove_dco_select").append("<div id=\"settings_auto_remove_dco_" + i + "\" class=\"select-opt btn-med\">" + AUTOREMOVEDCOS[i] + "</div>");
	});*/
    <?php endif; ?>

    /* NETWORK SETTINGS */
	//initialize Interface Type selectable options
	$(INTERFACETYPES).each(function(i) {
		$("#interface_type_select").append("<div id=\"interface_type_" + i + "\" class=\"select-opt btn-med\">" + INTERFACETYPES[i] + "</div>");
	});
	//set up Interface IP keys
	var vals = [];
	for (var i=0; i<10; i++) {
		vals.push(i);
	}
	$(vals, this).each(function(i) {
		$("#settings_key_keys").append("<div id=\"kk" + i + "\">" + dispHexDigit(i) + "</div>");
	});
	$("#settings_key_keys").append("<div id=\"kkdel\">&larr;</div>");



    /* RESTART */
	//set up Drive Inactivity Timeout slider
	createSlider("drive_inactivity_timeout_value", DISK_INACTIVITY_TIMEOUT);
	$("#drive_inactivity_timeout_value_slider").slider("option", "min", 0);
	$("#drive_inactivity_timeout_value_slider").slider("option", "max", 60);
}

//update tabs, small progress bars, Add Task button, and Delete Task button
//based on current tab and task status
function updateTabs() {
	//create tabs on each operation screen
	for (var op in TASK_OPS) {
		var op_pre = TASK_OPS[op].toLowerCase().replace(" ", "_");
		//show tabs with tasks
		for (var i=0; i<tab_tasks[op].length; i++) {
			var t = tab_tasks[op][i];		//the task for that tab

			if (current_tab[op] == i) $("#" + op_pre + "_tab_" + i).addClass("selected");
			else $("#" + op_pre + "_tab_" + i).removeClass("selected");
			var mapped_task = mappedTask(t, true);
			$("#" + op_pre + "_tab_" + i + " p").html(mapped_task);
			showObj($("#" + op_pre + "_tab_" + i));
		}
		//hide remaining tabs
		for (var j=i; j<MAX_TABS; j++) {
			hideObj($("#" + op_pre + "_tab_" + j));
		}
	}

	//update Add/Delete buttons on each screen's taskbar
	for (var op in TASK_OPS) {
		var op_pre = TASK_OPS[op].toLowerCase().replace(" ", "_");
		if (current_tab[op] != -1) {
			var op_task = tab_tasks[op][current_tab[op]];
			//if there are any tasks and current tab is not TASK_WORKING, allow Delete Task
			if ((tab_tasks[op].length > 0) && (task_status[op_task]['TaskState'] != "TASK_WORKING")) enableObj($("#" + op_pre + "_delete_btn"));
			else disableObj($("#" + op_pre + "_delete_btn"));

			//if there are fewer than MAX_TABS, allow Add Task
			if (tab_tasks[op].length == MAX_TABS) disableObj($("#" + op_pre + "_add_btn"));
			else enableObj($("#" + op_pre + "_add_btn"));
		}
	}

	updateSmallProgressBars();
}

function updateSmallProgressBars() {
	//update small progress bars
	var spt = smprog_tasks();
	for (var i=0; i<Math.min(MAX_TABS, spt.length); i++) {
		//map name to operation, e.g. T6 -> W1
		var t = spt[i];		//the task for that tab
		var sm_prog_info = "T" + t;
		if (t > 15) sm_prog_info = "P" + (t-15);
		else if (t > 10) sm_prog_info = "H" + (t-10);
		else if (t > 5) sm_prog_info = "W" + (t-5);

		//update small progress bar based on TaskState, then show small progress bar
		$("#sb_progressbar_" + i + "_info").html(sm_prog_info);
		//alert(i + " " + task_status[t]["TaskState"]);
		if (task_status[t]["TaskState"] == "TASK_RESERVED") {
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-completed");	//clear out small progress that was hidden
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-aborted");
			$("#sb_progressbar_" + i).progressbar('option', 'value', 0);
		}
		else if (task_status[t]["TaskState"] == "TASK_WORKING") {
			var totalpct = Math.floor(task_status[t]['JobsPercentage']);
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-completed");	//update small progress
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-aborted");
			$("#sb_progressbar_" + i).progressbar('option', 'value', totalpct);
		}
		else if (task_status[t]["TaskState"] == "TASK_COMPLETED") {
			var totalpct = Math.floor(task_status[t]['JobsPercentage']);
			$("#sb_progressbar_" + i).addClass("ui-progressbar-completed");	//update small progress
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-aborted");
			$("#sb_progressbar_" + i).progressbar('option', 'value', totalpct);
		}
        else if (task_status[t]["TaskState"] == "TASK_STARTING" || task_status[t]["TaskState"] == "TASK_AVAILABLE" || task_status[t]["TaskState"] == "Successful") {
            //do nothing, included to ensure 'else' only contains error states
        }
		else { //error states
			$("#sb_progressbar_" + i).removeClass("ui-progressbar-completed");	//update small progress
			$("#sb_progressbar_" + i).addClass("ui-progressbar-aborted");
			$("#sb_progressbar_" + i).progressbar('option', 'value', 100);
		}
		showObj($("#sb_progressbar_" + i));
		showObj($("#sb_progressbar_" + i + "_info"));
	}

	//hide remaining small progress bars
	for (var j=i; j<MAX_TABS; j++) {
		hideObj($("#sb_progressbar_" + j));
		hideObj($("#sb_progressbar_" + j + "_info"));
	}
}
function smprog_tasks() {
	var ftt = flat_tab_tasks();
	var spt = new Array();	//only show non TASK_RESERVED tasks in small progress bars
	for (i=0; i<ftt.length; i++) {
		if (task_status[ftt[i]]["TaskState"] != "TASK_RESERVED") {
			spt.push(ftt[i]);
		}
	}
	return spt;
}

//enable/disable Delete Task button, enable/disable config buttons, show/hide abort/reset button, update main progress bar, update small progress bars
/*
//Clever:
 'Stats' ...
                        'JobsTotal' => "3"
                        'JobsCompleted' => "2"
                        'JobsPercentage' => "66.66666666666667"
                        'Copy' ...
                            '0' ...
                                'JobIndex' => "0"
                                'JobResult' => "JOB_COMPLETED"
                                'Length' => "141340672"
                                'Rate' => "4.945910502320347"
                                'Time' => "1.714636833"
                                'Digest' => "0000000000000000000000000000000000000000000000000000000000000000"
                                'PartitionNumber' => "1"
                            '1' ...
                                'JobIndex' => "1"
                                'JobResult' => "JOB_COMPLETED"
                                'Length' => "157106176"
                                'Rate' => "1.202110732257159"
                                'Time' => "7.841516016"
                                'Digest' => "0000000000000000000000000000000000000000000000000000000000000000"
                                'PartitionNumber' => "2"
                        'CurrentJob' ...
                            'Operation' => "Resize"
                            'Percentage' => "6.082108464267612"
                            'Bay' => "A2"
*/
function updateProgressBars() {
    if (current_op >= TASK_OPS.length) return;
    var t = current_task();
	/* the following check is redundant since the check on the first
     * line should take care of this; but what the heck!
     */
    if (t == -1) return;
	var op_pre = TASK_OPS[current_op].toLowerCase().replace(" ", "_");

	if (task_status[t]['TaskState'] != "TASK_WORKING") enableObj($("#" + op_pre + "_delete_btn"));
	else disableObj($("#" + op_pre + "_delete_btn"));

	if (task_status[t]["TaskState"] == "TASK_RESERVED") {
		enableConfigButtons();			//update config buttons

		hideObj($("#clone_progress"));	//update main progress (hide and clear out)
        //console.log($("#clone_progressbar"));
		$("#clone_progressbar").progressbar('option', 'value', 0);
        //console.log($("#clone_subtask_progressbar"));
		$("#clone_subtask_progressbar").progressbar('option', 'value', 0);
		$("#clone_progressbar_info").html("");
		$("#clone_subtask_progressbar_info").html("");
		$("#clone_progress_details").html("");

		hideObj($("#clone_error"));		//update error msg
		$("#clone_error_btn").html("");
	}
	else {
		disableConfigButtons();			//disable config buttons while task running

		if ((task_status[t]["TaskState"] == "TASK_WORKING") || (task_status[t]["TaskState"] == "TASK_COMPLETED")) {
            //console.log($("#clone_progressbar"));
			$("#clone_progressbar").removeClass("ui-progressbar-aborted");				//remove aborted class
            //console.log($("#clone_subtask_progressbar"));
			$("#clone_subtask_progressbar").removeClass("ui-progressbar-aborted");
			$("#clone_subtask_progressbar").removeClass("ui-progressbar-alert");				//remove alert class

			if (task_status[t]['JobsTotal'] != 0) {	//don't update if Job 0
				var totalpct = Math.floor(task_status[t]['JobsPercentage']);
				var totalcmp = task_status[t]['JobsCompleted'];
                var badsectorcnt = (("BadSectorCount" in task_status[t]) ? task_status[t]['BadSectorCount'] : 0);
                if (("CurrentJob" in task_status[t]) && ("FileCopyStats" in task_status[t])) {
                    var curjobpct = Math.floor(task_status[t]['CurrentJob']['Percentage']);
                    var copied = task_status[t]['FileCopyStats']['Copied'];
                    var copy_failed = task_status[t]['FileCopyStats']['CopyFailed'];
                    var nfiles = copied + copy_failed;
                    var verified = task_status[t]['FileCopyStats']['Verified'];
                    var verify_failed = task_status[t]['FileCopyStats']['VerifyFailed'];
                    var curjobelapsed = task_status[t]['CurrentJob']['SecondsElapsed'];
                    var curjobremaining = task_status[t]['CurrentJob']['SecondsRemaining'];
                    var curjobrate = Math.round(100*task_status[t]['CurrentJob']['Rate'])/100;

                    $("#clone_progress_details").html("Files Captured: " + copied + " of " + nfiles + " &nbsp;&nbsp; "
                      + "Files Verified: " + verified + " of " + copied + " &nbsp;&nbsp; "
                      + "Rate: " + curjobrate + " GB/min &nbsp;&nbsp; "
                      + "Elapsed: " + secondsToHms(curjobelapsed) + " &nbsp;&nbsp; Remaining: " + secondsToHms(curjobremaining) + " &nbsp;&nbsp; "
                      + (typeof(badsectorcnt) != "undefined" ? "Read Errors: " + badsectorcnt : ""));
                }
                else if ("CurrentJob" in task_status[t]) {
                    var curjobpct = Math.floor(task_status[t]['CurrentJob']['Percentage']);
                    var curjobcmp = Math.floor(task_status[t]['CurrentJob']['Completed']);      //total bytes completed
                    var curjoblen = Math.floor(task_status[t]['CurrentJob']['Length']);         //total length
                    var curjobelapsed = task_status[t]['CurrentJob']['SecondsElapsed'];
                    var curjobremaining = task_status[t]['CurrentJob']['SecondsRemaining'];
                    var curjobrate = Math.round(100*task_status[t]['CurrentJob']['Rate'])/100;
                    var curjobpartition = task_status[t]['CurrentJob']['PartitionNumber'];

                    $("#clone_progress_details").html("Bytes: " + getDispSize(curjobcmp, 3) + " of " + getDispSize(curjoblen, 3) + " &nbsp;&nbsp; "
                      + (typeof(curjobpartition) != "undefined" ? "Partition: " + curjobpartition + " &nbsp;&nbsp; " : "")
                      + "Rate: " + curjobrate + " GB/min &nbsp;&nbsp; "
                      + "Elapsed: " + secondsToHms(curjobelapsed) + " &nbsp;&nbsp; Remaining: " + secondsToHms(curjobremaining) + " &nbsp;&nbsp; "
                      + (typeof(badsectorcnt) != "undefined" ? "Read Errors: " + badsectorcnt : ""));
                }
			}
		}
		else {	//no details for TASK_ERROR_OPERATION_ABORTED, **CHECKING ON WHETHER TO DISPLAY THIS FOR OTHER ERROR STATES**
			$("#clone_progress_details").html("");
		}

		if (task_status[t]["TaskState"] == "TASK_WORKING") {
			showObj($("#clone_abort_btn"));
			hideObj($("#clone_reset_btn"));
			enableObj($("#clone_abort_btn"));

			var totaljobs = task_status[t]['JobsTotal'];
			if (task_status[t]['JobsTotal'] != 0) {
				$("#clone_progressbar").progressbar('option', 'value', totalpct);			//update main progress
				$("#clone_subtask_progressbar").progressbar('option', 'value', curjobpct);
				$("#clone_progressbar_info").html(totalpct + "%");
				$("#clone_subtask_progressbar_info").html("Job " + Math.min(totaljobs, (totalcmp+1)) + " of " + totaljobs);
			}

			hideObj($("#clone_error"));		//update error msg
			$("#clone_error_btn").html("");
		}
		else if (task_status[t]["TaskState"] == "TASK_COMPLETED") {
			showObj($("#clone_reset_btn"));
			hideObj($("#clone_abort_btn"));

			$("#clone_progressbar").progressbar('option', 'value', totalpct);
			$("#clone_subtask_progressbar").progressbar('option', 'value', curjobpct);
			$("#clone_progressbar_info").html("<span style=\"text-transform: uppercase\"><?= t("COMPLETED"); ?></span>");

            if ("PushStats" in task_status[t]) {
                var nerrors = task_status[t]['PushStats']['CasesError'];
                var ncases = task_status[t]['PushStats']['CasesTotal'];
				if (task_status[t]['PushStats']['CasesError'] != 0) {
                	$("#clone_subtask_progressbar").addClass("ui-progressbar-aborted");
                	$("#clone_subtask_progressbar_info").html("<i> " + nerrors + "/" + ncases + " Cases Failed Verification</i>");
				}
				else
                	$("#clone_subtask_progressbar_info").html("<i> " + ncases + "/" + ncases + " Cases successful</i>");
            }
            else if (("BaysTotal" in task_status[t]) && ("BaysSuccessful" in task_status[t])) {
                var x = task_status[t]['BaysSuccessful'];
                var y = task_status[t]['BaysTotal'];
                $("#clone_subtask_progressbar_info").html("<i> Success (" + x + " of " + y + ") </i>");
            }
            else if ("FileCopyStats" in task_status[t]) {
                var copy_failed = task_status[t]['FileCopyStats']['CopyFailed'];
                var verify_failed = task_status[t]['FileCopyStats']['VerifyFailed'];
                if (copy_failed || verify_failed) {
                    var warn = "Errors (";
                    warn += " Copy: " + copy_failed;
                    warn += " Verify: " + verify_failed;
                    warn += " ). Please check log file!"
                    $("#clone_subtask_progressbar").addClass("ui-progressbar-alert");
                    $("#clone_subtask_progressbar_info").html("<i>" + warn +"</i>");
                }
                else
                    $("#clone_subtask_progressbar_info").html("");
            }
            else {
                $("#clone_subtask_progressbar_info").html("");
            }

			hideObj($("#clone_error"));		//update error msg
			$("#clone_error_btn").html("");
		}
		else {	//error states
			showObj($("#clone_reset_btn"));
			hideObj($("#clone_abort_btn"));
			enableObj($("#clone_abort_btn"));

			$("#clone_progressbar").addClass("ui-progressbar-aborted");					//update main progress
			$("#clone_subtask_progressbar").addClass("ui-progressbar-aborted");
			$("#clone_progressbar").progressbar('option', 'value', 100);
			$("#clone_subtask_progressbar").progressbar('option', 'value', 100);
			$("#clone_subtask_progressbar_info").html("");
			if (task_status[t]["TaskState"] == "TASK_ERROR_OPERATION_ABORTED") $("#clone_progressbar_info").html("ABORTED");
			else if (task_status[t]["TaskState"] == "TASK_ERROR_OPERATION_FAILED") $("#clone_progressbar_info").html("FAILED");
			else if (task_status[t]["TaskState"] == "TASK_ERROR_RESOURCE_UNAVAILABLE") $("#clone_progressbar_info").html("RESOURCE UNAVAILABLE");
			else if (task_status[t]["TaskState"] == "TASK_ERROR_PARAMETERS") $("#clone_progressbar_info").html("PARAMETERS ERROR");
			else $("#clone_progressbar_info").html("<span style=\"text-transform: uppercase\"><?= t("ERROR"); ?></span>");

			$("#clone_error_btn").html("<span style=\"text-transform: uppercase\"><?= t("ERROR"); ?></span>: " + task_status[t]['TaskState']);		//update error msg
			showObj($("#clone_error"));
		}

		showObj($("#clone_progress"));
	}

	updateSmallProgressBars();
}

function updateMacroProgressBars() {
	if (current_op == OP_TASK_MACRO) {
		var tab = current_tab[OP_TASK_MACRO];
		var macro_state = macro_list[tab]['State'];

		if (macro_state == "Not Started") {
			enableObj($("#task_macro_tasks_block"));

			hideObj($("#clone_progress"));	//update main progress (hide and clear out)
			$("#clone_progressbar").progressbar('option', 'value', 0);
			$("#clone_subtask_progressbar").progressbar('option', 'value', 0);
			$("#clone_progressbar_info").html("");
			$("#clone_subtask_progressbar_info").html("");
			$("#clone_progress_details").html("");

			hideObj($("#clone_error"));		//update error msg
			$("#clone_error_btn").html("");
		}
		else {
			disableObj($("#task_macro_tasks_block"));

			if ((macro_state == "Started") || (macro_state == "Completed Successfully")) {
				var current_macro_task = macro_list[tab]['CurrentTask'][0]['Task'];
				$("#clone_progressbar").removeClass("ui-progressbar-aborted");				//remove aborted class
				$("#clone_subtask_progressbar").removeClass("ui-progressbar-aborted");

				if (task_status[current_macro_task]['JobsTotal'] != 0) {	//don't update if Job 0
					var totalpct = Math.floor(task_status[current_macro_task]['JobsPercentage']);
					var totalcmp = task_status[current_macro_task]['JobsCompleted'];
                    var badsectorcnt = ("BadSectorCount" in task_status[current_macro_task]) ? task_status[current_macro_task]['BadSectorCount'] : 0;
                    if ("CurrentJob" in task_status[current_macro_task]) {
                        var curjobpct = Math.floor(task_status[current_macro_task]['CurrentJob']['Percentage']);
                        var curjobcmp = Math.floor(task_status[current_macro_task]['CurrentJob']['Completed']); //total bytes completed
                        var curjoblen = Math.floor(task_status[current_macro_task]['CurrentJob']['Length']);            //total length
                        var curjobelapsed = task_status[current_macro_task]['CurrentJob']['SecondsElapsed'];
                        var curjobremaining = task_status[current_macro_task]['CurrentJob']['SecondsRemaining'];
                        var curjobrate = Math.round(100*task_status[current_macro_task]['CurrentJob']['Rate'])/100;
                        var curjobpartition = task_status[current_macro_task]['CurrentJob']['PartitionNumber'];
                    }

					$("#clone_progress_details").html("Bytes: " + getDispSize(curjobcmp, 3) + " of " + getDispSize(curjoblen, 3) + " &nbsp;&nbsp; "
					  + (typeof(curjobpartition) != "undefined" ? "Partition: " + curjobpartition + " &nbsp;&nbsp; " : "")
					  + "Rate: " + curjobrate + " GB/min &nbsp;&nbsp; "
					  + "Elapsed: " + secondsToHms(curjobelapsed) + " &nbsp;&nbsp; Remaining: " + secondsToHms(curjobremaining) + " &nbsp;&nbsp; "
                      + (typeof(badsectorcnt) != "undefined" ? "Read Errors: " + badsectorcnt : ""));
				}
			}
			else {	//Stopped, Error
				$("#clone_progress_details").html("");
			}

			if (macro_state == "Started") {
				showObj($("#clone_abort_btn"));
				hideObj($("#clone_reset_btn"));
				enableObj($("#clone_abort_btn"));

				var num_macro_tasks = 0;	//get number of tasks in macro
				for (var i in macro_list[tab]['Tasks']) {
					if (macro_list[tab]['Tasks'][i] != 0) num_macro_tasks = parseInt(i)+1;
				}
				var current_macro_op = macro_list[tab]['CurrentTask'][0]['Index']+1;
				var current_macro_task = macro_list[tab]['CurrentTask'][0]['Task'];

				var prog_info = "<?= t("OPERATION_N_X_OF_M_IN_PROGRESS"); ?>";
				var mapped_task = mappedTask(current_macro_task);
				prog_info = prog_info.replace("%1", current_macro_op).replace("%2", mapped_task).replace("%3", num_macro_tasks);

				var totaljobs = task_status[current_macro_task]['JobsTotal'];
				if (task_status[current_macro_task]['JobsTotal'] != 0) {
					$("#clone_progressbar").progressbar('option', 'value', totalpct);			//update main progress
					$("#clone_subtask_progressbar").progressbar('option', 'value', curjobpct);
					$("#clone_progressbar_info").html(prog_info + " - " + totalpct + "%");
					$("#clone_subtask_progressbar_info").html("Job " + Math.min(totaljobs, (totalcmp+1)) + " of " + totaljobs);
				}

				hideObj($("#clone_error"));		//update error msg
				$("#clone_error_btn").html("");
			}
			else if (macro_state == "Completed Successfully") {
				showObj($("#clone_reset_btn"));
				hideObj($("#clone_abort_btn"));

				$("#clone_progressbar").progressbar('option', 'value', 100);
				$("#clone_subtask_progressbar").progressbar('option', 'value', 100);
				$("#clone_progressbar_info").html("<span style=\"text-transform: uppercase\"><?= t("COMPLETED"); ?></span>");
				$("#clone_subtask_progressbar_info").html("");

				hideObj($("#clone_error"));		//update error msg
				$("#clone_error_btn").html("");
			}
			else {	//error states
                var macro_current_task = macro_list[tab]['CurrentTask'][0]['Task'];
                //var macro_state = macro_list[tab]['State'];
                var macro_state_tag = macro_list[tab]['StateTag'];

				showObj($("#clone_reset_btn"));
				hideObj($("#clone_abort_btn"));
				enableObj($("#clone_abort_btn"));

				$("#clone_progressbar").addClass("ui-progressbar-aborted");					//update main progress
				$("#clone_subtask_progressbar").addClass("ui-progressbar-aborted");
				$("#clone_progressbar").progressbar('option', 'value', 100);
				$("#clone_subtask_progressbar").progressbar('option', 'value', 100);
				$("#clone_progressbar_info").html(macro_state_tag);
				$("#clone_subtask_progressbar_info").html("");

				$("#clone_error_btn").html("<span style=\"text-transform: uppercase\"><?= t("ERROR"); ?></span>: " + macro_state);		//update error msg
				showObj($("#clone_error"));
			}

			showObj($("#clone_progress"));
		}
	}

	updateSmallProgressBars();
}

function enableConfigButtons() {
	if (current_op == OP_CLONE) {
		enableObj($("#clone_mode_btn"));
		enableObj($("#clone_master_btn"));
		enableObj($("#clone_settings_btn"));
		enableObj($("#clone_target_btn"));
	}
	else if (current_op == OP_WIPE) {
		enableObj($("#wipe_target_btn"));
		enableObj($("#wipe_settings_btn"));
		enableObj($("#wipe_case_info_btn"));
	}
	else if (current_op == OP_HASH) {
	<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
		enableObj($("#hash_mode_btn"));
	<?php endif; ?>
		enableObj($("#hash_target_btn"));
		enableObj($("#hash_settings_btn"));
		enableObj($("#hash_case_info_btn"));
	}
	else if (current_op == OP_PUSH) {
		enableObj($("#push_master_btn"));
		enableObj($("#push_settings_btn"));
		enableObj($("#push_target_btn"));
	}
}

function disableConfigButtons() {
	if (current_op == OP_CLONE) {
		disableObj($("#clone_mode_btn"));
		disableObj($("#clone_master_btn"));
		disableObj($("#clone_settings_btn"));
		disableObj($("#clone_target_btn"));
	}
	else if (current_op == OP_WIPE) {
		disableObj($("#wipe_target_btn"));
		disableObj($("#wipe_settings_btn"));
		disableObj($("#wipe_case_info_btn"));
	}
	else if (current_op == OP_HASH) {
	<?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
		disableObj($("#hash_mode_btn"));
	<?php endif; ?>
		disableObj($("#hash_target_btn"));
		disableObj($("#hash_settings_btn"));
		disableObj($("#hash_case_info_btn"));
	}
	else if (current_op == OP_PUSH) {
		disableObj($("#push_master_btn"));
		disableObj($("#push_settings_btn"));
		disableObj($("#push_target_btn"));
	}
}

//trying this to improve memory leak issue
//save global window[id] variable and only change obj's html
//if it is different
function updateHtml(obj, newhtml) {
	id = obj.attr("id");
	if (typeof(window[id]) == "undefined") {
		window[id] = newhtml;
		obj.html(newhtml);
	}
	else if (window[id] != newhtml) {
		obj.html(newhtml);
		window[id] = newhtml;
	}
}

//update the specified button with current task's task_config
//b = all/mode/master/settings/target
function updateButtons(b) {
	var t = current_task();
    if (t == -1) return;

	if ((b == "all") || (b == "mode")) {
		if (current_op == OP_CLONE) {
            var mode = task_config[t]["CloneMode"];
            $("#clone_mode_btn_bottom").html(MODES[mode]);

            //mode determines if Master/Target or Image File buttons
            if (mode == MODE_I2D) {
                $("#clone_master_btn_top").html("<?= t("IMAGE_FILE"); ?>");	//Master -> Image File
                $("#clone_target_btn_top").html("<?= t("TARGET"); ?>");
            }
            else if (mode == MODE_D2I) {
                $("#clone_master_btn_top").html("<?= t("MASTER"); ?>");
                if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) $("#clone_target_btn_top").html("<?= t("IMAGE_FILE"); ?>");	//Target -> Image File button
                else $("#clone_target_btn_top").html("<?= t("TARGET"); ?>");
            }
            else if (mode == MODE_F2F) {
                $("#clone_master_btn_top").html("<?= t("MASTER"); ?>");
                $("#clone_target_btn_top").html("<?= t("IMAGE_FILE"); ?>");
            }
            else {
                $("#clone_master_btn_top").html("<?= t("MASTER"); ?>");
                $("#clone_target_btn_top").html("<?= t("TARGET"); ?>");
            }
            updateButtons("master");
            updateButtons("target");
        }
		else if (current_op == OP_HASH) {
            var mode = task_config[t]["ValidateMode"];
            $("#hash_mode_btn_bottom").html(HASHMODES[mode]);
        }
	}

	if ((b == "all") || (b == "master")) {
		if (current_op == OP_CLONE) {
			var mode = task_config[t]["CloneMode"];
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                if (mode == MODE_I2D) {
                    $("#clone_master_btn_top").html("<?= t("CASE"); ?>");
                    var fs = fsWithMountPath(task_config[t]["MountPath"]);
                    if (fs == -1) var btninfo = "<?= t("NONE_SELECTED"); ?>";
                    else {
                        var btninfo = fs["Name"];
                        var cases = task_config[t]["CaseList"];
                        if (cases.length > 0) btninfo += " - ";
                        for (var c in cases) {
                            if (c > 0) btninfo += ", ";
                            btninfo += cases[c];
                        }
                        btninfo = truncate(btninfo, 160);
                    }
                    $("#clone_master_btn_bottom").html(btninfo);
                }
                else {
                    $("#clone_master_btn_top").html("<?= t("DRIVES"); ?>");
            <?php endif; ?>

            if (mode == MODE_I2D) {
                var master_image = task_config[t]["SourceImagePath"].substring(task_config[t]["SourceImagePath"].lastIndexOf("/")+1);
				$("#clone_master_btn_bottom").html(master_image == "" ? "<?= t("NO_IMAGE_SELECTED"); ?>" : master_image);
			}
			else if (mode == MODE_F2F) {
				var source = task_config[t]["Master"];
				if (source == "") source = task_config[t]["Repository"];
				$("#clone_master_btn_bottom").html(source == "" ? "<?= t("NONE_SELECTED"); ?>" : source);
			}
			else if (mode == MODE_P2F) {
				var master = task_config[t]["Master"];
                var part_num = task_config[t]["SourcePartitionNumber"];
				$("#clone_master_btn_bottom").html(master == "" ? "<?= t("NONE_SELECTED"); ?>" : master + " " + part_num);
            }
			else {
				var master = task_config[t]["Master"];
				$("#clone_master_btn_bottom").html(master == "" ? "<?= t("NONE_SELECTED"); ?>" : master);
			}

            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            }
            <?php endif; ?>

        }
		else if (current_op == OP_PUSH) {
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            var fs = fsWithMountPath(task_config[t]["MountPath"]);
            if (fs == -1) var btninfo = "<?= t("NONE_SELECTED"); ?>";
            else {
                var btninfo = fs["Name"];
                var cases = task_config[t]["CaseList"];
                if (cases.length > 0) btninfo += " - ";
                for (var c in cases) {
                    if (c > 0) btninfo += ", ";
                    btninfo += cases[c];
                }
                btninfo = truncate(btninfo, 160);
            }
			$("#push_master_btn_bottom").html(btninfo);
            <?php else: ?>
			var repo = task_config[t]["Repository"];
            if (repo == "") var btninfo = "<?= t("NONE_SELECTED"); ?>";
            else {
                var btninfo = repo;
                var cases = task_config[t]["CaseList"];
                if (cases.length > 0) btninfo += " - ";
                for (var c in cases) {
                    if (c > 0) btninfo += ", ";
                    btninfo += cases[c];
                }
                btninfo = truncate(btninfo, 160);
            }
            $("#push_master_btn_bottom").html(btninfo);
            <?php endif; ?>
		}
	}

	if ((b == "all") || (b == "settings")) {
		var mode = task_config[t]["CloneMode"];
		var method = task_config[t]["CloneMethod"];
		var resize = task_config[t]["CleverResizePercentages"];
		if (resize.length <= 2) var res = resize.join(", ");	//only show up to two max partitions (that's all that fits)
		else var res = resize[0] + ", ...";

		var mirraid = task_config[t]["MirrorRAIDEnable"];
		var lbacount = task_config[t]["LBACount"];
		var master = task_config[t]["Master"];

		if (mode == MODE_I2D) {		//for ImageToDrive, get master size from ImageConfig
			master_lbas = task_config[t]["SourceSize"]/512;
			if (lbacount == 0 || lbacount > master_lbas) lbacount = master_lbas;
			var pct = getLBADispPercent(lbacount, master_lbas);
		}
		else if (master != "") {
			var master_drive = driveWithBay(master);
			var master_lbas = 0;
			pct = 0;

			if (master_drive != -1) {	//make sure drive is still connected
				master_lbas = master_drive.LogicalSectors;
				if (lbacount == 0 || lbacount > master_lbas) lbacount = master_lbas;	//LBA Count = 0 on server means 100%
				var pct = getLBADispPercent(lbacount, master_lbas);
			}
		}
		else var pct = 100;

		var hash = task_config[t]["HashType"];
		var verif = task_config[t]["VerifyHash"];
		var capturemethod = task_config[t]["CaptureMethod"];
		if (mode == MODE_D2I || mode == MODE_P2F) {
            showObj($("#clone_hpa_block"));
            showObj($("#clone_error_handling_block"));
			var settings_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td><?= t("METHOD_BTN_COL"); ?>:</td><td>" + CAPTUREMETHODS[capturemethod] + "</td></tr>";
			if (capturemethod == CAPTUREMETHOD_DD) {
				settings_btn_html += "<tr><td><?= t("SEGMENT_SIZE_BTN_COL"); ?>:</td><td>" + SEGMENTSIZES[task_config[t]["SegmentSize"]] + "</td></tr>";
			}
			else if ((capturemethod == CAPTUREMETHOD_E01) || (capturemethod == CAPTUREMETHOD_EX01)) {
				settings_btn_html += "<tr><td><?= t("SEGMENT_SIZE_BTN_COL"); ?>:</td><td>" + SEGMENTSIZES[task_config[t]["SegmentSize"]] + "</td></tr>" +
				"<tr><td><?= t("COMPRESSION_BTN_COL"); ?>:</td><td>" + COMPRESSIONS[task_config[t]["CompressionLevel"]] + "</td></tr>";
			}
			else if (capturemethod == CAPTUREMETHOD_LOGICUBE_IMAGE) {
				/* !!! DO NOT REMOVE !!! */
				/* Bug 2111: DriveToImage Clever mode should NOT have clever resize Settings. */
				settings_btn_html += "<tr><td><?= t("MODE_BTN_COL"); ?>:</td><td>" + METHODS[method] + "</td></tr>" +
				"<tr>" + (method == METHOD_MIRROR ? (mirraid == 1 ? "<td><?= t("RAID"); ?></td><td>&nbsp;</td>" : "<td><?= t("PERCENTAGE_BTN_COL"); ?>:</td><td>" + pct + "%</td>") : "") + "</tr>";
			}
			settings_btn_html += "<tr><td><?= t("UNLOCK_HPA_BTN_COL"); ?>:</td><td>" + (task_config[t]["UnlockHPA"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>")  + "</td></tr>" +
				"<tr><td><?= t("UNLOCK_DCO_BTN_COL"); ?>:</td><td>" + (task_config[t]["UnlockDCO"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>") + "</td></tr>" +
				"<tr><td><?= t("ERROR_HANDLING_BTN_COL"); ?>:</td><td>" + (task_config[t]["IgnoreReadFailure"] ? "<?= t("SKIP"); ?>" : "<?= t("ABORT"); ?>") + "</td></tr>" +
                "<tr><td><?= t("ERROR_GRANULARITY_BTN_COL"); ?>:</td><td>" + (task_config[t]["IgnoreReadFailure"] ? ERRORGRANULARITIES[task_config[t]["ErrorGranularity"]] : "<?= t("N_A"); ?>") + "</td></tr>" +
				"<tr><td><?= t("HASH_METHOD_BTN_COL"); ?>:</td><td>" + HASHES[hash] + "</td></tr>" +
				"<tr><td><?= t("VERIFY_BTN_COL"); ?>:</td><td>" + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "</td></tr></table>";
		}
		else if (mode == MODE_F2F) {
            hideObj($("#clone_hpa_block"));
            hideObj($("#clone_error_handling_block"));
			var settings_btn_html = "<table align=\"center\" width=\"95%\">";
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            var outputformat = task_config[t]["FileOutputFormat"];
            var rootdir = task_config[t]["FileSearchRoot"];
            var pathfilter = getPathFilterString();
            var filecats = getFileCatString();
            var keywords = getKeywordsString();
			settings_btn_html += "<tr><td><?= t("OUTPUT_FORMAT_BTN_COL"); ?>:</td><td>" + OUTPUTFORMATS[outputformat] + "</td></tr>" +
            (rootdir != "" ? "<tr><td><?= t("ROOT_DIRECTORY_BTN_COL"); ?>:</td><td>" + truncate(rootdir, 25) + "</td></tr>" : "") +
            (pathfilter != "" ? "<tr><td><?= t("PATH_FILTER_BTN_COL"); ?>:</td><td>" + truncate(pathfilter, 25) + "</td></tr>" : "") +
            (filecats != "" ? "<tr><td><?= t("FILE_CAT_BTN_COL"); ?>:</td><td>" + truncate(filecats, 25) + "</td></tr>" : "") +
            (keywords != "" ? "<tr><td><?= t("KEYWORDS_BTN_COL"); ?>:</td><td>" + truncate(keywords, 25) + "</td></tr>" : "");
            <?php else: ?>
            settings_btn_html += "<tr><td><?= t("METHOD_BTN_COL"); ?>:</td><td>" + CAPTUREMETHODS[capturemethod] + "</td></tr>";
			if (capturemethod == CAPTUREMETHOD_FILE) {
				settings_btn_html += "<tr><td><?= t("FILE_FILTER_BTN_COL"); ?>:</td><td style=\"word-wrap:break-word\">" + (typeof(task_config[t]["FileFilter"]) != "undefined" ? task_config[t]["FileFilter"].replace(/,/g, ",&#8203;") : "") + "</td></tr>";
			}
			settings_btn_html += "<tr><td><?= t("HASH_METHOD_BTN_COL"); ?>:</td><td>" + HASHES[hash] + "</td></tr>" +
				"<tr><td><?= t("VERIFY_BTN_COL"); ?>:</td><td>" + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "</td></tr>";
            <?php endif; ?>
            settings_btn_html += "</table>";
		}
		else {
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            if (mode == MODE_I2D) {
                var settings_btn_html = "<table align=\"center\" width=\"95%\">" +
                    "<tr><td><?= t("VERIFY_BTN_COL"); ?>:</td><td>" + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "</td></tr></table>";
            }
            else {
            <?php endif; ?>

            showObj($("#clone_hpa_block"));
            showObj($("#clone_error_handling_block"));
			var settings_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td><?= t("METHOD_BTN_COL"); ?>:</td><td>" + METHODS[method] + "</td></tr>" +
				"<tr>" + (method == METHOD_CLEVER ? "<td><?= t("RESIZE_BTN_COL"); ?>:</td><td>[" + res + "]</td>" : (mirraid == 1 ? "<td><?= t("RAID"); ?></td><td>&nbsp;</td>" : "<td><?= t("PERCENTAGE_BTN_COL"); ?>:</td><td>" + pct + "%</td>")) + "</tr>" +
				"<tr><td><?= t("UNLOCK_HPA_BTN_COL"); ?>:</td><td>" + (task_config[t]["UnlockHPA"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>")  + "</td></tr>" +
				"<tr><td><?= t("UNLOCK_DCO_BTN_COL"); ?>:</td><td>" + (task_config[t]["UnlockDCO"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>") + "</td></tr>" +
<?php if (($LOGICUBE_PLATFORM == "forensic") || ($LOGICUBE_PLATFORM == "zxiforensic") || ($LOGICUBE_PLATFORM == "talonu")): ?>
				(mode == MODE_D2D && method == METHOD_MIRROR ? "<tr><td><?= t("DRIVE_TRIM_BTN_COL"); ?>:</td><td>" + (task_config[t]["DriveTrim"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>") + "</td></tr>" : "") +
<?php endif; ?>
				"<tr><td><?= t("ERROR_HANDLING_BTN_COL"); ?>:</td><td>" + (task_config[t]["IgnoreReadFailure"] ? "<?= t("SKIP"); ?>" : "<?= t("ABORT"); ?>") + "</td></tr>" +
                "<tr><td><?= t("ERROR_GRANULARITY_BTN_COL"); ?>:</td><td>" + (task_config[t]["IgnoreReadFailure"] ? ERRORGRANULARITIES[task_config[t]["ErrorGranularity"]] : "<?= t("N_A"); ?>") + "</td></tr>" +
				"<tr><td><?= t("HASH_METHOD_BTN_COL"); ?>:</td><td>" + HASHES[hash] + "</td></tr>" +
				"<tr><td><?= t("VERIFY_BTN_COL"); ?>:</td><td>" + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "</td></tr></table>";

            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            }
            <?php endif; ?>            
        }
		$("#clone_settings_btn_bottom").html(settings_btn_html);
	}

	if ((b == "all") || (b == "target")) {
		if (current_op == OP_CLONE) {
			var mode = task_config[t]["CloneMode"];
			if ((mode == MODE_D2I) || (mode == MODE_P2F) || (mode == MODE_F2F)) {
				if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) { //show Image
					var target_image = task_config[t]["DestinationImagePath"].substring(task_config[t]["DestinationImagePath"].lastIndexOf("/")+1);
					$("#clone_target_btn_bottom").html(target_image == "" ? "<?= t("NO_IMAGE_SELECTED"); ?>" : target_image);
				}
				else {
					var repos = task_config[t]["RepositoryList"];
					var repohtml = "";
					if (repos.length == 0) repohtml += "<?= t("NONE_SELECTED"); ?>";
					else {
						for (var i in repos) {
							repohtml += "<div class=\"repo_name\">" + repos[i] + "</div>";
						}
					}
					$("#clone_target_btn_bottom").html(repohtml);
				}
			}
			else {
				var targets = task_config[t]["Targets"];
				var tgts = "";
				if (targets.length == 0) tgts += "<?= t("NONE_SELECTED"); ?>";
				else {
					for (var i in targets) {
						tgts += "<div class=\"target_bay\">" + targets[i] + "</div>";
					}
				}

				$("#clone_target_btn_bottom").html(tgts);
			}
		}
		else if (current_op == OP_WIPE) {
			var targets = task_config[t]["Targets"];
			var tgts = "";
			if (targets.length == 0) tgts += "<?= t("NONE_SELECTED"); ?>";
			else {
				for (var i in targets) {
					tgts += "<div class=\"target_bay\">" + targets[i] + "</div>";
				}
			}

			$("#wipe_target_btn_bottom").html(tgts);	//update WIPE target button
		}
		else if (current_op == OP_HASH) {
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY) {
                $("#hash_target_btn_top").html( "<?= t("CASE"); ?>");

                var fs = fsWithMountPath(task_config[t]["MountPath"]);
                if (fs == -1) var btninfo = "<?= t("NONE_SELECTED"); ?>";
                else {
                    var btninfo = fs["Name"];
                    var cases = task_config[t]["CaseList"];
                    if (cases.length > 0) btninfo += " - ";
                    for (var c in cases) {
                        if (c > 0) btninfo += ", ";
                        btninfo += cases[c];
                    }
                    btninfo = truncate(btninfo, 160);
                }
                $("#hash_target_btn_bottom").html(btninfo);
            }
            else {
                $("#hash_target_btn_top").html( "<?= t("HASH_TARGET"); ?>");
            <?php endif; ?>

			var targets = task_config[t]["Targets"];
			var tgts = "";
			if (targets.length == 0) tgts += "<?= t("NONE_SELECTED"); ?>";
			else {
				for (var i in targets) {
					tgts += "<div class=\"target_bay\">" + targets[i] + "</div>";
				}
			}
			$("#hash_target_btn_bottom").html(tgts);	//update HASH target button

            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            }
            <?php endif; ?>
		}
		else if (current_op == OP_PUSH) {
			var repos = task_config[t]["RepositoryList"];
			var repohtml = "";
			if (repos.length == 0) repohtml += "<?= t("NONE_SELECTED"); ?>";
			else {
				for (var i in repos) {
					repohtml += "<div class=\"repo_name\">" + repos[i] + "</div>";
				}
			}
			$("#push_target_btn_bottom").html(repohtml);
		}
	}

	if ((b == "all") || (b == "wipe_settings")) {
		if (current_op == OP_WIPE) {
			var targets = task_config[t]["Targets"];
			var cur_max_lbas = 0;
			for (var i in targets) {
				var target_drive = driveWithBay(targets[i]);
				if (target_drive != -1) {		//make sure drive is still connected
					target_lbas = target_drive.LogicalSectors;
					cur_max_lbas = Math.max(cur_max_lbas, target_lbas);
				}
			}

			var lbacount = task_config[t]["LBACount"];
			if (lbacount == 0 || lbacount > cur_max_lbas) lbacount = cur_max_lbas;
			var pct = getLBADispPercent(lbacount, cur_max_lbas);

			var settings_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td valign=\"top\"><?= t("SECURE_ERASE_BTN_COL"); ?>:</td><td valign=\"top\">" + (task_config[t]["WipeSecure"] ? "<?= t("ON"); ?>" : "<?= t("OFF"); ?>") + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("MODE_BTN_COL"); ?>:</td><td valign=\"top\">" + WIPEMETHODS[task_config[t]["WipeMethod"]] + "</td></tr>" +
                "<tr><td valign=\"top\"><?= t("UNLOCK_HPA_BTN_COL"); ?>:</td><td valign=\"top\">" + (task_config[t]["UnlockHPA"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>")  + "</td></tr>" +
                "<tr><td valign=\"top\"><?= t("UNLOCK_DCO_BTN_COL"); ?>:</td><td valign=\"top\">" + (task_config[t]["UnlockDCO"] ? "<?= t("TRUE"); ?>" : "<?= t("FALSE"); ?>") + "</td></tr>" +
                "<tr><td valign=\"top\"><?= t("LBAS_BTN_COL"); ?>:</td><td valign=\"top\">" + pct + "%</td></tr>" +
                "<tr><td valign=\"top\"><?= t("PASSES_BTN_COL"); ?>:</td><td valign=\"top\">" + dispWipeValues(task_config[t]["WipeValues"]) + "</td></tr>" +
                <?php if ($LOGICUBE_PLATFORM != "zxtower"): ?>
                "<tr><td valign=\"top\"><?= t("FORMAT_BTN_COL"); ?>:</td><td valign=\"top\">" + (!task_config[t]["WipeFormat"] ? "<?= t("OFF"); ?>" : FILESYSTEMS[task_config[t]["WipeFilesystem"]] + (task_config[t]["EncryptEnable"] ? "<br/>" + "<?= t("ENCRYPTED"); ?>" : "")) + "</td></tr>" +
                <?php endif; ?>
				"</table>";

			$("#wipe_settings_btn_bottom").html(settings_btn_html);	//update WIPE target button
		}
	}

	if ((b == "all") || (b == "wipe_case_info")) {
		if (current_op == OP_WIPE) {
			var case_name = truncate(task_config[t]["CaseName"], 10);
			var case_id = truncate(task_config[t]["CaseNumber"], 10);
			var examiner = truncate(task_config[t]["ExaminerName"], 10);
			var evidence_id = truncate(task_config[t]["EvidenceNumber"], 10);
			var case_notes = truncate(task_config[t]["CaseNotes"], 10);
			var case_info_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td valign=\"top\"><?= t("CASE_FILE_NAME"); ?>:</td><td valign=\"top\">" + case_name + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("CASE_ID"); ?>:</td><td valign=\"top\">" + case_id + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("EXAMINER"); ?>:</td><td valign=\"top\">" + examiner + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("EVIDENCE_NUMBER"); ?>:</td><td valign=\"top\">" + evidence_id + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("CASE_NOTES"); ?>:</td><td valign=\"top\">" + case_notes + "</td></tr>" +
				"</table>";
			$("#wipe_case_info_btn_bottom").html(case_info_btn_html);	//update WIPE Case Info button
		}
	}

	if ((b == "all") || (b == "hash_settings")) {
		if (current_op == OP_HASH) {
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY) {
                var hashverify = task_config[t]["VerifyCaseHash"];
                var html = "<table align=\"center\" width=\"95%\">" +
                    "<tr><td valign=\"top\"><?= t("VERIFY_HASH_COL"); ?>:</td><td nowrap>" + HASHVERIFIES[hashverify] + "</td></tr>" +
                    "</table>";

                $("#hash_settings_btn_bottom").html(html);	//update Hash Settings button
            }
            else {
            <?php endif; ?>

            var targets = task_config[t]["Targets"];
			var cur_min_lbas = 0;
			for (var i in targets) {
				var target_drive = driveWithBay(targets[i]);
				if (target_drive != -1) {	//make sure drive is still connected
					if (0 == cur_min_lbas) {
						cur_min_lbas = target_drive.LogicalSectors;
					}
					else {
						target_lbas = target_drive.LogicalSectors;
						cur_min_lbas = Math.min(cur_min_lbas, target_lbas);
					}
 				}
			}

			var verif = task_config[t]["HashType"];
			var hashval = formatHashValue(task_config[t]["HashValue"], 8);
			var lbacount = task_config[t]["LBACount"];
			if (lbacount == 0 || lbacount > cur_min_lbas) lbacount = cur_min_lbas;
			var pct = getLBADispPercent(lbacount, cur_min_lbas);
			var start_pct = getLBADispPercent(task_config[t]["TargetStartLBA"], cur_min_lbas, true);

			var html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td valign=\"top\"><?= t("METHOD_BTN_COL"); ?>:</td><td nowrap>" + HASHES[verif] + "</td></tr>" +
				"<tr><td valign=\"top\"><?= t("EXPECTED_VALUE_BTN_COL"); ?>:</td><td>" + hashval + "</td></tr>" +
				"<tr><td><?= t("LENGTH_BTN_COL"); ?>:</td><td>" + pct + "%</td></tr>" +
				"<tr><td><?= t("START_BTN_COL"); ?>:</td><td>" + start_pct + "%</td></tr>" +
                "</table>";

			$("#hash_settings_btn_bottom").html(html);	//update Hash Settings button

            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            }
            <?php endif; ?>
		}
	}

	if ((b == "all") || (b == "hash_case_info")) {
		if (current_op == OP_HASH) {
			var case_name = truncate(task_config[t]["CaseName"], 10);
			var case_id = truncate(task_config[t]["CaseNumber"], 10);
			var examiner = truncate(task_config[t]["ExaminerName"], 10);
			var evidence_id = truncate(task_config[t]["EvidenceNumber"], 10);
			var case_notes = truncate(task_config[t]["CaseNotes"], 10);
			var case_info_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td><?= t("CASE_FILE_NAME"); ?>:</td><td>" + case_name + "</td></tr>" +
				"<tr><td><?= t("CASE_ID"); ?>:</td><td>" + case_id + "</td></tr>" +
				"<tr><td><?= t("EXAMINER"); ?>:</td><td>" + examiner + "</td></tr>" +
				"<tr><td><?= t("EVIDENCE_NUMBER"); ?>:</td><td>" + evidence_id + "</td></tr>" +
				"<tr><td><?= t("CASE_NOTES"); ?>:</td><td>" + case_notes + "</td></tr>" +
				"</table>";
			$("#hash_case_info_btn_bottom").html(case_info_btn_html);	//update HASH Case Info button
		}
	}

	if ((b == "all") || (b == "push_settings")) {
		if (current_op == OP_PUSH) {
			var hash = task_config[t]["HashType"];
			var verif = task_config[t]["VerifyHash"];
			var settings_btn_html = "<table align=\"center\" width=\"95%\">" +
				"<tr><td><?= t("VERIFY_BTN_COL"); ?>:</td><td>" + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "</td></tr></table>";
			$("#push_settings_btn_bottom").html(settings_btn_html);
		}
	}

	//enable/disable Start button
	if (((current_op == OP_CLONE) && ((b == "all") || (b == "master") || (b == "target"))) ||
	    ((current_op == OP_WIPE)  && ((b == "all") || (b == "target"))) ||
		((current_op == OP_HASH)  && ((b == "all") || (b == "target") || (b == "hash_settings"))) ||
		((current_op == OP_PUSH)  && ((b == "all") || (b == "master") || (b == "target")))) {
		 	if (readyToStart(current_op, t, false)) enableObj($("#clone_start_btn"));
			else disableObj($("#clone_start_btn"));
	}
}

//returns if op/task is ready to start based on selections
//if for_macro = true, readyToStart is true also if task is in Aborted state
function readyToStart(op, t, for_macro) {
	var ready_to_start = false;
	if (op < TASK_OPS.length) {
		if ((task_status[t]["TaskState"] == "TASK_RESERVED") || ((task_status[t]["TaskState"] == "TASK_ERROR_OPERATION_ABORTED") && for_macro)) {
			if (op == OP_CLONE) {	//on Clone page, see if ready to Start after Master or Targets change
									//assumes Mode and Settings buttons have a valid state by default
				var mode = task_config[t]["CloneMode"];
				var master = task_config[t]["Master"];
				var targets = task_config[t]["Targets"];
				var master_image = task_config[t]["SourceImagePath"];
				var target_image = task_config[t]["DestinationImagePath"];
				var repo = task_config[t]["Repository"];
				var repo_list = task_config[t]["RepositoryList"];

				if (mode == MODE_D2D) {
					if ((master != "") && (targets.length > 0)) ready_to_start = true;
				}
				else if (mode == MODE_I2D) {
                    <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                    var fs = task_config[t]["MountPath"];
                    var cases = task_config[t]["CaseList"];
                    var targets = task_config[t]["Targets"];
                    if ((fs != "") && (cases.length > 0) && (targets.length > 0)) ready_to_start = true;
                    <?php else: ?>
					if ((master_image != "") && (targets.length > 0)) ready_to_start = true;
                    <?php endif; ?>
				}
				else if (mode == MODE_D2I) {
					if ((master != "") &&
						  (((task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) && (target_image != "")) ||
						  ((task_config[t]["CaptureMethod"] != CAPTUREMETHOD_LOGICUBE_IMAGE) && (repo_list.length > 0)))) {
						ready_to_start = true;
					}
				}
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				else if (mode == MODE_P2F) {
                    var part_num = task_config[t]["SourcePartitionNumber"];
					if ((master != "") && (part_num != "") &&
						  (((task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) && (target_image != "")) ||
						  ((task_config[t]["CaptureMethod"] != CAPTUREMETHOD_LOGICUBE_IMAGE) && (repo_list.length > 0)))) {
						ready_to_start = true;
					}
                }
                <?php endif; ?>
				else if (mode == MODE_F2F) {
					if (((master != "") || (repo != "")) && (repo_list != "")) ready_to_start = true;
				}
			}
			else if (op == OP_WIPE) {
				var targets = task_config[t]["Targets"];
				var format = task_config[t]["WipeFormat"];
				var secure_wipe = task_config[t]["WipeSecure"];
				var wipe_method = task_config[t]["WipeMethod"];
				var opr_set = (format || secure_wipe || (wipe_method != WIPEMETHOD_NONE));
				if ((targets.length > 0) && opr_set) ready_to_start = true;
			}
			else if (op == OP_HASH) {
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY) {
                    var fs = task_config[t]["MountPath"];
                    var cases = task_config[t]["CaseList"];
                    if ((fs != "") && (cases.length > 0)) ready_to_start = true;
                }
                else {
                <?php endif; ?>

                var targets = task_config[t]["Targets"];
				var hash = task_config[t]["HashType"];
				if ((targets.length > 0) && (hash != HASH_NONE)) ready_to_start = true;

                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
                }
                <?php endif; ?>
			}
			else if (op == OP_PUSH) {
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				var fs = task_config[t]["MountPath"];
				var targets = task_config[t]["RepositoryList"];
				// Allow the back end to push all images from source drive
				if ((fs != "") && (targets.length > 0)) ready_to_start = true;
                <?php else: ?>
				var master = task_config[t]["Repository"];
				var targets = task_config[t]["RepositoryList"];
				if ((master != "") && (targets.length > 0)) ready_to_start = true;
                <?php endif; ?>
			}
		}
	}

	return ready_to_start;
}


//update/reset specified modal with current task_config
function updateModals(m) {
	var t = current_task();
	if (t == -1) return;

	if (current_op == OP_CLONE) {	//CLONE modals

		if ((m == "all") || (m == "mode")) {
			var mode = task_config[t]["CloneMode"];
			$("#clone_mode_select .select-opt").each(function(i) {
				var id = $(this).attr("id").replace("clone_mode_", "");	//need to get the ID in case clone_mode_1 has been removed for Forensic
				if (id == mode) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "master")) {
			var master = task_config[t]["Master"];
			$("#clone_master_select .select-opt").each(function(i) {
                if (typeof(drives[i]) != "undefined") {
					if (typeof(drives[i]["Bay"]) != "undefined") {
						if (drives[i]["Bay"] == master) $(this).addClass("ui-selected");
						else $(this).removeClass("ui-selected");
					}
				}
			});

			disableHideDrives();
			updateDriveStatus("master");
			updateDriveStatus("target");
		}

		if ((m == "all") || (m == "master_repo")) {
			var repo = task_config[t]["Repository"];
			$("#clone_master_repo_select .select-opt").each(function(i) {
				if ($(this).find(".col1").text() == repo) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
		if ((m == "all") || (m == "master_source")) {
			var source = task_config[t]["Master"];
			var type = "bay";
			if (source == "") {
				source = task_config[t]["Repository"];
				type = "repo";
			}
			$("#clone_master_source_select .select-opt").each(function(i) {
				var is_bay = $(this).hasClass("source-type-bay");
				if (($(this).find(".col1").text() == source) && ((type == "bay" && is_bay) || (type == "repo" && !is_bay))) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
		if ((m == "all") || (m == "master_image")) {
			var master_image = task_config[t]["SourceImagePath"];
			$("#clone_master_image_select .select-opt").each(function(i) {
                if (typeof(images[i]) != "undefined") {
                    if (typeof(images[i]["Path"]) != "undefined") {
                        if (images[i]["Path"] == master_image) $(this).addClass("ui-selected");
                        else $(this).removeClass("ui-selected");
                    }
                }
			});
		}

		if ((m == "all") || (m == "settings")) {
			//enable/disable Settings blocks
			if (task_config[t]["CloneMode"] == MODE_D2D) {
				//enable Settings dialog button (in case they were disabled from I2D mode)
				enableObj($("#clone_hpa_block"));
				enableObj($("#clone_verif_block"));
				enableObj($("#clone_method_block"));
				enableObj($("#clone_method_imgmode_block"));
			}
			else if (task_config[t]["CloneMode"] == MODE_I2D) {
				//disable Settings dialog buttons
				disableObj($("#clone_hpa_block"));
				enableObj($("#clone_verif_block"));
				enableObj($("#clone_method_imgmode_block"));
				enableObj($("#clone_method_settings_block"));
			}
                        <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): ?>
			else if (task_config[t]["CloneMode"] == MODE_D2I) {
				//enable Settings dialog button (in case they were disabled from I2D mode)
				enableObj($("#clone_hpa_block"));
				enableObj($("#clone_verif_block"));
				enableObj($("#clone_method_imgmode_block"));
				disableObj($("#clone_method_settings_block"));
			}
            else if (task_config[t]["CloneMode"] == MODE_F2F) {
            <?php else: ?>
            else if (task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F || task_config[t]["CloneMode"] == MODE_F2F) {
            <?php endif; ?>
				//enable Settings dialog button (in case they were disabled from I2D mode)
				enableObj($("#clone_hpa_block"));
				enableObj($("#clone_verif_block"));
				enableObj($("#clone_method_imgmode_block"));
				disableObj($("#clone_method_settings_block"));
            }

			//show/hide Settings blocks based on mode, show/hide SHA-256
			if (task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F) {
				hideObj($("#clone_method_block"));
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				hideObj($("#clone_filter_settings_block"));
				hideObj($("#clone_output_format_block"));
				hideObj($("#clone_root_dir_block"));
				hideObj($("#clone_path_filter_block"));
				hideObj($("#clone_file_cat_block"));
				hideObj($("#clone_keywords_block"));
                <?php endif; ?>
				showObj($("#clone_file_image_block"));
				showObj($("#clone_verif_block"));
			}
			else if (task_config[t]["CloneMode"] == MODE_F2F) {
				hideObj($("#clone_method_block"));
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				hideObj($("#clone_file_image_block"));
				showObj($("#clone_filter_settings_block"));
				showObj($("#clone_verif_block"));
				showObj($("#clone_output_format_block"));
				showObj($("#clone_root_dir_block"));
				showObj($("#clone_path_filter_block"));
				showObj($("#clone_file_cat_block"));
				showObj($("#clone_keywords_block"));
                <?php else: ?>
				showObj($("#clone_file_image_block"));
                <?php endif; ?>
			}
			else {
                <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
				hideObj($("#clone_filter_settings_block"));
				hideObj($("#clone_output_format_block"));
				hideObj($("#clone_root_dir_block"));
				hideObj($("#clone_path_filter_block"));
				hideObj($("#clone_file_cat_block"));
				hideObj($("#clone_keywords_block"));
				showObj($("#clone_verif_block"));
                <?php endif; ?>
				hideObj($("#clone_file_image_block"));
				showObj($("#clone_method_block"));
			}

            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            if (task_config[t]["CloneMode"] == MODE_I2D) {
				hideObj($("#clone_mc_block"));
				hideObj($("#clone_hpa_block"));
				hideObj($("#clone_error_handling_block"));
                $("#clone_verif_block .btn-block-title").html("<?= t("VERIFY_HASH"); ?>");

                // Hash Verify dialog
                hideObj($("#clone_verif_dialog").prev(".ui-dialog-titlebar"));
                $("#clone_verif_title").html("<?= t("VERIFY_HASH"); ?>");
                $("#clone_verif_dialog").addClass("verif-only");
            }
            else {
                showObj($("#clone_mc_block"));
                if (task_config[t]["CloneMode"] != MODE_F2F) {
				    showObj($("#clone_hpa_block"));
				    showObj($("#clone_error_handling_block"));
                }
                $("#clone_verif_block .btn-block-title").html("<?= t("HASH_VERIFICATION_METHOD"); ?>");

                // Hash Verify dialog
                showObj($("#clone_verif_dialog").prev(".ui-dialog-titlebar"));
                $("#clone_verif_title").html("<?= t("VERIFY"); ?>");
                $("#clone_verif_dialog").removeClass("verif-only");
            }
            <?php endif; ?>
            
            
			updateCloneMethodBlock();
			updateHPABlock();
			updateErrorHandlingBlock();
			updateHashVerifBlock();
			updateCaseInfoBlock();
			updateFileImageBlock();
			updateHashSelect();

			//update HPA
			var hpa = (task_config[t]["UnlockHPA"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#clone_hpa_select .select-opt").each(function(i) {
				if (i == hpa) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });

			//update DCO
			var dco = (task_config[t]["UnlockDCO"] == 0 ? 1 : 0);
			$("#clone_dco_select .select-opt").each(function(i) {
				if (i == dco) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			//update Drive Trim
			var drive_trim = (task_config[t]["DriveTrim"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#clone_drive_trim_select .select-opt").each(function(i) {
				if (i == drive_trim) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });

            <?php if (($LOGICUBE_PLATFORM == "forensic") || ($LOGICUBE_PLATFORM == "zxiforensic") || ($LOGICUBE_PLATFORM == "talonu")): ?>
            //show/hide Drive Trim in HPA/DCO/Drive Trim modal
            if (task_config[t]["CloneMode"] == MODE_D2D && task_config[t]["CloneMethod"] == METHOD_MIRROR) {
                showObj($("#clone_drive_trim_title")); showObj($("#clone_drive_trim_select"));
            }
            else {
                hideObj($("#clone_drive_trim_title")); hideObj($("#clone_drive_trim_select"));
            }

            //update Output Format
			var output_format = task_config[t]["FileOutputFormat"];
			$("#clone_output_format_select .select-opt").each(function(i) {
				if (i == output_format) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });
            updateOutputFormatBlock();

            //update Root Directory
            updateRootDirBlock();
            
            //update Path Filters
            for (var i=0; i<task_config[t]["PresetFilterList"].length; i++) {
                var preset = (task_config[t]["PresetFilterList"][i] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
                $("#clone_preset_filter_" + i + "_select .select-opt").each(function(j) {
                    if (j == preset) $(this).addClass("ui-selected");
                    else $(this).removeClass("ui-selected");
                });
            }
            updatePathFilterBlock();
            updatePresetFilterBlock();
            updateCustomFilterBlock();

            //update Signature-Based File Categories
            for (var i=0; i<task_config[t]["FileCategoryList"].length; i++) {
                var filecat = (task_config[t]["FileCategoryList"][i] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
                $("#clone_file_cat_" + i + "_select .select-opt").each(function(j) {
                    if (j == filecat) $(this).addClass("ui-selected");
                    else $(this).removeClass("ui-selected");
                });
            }
            updateFileCatBlock();
            
            //update Keywords
            var ignore_case = (task_config[t]["IgnoreCase"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#clone_ignore_case_select .select-opt").each(function(i) {
				if (i == ignore_case) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });
            var char_encoding = (task_config[t]["FileCharEncodingList"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#clone_char_encoding_select .select-opt").each(function(i) {
				if (i == char_encoding) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });
            updateKeywordsBlock();
            updateSearchKeywordsBlock();
			updateFilterSettingsBlock();	
            <?php endif; ?>

			//update Error Handling
			var error_handling = (task_config[t]["IgnoreReadFailure"] == 0 ? 1 : 0);	//0 button = Skip/Yes, 1 button = Abort/No
			$("#clone_error_handling_select .select-opt").each(function(i) {
				if (i == error_handling) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

            //update Error Granularity
			var error_granularity = task_config[t]["ErrorGranularity"];
			$("#clone_error_granularity_select .select-opt").each(function(i) {
				if (i == error_granularity) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
            //if Error Handling = ABORT, disable Error Granularity
            if (task_config[t]["IgnoreReadFailure"] == 0) {
                disableObj($("#clone_error_granularity_0"));
                disableObj($("#clone_error_granularity_1"));
                disableObj($("#clone_error_granularity_2"));
                disableObj($("#clone_error_granularity_3"));
            }
            else {
                enableObj($("#clone_error_granularity_0"));
                enableObj($("#clone_error_granularity_1"));
                enableObj($("#clone_error_granularity_2"));
                enableObj($("#clone_error_granularity_3"));
            }

			//update Hash Method
			var hash = task_config[t]["HashType"];
			$("#clone_hash_select .select-opt").each(function(i) {
				if (i == hash) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			//update Verify
			var verif = (task_config[t]["VerifyHash"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#clone_verif_select .select-opt").each(function(i) {
				if (i == verif) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "case_info")) {
			updateCaseInfoModal();
		}

		if ((m == "all") || (m == "clone_method")) {
			var imgmode = METHODS[task_config[t]["CloneMethod"]];
			$("#clone_method_imgmode_block_content").html(imgmode);
			updateCloneMethodBlock();
		}

		if ((m == "all") || (m == "file_image")) {
			//update Capture Method
			var capturemethod = task_config[t]["CaptureMethod"];
			$("#clone_capture_select .select-opt").each(function(i) {
				if ($(this).text() == CAPTUREMETHODS[capturemethod]) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			//show/hide Capture buttons
			if (capturemethod == CAPTUREMETHOD_FILE) {		//show/hide Capture Method buttons
				showObj($("#clone_capture_4"));
				hideObj($("#clone_capture_0")); hideObj($("#clone_capture_1")); hideObj($("#clone_capture_2")); hideObj($("#clone_capture_3"));
			}
			else {
				showObj($("#clone_capture_0")); showObj($("#clone_capture_1")); showObj($("#clone_capture_2")); showObj($("#clone_capture_3"));
				hideObj($("#clone_capture_4"));
			}

			//show/hide Capture blocks
			if (capturemethod == CAPTUREMETHOD_DD) {
				showObj($("#clone_segment_block"));
				hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
			}
			else if (capturemethod == CAPTUREMETHOD_E01) {
				showObj($("#clone_segment_block")); showObj($("#clone_compression_block"));
				hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
			}
			else if (capturemethod == CAPTUREMETHOD_EX01) {
				showObj($("#clone_segment_block")); showObj($("#clone_compression_block"));
				hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
			}
			else if (capturemethod == CAPTUREMETHOD_FILE) {
				showObj($("#clone_filefilter_block"));
				hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
			}
			else if (capturemethod == CAPTUREMETHOD_LOGICUBE_IMAGE) {
				showObj($("#clone_imgmode_block")); showObj($("#clone_imgsettings_block"));
				hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block"));
            }
			else {
				hideObj($("#clone_segment_block")); hideObj($("#clone_compression_block")); hideObj($("#clone_filefilter_block")); hideObj($("#clone_imgmode_block")); hideObj($("#clone_imgsettings_block"));
			}

			updateCaptureBlocks();

			//update Segment Size
			var segment = task_config[t]["SegmentSize"];
			$("#clone_segment_select .select-opt").each(function(i) {
				if (i == segment) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });

			//update Compression
			var compression = task_config[t]["CompressionLevel"];
			/*$("#clone_compression_select .select-opt").each(function(i) {
				if (i == compression) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			 });*/
			 setSlider("clone_compression_value", compression);
		}

		if ((m == "all") || (m == "imgmode")) {
			//update File Image Mode (Clone Method)
			var method = task_config[t]["CloneMethod"];
			$("#clone_imgmode_select .select-opt").each(function(i) {	//when this appears in File Image modal
				if (i == method) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "clever")) {
			updateCleverModal();
		}

		if ((m == "all") || (m == "mirror")) {
			updateMirrorModal();
		}

		if ((m == "all") || (m == "target")) {
			var targets = task_config[t]["Targets"];
			$("#clone_target_select .select-opt").each(function(i) {
                if (typeof(drives[i]) != "undefined") {
					if (typeof(drives[i]["Bay"]) != "undefined") {
						if (inArray(drives[i]["Bay"], targets)) $(this).addClass("ui-selected");
						else $(this).removeClass("ui-selected");
					}
				}
			});

			disableHideDrives();
			updateDriveStatus("target");
			updateDriveStatus("master");
		}
		if ((m == "all") || (m == "target_repo")) {
			if ((task_config[t]["CloneMode"] != MODE_F2F) && (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE)) var repos = new Array(task_config[t]["Repository"]);
			else var repos = task_config[t]["RepositoryList"];
			$("#clone_target_repo_select .select-opt").each(function(i) {
				if (inArray($(this).find(".col1").text(), repos)) { $(this).addClass("ui-selected"); }
				else $(this).removeClass("ui-selected");
			});
		}
		if ((m == "all") || (m == "target_image")) {
			var target_image = task_config[t]["DestinationImagePath"];
			$("#clone_target_image_select .select-opt").each(function(i) {
                if (typeof(images[i]) != "undefined") {
                    if (typeof(images[i]["Path"]) != "undefined") {
                        if (images[i]["Path"] == target_image) $(this).addClass("ui-selected");
                        else $(this).removeClass("ui-selected");
                    }
                }
			});
		}
	}
	else if (current_op == OP_WIPE) {	//WIPE modals
		if ((m == "all") || (m == "target")) {
			var targets = task_config[t]["Targets"];
			$("#clone_target_select .select-opt").each(function(i) {
				if (typeof(drives[i]) != "undefined") {
					if (typeof(drives[i]["Bay"]) != "undefined") {
						if (inArray(drives[i]["Bay"], targets)) $(this).addClass("ui-selected");
						else $(this).removeClass("ui-selected");
					}
				}
			});

			disableHideDrives();
			updateDriveStatus("target");
			updateDriveStatus("master");
		}

		if ((m == "all") || (m == "wipe_settings")) {
            if ($('#wipe_settings_dialog').dialog('isOpen') !== true && $('#wipe_settings_dialog').data('opening_another_dialog') !== true) { //check this to preserve Secure Erase state when user is editing Wipe Mode, which gets server callback
                //update Secure Erase
                var secure_erase = (task_config[t]["WipeSecure"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
                $("#wipe_erase_select .select-opt").each(function(i) {
                    if (i == secure_erase) $(this).addClass("ui-selected");
                    else $(this).removeClass("ui-selected");
                });
            }
			updateWipeModeButton();
			updateWipeHPAButton();
			updateWipeLBAButton();
			updateWipePassesButton();
			updateWipeFormatButton();
		}

		if ((m == "all") || (m == "wipe_mode")) {
			//Wipe Mode
			var wipe_mode = task_config[t]["WipeMethod"];
			$("#wipe_mode_select .select-opt").each(function(i) {
				if (i == wipe_mode) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "wipe_hpa")) {
			//HPA/DCO
			var wipe_hpa = (task_config[t]["UnlockHPA"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#wipe_hpa_select .select-opt").each(function(i) {
				if (i == wipe_hpa) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
			var wipe_dco = (task_config[t]["UnlockDCO"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#wipe_dco_select .select-opt").each(function(i) {
				if (i == wipe_dco) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "wipe_lba")) {
			updateWipeLBASlider();
		}

		if ((m == "all") || (m == "wipe_format")) {
			//Wipe Format
			var wipe_format = (task_config[t]["WipeFormat"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#wipe_format_select .select-opt").each(function(i) {
				if (i == wipe_format) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			var wipe_file_system = task_config[t]["WipeFilesystem"];
			$("#wipe_format_file_system_select .select-opt").each(function(i) {
				if (i == wipe_file_system) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			var wipe_encrypt = (task_config[t]["EncryptEnable"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#wipe_format_encryption_select .select-opt").each(function(i) {
				if (i == wipe_encrypt) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "wipe_passes")) {
			updateWipePassesModal();
		}

		if ((m == "all") || (m == "case_info")) {
			updateCaseInfoModal();
		}
	}
	else if (current_op == OP_HASH) {	//HASH modals
        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
		if ((m == "all") || (m == "mode")) {
			var mode = task_config[t]["ValidateMode"];
			$("#hash_mode_select .select-opt").each(function(i) {
				if (i == mode) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
		if ((m == "all") || (m == "hash_verify")) {
			var hashverify = task_config[t]["VerifyCaseHash"];
			$("#hash_verify_select .select-opt").each(function(i) {
				if (i == hashverify) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
        <?php endif; ?>

        if ((m == "all") || (m == "target")) {
			var targets = task_config[t]["Targets"];
			$("#clone_target_select .select-opt").each(function(i) {
                if (typeof(drives[i]) != "undefined") {
					if (typeof(drives[i]["Bay"]) != "undefined") {
						if (inArray(drives[i]["Bay"], targets)) $(this).addClass("ui-selected");
						else $(this).removeClass("ui-selected");
					}
				}
			});

			disableHideDrives();
			updateDriveStatus("target");
			updateDriveStatus("master");
		}

		if ((m == "all") || (m == "hash_settings")) {
            <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
            if (task_config[t]["ValidateMode"] == HASHMODE_CASE_VERIFY) {
                hideObj($("#hash_values_btn"));
                hideObj($("#hash_lba_btn"));
                showObj($("#hash_verify_btn"));
                updateHashVerifyButton();
            }
            else {
                showObj($("#hash_values_btn"));
                showObj($("#hash_lba_btn"));
                hideObj($("#hash_verify_btn"));
                updateHashValuesButton();
                updateHashLBAButton();
            }
            <?php else: ?>
			updateHashValuesButton();
			updateHashLBAButton();
			hideObj($("#hash_verify_btn"));
            <?php endif; ?>
		}

        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
		if ((m == "all") || (m == "filesystems")) {
			var fs = fsWithMountPath(task_config[t]["MountPath"]);
            var fsname = fs["Name"];
			$("#push_filesystem_select .select-opt").each(function(i) {
				if ($(this).find(".col1").text() == fsname) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
		if ((m == "all") || (m == "push_case")) {
			var cases = task_config[t]["CaseList"];
			$("#push_case_select .select-opt").each(function(i) {
				if (inArray($(this).find(".col1").text(), cases)) { $(this).addClass("ui-selected"); }
				else $(this).removeClass("ui-selected");
			});
		}
        <?php endif; ?>

		if ((m == "all") || (m == "hash_values")) {
			var hash = task_config[t]["HashType"];
			$("#hash_method_select .select-opt").each(function(i) {
				if (hash == i+1) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			updateHashValueTable();
		}

		if ((m == "all") || (m == "hash_enter_values")) {
			var hashvals = task_config[t]["HashValue"].split("");
			$("#hash_value_boxes input").each(function(i) {
				$(this).val(hashvals[2*i]+hashvals[2*i+1]);
			});
		}

		if ((m == "all") || (m == "hash_lba")) {
			updateHashLBASliders();
		}

		if ((m == "all") || (m == "case_info")) {
			updateCaseInfoModal();
		}
	}
	else if (current_op == OP_PUSH) {	//PUSH modals
		if ((m == "all") || (m == "master_repo")) {
			var repo = task_config[t]["Repository"];
			$("#clone_master_repo_select .select-opt").each(function(i) {
				if ($(this).find(".col1").text() == repo) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
			disableHideDrives();
		}
        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
		if ((m == "all") || (m == "filesystems")) {
			var fs = fsWithMountPath(task_config[t]["MountPath"]);
			var fsname = fs["Name"];
			var fsloc = fs["Location"];
			$("#push_filesystem_select .select-opt").each(function(i) {
				if (($(this).find(".col1").text() == fsname) &&
				    ($(this).find(".col2").text() == fsloc))
					$(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});
		}
        <?php endif; ?>
		if ((m == "all") || (m == "push_case")) {
			var cases = task_config[t]["CaseList"];
			$("#push_case_select .select-opt").each(function(i) {
				if (inArray($(this).find(".col1").text(), cases)) { $(this).addClass("ui-selected"); }
				else $(this).removeClass("ui-selected");
			});
		}

		if ((m == "all") || (m == "settings")) {
			//update Verify
			var verif = (task_config[t]["VerifyHash"] == 0 ? 1 : 0);	//0 button = Yes, 1 button = No
			$("#push_verif_select .select-opt").each(function(i) {
				if (i == verif) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			});

			updateHashVerifBlock();
			updateCaseInfoBlock();
			updateHashSelect();
		}

		if ((m == "all") || (m == "case_info")) {
			updateCaseInfoModal();
		}

		if ((m == "all") || (m == "target_repo")) {
			var repos = task_config[t]["RepositoryList"];
			$("#clone_target_repo_select .select-opt").each(function(i) {
				if (inArray($(this).find(".col1").text(), repos)) { $(this).addClass("ui-selected"); }
				else $(this).removeClass("ui-selected");
			});
			disableHideDrives();
		}
	}
}

function updateCaseInfoModal() {
	var t = current_task();
	if (t == -1) return;
	var case_name = task_config[t]["CaseName"];
	var examiner = truncate(task_config[t]["ExaminerName"], 34);
	var case_id = truncate(task_config[t]["CaseNumber"], 34);
	var evidence_id = task_config[t]["EvidenceNumber"];
	var case_notes = truncate(task_config[t]["CaseNotes"], 64);
	$("#clone_case_name_block_content").html(case_name);
	$("#clone_examiner_block_content").html(examiner);
	$("#clone_case_id_block_content").html(case_id);
	$("#clone_evidence_id_block_content").html(evidence_id);
	$("#clone_case_notes_block_content").html(case_notes);
}

//update Hash options and disabled/enabled status, set to valid value in some cases
function updateHashSelect() {
    var t = current_task();
	if (t == -1) return;

    var setconfig_params = new Array();
    setconfig_params = {"Task": t};
    var update = false;

    <?php if ($LOGICUBE_PLATFORM == "default" || $LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): ?>
    if (current_op == OP_CLONE && task_config[t]["CloneMode"] == MODE_D2I) {  //only SHA-1 or SHA-256 for ZClone/ZXi D2I and I2D
		hideObj($("#clone_hash_0"));
		showObj($("#clone_hash_1"));
		showObj($("#clone_hash_2"));
		hideObj($("#clone_hash_3"));
		hideObj($("#clone_hash_4"));
        if (task_config[t]["HashType"] != HASH_SHA1 && task_config[t]["HashType"] != HASH_SHA2) {   //set to SHA-256 if not a valid value
            task_config[t]["HashType"] = HASH_SHA2;
            setconfig_params["HashType"] = APIHASHES[task_config[t]["HashType"]];
            update = true;
        }
        enableObj($("#clone_hash_1"));          //allow user selection (in case it was disallowed)
		enableObj($("#clone_hash_2"));
    }
    else if (current_op == OP_CLONE && task_config[t]["CloneMode"] == MODE_I2D) {  //only SHA-1 or SHA-256 for ZClone/ZXi D2I and I2D
		hideObj($("#clone_hash_0"));
		showObj($("#clone_hash_1"));
		showObj($("#clone_hash_2"));
		hideObj($("#clone_hash_3"));
		hideObj($("#clone_hash_4"));
        disableObj($("#clone_hash_1"));         //server will set valid value, disallow user selection
        disableObj($("#clone_hash_2"));
    }
    else if (current_op == OP_CLONE && task_config[t]["CloneMode"] == MODE_F2F) {   //no SHA-256 for ZClone/ZXi F2F
    <?php else: ?>
    if (current_op == OP_CLONE && (task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F || task_config[t]["CloneMode"] == MODE_F2F)) {   //no SHA-256 for Falcon D2I or F2F
    <?php endif; ?>
        if ((task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F) 
            && (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_DD || task_config[t]["CaptureMethod"] == CAPTUREMETHOD_E01 || task_config[t]["CaptureMethod"] == CAPTUREMETHOD_EX01)) {    //show SHA-1+MD5 for Falcon D2I/P2F dd/E01/Ex01
            showObj($("#clone_hash_4"));
        }
        else {
            hideObj($("#clone_hash_4"));
            if (task_config[t]["HashType"] == HASH_SHA1_MD5) {
                task_config[t]["HashType"] = HASH_SHA1;
                setconfig_params["HashType"] = APIHASHES[task_config[t]["HashType"]];
                update = true;
            }
        }            
        if (((task_config[t]["CloneMode"] == MODE_D2I || task_config[t]["CloneMode"] == MODE_P2F)
            && (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_E01 || task_config[t]["CaptureMethod"] == CAPTUREMETHOD_EX01)) 
            || (task_config[t]["CloneMode"] == MODE_F2F)) {    //no NONE or SHA-256 for Falcon D2I/P2F E01/Ex01 or F2F
            hideObj($("#clone_hash_2"));
            if ((task_config[t]["HashType"] == HASH_NONE) || (task_config[t]["HashType"] == HASH_SHA2)) {
                task_config[t]["HashType"] = HASH_SHA1;
                setconfig_params["HashType"] = APIHASHES[task_config[t]["HashType"]];
                update = true;
            }
        }
        else {
            showObj($("#clone_hash_2"));
        }
        hideObj($("#clone_hash_0"));
		showObj($("#clone_hash_1"));
		showObj($("#clone_hash_3"));
        enableObj($("#clone_hash_1"));          //allow user selection (in case it was disallowed)
		enableObj($("#clone_hash_2"));
	}
	else { //all hash options available for Clone D2D and Push
		showObj($("#clone_hash_0"));
		showObj($("#clone_hash_1"));
		showObj($("#clone_hash_2"));
		showObj($("#clone_hash_3"));
		hideObj($("#clone_hash_4"));
        if (task_config[t]["HashType"] == HASH_SHA1_MD5) {
            task_config[t]["HashType"] = HASH_SHA1;
            setconfig_params["HashType"] = APIHASHES[task_config[t]["HashType"]];
            update = true;
        }
        enableObj($("#clone_hash_1"));          //allow user selection (in case it was disallowed)
		enableObj($("#clone_hash_2"));
	}

    if (update) {
        TaskSetConfiguration(setconfig_params);
        updateHashVerifBlock();
        updateButtons("settings");

        $("#clone_hash_select .select-opt").each(function(i) {
            if (i == task_config[t]["HashType"]) $(this).addClass("ui-selected");
            else $(this).removeClass("ui-selected");
        });
    }
}

function resetKeyboard(the_keyboard) {
	//switch to ABC keyboard
	//if ($("#" + the_keyboard + "_keyboard #qk0").html() != "Q") $("#" + the_keyboard + "_keyboard div#qkabc").mousedown();

	//unshift
	//if ($("#" + the_keyboard + "_keyboard div#qkshift").hasClass("on")) $("#" + the_keyboard + "_keyboard div#qkshift").mousedown();
}

function updateCleverModal() {
	var t = current_task();
	if (t == -1) return;

	var resize = task_config[t]["CleverResizePercentages"];
	if (resize.length == 0) {
		$("#clone_clever_partition_rows").html("");
	}
	else {
		//update Clever sliders
		var mode = task_config[t]["CloneMode"];
		var part_rows = "";
		if (mode == MODE_I2D) {		//for ImageToDrive, get master info from ImageConfig/SourcePartitionNumber and percentages from CleverResizePercentages
			var part_strs = task_config[t]["SourcePartitionNumber"].split(";");	//"<Number1>,<Size1>,<FileSystem1>;<Number2>,<Size2>,<FileSystem2>;..."
			for (var i in part_strs) {
				i = parseInt(i);
				var parts = part_strs[i].split(",");
				part_rows += "<tr class=\"clone_clever_settings_row\"><td class=\"col1\">" + (i+1) + "</td><td class=\"col2\">" + parts[2] + "</td><td class=\"col3\">" +
					"<div id=\"clone_clever_pct" + (i+1) + "\" style=\"position: relative; left: 31px\"><!-- slider here --></div>" +
					"</td></tr>\n" +
					"<tr class=\"clone_clever_settings_spacer" + (i == part_strs.length-1 ? "2" : "") + "_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>";
			}
			$("#clone_clever_partition_rows").html(part_rows);
			for (var i=0; i<part_strs.length; i++) {
				createSlider("clone_clever_pct" + (i+1), resize[i]);
			}
		}
		else {
			var master = task_config[t]["Master"];
			var master_drive = driveWithBay(master);
			if (master_drive != -1) {		//make sure drive is still connected
				for (var i=0; i<master_drive.Partitions.length; i++) {
					if (typeof(master_drive.Partitions[i]) != "undefined") {
						var part = master_drive.Partitions[i];
						var filesys = part.FileSystem.toUpperCase();
						var drivesize = getDispSize(part.Size, 2);

						part_rows += "<tr class=\"clone_clever_settings_row\"><td class=\"col1\">" + (i+1) + "</td><td class=\"col2\">" + filesys + "</td><td class=\"col3\">" +
							"<div id=\"clone_clever_pct" + (i+1) + "\" style=\"position: relative; left: 31px\"><!-- slider here --></div>" +
							"</td></tr>\n" +
							"<tr class=\"clone_clever_settings_spacer" + (i == resize.length-1 ? "2" : "") + "_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td></tr>";
					}
				}
			}

			$("#clone_clever_partition_rows").html(part_rows);
			if (master_drive != -1) {         //make sure drive is still connected
				for (var i=0; i<master_drive.Partitions.length; i++) {
					createSlider("clone_clever_pct" + (i+1), resize[i]);
				}
			}
		}
	}
}

function updateMirrorModal() {
	var t = current_task();
	if (t == -1) return;

	var master = task_config[t]["Master"];
	var mode = task_config[t]["CloneMode"];
	if ((master == "") && (mode != MODE_I2D)) {	//no Master selected
		enableObj($("#clone_mirmode_0"));	//enable RAID button

		$("#clone_mirror_length_slider").slider("option", "max", 1);
		setSlider("clone_mirror_length", 1);	//100%
		$("#clone_mirror_mstart_slider").slider("option", "max", 1);
		setSlider("clone_mirror_mstart", 0);	//0
		$("#clone_mirror_tstart_slider").slider("option", "max", 1);
		setSlider("clone_mirror_tstart", 0);	//0

		disableMirrorSettings();
	}
	else {
		//update Mirror sliders max value
		var lbacount = task_config[t]["LBACount"];
		var master_drive = driveWithBay(master);
		var master_lbas = 0;
		var pct = 0;
		var mstart = task_config[t]["MasterStartLBA"];
		var tstart = task_config[t]["TargetStartLBA"];

		if (mode == MODE_I2D) {		//for ImageToDrive, get master size from ImageConfig
			master_lbas = task_config[t]["SourceSize"]/512;
			if (lbacount == 0 || lbacount > master_lbas) lbacount = master_lbas;
			pct = getLBADispPercent(lbacount, master_lbas);
		}
		else if (master_drive != -1) {		//make sure drive is still connected
			master_lbas = master_drive.LogicalSectors;
			if (lbacount == 0 || lbacount > master_lbas) lbacount = master_lbas;
			pct = getLBADispPercent(lbacount, master_lbas);
		}

		//update mirror sliders
		$("#clone_mirror_length_slider").slider("option", "max", master_lbas);
		$("#clone_mirror_mstart_slider").slider("option", "max", master_lbas);
		$("#clone_mirror_tstart_slider").slider("option", "max", master_lbas);

		setSlider("clone_mirror_length", lbacount);
		setSlider("clone_mirror_mstart", mstart);
		setSlider("clone_mirror_tstart", tstart);

		var mirraid = task_config[t]["MirrorRAIDEnable"];
		if (mirraid) {
			$("#clone_mirmode_0").addClass("ui-selected");		//select RAID
			$("#clone_mirmode_1").removeClass("ui-selected");
			enableObj($("#clone_mirmode_0"));	//enable RAID button
			disableMirrorSettings();
		}
		else {
			$("#clone_mirmode_1").addClass("ui-selected");		//select Non-RAID
			$("#clone_mirmode_0").removeClass("ui-selected");
			enableMirrorSettings();
			var master_drive = driveWithBay(master);

			if (master_drive != -1) {	//make sure drive is still connected
				if (master_drive.RAIDHeaderDetected) enableObj($("#clone_mirmode_0"));  //enable RAID button
				else disableObj($("#clone_mirmode_0"));	//disable RAID button
			}
		}
	}
}

function updateCloneMethodBlock() {
	var t = current_task();
	if (t == -1) return;

	var master = task_config[t]["Master"];
	var mode = task_config[t]["CloneMode"];
	var method = task_config[t]["CloneMethod"];
	if (method == METHOD_CLEVER) {
		if (mode == MODE_I2D) {		//for ImageToDrive, get master info from ImageConfig/SourcePartitionNumber and percentages from CleverResizePercentages
			var settings_txt = "";
			var resize = task_config[t]["CleverResizePercentages"];

			if ((typeof(task_config[t]["SourcePartitionNumber"]) == "undefined") || (task_config[t]["SourcePartitionNumber"] == "")) {
				$("#clone_method_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");
				$("#clone_method_imgsettings_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");	//Clone Method Settings (this isn't shown)
				$("#clone_imgsettings_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");		//Clone File Image Settings (this isn't shown)
			}
			else {
				var part_strs = task_config[t]["SourcePartitionNumber"].split(";");	//"<Number1>,<Size1>,<FileSystem1>;<Number2>,<Size2>,<FileSystem2>;..."
				
				for (var i in part_strs) {
					i = parseInt(i);
					var parts = part_strs[i].split(",");
					var drivesize = getDispSize(parts[1], 2);
					var filesys;

					if(typeof(parts[2]) == "undefined")
						filesys = "UNKNOWN";
					else
						filesys = parts[2].toUpperCase();

					if (i<2) {
						settings_txt += "<div class=\"col1\">" + (i+1) + "</div><div class=\"col2\">" + drivesize + "</div>" +
						"<div class=\"col3\">" + filesys + "</div><div class=\"col4\">" + resize[i] + "%</div>";
					}
					else if (i==2) {
						settings_txt += "<div class=\"col5\">... (" + resize.length + " partitions)</div>";
						break;
					}
				}
				$("#clone_method_block_content").html(settings_txt);
				$("#clone_method_imgsettings_block_content").html(settings_txt);	//Clone Method Settings (this isn't shown)
				$("#clone_imgsettings_block_content").html(settings_txt);			//Clone File Image Settings (this isn't shown)
			}
		}
		else if (master == "") {	//no Master selected
			$("#clone_method_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");
			$("#clone_method_imgsettings_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");
			$("#clone_imgsettings_block_content").html("<?= t("NO_IMAGE_SELECTED_CLEVER_BLOCK"); ?>");
		}
		else {
			var settings_txt = "";
			var resize = task_config[t]["CleverResizePercentages"];
			var master_drive = driveWithBay(master);

			if (master_drive != -1) {	//make sure drive is still connected
				for (var i=0; i<master_drive.Partitions.length; i++) {
					if (typeof(master_drive.Partitions[i]) != "undefined") {
						var part = master_drive.Partitions[i];
						var filesys = part.FileSystem.toUpperCase();
						var drivesize = getDispSize(part.Size, 2);
						if (i<2) {
							settings_txt += "<div class=\"col1\">" + (i+1) + "</div><div class=\"col2\">" + drivesize + "</div>" +
							"<div class=\"col3\">" + filesys + "</div><div class=\"col4\">" + resize[i] + "%</div>";
						}
						else if (i==2) {
							settings_txt += "<div class=\"col5\">... (" + resize.length + " partitions)</div>";
							break;
						}
					}
				}
			}

			$("#clone_method_block_content").html(settings_txt);
			$("#clone_method_imgsettings_block_content").html(settings_txt);
			$("#clone_imgsettings_block_content").html(settings_txt);
		}
	}
	else {	//METHOD_MIRROR
		if ((master == "") && (mode != MODE_I2D)) {	//no Master selected
			$("#clone_method_block_content").html("<?= t("NO_MASTER_SELECTED"); ?>");
			$("#clone_method_imgsettings_block_content").html("<?= t("NO_MASTER_SELECTED"); ?>");	//Clone Method Settings
			$("#clone_imgsettings_block_content").html("<?= t("NO_MASTER_SELECTED"); ?>");			//File Image Settings
		}
		else {
			var mirraid = task_config[t]["MirrorRAIDEnable"];
			if (mirraid) {
				$("#clone_method_block_content").html("<div class=\"main\">RAID</div>");
				$("#clone_method_imgsettings_block_content").html("<div class=\"main\">RAID</div>");
				$("#clone_imgsettings_block_content").html("<div class=\"main\">RAID</div>");
			}
			else {
				var lbacount = task_config[t]["LBACount"];
				var master_drive = driveWithBay(master);
				var master_lbas = 0;
				var pct = 0;
				var mstart = task_config[t]["MasterStartLBA"];
				var tstart = task_config[t]["TargetStartLBA"];

				if (mode == MODE_I2D) {		//for ImageToDrive, get master size from ImageConfig
					master_lbas = task_config[t]["SourceSize"]/512;
					pct = getLBADispPercent(lbacount, master_lbas);
				}
				else if (master_drive != -1) {	//make sure drive is still connected
					master_lbas = master_drive.LogicalSectors;
					if (lbacount == 0 || lbacount > master_lbas) lbacount = master_lbas;
					pct = getLBADispPercent(lbacount, master_lbas);
				}
				var info = "<?= t("COPY_N_LBAS_A_TO_B"); ?>";
				info = info.replace("%1", lbacount).replace("%2", mstart).replace("%3", tstart);
				$("#clone_method_block_content").html("<div class=\"main\">" + pct + "%</div><div class=\"details\">" + info + "</div>");
				$("#clone_method_imgsettings_block_content").html("<div class=\"main\">" + pct + "%</div><div class=\"details\">" + info + "</div>");
				$("#clone_imgsettings_block_content").html("<div class=\"main\">" + pct + "%</div><div class=\"details\">" + info + "</div>");
			}
		}
	}
}

<?php if (($LOGICUBE_PLATFORM == "forensic") || ($LOGICUBE_PLATFORM == "zxiforensic") || ($LOGICUBE_PLATFORM == "talonu")): ?>
function updateOutputFormatBlock() {
    var t = current_task();
	if (t == -1) return;
	$("#clone_output_format_block_content").html(OUTPUTFORMATS[task_config[t]["FileOutputFormat"]]);
}
                
function updateRootDirBlock() {
    var t = current_task();
	if (t == -1) return;
	$("#clone_root_dir_block_content").html(task_config[t]["FileSearchRoot"]);
}

function updatePathFilterBlock() {
    $("#clone_path_filter_block_content").html(truncate(getPathFilterString(), 40));
}

function updatePresetFilterBlock() {
	$("#clone_preset_filter_block_content").html(truncate(getPresetFilterString(), 60));
}

function updateCustomFilterBlock() {
    var t = current_task();
    if (t == -1) return;
    var custom = task_config[t]["FileCustomFilter"];
	$("#clone_custom_filter_block_content").html(truncate(custom, 60));
}

function updateFileCatBlock() {
	$("#clone_file_cat_block_content").html(truncate(getFileCatString(), 40));
}

function updateFilterSettingsBlock() {
	var html = "";
	var str = $("#clone_file_cat_block_content").html();

	if (str.length) html += "<?= t("FILE_CAT_BTN_COL"); ?>: " + truncate(str, 15) + "</br>";
	str = $("#clone_path_filter_block_content").html();
	if (str.length) html += "<?= t("PATH_FILTER"); ?>: " + truncate(str, 20) + "</br>";
	str = $("#clone_keywords_block_content").html();
	if (str.length) html += "<?= t("KEYWORDS"); ?>: " + truncate(str, 20) + "</br>";
	$("#clone_filter_settings_block_content").html(html);
}

function updateKeywordsBlock() {
    $("#clone_keywords_block_content").html(truncate(getKeywordsString(), 40));
}

function updateSearchKeywordsBlock() {
    var t = current_task();
    if (t == -1) return;
	$("#clone_search_keywords_block_content").html(truncate(task_config[t]["FileKwDictionary"], 60));
}

function getPresetFilterString() {
    var t = current_task();
    if (t == -1) return "";
    var presets = "";
    for (var i=0; i<task_config[t]["PresetFilterList"].length; i++) {
        if (task_config[t]["PresetFilterList"][i] == 1) {
            presets += (presets != "" ? ", " : "") + PRESETFILTERS_SHORT[i];
        }
    }
    return presets;
}

function getPathFilterString() {
    var t = current_task();
    if (t == -1) return "";
    var filters = getPresetFilterString();
    filters += (task_config[t]["FileCustomFilter"] != "" ? (filters != "" ? ", " : "") + task_config[t]["FileCustomFilter"] : "");
    return filters;
}

                                    
function getFileCatString() {
    var t = current_task();
    if (t == -1) return "";
    var filecats = "";
    for (var i=0; i<task_config[t]["FileCategoryList"].length; i++) {
        if (task_config[t]["FileCategoryList"][i] == 1) {
            filecats += (filecats != "" ? ", " : "") + FILECATS_SHORT[i];
        }
    }
    return filecats;                
}

function getKeywordsString() {
    var t = current_task();
    if (t == -1) return "";
    var keywords = "";
    keywords += (task_config[t]["IgnoreCase"] ? "<?= t("IGNORE_CASE"); ?>" : "");
    keywords += (task_config[t]["FileCharEncodingList"] ? (keywords != "" ? ", " : "") + "<?= t("UNICODE"); ?>" : "");
    keywords += (task_config[t]["FileKwDictionary"] != "" ? (keywords != "" ? ", " : "") + task_config[t]["FileKwDictionary"] : "");
    return keywords;
}

<?php endif; ?>
                
function updateHPABlock() {
	var t = current_task();
	if (t == -1) return;

	var html = "<?= t("UNLOCK_HPA"); ?>: " + (task_config[t]["UnlockHPA"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") + "<br/>" +
		"<?= t("UNLOCK_DCO"); ?>: " + (task_config[t]["UnlockDCO"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>");
<?php if (($LOGICUBE_PLATFORM == "forensic")||($LOGICUBE_PLATFORM == "zxiforensic")||($LOGICUBE_PLATFORM == "talonu")): ?>
    html += (task_config[t]["CloneMode"] == MODE_D2D && task_config[t]["CloneMethod"] == METHOD_MIRROR ? "<br/><?= t("DRIVE_TRIM"); ?>: " + (task_config[t]["DriveTrim"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>") : "");
<?php endif; ?>
	$("#clone_hpa_block_content").html(html);
}

function updateErrorHandlingBlock() {
	var t = current_task();
	if (t == -1) return;

	var html = "<?= t("ACTION"); ?>: " + (task_config[t]["IgnoreReadFailure"] ? "<?= t("SKIP"); ?>" : "<?= t("ABORT"); ?>") + "<br/>" +
        "<?= t("GRANULARITY"); ?>: " + (task_config[t]["IgnoreReadFailure"] ? ERRORGRANULARITIES[task_config[t]["ErrorGranularity"]] : "<?= t("N_A"); ?>");
    $("#clone_error_handling_block_content").html(html);
}

function updateHashVerifBlock() {
	var t = current_task();
	if (t == -1) return;

	if (current_op == OP_CLONE) {
        var html = "<?= t("HASH_METHOD"); ?>: " + HASHES[task_config[t]["HashType"]] + "<br/>" +
            "<?= t("VERIFY"); ?>: " + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>");
        <?php if ($LOGICUBE_PLATFORM == "forensic" || $LOGICUBE_PLATFORM == "zxiforensic" || $LOGICUBE_PLATFORM == "talonu"): ?>
        if (task_config[t]["CloneMode"] == MODE_I2D) {
            html = "<?= t("VERIFY"); ?>: " + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>");
        }
        <?php endif; ?>
		$("#clone_verif_block_content").html(html);
	}
	else if (current_op == OP_PUSH) {
        var html = "<?= t("VERIFY"); ?>: " + (task_config[t]["VerifyHash"] ? "<?= t("YES"); ?>" : "<?= t("NO"); ?>");
		$("#push_verif_block_content").html(html);
	}
}

function updateCaseInfoBlock() {
	var t = current_task();
	if (t == -1) return;

	var case_name = task_config[t]["CaseName"];
	var examiner = task_config[t]["ExaminerName"];
	var case_id = task_config[t]["CaseNumber"];
	var evidence_id = task_config[t]["EvidenceNumber"];
	var case_notes = task_config[t]["CaseNotes"];
	var case_info = "";
	case_name = truncate(case_name, 22);
	if (case_name != "") case_info += "<?= t("CASE_FILE_NAME"); ?>: " + case_name;
	if (examiner != "") {
		if (case_info != "") case_info += "<br/>";
		examiner = truncate(examiner, 22);
		case_info += "<?= t("EXAMINER"); ?>: " + examiner;
	}
	if (case_id != "") {
		if (case_info != "") case_info += "<br/>";
		case_id = truncate(case_id, 22);
		case_info += "<?= t("CASE_ID"); ?>: " + case_id;
	}
	if (evidence_id != "") {
		if (case_info != "") case_info += "<br/>";
		evidence_id = truncate(evidence_id, 22);
		case_info += "<?= t("EVIDENCE_NUMBER"); ?>: " + evidence_id;
	}
	if (case_notes != "") {
		if (case_info != "") case_info += "<br/>";
		case_notes = truncate(case_notes, 22);
		case_info += "<?= t("CASE_NOTES"); ?>: " + case_notes;
	}
	if (current_op == OP_CLONE) {
		$("#clone_case_info_block_content").html(case_info);
	}
	else if (current_op == OP_PUSH) {
		$("#push_case_info_block_content").html(case_info);
	}
}

function updateFileImageBlock() {
	var t = current_task();
	if (t == -1) return;

	var capturemethod = task_config[t]["CaptureMethod"];
	var fileimginfo = "Method: " + CAPTUREMETHODS[capturemethod];
	var segmentsize = SEGMENTSIZES[task_config[t]["SegmentSize"]];
	var compression = COMPRESSIONS[task_config[t]["CompressionLevel"]];
	var imgmode = METHODS[task_config[t]["CloneMethod"]];

	if (capturemethod == CAPTUREMETHOD_DD) fileimginfo += "<br/><?= t("SEGMENT_SIZE"); ?>: " + segmentsize;
	else if (capturemethod == CAPTUREMETHOD_E01) fileimginfo += "<br/><?= t("SEGMENT_SIZE"); ?>: " + segmentsize + "<br/><?= t("COMPRESSION"); ?>: " + compression;
	else if (capturemethod == CAPTUREMETHOD_EX01) fileimginfo += "<br/><?= t("SEGMENT_SIZE"); ?>: " + segmentsize + "<br/><?= t("COMPRESSION"); ?>: " + compression;
	else if (capturemethod == CAPTUREMETHOD_FILE) fileimginfo += "<br/><?= t("FILE_FILTER"); ?>: " + task_config[t]["FileFilter"];
	else if (capturemethod == CAPTUREMETHOD_LOGICUBE_IMAGE) fileimginfo += "<br/><?= t("MODE"); ?>: " + imgmode;
	$("#clone_file_image_block_content").html(fileimginfo);
}

function updateCaptureBlocks() {
	var t = current_task();
	if (t == -1) return;

	var segmentsize = SEGMENTSIZES[task_config[t]["SegmentSize"]];
	$("#clone_segment_block_content").html(segmentsize);
	var compression = COMPRESSIONS[task_config[t]["CompressionLevel"]];
	$("#clone_compression_block_content").html(compression);
	var filefilter = task_config[t]["FileFilter"];
	$("#clone_filefilter_block_content").html(filefilter);
	var imgmode = METHODS[task_config[t]["CloneMethod"]];
	$("#clone_imgmode_block_content").html(imgmode);

	/* !!! DO NOT REMOVE !!! */
	/* Bug 2111: DriveToImage Clever mode should NOT have clever resize Settings. */
	/* This only applies to the IT products */
        <?php if ($LOGICUBE_PLATFORM == "zclonexi" || $LOGICUBE_PLATFORM == "zxtower" || $LOGICUBE_PLATFORM == "supersonixng" || $LOGICUBE_PLATFORM == "echoplusng"): ?>
	var clonemode = task_config[t]["CloneMode"];
	var clonemethod = task_config[t]["CloneMethod"];
	//hide imgsettings if clone mode is DriveToImage and Clever and Logicube Image
	if (clonemode == MODE_D2I && clonemethod == METHOD_CLEVER) hideObj($("#clone_imgsettings_block"));
	else showObj($("#clone_imgsettings_block"));
	<?php endif; ?>

	updateCloneMethodBlock();
}

//disable Length, Master Start, and Target Start
function disableMirrorSettings() {
	disableObj($("#clone_mirror_length_row"));
	disableObj($("#clone_mirror_length_down"));
	disableObj($("#clone_mirror_length_slider"));
	disableObj($("#clone_mirror_length_up"));
	disableObj($("#clone_mirror_mstart_row"));
	disableObj($("#clone_mirror_mstart_down"));
	disableObj($("#clone_mirror_mstart_slider"));
	disableObj($("#clone_mirror_mstart_up"));
	disableObj($("#clone_mirror_tstart_row"));
	disableObj($("#clone_mirror_tstart_down"));
	disableObj($("#clone_mirror_tstart_slider"));
	disableObj($("#clone_mirror_tstart_up"));
}

//enable Length, Master Start, and Target Start
function enableMirrorSettings() {
	enableObj($("#clone_mirror_length_row"));
	enableObj($("#clone_mirror_length_down"));
	enableObj($("#clone_mirror_length_slider"));
	enableObj($("#clone_mirror_length_up"));
	enableObj($("#clone_mirror_mstart_row"));
	enableObj($("#clone_mirror_mstart_down"));
	enableObj($("#clone_mirror_mstart_slider"));
	enableObj($("#clone_mirror_mstart_up"));
	enableObj($("#clone_mirror_tstart_row"));
	enableObj($("#clone_mirror_tstart_down"));
	enableObj($("#clone_mirror_tstart_slider"));
	enableObj($("#clone_mirror_tstart_up"));
}

//update Clone Parallel Task dialog with current task_status tasks, highlight task selected in Operation row
function updateParallelTaskSelect(task, parallel_tasks) {
	$("#clone_parallel_task_select").empty();
	$("#clone_parallel_task_select").append("<tr class=\"header_row\"><td class=\"col1\"></td></tr>");
	//show task row selected
	$("#clone_parallel_task_select").append("<tr class=\"select_row select-opt ui-selected ui-state-disabled\"><td class=\"col1\"><span class=\"info\">" + mappedTask(task, true) + "</span><span class=\"task_num\">" + task + "</span></td></tr>"
		+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
	//show parallel task rows
	for (var i in parallel_tasks) {
		var t = parallel_tasks[i];
		$("#clone_parallel_task_select").append("<tr class=\"select_row select-opt\"><td class=\"col1\"><span class=\"info\">" + mappedTask(t, true) + "</span><span class=\"task_num\">" + t + "</span></td></tr>"
			+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
	}
	$("#clone_parallel_task_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
}


function updateWipeModeButton() {
	var t = current_task();
	if (t == -1) return;

	var wipe_mode = task_config[t]["WipeMethod"];
	$("#wipe_mode_btn_bottom").html(WIPEMETHODS[wipe_mode]);
	if (wipe_mode == WIPEMETHOD_NONE) disableObj($("#wipe_passes_btn"));
	else enableObj($("#wipe_passes_btn"));
}

function updateWipeHPAButton() {
	var t = current_task();
	if (t == -1) return;

	var html = "<?= t("UNLOCK_HPA"); ?>: " + (task_config[t]["UnlockHPA"] ? "True" : "False") + "<br/>"
		+ "<?= t("UNLOCK_DCO"); ?>: " + (task_config[t]["UnlockDCO"] ? "True" : "False");
	$("#wipe_hpa_btn_bottom").html(html);
}

function updateWipeLBAButton() {
	var t = current_task();
	if (t == -1) return;

	var targets = task_config[t]["Targets"];
	var cur_max_lbas = 0;
	var lbacount = task_config[t]["LBACount"];
	for (var i in targets) {
		var target_drive = driveWithBay(targets[i]);
		if (target_drive != -1) {		//make sure drive is still connected
			target_lbas = target_drive.LogicalSectors;
			cur_max_lbas = Math.max(cur_max_lbas, target_lbas);
		}
	}
	if (lbacount == 0 || lbacount > cur_max_lbas) lbacount = cur_max_lbas;
	var pct = getLBADispPercent(lbacount, cur_max_lbas);
	var html = "<?= t("LBAS"); ?>: " + pct + "%";
	$("#wipe_lba_btn_bottom").html(html);
}

function updateWipePassesButton() {
	var t = current_task();
	if (t == -1) return;

	var wipe_values = task_config[t]["WipeValues"];
	$("#wipe_passes_btn_bottom").html(dispWipeValues(wipe_values));
}

function updateWipeLBASlider() {
	var t = current_task();
	if (t == -1) return;

	var targets = task_config[t]["Targets"];

	if (targets.length == 0) {	//no Targets selected
		disableWipeSlider();
		$("#wipe_lba_range_slider").slider("option", "max", 1);
		setSlider("wipe_lba_range", 1);	//100%
	}
	else {
		//update LBA Range slider max value
		var new_max_lbas = 0;
		for (var i in targets) {
			var target_drive = driveWithBay(targets[i]);
			if (target_drive != -1) {		//make sure drive is still connected
				var target_lbas = target_drive.LogicalSectors;
 				new_max_lbas = Math.max(new_max_lbas, target_lbas);
			}
		}
		$("#wipe_lba_range_slider").slider("option", "max", new_max_lbas);

		//update LBA Range value
		enableWipeSlider();

		//make sure slider isn't more than new max value
		var lbacount = task_config[t]["LBACount"];
		if (lbacount == 0 || lbacount > new_max_lbas) lbacount = new_max_lbas;
		setSlider("wipe_lba_range", lbacount);
	}
}

function updateWipeFormatButton() {
	var t = current_task();
	if (t == -1) return;

	var html = (!task_config[t]["WipeFormat"] ? "<?= t("OFF"); ?>" : FILESYSTEMS[task_config[t]["WipeFilesystem"]] + (task_config[t]["EncryptEnable"] ? " / " + "<?= t("ENCRYPTED"); ?>" : ""));
	$("#wipe_format_btn_bottom").html(html);
}

//update Tasks button, Operations dialog, and Start button
function updateMacroPage() {
	if (current_op == OP_TASK_MACRO) {
		//update Tasks button and Start button
		var tab = current_tab[OP_TASK_MACRO];
		var macro_info = "";
		var ready_to_start = false;
		var next_op_enabled = false;
		for (var i in macro_list[tab]['Tasks']) {
			var t = macro_list[tab]['Tasks'][i];
			if (t > 0) {	//macro list contains 0s for unset tasks up to 15
				var op = OP_CLONE;
				if (t > 15) op = OP_PUSH;
				else if (t > 10) op = OP_HASH;
				else if (t > 5) op = OP_WIPE;
				if (i == 0) var ready_to_start = readyToStart(op, t, true);			//if all macro tasks are ready, enable Start
				else ready_to_start = ready_to_start && readyToStart(op, t, true);

				var mapped_task = mappedTask(t);
				$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ") .op").text(mapped_task);		//update Operations dialog
				showObj($("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ") .x"));		//show X if there's an operation
				$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").removeAttr('disabled');	//enableObj function only handles ids
				$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").removeClass('ui-state-disabled');
				if (macro_info != "") macro_info += ", ";
				macro_info += mapped_task;
			}
			else {
				$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ") .op").text("");		//update Operations dialog
				hideObj($("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ") .x"));
				if (!next_op_enabled) {		//enable only one next operation, disable the rest
					$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").removeAttr('disabled');	//enableObj function only handles ids
					$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").removeClass('ui-state-disabled');
					next_op_enabled = true;
				}
				else {
					$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").attr('disabled', 'disabled');	//disableObj function only handles ids
					$("#task_macro_operations .task_macro_op:nth-child(" + (parseInt(i)+1) + ")").addClass('ui-state-disabled');
				}
			}
		}

		if (macro_info == "") macro_info = "<?= t("NONE_SELECTED"); ?>";	//update Tasks button
		$("#task_macro_tasks_block_content").html(macro_info);

		if (ready_to_start) enableObj($("#clone_start_btn"));	//enable/disable Start button
		else disableObj($("#clone_start_btn"));

		updateMacroProgressBars();
	}
}

//update Macro Tasks dialog with current task_status tasks, highlight task selected in Operation row
//e.g. sel_task = "Hash 1"
function updateMacroTaskSelect(sel_task) {
	$("#task_macro_task_select").empty();
	$("#task_macro_task_select").append("<tr class=\"header_row\"><td class=\"col1\"></td></tr>");

	for (var t in task_status) {
       var min_t = 1;
       var max_t = num_tasks;
       if (WIPE_ONLY) {
            min_t = 6;
            max_t = 11;
        }
        if (task_status[t]["TaskState"] == "TASK_RESERVED" && (t >= min_t && t < max_t)) {
			var mapped_task = mappedTask(t);
			$("#task_macro_task_select").append("<tr class=\"select_row select-opt" + (sel_task == mapped_task ? " ui-selected" : "") + "\"><td class=\"col1\"><span class=\"info\">" + mapped_task + "</span><span class=\"task_num\">" + t + "</span></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td></tr>");
		}
	}
	$("#task_macro_task_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td></tr>");
}

//update USB Device drive select, disable drives that have USBExportStatus = "Engaged"
function updateUSBDevicePage() {
	//have the drive modals been initialized
	if ($("#usb_device_drive_select .header_row").length == 0) {		//first time showing drives in USB Drive Select
		//initialize USB Drive Select
		$("#usb_device_drive_select").append("<tr class=\"header_row\"><td class=\"col1\"><?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?><?= t("PORT"); ?><?php else: ?><?= t("DRIVE_BAY"); ?><?php endif; ?></td><td class=\"col2\"><?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?><?= t("INFORMATION"); ?><?php else: ?><?= t("DRIVE_INFORMATION"); ?><?php endif; ?></td><td class=\"col3\"><?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?><?= t("STATUS"); ?><?php else: ?><?= t("DRIVE_STATUS"); ?><?php endif; ?></td><td class=\"col4\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var d in drives) {
			$("#usb_device_drive_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[d]["Model"] + "<br/>" + getDispSize(drives[d]["Size"]) + "</td>"
				+ "<td class=\"col3\">" + translateUSBExportStatus(drives[d]["USBExportStatus"]) + "</td>"
				+ "<td class=\"col4 select-more" + (((drives[d]["IsSAS"] && !drives[d]["IsPortSASEnabled"]) || !drives[d]["IsPortEnabled"]) ? " sas-alert" : "")
                <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
                + (drives[d]["HPAEnabled"] == "Yes" || drives[d]["DCOEnabled"] == "Yes" ? " hpa-dco-enabled" : "")
                <?php endif; ?> 
                + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#usb_device_drive_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
	}
	else {	//Drive Select already initialized, just update rows with new drive info
		var row = -1;
		$("#usb_device_drive_select .select_row").each(function(i) {
			if (drives.length > i) {
				$(this).find(".col1").html(drives[i]["Bay"]);
				$(this).find(".col2").html(drives[i]["Model"] + "<br/>" + getDispSize(drives[i]["Size"]));
				$(this).find(".col3").html(translateUSBExportStatus(drives[i]["USBExportStatus"]));
				if ($(this).hasClass("ui-selected")) {
					if (drives[i]["USBExportStatus"] == APIUSBEXPORTSTATUSES[USBEXPORTSTATUS_ENGAGED]) $("#usb_device_engage_btn").html("<?= t("DISENGAGE_BTN"); ?>");
					else $("#usb_device_engage_btn").html("<?= t("ENGAGE_BTN"); ?>");
				}

                if ((drives[i]["IsSAS"] && !drives[i]["IsPortSASEnabled"]) || !drives[i]["IsPortEnabled"]) $(this).find(".col4").addClass("sas-alert");
				else $(this).find(".col4").removeClass("sas-alert");
                <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
                if (drives[i]["HPAEnabled"] == "Yes" || drives[i]["DCOEnabled"] == "Yes") $(this).find(".col4").addClass("hpa-dco-enabled");
				else $(this).find(".col4").removeClass("hpa-dco-enabled");
                <?php endif; ?>
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<drives.length; j++) {	//more drives than before, so add before footer row
			$("#usb_device_drive_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[j]["Model"] + "<br/>" + getDispSize(drives[j]["Size"]) + "</td>"
				+ "<td class=\"col3\">" + translateUSBExportStatus(drives[j]["USBExportStatus"]) + "</td>"
				+ "<td class=\"col4 select-more" + (((drives[j]["IsSAS"] && !drives[j]["IsPortSASEnabled"]) || !drives[j]["IsPortEnabled"]) ? " sas-alert" : "") + "\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
	}
}

                                           
//update HPA/DCO drive select, disable drives that have USBExportStatus = "Engaged"
function updateHPADCODrives() {
	//have the drive modals been initialized
	if ($("#hpa_dco_drive_select .header_row").length == 0) {		//first time showing drives in USB Drive Select
		//initialize USB Drive Select
		$("#hpa_dco_drive_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("PORT"); ?></td><td class=\"col2\"><?= t("INFORMATION"); ?></td><td class=\"col3\"><?= t("HPA_SIZE"); ?></td><td class=\"col4\"><?= t("DCO_SIZE"); ?></td></tr>");
		for (var d in drives) {
			$("#hpa_dco_drive_select").append("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[d]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[d]["Model"] + "<br/>" + getDispSize(drives[d]["Size"]) + "</td>"
				+ "<td class=\"col3\">" + drives[d]["HPASizeSectors"] + "</td>"
				+ "<td class=\"col4\">" + drives[d]["DCOSizeSectors"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
		$("#hpa_dco_drive_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
	}
	else {	//Drive Select already initialized, just update rows with new drive info
		var row = -1;
		$("#hpa_dco_drive_select .select_row").each(function(i) {
			if (drives.length > i) {
				$(this).find(".col1").html(drives[i]["Bay"]);
				$(this).find(".col2").html(drives[i]["Model"] + "<br/>" + getDispSize(drives[i]["Size"]));
				$(this).find(".col3").html(drives[i]["HPASizeSectors"]);
				$(this).find(".col4").html(drives[i]["DCOSizeSectors"]);
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			row = i;
		});
		for (var j=row+1; j<drives.length; j++) {	//more drives than before, so add before footer row
			$("#hpa_dco_drive_select .footer_row").before("<tr class=\"select_row select-opt\">"
				+ "<td class=\"col1\">" + drives[j]["Bay"] + "</td>"
				+ "<td class=\"col2\">" + drives[j]["Model"] + "<br/>" + getDispSize(drives[j]["Size"]) + "</td>"
				+ "<td class=\"col3\">" + drives[j]["HPASizeSectors"] + "</td>"
				+ "<td class=\"col4\">" + drives[j]["DCOSizeSectors"] + "</td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td></tr>");
		}
	}
}


//convert to hex
function dispHexDigit(val) {
	return (val+0x10).toString(16).substr(-1).toUpperCase();
}
function dispWipeValue(wipe_val) {
	if (wipe_val === "") return "&mdash;";
	if (wipe_val == 256) return "XX";
	if (wipe_val == 512) return "XX";
	return (wipe_val+0x100).toString(16).substr(-2).toUpperCase();
}
//convert to hex and join
function dispWipeValues(wipe_values) {
	var str = "";
	for (var v in wipe_values) {
		str += dispWipeValue(wipe_values[v]);
		if (v < wipe_values.length-1) str += ", ";
	}
	return str;
}

function disableWipeSlider() {
	disableObj($("#wipe_lba_btn"));
	/*disableObj($("#wipe_lba_range_row"));
	disableObj($("#wipe_lba_range_down"));
	disableObj($("#wipe_lba_range_slider"));
	disableObj($("#wipe_lba_range_up"));
	disableObj($("#wipe_lba_range_percent"));
	disableObj($("#wipe_lba_range_lbas"));*/
}

function enableWipeSlider() {
	enableObj($("#wipe_lba_btn"));
	/*enableObj($("#wipe_lba_range_row"));
	enableObj($("#wipe_lba_range_down"));
	enableObj($("#wipe_lba_range_slider"));
	enableObj($("#wipe_lba_range_up"));
	enableObj($("#wipe_lba_range_percent"));
	enableObj($("#wipe_lba_range_lbas"));*/
}

/* Hash */
function updateHashValuesButton() {
	var t = current_task();
	if (t == -1) return;

	var hash = task_config[t]["HashType"];
	var hashval = formatHashValue(task_config[t]["HashValue"], 8);
	$("#hash_values_btn_bottom").html("<table align=\"center\" width=\"95%\">" +
	"<tr><td valign=\"top\"><?= t("METHOD_BTN_COL"); ?>:</td><td nowrap>" + HASHES[hash] + "</td></tr>" +
	"<tr><td valign=\"top\"><?= t("EXPECTED_VALUE_BTN_COL"); ?>:</td><td>" + hashval + "</td></tr></table>");
}

function formatHashValue(hashval, n) {
	hashval = hashval.toString().toUpperCase();
	var splithashval = "";
	while (hashval.length > 0) {
		splithashval += hashval.substring(0, n) + "<br/>";
		hashval = hashval.substring(n);
	}
	return splithashval;
}

function updateHashLBAButton() {
	var t = current_task();
	if (t == -1) return;

	var targets = task_config[t]["Targets"];
	var cur_min_lbas = 0;
	for (var i in targets) {
		var target_drive = driveWithBay(targets[i]);
		if (target_drive != -1) {		//make sure drive is still connected
			if (0 == cur_min_lbas) {
				cur_min_lbas = target_drive.LogicalSectors;
			}
			else {
				var target_lbas = target_drive.LogicalSectors;
				cur_min_lbas = Math.min(cur_min_lbas, target_lbas);
			}
		}
	}

	var lbacount = task_config[t]["LBACount"];
	if ((lbacount == 0) || (lbacount > cur_min_lbas)){
		lbacount = cur_min_lbas;
		task_config[t]["TargetStartLBA"] = 0;
	}

	var startlba = task_config[t]["TargetStartLBA"];
	if (startlba > cur_min_lbas) { 
		startlba = 0;
		task_config[t]["TargetStartLBA"] = 0;
	}

	var pct = getLBADispPercent(lbacount, cur_min_lbas);
	var start_pct = getLBADispPercent(startlba, cur_min_lbas, true);
	$("#hash_lba_btn_bottom").html("<table align=\"center\" width=\"95%\">" +
		"<tr><td><?= t("LENGTH_BTN_COL"); ?>:</td><td>" + pct + "%</td></tr>" +
		"<tr><td><?= t("START_BTN_COL"); ?>:</td><td>" + start_pct + "%</td></tr></table>");
}

function updateHashVerifyButton() {
	var t = current_task();
	if (t == -1) return;

	var hashverify = task_config[t]["VerifyCaseHash"];
    $("#hash_verify_btn_bottom").html(HASHVERIFIES[hashverify]);
}

function updateHashValueTable() {
	var t = current_task();
	if (t == -1) return;

	var hashval = task_config[t]["HashValue"];
	if (hashval != "") hashval = hashval.substr(0,32) + "<br/>" + hashval.substr(32);
	$("#hash_values_table .hash_values_table_row .col1").html(hashval);
}

//updates Hash LBA slider max values and values based on all Targets selected
//max LBACount and TargetStartLBA are determined by Target with least LBAs
function updateHashLBASliders() {
	var t = current_task();
	if (t == -1) return;

	var targets = task_config[t]["Targets"];

	if (targets.length == 0) {	//no Targets selected
		disableHashSliders();
		$("#hash_lba_length_slider").slider("option", "max", 1);
		setSlider("hash_lba_length", 1);	//100%
		$("#hash_lba_tstart_slider").slider("option", "max", 1);
		setSlider("hash_lba_tstart", 0);	//0%
	}
	else {
		//update LBA Range slider max value
		var new_min_lbas = 0;
        var updated_min_lbas = false;

        //loop through targets
        for (var i in targets) {
			var target_drive = driveWithBay(targets[i]);
			if (target_drive != -1) {	//make sure drive is still connected
                updated_min_lbas = true;
                if (new_min_lbas == 0) {    //get target with least LBAs
					new_min_lbas = target_drive.LogicalSectors;
				}
				else {
					var target_lbas = target_drive.LogicalSectors;
					new_min_lbas = Math.min(new_min_lbas, target_lbas);
				}
			}
		}
        if (updated_min_lbas) {
            //update Hash LBA sliders with min LBAs from all targets
            $("#hash_lba_length_slider").slider("option", "max", new_min_lbas);
            $("#hash_lba_tstart_slider").slider("option", "max", new_min_lbas);
        }
        else {
            //initialize to default
            $("#hash_lba_length_slider").slider("option", "max", 1);
            setSlider("hash_lba_length", 1);        //100%
            $("#hash_lba_tstart_slider").slider("option", "max", 1);
            setSlider("hash_lba_tstart", 0);        //0%
        }

        //update LBA Range value
		enableHashSliders();

		//var lba_length = task_config[t]["LBACount"];
		//var new_tstart = task_config[t]["TargetStartLBA"];
		//setSlider("hash_lba_length", lba_length);
		//setSlider("hash_lba_tstart", new_tstart);


		var lbacount = task_config[t]["LBACount"];
		if ((lbacount == 0) || (lbacount > new_min_lbas)){
			lbacount = new_min_lbas;
			task_config[t]["TargetStartLBA"] = 0;
		}
		setSlider("hash_lba_length", lbacount);

		var new_tstart = task_config[t]["TargetStartLBA"];
		if (new_tstart > new_min_lbas) {
			new_tstart = 0;
			task_config[t]["TargetStartLBA"] = 0;
		}
		setSlider("hash_lba_tstart", new_tstart);

	}
}

//disable Length and Target Start
function disableHashSliders() {
	disableObj($("#hash_lba_length_row"));
	disableObj($("#hash_lba_length_down"));
	disableObj($("#hash_lba_length_slider"));
	disableObj($("#hash_lba_length_up"));
	disableObj($("#hash_lba_tstart_row"));
	disableObj($("#hash_lba_tstart_down"));
	disableObj($("#hash_lba_tstart_slider"));
	disableObj($("#hash_lba_tstart_up"));
}

//enable Length and Target Start
function enableHashSliders() {
	enableObj($("#hash_lba_length_row"));
	enableObj($("#hash_lba_length_down"));
	enableObj($("#hash_lba_length_slider"));
	enableObj($("#hash_lba_length_up"));
	enableObj($("#hash_lba_tstart_row"));
	enableObj($("#hash_lba_tstart_down"));
	enableObj($("#hash_lba_tstart_slider"));
	enableObj($("#hash_lba_tstart_up"));
}






//hide drives based on role -- for Clone: no Target/Destination drives/repos in Master select, no Master/Source drives/repos in Target select
//                             for Wipe: no Master drives in Target select
//hide SCSI_S1 on Clone Target/Destination
//disable selected drives/repos -- for Clone D2D and F2F: if a drive/repo is being used as a Master/Target, cannot be selected as Target/Master within same task
//                                 (also if drive X is Master, repo X cannot be selected as Target within same task)
//keep non MOUNTED repos disabled -- for clone_master_repo_select and clone_master_source_select, keep repos with status != MOUNTED as disabled
//                            	     (for clone_target_repo_select, unmounted drives can be clicked to Format)
function disableHideDrives() {
	var masters_to_disable = new Array();
	var targets_to_disable = new Array();
	var masters_to_hide = new Array();	//for Clone master, hide role=Target
	var targets_to_hide = new Array();	//for Clone and Wipe target, hide role=Master

	var t = current_task();
	if (t == -1) return;

	if (current_op == OP_CLONE) {
		if (typeof(task_config[t]) != "undefined") {
			var mode = task_config[t]["CloneMode"];
			if (mode == MODE_D2D) {
				for (var d in drives) {
					if (drives[d]['Role'] == "Target") masters_to_hide.push(drives[d]["Bay"]);
					if (drives[d]['Role'] == "Master" || drives[d]['Bay'] == 'SCSI_S1') targets_to_hide.push(drives[d]["Bay"]);
				}
			}
			else if (mode == MODE_D2I) {
				for (var d in drives) {
					if (drives[d]['Role'] == "Target") masters_to_hide.push(drives[d]["Bay"]);
				}
				for (var r in repositories) {
					if (repositories[r]['Role'] == "Source") targets_to_hide.push(repositories[r]["Name"]);
				}
			}
			else if (mode == MODE_I2D) {
				for (var r in repositories) {
					if (repositories[r]['Role'] == "Destination") masters_to_hide.push(repositories[r]["Name"]);
				}
				for (var d in drives) {
					if (drives[d]['Role'] == "Master" || drives[d]['Bay'] == 'SCSI_S1') targets_to_hide.push(drives[d]["Bay"]);
				}
			}
			else if (mode == MODE_F2F) {
				for (var d in drives) {
					if (drives[d]['Role'] == "Target") masters_to_hide.push(drives[d]["Bay"]);
				}
				for (var r in repositories) {
					if ((repositories[r]['Role'] == "Destination") || (repositories[r]['Status'] == "NOT_MOUNTED")) masters_to_hide.push(repositories[r]["Name"]);
					if (repositories[r]['Role'] == "Source") targets_to_hide.push(repositories[r]["Name"]);
				}
			}
		}
	}
	else if (current_op == OP_HASH) {
		//don't hide any drives
	}
	else if (current_op == OP_WIPE) {
		for (var d in drives) {
			if (drives[d]['Role'] == "Master") targets_to_hide.push(drives[d]["Bay"]);
		}
	}
	else if (current_op == OP_PUSH) {
		for (var r in repositories) {
			if (repositories[r]['Role'] == "Destination") masters_to_hide.push(repositories[r]["Name"]);
			if (repositories[r]['Role'] == "Source") targets_to_hide.push(repositories[r]["Name"]);
		}
	}
	else if (current_op == OP_MANAGE_REPOS) {
		//don't hide any drives
	}

	if (current_op == OP_CLONE) {
		if (typeof(task_config[t]) != "undefined") {
			var mode = task_config[t]["CloneMode"];
			if (mode == MODE_D2D) {
				var master = task_config[t]["Master"];
				var targets = task_config[t]["Targets"];
				targets_to_disable.push(master);			//if a drive is being used as a master, cannot be used as a target
				masters_to_disable = masters_to_disable.concat(targets);			//if a drive is being used as a target, cannot be used as a master
			}
			else if (mode == MODE_F2F) {
				var master = task_config[t]["Master"];	//could be drive or repo, also disables Master drive X and Target repo X scenario
				if (master == "") master = task_config[t]["Repository"];
				var targets = task_config[t]["RepositoryList"];
				targets_to_disable.push(master);			//if a drive is being used as a master, cannot be used as a target
				masters_to_disable = masters_to_disable.concat(targets);			//if a drive is being used as a target, cannot be used as a master
			}

			var master_select = "clone_master_select";
			var target_select = "clone_target_select";
			if (mode == MODE_F2F) {
				var master_select = "clone_master_source_select";
				var target_select = "clone_target_repo_select";
			}
			else if (mode == MODE_D2I) {
				var target_select = "clone_target_repo_select";
			}
			else if (mode == MODE_I2D) {
				var master_select = "clone_master_repo_select";
			}

			$("#" + master_select + " .select-opt").each(function(i) {
				if (DRIVE_MODAL_OPEN && ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>")) {
					//don't change any drive status to or from "Selected" when drive modal is open
					//except make sure bay is visible, for the case where selected drive is disconnected and reconnected
					if (!inArray(bay, masters_to_hide)) { $(this).show(); $(this).next(".spacer_row").show(); }
				}
				else {
					var bay = $(this).find(".col1").text();
					if (inArray(bay, masters_to_hide)) { $(this).hide(); $(this).next(".spacer_row").hide(); }
					else { $(this).show(); $(this).next(".spacer_row").show(); }
					if (inArray(bay, masters_to_disable)) $(this).addClass("ui-state-disabled");
					else if ($(this).hasClass("unmounted-repo")) $(this).addClass("ui-state-disabled");		//keep unmounted repos disabled
					else $(this).removeClass("ui-state-disabled");
				}
			});
			$("#" + target_select + " .select-opt").each(function(i) {
				if (DRIVE_MODAL_OPEN && ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>")) {
					//don't change any drive status to or from "Selected" when drive modal is open
					//except make sure bay is visible, for the case where selected drive is disconnected and reconnected
					if (!inArray(bay, targets_to_hide)) { $(this).show(); $(this).next(".spacer_row").show(); }
				}
				else {
					var bay = $(this).find(".col1").text();
					if (inArray(bay, targets_to_hide)) { $(this).hide(); $(this).next(".spacer_row").hide(); }
					else { $(this).show(); $(this).next(".spacer_row").show(); }
					if (inArray(bay, targets_to_disable)) $(this).addClass("ui-state-disabled");
					else if ($(this).hasClass("unmounted-repo") && $(this).hasClass("ui-state-disabled")) $(this).addClass("ui-state-disabled");		//keep unmounted network repos disabled
					else $(this).removeClass("ui-state-disabled");
				}
			});
		}
	}
	else if ((current_op == OP_HASH) || (current_op == OP_WIPE)) {
		$("#clone_target_select .select-opt").each(function(i) {
			if (DRIVE_MODAL_OPEN && ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>")) {
				//don't change any drive status to or from "Selected" when drive modal is open
			}
			else {
				var bay = $(this).find(".col1").text();
				if (inArray(bay, targets_to_hide)) { $(this).hide(); $(this).next(".spacer_row").hide(); }
				else { $(this).show(); $(this).next(".spacer_row").show(); }
				if (inArray(bay, targets_to_disable)) $(this).addClass("ui-state-disabled");
				else $(this).removeClass("ui-state-disabled");
			}
		});
	}
	else if (current_op == OP_PUSH) {
		$("#clone_master_repo_select" + " .select-opt").each(function(i) {
			if (DRIVE_MODAL_OPEN && ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>")) {
				//don't change any drive status to or from "Selected" when drive modal is open
			}
			else {
				var bay = $(this).find(".col1").text();
				if (inArray(bay, masters_to_hide)) { $(this).hide(); $(this).next(".spacer_row").hide(); }
				else { $(this).show(); $(this).next(".spacer_row").show(); }
				if (inArray(bay, masters_to_disable)) $(this).addClass("ui-state-disabled");
				else if ($(this).hasClass("unmounted-repo")) $(this).addClass("ui-state-disabled");             //keep unmounted repos disabled
				else $(this).removeClass("ui-state-disabled");
			}
		});
		$("#clone_target_repo_select" + " .select-opt").each(function(i) {
			if (DRIVE_MODAL_OPEN && ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>")) {
				//don't change any drive status to or from "Selected" when drive modal is open
			}
			else {
				var bay = $(this).find(".col1").text();
				if (inArray(bay, targets_to_hide)) { $(this).hide(); $(this).next(".spacer_row").hide(); }
				else { $(this).show(); $(this).next(".spacer_row").show(); }
				if (inArray(bay, targets_to_disable)) $(this).addClass("ui-state-disabled");
				else if ($(this).hasClass("unmounted-repo") && repositories[i]["Location"] == "Network") $(this).addClass("ui-state-disabled");		//keep unmounted Network repos disabled
				else $(this).removeClass("ui-state-disabled");
			}
		});
	}
	else if (current_op == OP_MANAGE_REPOS) {		//disable drives used as masters and targets in Format Drives table
		$("#format_drives_select .select-opt").each(function(i) {
			if ($(this).find(".col3").html() == "<?= t("SELECTED"); ?>") {	//DRIVE_MODAL_OPEN = true since the Format Drives table is displayed on the page and not in a modal
				//don't change any drive status to or from "Selected" when drive modal is open
			}
			else {
				var bay = $(this).find(".col1").text();
				if (inArray(bay, masters_to_disable)) $(this).addClass("ui-state-disabled");
				else $(this).removeClass("ui-state-disabled");
				if (inArray(bay, targets_to_disable)) $(this).addClass("ui-state-disabled");
				else $(this).removeClass("ui-state-disabled");
			}
		});
	}
}


//update Drive Status ("Available", "Selected", "Assigned", "Clone t") for current task
//displayed in Master/Target Select modals
function updateDriveStatus(master_or_target) {
	var drive_status = new Array();
	//initialize Drive Status
	for (var i=0; i<drives.length; i++) {
		drive_status[drives[i]["Bay"]] = "<?= t("AVAILABLE"); ?>";
	}

	var ftt = flat_tab_tasks();
	for (var i=0; i<ftt.length; i++) {
		var t = ftt[i];
		var master = task_config[t]["Master"];
		var targets = task_config[t]["Targets"];
		var state = task_status[t]["TaskState"];

		if (task_config[t]["Operation"] == OP_CLONE) {	//for some Clone tasks Master/Targets will be Repositories
			var mode = task_config[t]["CloneMode"];
			if (mode == MODE_D2I) {
				if (task_config[t]["CaptureMethod"] == CAPTUREMETHOD_LOGICUBE_IMAGE) targets = new Array();	//uses DestinationImagePath
				else targets = task_config[t]["RepositoryList"];
			}
			else if (mode == MODE_F2F) {
				if (master == "") master = task_config[t]["Repository"];	//if no Master, check Repository
				targets = task_config[t]["RepositoryList"];
			}
		}


		if (t != current_task()) {
			if (state == "TASK_RESERVED")  {
				if ((master != "") && (drive_status[master] != "<?= t("SELECTED"); ?>")) drive_status[master] = "<?= t("ASSIGNED"); ?>";	//show other task Masters as ASSIGNED
				else drive_status[master] = "SELECTED_ASSIGNED";
				for (var j=0; j<targets.length; j++) {
					if (drive_status[targets[j]] != "<?= t("SELECTED"); ?>") {
						drive_status[targets[j]] = "<?= t("ASSIGNED"); ?>";	//show other task Targets as ASSIGNED
					}
					else  {
						drive_status[targets[j]] = "SELECTED_ASSIGNED";	//handle toggle between SELECTED and ASSIGNED
					}
				}
			}
			else {
				var mapped_task = mappedTask(t);
				drive_status[master] = mapped_task;
				for (var j=0; j<targets.length; j++) {
					drive_status[targets[j]] = mapped_task;
				}
			}
		}
		else {
			//show current task Master as SELECTED in Master modal, show as ASSIGNED in Target modal
			//show current task Targets as SELECTED in Target modal, show as ASSIGNED in Master modal
			if (master != "") drive_status[master] = (master_or_target == "master" ? "<?= t("SELECTED"); ?>" : "<?= t("ASSIGNED"); ?>");
			for (var j=0; j<targets.length; j++) {
				drive_status[targets[j]] = (master_or_target == "target" ? "<?= t("SELECTED"); ?>" : "<?= t("ASSIGNED"); ?>");
			}
		}
	}

	if (master_or_target == "manage_drives") var table_id = "#format_drives_select";
	else var table_id = "#clone_" + master_or_target + "_select";
	$(table_id + " .select-opt").each(function(i) {
		if ((table_id != "master_source") || (table_id == "master_source" && $(this).hasClass("source-type-bay"))) {	//bays only, no repos
			var source = $(this).find(".col1").text();
			var status = $(this).find(".col3").text();
			if (DRIVE_MODAL_OPEN && ((status == "<?= t("SELECTED"); ?>") || (drive_status[source] == "<?= t("SELECTED"); ?>"))) {
				//don't change any drive status to or from "Selected" when drive modal is open
			}
			else {
				if (drive_status[source] == "SELECTED_ASSIGNED") {
					if ($(this).hasClass("ui-selected")) $(this).find(".col3").html("<?= t("SELECTED"); ?>");
					drive_status[source] = "<?= t("ASSIGNED"); ?>";
				}
				else $(this).find(".col3").text(drive_status[source]);
				if ((typeof(drive_status[source]) != "undefined") && (drive_status[source] != "<?= t("SELECTED"); ?>") && (drive_status[source] != "<?= t("AVAILABLE"); ?>"))  {
					$(this).find(".col3").addClass(drive_status[source].replace(" ", "_"));	//add class so when user is clicking, we know to toggle between SELECTED and ASSIGNED / CLONE 1 / etc. (instead of AVAILABLE)
				}
				else $(this).find(".col3").attr("class", "col3");	//remove other classes
			}
		}
	});
}


//updateTabs, updateProgressBars (current task), updateButtons (current task), updateModals (current task)
function updateGUI() {
	updateTabs();
	updateProgressBars();
	updateButtons("all");
	updateModals("all");
}

//disable/enable GUI by showing/hiding semi-opaque background
function disableGUI() {
	$("#disabled_gui").show();
}
function enableGUI() {
    $("#disabled_gui").hide();
}







//------------------------------------------------------------
// HELPER FUNCTIONS
//------------------------------------------------------------
//convert seconds to H:m:s
function secondsToHms(d) {
	d = Number(d);
    if (isNaN(d)) {
        return "<?= t("N_A"); ?>";
    }

    var h = Math.floor(d / 3600);
	var m = Math.floor(d % 3600 / 60);
	var s = Math.floor(d % 3600 % 60);
	return ((h > 0 ? h + ":" : "") + (m > 0 ? (h > 0 && m < 10 ? "0" : "") + m + ":" : "00:") + (s < 10 ? "0" : "") + (s < 0 ? "0" : s));
}

//get display size of hard drive, e.g. 320G instead of 343597383680
function getDispSize(bytes, precision, useSI) {
	"use strict";

	/* Params */
	if (typeof(precision) == "undefined") var precision = 1;	//default to 1 digit behind decimal
	if (typeof(useSI) == "undefined") var useSI = 1;	//default to 1
	var useSISuffix = 1;

	if (!(!isNaN(bytes) && +bytes > -1 && isFinite(bytes))) {
		return "NaN";
	}
	var units, obj, amountOfUnits, unitSelected, suffix;
	units = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
	obj = {
		base : useSI ? 10 : 2,
		unitDegreeDiff : useSI ? 3 : 10
	};
	amountOfUnits = Math.max(0, Math.floor(Math.round(Math.log(+bytes) / Math.log(obj.base) * 1e6) / 1e6));
	unitSelected = Math.floor(amountOfUnits / obj.unitDegreeDiff);
	unitSelected = units.length > unitSelected ? unitSelected : units.length - 1;
	suffix = (useSI || useSISuffix) ? units[unitSelected] : units[unitSelected].replace('B', 'iB');
	bytes = +bytes / Math.pow(obj.base, obj.unitDegreeDiff * unitSelected);
	if (bytes.toString().length > bytes.toFixed(precision).toString().length) {
		bytes = bytes.toFixed(precision);
	}
	return bytes + " " + suffix;
}

//helper function to display multidimensional array as string (like PHP's print_r)
function dump(arr,level) {
	var dumped_text = "";
	if(!level) level = 0;

	//The padding given at the beginning of the line.
	var level_padding = "";
	for(var j=0;j<level+1;j++) level_padding += "    ";

	if(typeof(arr) == 'object') { //Array/Hashes/Objects
		for(var item in arr) {
			var value = arr[item];

			if(typeof(value) == 'object') { //If it is an array,
				dumped_text += level_padding + "'" + item + "' ...\n";
				dumped_text += dump(value,level+1);
			} else {
				dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
			}
		}
	} else { //Stings/Chars/Numbers etc.
		dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
	}
	return dumped_text;
}

//remove item from array of arrays
//e.g. h = ([1, 2], [3], [4, 5]), n = 3 -> ([1, 2], [], [4, 5])
function removeFromArrayOfArrays(haystack, needle) {
	for (var i=0; i<haystack.length; i++) {
		for (var j=0; j<haystack[i].length; j++) {
			if (haystack[i][j] == needle) {
				var h1 = haystack[i].slice(0, j);
				var h2 = haystack[i].slice(j+1);
				haystack[i] = h1.concat(h2);
			}
		}
	}
	return haystack;
}

function addErrorClass(obj) {
	//obj.addClass("ui-state-error");
}

function removeErrorClass(obj) {
	//obj.removeClass("ui-state-error");
}

function disableObj(obj) {
	var id = obj.attr("id") + "_ENABLED";
	if (typeof(window[id]) == "undefined") {
		window[id] = false;
		obj.attr('disabled', 'disabled');
		obj.addClass('ui-state-disabled');
	}
	else if (window[id] == true) {
		obj.attr('disabled', 'disabled');
		obj.addClass('ui-state-disabled');
		window[id] = false;
	}

	//obj.attr('disabled', 'disabled');
	//obj.addClass('ui-state-disabled');

	//(clicking is disabled on divs in each div's click handler)
}

function enableObj(obj) {
	var id = obj.attr("id") + "_ENABLED";
	if (typeof(window[id]) == "undefined") {
		window[id] = true;
		obj.removeAttr('disabled');
		obj.removeClass('ui-state-disabled');
	}
	else if (window[id] == false) {
		obj.removeAttr('disabled');
		obj.removeClass('ui-state-disabled');
		window[id] = true;
	}
}

function showObj(obj) {
	if (obj.hasClass("inline-block")) obj.css("display", "inline-block");
	else obj.show();
}

function hideObj(obj) {
	if (obj.css("display") == "inline-block") obj.addClass("inline-block");
	obj.hide();
}

function inArray(needle, haystack) {
	for (var i in haystack) {
		if (haystack[i] == needle) return true;
	}
	return false;
}

//get drive in "all_drives" array with Bay = b (e.g. "A1")
function driveWithBay(b) {
	for (var d in all_drives) {
        if (all_drives[d]["Bay"] == b && all_drives[d]["Connected"] == true) {
			return all_drives[d];
		}
	}
	return -1;
}

//get repo in "repositories" with Name = n (e.g. "Bay-SAS_D2")
function repoWithName(n) {
	for (var r in repositories) {
		if (repositories[r]["Name"] == n) {
			return repositories[r];
		}
	}
	return -1;
}
            
//get filesystem in "filesystems" with MountPath = mp (e.g. "/var/repo/sas-d1")
function fsWithMountPath(mp) {
	for (var f in filesystems) {
		if (filesystems[f]["MountPath"] == mp) {
			return filesystems[f];
		}
	}
	return -1;
}

//get interface in "interfaces" with Name = n (e.g. "eth0")
function interfaceWithName(n) {
	for (var i in interfaces) {
		if (interfaces[i]["Name"] == n) {
			return interfaces[i];
		}
	}
	return -1;
}

//input export_status returned from server, and return translation from USBEXPORTSTATUSES array
function translateUSBExportStatus(export_status) {
	for (var i in APIUSBEXPORTSTATUSES) {
		if (export_status == APIUSBEXPORTSTATUSES[i]) return USBEXPORTSTATUSES[i];
	}
	return "-";
}

//for Drive Details dialog
function updateDriveDetails(b) {
	var drive = driveWithBay(b);
	var drive_info = "";

	if ((typeof(drive) == "object") && ("SerialNumber" in drive)) {	//bay
        if (drive["IsSAS"] && !drive["IsPortSASEnabled"]) {
            var msg = "<?= t("N_NOT_ENABLED"); ?>";
            msg = msg.replace("%1", b);
			drive_info += "<div class=\"sas-alert-msg\"><?= t("SAS_OPTION_NOT_ENABLED"); ?></div>";
		}
        else if (!drive["IsPortEnabled"]) {
            var msg = "<?= t("N_NOT_ENABLED"); ?>";
            msg = msg.replace("%1", b);
			drive_info += "<div class=\"sas-alert-msg\">" + msg + "</div>";
        }
	}

	drive_info += "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";

	for (var key in drive) {
		if (key == "Partitions") {
            drive_info += "<tr><td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">";

			// if no partitions
			if (drive[key].length <= 0) {
				drive_info += "None";
			}

			for (var p=0; p<drive[key].length; p++) {
				for (var pkey in drive[key][p]) {
					drive_info += "<i><b>" + pkey + "</b></i>" + ": " + drive[key][p][pkey] + "<br/>\n";
				}
				drive_info += "<br/>\n";
			}
			drive_info += "</td><tr><td colspan=\"3\"></td></tr>\n</tr>\n";
		}
		else {
            if (!(WIPE_ONLY && key == "Role")) {
                <?php if ($LOGICUBE_PLATFORM == "writeprotect" || $LOGICUBE_PLATFORM == "writeprotectportable" || $LOGICUBE_PLATFORM == "pciebridge"): ?>
                if ((key == "HPAEnabled" || key == "DCOEnabled") && drive[key] == "Yes") drive_info += "<tr class=\"hpa-dco-enabled-row\">";
                else drive_info += "<tr>";
                drive_info += "<td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">" + drive[key] + "</td></tr>\n<tr><td colspan=\"3\"></td></tr>\n";
                <?php else: ?>
                drive_info += "<tr><td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">" + drive[key] + "</td></tr>\n<tr><td colspan=\"3\"></td></tr>\n";
                <?php endif; ?>
            }
		}
	}
	drive_info += "</table>";
	$('#clone_drive_details_content').html(drive_info);
}

//for Repository Details dialog
function updateRepoDetails(n) {
	var repo = repoWithName(n);
	var repo_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
	for (var key in repo) {
        if (!(WIPE_ONLY && key == "Role"))
		  repo_info += "<tr><td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">" + (key == "Password" ? Array(repo[key].length+1).join("*") : repo[key]) + "</td></tr>\n";
	}
	repo_info += "</table>";
	$('#clone_repo_details_content').html(repo_info);
}

//for Image Details dialog
function updateImageDetails(i) {
	var image_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
	for (var key in images[i]) {
        if (!(WIPE_ONLY && key == "Role"))
            image_info += "<tr><td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">" + (key == "Size" ? getDispSize(images[i][key]) : images[i][key]) + "</td></tr>\n";
	}
	image_info += "</table>";
	$('#clone_image_details_content').html(image_info);
}

<?php if (($LOGICUBE_PLATFORM == "forensic") || ($LOGICUBE_PLATFORM == "zxiforensic") || ($LOGICUBE_PLATFORM == "talonu")): ?>
//for Partition dialog
function updatePartitionModal(bay) {
	var t = current_task();
	if (t == -1) return;
    var master = task_config[t]["Master"];
    var part_num = task_config[t]["SourcePartitionNumber"];
    var drive = driveWithBay(bay);
    var partitions = drive.Partitions;

	//has the modal been initialized
	if ($("#clone_master_partition_select .header_row").length == 0) {		//first time showing
		//initialize Master Select
		$("#clone_master_partition_select").append("<tr class=\"header_row\"><td class=\"col1\"><?= t("PARTITION"); ?></td><td class=\"col2\"><?= t("PARTITION_INFORMATION"); ?></td><td class=\"col3\"><?= t("PARTITION_STATUS"); ?></td><td class=\"col4\"><?= t("LOCKED_COL"); ?></td><td class=\"col5\"><?= t("MORE_INFO_COL"); ?></td></tr>");
		for (var p in partitions) {
			$("#clone_master_partition_select").append("<tr class=\"select_row select-opt" + (bay == master && partitions[p]["Number"] == part_num ? " ui-selected" : "") + "\">"
                + "<td class=\"col1\"><span class=\"bay\">" + bay + "</span> <span class=\"part_num\">" + partitions[p]["Number"] + "</span></td>"
				+ "<td class=\"col2\">" + partitions[p]["Device"] + "<br/>" + getDispSize(partitions[p]["Size"]) + "</td>"
				+ "<td class=\"col3\"><?= t("AVAILABLE"); ?></td>"
				+ "<td class=\"col4" + (partitions[p]["PartnEncrypted"] ? (partitions[p]["PartnLocked"] ? " part-locked" : " part-unlocked") : "") + "\"></td>"
				+ "<td class=\"col5 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
		$("#clone_master_partition_select").append("<tr class=\"footer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
    }
    else {	//already initialized, just update rows with new partition info
		var part_row = -1;
		$("#clone_master_partition_select .select_row").each(function(i) {
			if (partitions.length > i) {
				$(this).find(".col1 .bay").html(bay);
				$(this).find(".col1 .part_num").html(partitions[i]["Number"]);
				$(this).find(".col2").html(partitions[i]["Device"] + "<br/>" + getDispSize(partitions[i]["Size"]));
				if (partitions[i]["Number"] == part_num && $(this).hasClass("ui-selected")) $(this).find(".col3").html("<?= t("SELECTED"); ?>");
                else $(this).find(".col3").html("<?= t("AVAILABLE"); ?>");
                if (partitions[i]["PartnEncrypted"]) {
                if (partitions[i]["PartnLocked"]) $(this).find(".col4").removeClass("part-unlocked").addClass("part-locked");
                else $(this).find(".col4").removeClass("part-locked").addClass("part-unlocked");
                }
                else {
                    $(this).find(".col4").removeClass("part-locked").removeClass("part-unlocked");
                }
				if (bay == master && partitions[i]["Number"] == part_num) $(this).addClass("ui-selected");
				else $(this).removeClass("ui-selected");
			}
			else {	//fewer drives than before, so delete additional rows
				$(this).next().remove();	//remove spacer row
				$(this).remove();
			}
			part_row = i;
		});
		for (var j=part_row+1; j<partitions.length; j++) {	//more partitions than before, so add before footer row
			$("#clone_master_partition_select .footer_row").before("<tr class=\"select_row select-opt" + (bay == master && partitions[j]["Number"] == part_num ? " ui-selected" : "") + "\">"
                + "<td class=\"col1\"><span class=\"bay\">" + bay + "</span> <span class=\"part_num\">" + partitions[j]["Number"] + "</span></td>"
				+ "<td class=\"col2\">" + partitions[j]["Device"] + "<br/>" + getDispSize(partitions[j]["Size"]) + "</td>"
				+ "<td class=\"col3\"><?= t("AVAILABLE"); ?></td>"
                + "<td class=\"col4" + (partitions[j]["PartnEncrypted"] ? (partitions[j]["PartnLocked"] ? " part-locked" : " part-unlocked") : "") + "\"></td>"
				+ "<td class=\"col5 select-more\"></td></tr>"
				+ "<tr class=\"spacer_row\"><td class=\"col1\"></td><td class=\"col2\"></td><td class=\"col3\"></td><td class=\"col4\"></td><td class=\"col5\"></td></tr>");
		}
    }
}

//for Partition Details dialog
function updatePartitionDetails(bay, part_num) {
    var drive = driveWithBay(bay);
    var part = drive.Partitions[part_num-1];
	var part_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
	for (var key in part) {
        if (!(WIPE_ONLY && key == "Role"))
            part_info += "<tr><td style=\"font-weight: bolder;\" valign=\"top\">" + key + ":</td><td width=\"60\">&nbsp;</td><td valign=\"top\">" + (key == "Size" ? getDispSize(part[key]) : part[key]) + "</td></tr>\n";
	}
	part_info += "</table>";
	$('#clone_partition_details_content').html(part_info);
}

<?php endif; ?>

//e.g. for task 11, return "Hash 1"
function mappedTask(t, usetask) {
	var m = t;
	if (t > 15) { m -= 15; info = "<?= t("PUSH_N"); ?>"; }
	else if (t > 10) { m -= 10; info = "<?= t("HASH_N"); ?>"; }
	else if (t > 5) { m -= 5; info = "<?= t("WIPE_N"); ?>"; }
	else if (t > 0) {
		if (usetask) info = "<?= t("TASK_N"); ?>";
		else info = "<?= t("CLONE_N"); ?>";
	}
	else info = "";
	info = info.replace("%1", m);
	return info;
}

//e.g. sliderid = "clone_mirror_length", initval = 100
var pctInterval;
var upInc = 1;
var downInc = 1;
function createSlider(slidername, initval) {
	//show slider HTML
	var sliderhtml =
	'		<table style="margin: 4px 0px 0px 7px" cellspacing="0" cellpadding="0">' +
	'		<tr>' +
	'			<td valign="middle"><div id="' + slidername + '_min" class="ui-slider-min ui-button ui-state-default"></div></td>' +
	'			<td valign="middle"><div id="' + slidername + '_down" class="ui-slider-down ui-button ui-state-default"></div></td>' +
	'			<td valign="middle" class="ui-slider-horizontal"><div id="' + slidername + '_slider"></div></td>' +
	'			<td valign="middle"><div id="' + slidername + '_up" class="ui-slider-up ui-button ui-state-default"></div></td>' +
	'			<td valign="middle"><div id="' + slidername + '_max" class="ui-slider-max ui-button ui-state-default"></div></td>' +
	'			<td valign="middle" align="right" style="position: absolute"><div id="' + slidername + '_percent" class="ui-slider-amount"></div></td>' +
	'		</tr>' +
	'		</table>';

	$("#" + slidername).html(sliderhtml);

	//set up slider (default min=0, max=100)
	$("#" + slidername + "_slider").slider({
		value: initval,
		slide: function(event, ui) {
			if ($(this).attr('disabled') != 'disabled') {
				return setSlider(slidername, ui.value);	//return false to prevent sliding when Clever/Mirror sum > 100
			}
			else {
				return false;
			}
		}
	});

	//set up up/down buttons on click
	$("#" + slidername + "_down").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			downSlider(slidername);
			var denom = 100;	//increment by 1% on sliders when button held down
			if (slidername == "wipe_pass_value") denom = 16;	//on wipe_pass_value slider, increment by 16
			else if (slidername == "settings_autolock_value") denom = 12;	//on settings_autolock_value slider, increment by 5 (60 max / 12)
			pctInterval = setInterval(function() { downInc = Math.round($("#" + slidername + "_slider").slider("option", "max") / denom); downSlider(slidername); }, 300);
		}
	});
	$("#" + slidername + "_down").mouseup(function() {
		clearInterval(pctInterval);
		downInc = 1;
	});

	$("#" + slidername + "_up").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			upSlider(slidername);
			var denom = 100;	//increment by 1% on sliders when button held down
			if (slidername == "wipe_pass_value") denom = 16;	//on wipe_pass_value slider, increment by 16
			else if (slidername == "settings_autolock_value") denom = 12;	//on settings_autolock_value slider, increment by 5 (60 max / 12)
			pctInterval = setInterval(function() { upInc = Math.round($("#" + slidername + "_slider").slider("option", "max") / denom); upSlider(slidername); }, 300);
		}
	});
	$("#" + slidername + "_up").mouseup(function() {
		clearInterval(pctInterval);
		upInc = 1;
	});

    //slider to 0%
	$("#" + slidername + "_min").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			minSlider(slidername);
		}
	});
    //slider to 100%
	$("#" + slidername + "_max").mousedown(function() {
		if ($(this).attr('disabled') != 'disabled') {
			maxSlider(slidername);
		}
	});

	//mouseout mouseleave
	$("#" + slidername + "_down").mouseleave(function() {
		clearInterval(pctInterval);
		downInc = 1;
	});
	//mouseout mouseleave
	$("#" + slidername + "_up").mouseleave(function() {
		clearInterval(pctInterval);
		upInc = 1;
	});

	//initialize slider
	if (slidername == "settings_brightness_value") setSlider(slidername, initval, true);
	else setSlider(slidername, initval);
}

//get the current slider value, and call setSlider on that minus one
function downSlider(slidername) {
	/*REMOVE THIS BEHAVIOR due to touch screen mouse issue
	//on click and hold, open LBA blocks set dialog
	if (downInc > 1) {
		if (slidername == "wipe_lba_range") {
			var slidertitle = "LBA Range";
			var sliderval = $("#" + slidername).parent().parent().find(".col2").html();
		}
		else {
			var slidertitle = $("#" + slidername).parent().parent().find(".col1").html();
			var sliderval = $("#" + slidername).parent().parent().find(".col3").html();
		}
		$("#blocks_slidername").html(slidername);
		$("#blocks_set_title").html(slidertitle + " Blocks");
		$("#blocks_val").val(sliderval);
		$("#blocks_set_dialog").dialog('open');
	}
	else { */
		var val = $("#" + slidername + "_slider").slider("value");
		if (slidername == "settings_brightness_value") val -= 10;
		else val -= downInc;
		setSlider(slidername, val);
	/*}*/
}

//get the current slider value, and call setSlider on that plus one
function upSlider(slidername) {
	/*REMOVE THIS BEHAVIOR due to touch screen mouse issue
	//on click and hold, open LBA blocks set dialog
	if (upInc > 1) {
		if (slidername == "wipe_lba_range") {
			var slidertitle = "LBA Range";
			var sliderval = $("#" + slidername).parent().parent().find(".col2").html();
		}
		else {
			var slidertitle = $("#" + slidername).parent().parent().find(".col1").html();
			var sliderval = $("#" + slidername).parent().parent().find(".col3").html();
		}
		$("#blocks_slidername").html(slidername);
		$("#blocks_set_title").html(slidertitle + " Blocks");
		$("#blocks_val").val(sliderval);
		$("#blocks_set_dialog").dialog('open');
	}
	else { */
		var val = $("#" + slidername + "_slider").slider("value");
		if (slidername == "settings_brightness_value") val += 10;
		else val += upInc;
		setSlider(slidername, val);
	/*}*/
}

//set slider to min value
function minSlider(slidername) {
    var min = $("#" + slidername + "_slider").slider("option", "min");
    setSlider(slidername, min);
}

//set slider to max value
function maxSlider(slidername) {
    var max = $("#" + slidername + "_slider").slider("option", "max");
    setSlider(slidername, max);
}

//set the slider position to 'val' and update _percent to the numeric value
//e.g. #clone_mirror_length_slider moves to 75% position, #clone_mirror_length_percent innerHTML is set to "75%"
function setSlider(slidername, val) {
	val = parseInt(val);
	if ((slidername == "clone_mirror_length") || (slidername == "clone_mirror_mstart") || (slidername == "clone_mirror_tstart")) {	//Mirror sliders
		//get master LBAs and percent
		if ((current_op == OP_CLONE) && (tab_tasks[current_op].length >= 1)) {
			var t = current_task();
			if (t == -1) return;
			var master = task_config[t]["Master"];
			var mode = task_config[t]["CloneMode"];
			var master_lbas = 0;

			if (mode == MODE_I2D) {		//for ImageToDrive, get master size from ImageConfig
				master_lbas = task_config[t]["SourceSize"]/512;
			}
			else if (master != "") {
				var master_drive = driveWithBay(master);
				master_lbas = 0;

				if (master_drive != -1) {	//make sure drive is still connected
					master_lbas = master_drive.LogicalSectors;
				}
			}
			else master_lbas = 1;

			//minimum val
			var min = $("#" + slidername + "_slider").slider("option", "min");
			if (val < min) val = min;

			//make sure MasterStart + Length <= # Master LBAs and TargetStart + Length <= # Master LBAs
			if ($("#clone_mirror_length_slider").length > 0) var lengthval = parseInt($("#clone_mirror_length_slider").slider("value"));
			else var lengthval = master_lbas;
			if ($("#clone_mirror_mstart_slider").length > 0) var mstartval = parseInt($("#clone_mirror_mstart_slider").slider("value"));
			else var mstartval = 0;
			if ($("#clone_mirror_tstart_slider").length > 0) var tstartval = parseInt($("#clone_mirror_tstart_slider").slider("value"));
			else var tstartval = 0;

			if (slidername == "clone_mirror_length") {
				if (val + mstartval > master_lbas) val = master_lbas - mstartval;
				if (val + tstartval > master_lbas) val = master_lbas- tstartval;
				//if ((val == lengthval) && $("#clone_mirror_length_lbas").html() != "&nbsp;") return false;	//this line was not letting Mirror Length clear out when task deleted
			}
			else if (slidername == "clone_mirror_mstart") {
				if (val + lengthval > master_lbas) val = master_lbas - lengthval;
				if ((val == mstartval) && $("#clone_mirror_mstart_lbas").html() != "&nbsp;") return false;
			}
			else if (slidername == "clone_mirror_tstart") {
				if (val + lengthval > master_lbas) val = master_lbas - lengthval;
				if ((val == tstartval) && $("#clone_mirror_tstart_lbas").html() != "&nbsp;") return false;
			}

			var pct = getLBADispPercent(val, master_lbas);

			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_lbas").html(val);	//update Blocks

			//update Percentage
			$("#" + slidername + "_percent").html(pct + "%");

			return false;	//prevents slider from sliding above max sum 100%
		}
	}
	else if (slidername.match(/^clone_clever_/)) {	//Clever sliders
		val = Math.min(Math.max(0, val), 100);
		if ((val >= 0) && (val <= 100)) {
			var sum = potentialSumOfCleverSliders(slidername, val);
			if (sum <= 100) {
				$("#" + slidername + "_slider").slider("value", val);
				$("#" + slidername + "_percent").html(val + "%");
			}
			else {
				return false; //prevent from sliding
			}
		}
	}
	else if (slidername == "wipe_lba_range") {	//Wipe slider
		if ((current_op == OP_WIPE) && (tab_tasks[current_op].length >= 1)) {
			var max_lbas = $("#wipe_lba_range_slider").slider("option", "max");
			val = Math.min(Math.max(0, val), max_lbas);

			//minimum val
			var min = $("#" + slidername + "_slider").slider("option", "min");

			if ((val >= min) && (val <= max_lbas)) {
				var pct = getLBADispPercent(val, max_lbas);

				$("#" + slidername + "_slider").slider("value", val);
				$("#" + slidername + "_percent").html(pct + "%");
				$("#" + slidername + "_lbas").html(val);
			}
			else {
				return false;	//prevent from sliding
			}
		}
	}
	else if (slidername == "wipe_pass_value") {	//Wipe Pass Value slider
		if ((current_op == OP_WIPE) && (tab_tasks[current_op].length >= 1)) {
			if (val == "<?= t("SKIP"); ?>") {
				disableObj($("#" + slidername));
				//$("#" + slidername + "_slider").slider("value", 0);
				$("#" + slidername + "_percent").html("&mdash;");
			}
			else if (val == "<?= t("RANDOM"); ?>") {
				disableObj($("#" + slidername));
				//$("#" + slidername + "_slider").slider("value", 0);
				$("#" + slidername + "_percent").html("XX");
			}
			else if (val == "<?= t("RANDOM_BUFFER"); ?>") {
				disableObj($("#" + slidername));
				//$("#" + slidername + "_slider").slider("value", 0);
				$("#" + slidername + "_percent").html("XX");
			}
			else if (val == "<?= t("VALUE"); ?>") {	//user clicked Value button, show value just set within this window or show current API wipe value
				enableObj($("#" + slidername));
				//$("#" + slidername + "_slider").slider("value", 0);
				var sliderval = parseInt($("#" + slidername + "_slider").slider("value"));
				$("#" + slidername + "_percent").html(dispWipeValue(sliderval));
			}
			else {
				enableObj($("#" + slidername));
				val = Math.min(Math.max(0, val), 255);
				if ((val >= 0) && (val <= 255)) {
					$("#" + slidername + "_slider").slider("value", val);
					$("#" + slidername + "_percent").html(dispWipeValue(val));
				}
				else {
					return false;
				}
			}
		}
	}
	else if ((slidername == "hash_lba_length") || (slidername == "hash_lba_tstart")) {	//Hash sliders
		if ((current_op == OP_HASH) && (tab_tasks[current_op].length >= 1)) {

			var target_lbas = $("#" + slidername + "_slider").slider("option", "max");
			if ($("#hash_lba_length_slider").length > 0) var lengthval = parseInt($("#hash_lba_length_slider").slider("value"));
			else var lengthval = target_lbas;
			if ($("#hash_lba_tstart_slider").length > 0) var tstartval = parseInt($("#hash_lba_tstart_slider").slider("value"));
			else var tstartval = 0;

			//minimum val
			var min = $("#" + slidername + "_slider").slider("option", "min");
			if (val < min) val = min;

			//length + start <= 100%
			if (slidername == "hash_lba_length") {
				if (val + tstartval > target_lbas) val = target_lbas - tstartval;
			}
			else if (slidername == "hash_lba_tstart") {
				if (val + lengthval > target_lbas) val = target_lbas - lengthval;
				if ((val == tstartval) && $("#hash_lba_tstart_lbas").html() != "&nbsp;") return false;
			}

			var pct = getLBADispPercent(val, target_lbas);

			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_percent").html(pct + "%");
			$("#" + slidername + "_lbas").html(val);

			return false;	//prevents slider from sliding above max sum 100%
		}
	}
	else if (slidername == "settings_autolock_value") {	//Settings Auto Lock slider
		val = Math.min(Math.max(0, val), 60);
		if ((val >= 1) && (val <= 60)) {
			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_percent").html(val);
		}
		else {
			return false;
		}
	}
	else if (slidername == "drive_inactivity_timeout_value") {	//Drive Inactivity Timeout slider
		val = Math.min(Math.max(0, val), 60);
		if ((val >= 0) && (val <= 60)) {
			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_percent").html(val);
		}
		else {
			return false;
		}
	}
	else if (slidername == "settings_brightness_value") {
		val = Math.min(Math.max(0, val), 100);
		if ((val >= 0) && (val <= 100)) {
			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_slider .ui-slider-handle").css("margin-left", -69*val/100 + "px");	//without this, at 100% the handle overflows to slider the right (jQuery UI left aligns slider handle)
			$("#" + slidername + "_percent").html(val + "%");

			var dont_update_server = arguments[2];
			if (!dont_update_server) {
				var pct = $("#settings_brightness_value_slider").slider("value");
				//convert 0-100% to 0-255 value
				var b = Math.round(pct*255/100);
				SetLCDBrightness(b);
			}

		}
		else {
			return false;
		}
	}
	else if (slidername == "clone_compression_value") {
		val = Math.min(Math.max(0, val), 4);
		if ((val >= 0) && (val <= 4)) {
			$("#" + slidername + "_slider").slider("value", val);
		}
		else {
			return false;
		}
	}
	else {
		val = Math.min(Math.max(0, val), 100);
		if ((val >= 0) && (val <= 100)) {
			$("#" + slidername + "_slider").slider("value", val);
			$("#" + slidername + "_percent").html(val);
		}
		else {
			return false;
		}
	}

	return true;
}



//get sum of Clever sliders if slidername is set to val
function potentialSumOfCleverSliders(slidername, val) {
	var i = 1;
	var sum = 0;
	while ($("#clone_clever_pct" + i + "_slider").length > 0) {
		if (slidername == "clone_clever_pct" + i) sum += val;
		else sum += $("#clone_clever_pct" + i + "_slider").slider("value");
		i++;
	}
	return sum;
}

//gets display percentage for LBA counts -- uses ceil for 95% and below so 1 LBA shows as 1%, uses floor for over 95% so max-1 LBAs shows as 99%
//pass start_pct=true for TargetStartLBA
function getLBADispPercent(lbacount, max_lbas, start_pct) {
	if (typeof(start_pct) == "undefined") start_pct = false;
	if (max_lbas == 0 && !start_pct) var pct = 100;
	else if (max_lbas == 0 && start_pct) var pct = 0;
	else if (lbacount*100/max_lbas <= 95) var pct = Math.round(lbacount*100/max_lbas);
	else var pct = Math.floor(lbacount*100/max_lbas);

	return pct;
}

//truncate a string to len
function truncate(str, len) {
	len = len || 10;
	if (typeof(str) != "undefined") {
        if (str.length > len-2) {
		  return $.trim(str).substring(0, len-2).trim(this) + "...";
        }
	}
	return str;
}

//show solid background behind modal dialog windows
function showMask() {
	$("#mask").show();
}
function hideMask() {
	$("#mask").hide();
}

//cookie functions
function setCookie(c_name, value, expmins) {
	var now = new Date();
	var expdate = new Date();
	expdate.setTime(now.getTime() + (expmins * 60 * 1000));
	var c_value = escape(value) + ((expmins==null) ? "" : "; expires="+expdate.toUTCString());
	document.cookie = c_name + "=" + c_value;
}

function getCookie(c_name) {
	var i,x,y,ARRcookies=document.cookie.split(";");
	for (i=0;i<ARRcookies.length;i++) {
		x=ARRcookies[i].substr(0,ARRcookies[i].indexOf("="));
		y=ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1);
		x=x.replace(/^\s+|\s+$/g,"");
		if (x==c_name) {
			return unescape(y);
		}
	}
	return 'undefined';
}


$(function() {
	//show/hide mask behind all dialog windows
	var num_mask_dialogs_open = 0;
	$(".mask-dialog").bind("dialogopen", function() {
		num_mask_dialogs_open++;
		showMask();
	});
	$(".mask-dialog").bind("dialogclose", function() {
		num_mask_dialogs_open--;
		if (num_mask_dialogs_open == 0) hideMask();
	});

	//handle errors by opening jQuery modal, and reload on OK/close
	window.onerror = function(message, url, linenumber) {
		var msg = ("JavaScript error: " + message + " on line " + linenumber + " for " + url);
		//alert(msg);

        var trace = printStackTrace();
        console.log(trace.join('\n\n'));

		var error_info = "<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">";
		error_info += "<tr><td>" + msg + "</td></tr>\n";
		error_info += "</table>";
		showMask();
		$('#js_error_details_scroller').html(error_info);
		$('#js_error_details_dialog').dialog('open');
		$('#js_error_details_dialog').parent().css("z-index", "10020");	//set dialog z-index here (not working in dialog setup)
	}

	$("#js_error_details_dialog").dialog({
		bgiframe: true,
		autoOpen: false,
		position: [17,11],
		modal: true,
		resizable: false,
		draggable: false,
		zIndex: 10020,
		buttons: {
			'OK': function() {
				//location.reload();
			}
		},
		close: function(event, ui) {
			//location.reload();
		}
	});
});

//handles errors that might occur before document is loaded with a JS alert
window.onerror = function(message, url, linenumber) {
	var msg = ("JavaScript error: " + message + " on line " + linenumber + " for " + url);

    var trace = printStackTrace();
    console.log(trace.join('\n\n'));

    //location.reload();
}




